<?php
/*----------------------------------------------------------------------------------------------
| Kiss Advertiser (com_ksadvertiser)						Version	1.5.63
|-----------------------------------------------------------------------------------------------
| Author: Heiner Klostermann (DocChicago) - KISS Software Germany				
| Copyright (c) 2010 by KISS Software, 59227 Ahlen (NRW), Germany				
|-----------------------------------------------------------------------------------------------
| License GNU/GPL 					http://www.gnu.org/copyleft/gpl.html
|-----------------------------------------------------------------------------------------------
|												
| This component is free software, distributed under the GNU / GPL License. You may use,	
| copy and redistribute it free of charge as long as it complies with the license terms.	
|												
| 
| For help and suggestions please visit our support forum at www.kiss-software.de
|
|-----------------------------------------------------------------------------------------------
| created 2010-01-01							updated	2011-03-11
|-----------------------------------------------------------------------------------------------*/

defined('_JEXEC') or die('Restricted Access');
require_once(JApplicationHelper::getPath( 'admin_html') );
JTable::addIncludePath(JPATH_COMPONENT.DS.'tables');
$cid 	= JArrayHelper::getValue($_REQUEST, 'cid', array());

require_once(JPATH_ROOT. DS. 'components' .DS. 'com_ksadvertiser' .DS.'class.help.php' );
require_once(JPATH_COMPONENT .DS.'admin.cpanel.html.php' );

switch($task)
{
//-------------- Configuration ---------------------------
	case 'conf':
		conf();
		break;
	case 'saveconf':
	case 'applyconf':
		saveconf($task);
		break;
//-------------- Categories ---------------------------		
	case 'categories':
		categories($option);
		break;
	case 'publish_categories':
		categoriesPublish( $cid, 1, $option );
	break;
	case 'unpublish_categories':
		categoriesPublish( $cid, 0, $option );
	break;
	case 'categories_orderup':
		categoriesOrder( $cid[0], -1, $option );
	break;
	case 'categories_orderdown':
		categoriesOrder( $cid[0], 1, $option );
	break;
    case 'saveorder':
	    categoriesSaveOrder( $cid );
    break;
	case 'addcategory':
	case 'editcategory':
		editCategory();
		break;
	case 'removecategory':
		removecategory();
		break;
	case 'savecategory':
	case 'applycategory':	
		savecategory($option, $task);
		break;
//-------------- Classifieds ---------------------------
	case 'add':
	case 'edit':
		editClassified();
		break;
	case 'edit_complaint':
		editComplaint($option);
		break;
	case 'apply':
	case 'save':
		saveClassified($task);
		break;
	case 'remove':
		removeClassifieds($option);
		break;
	case "show_classifieds":
		showClassifieds($option);
		break;
	case 'publish_ads':
		publishClassifieds( $cid, 1, $option );
	break;
	case 'unpublish_ads':
		publishClassifieds( $cid, 0, $option );
	break;
	case 'cancel':
		cancelClassifiedEdit();
		break;
//-------------- Additional functions ---------------------------		
	case 'showcss':
		showcss($option);
		break;
	case 'savecss':
        $file =JRequest::getVar( 'file', 1);
        $csscontent = JRequest::getVar( 'csscontent', 1);
        saveCss($file, $csscontent, $option);
	break;
	case 'savadimgs':
        saveAdditionalImage($option);
	break;
	case 'deletimgs':
        deleteAdditionalImage($option);
	break;
	case 'prune':
		pruneclassified();
		break;
	case 'fields':
		showfields($option);
		break;
	case 'savefields':
		savefields($task);
		break;
//-------------- Addresses ---------------------------				
	case 'addresses':
		addresses();
		break;
	case 'removeaddress':
		removeAddress();
		break;
	case 'publish_addresses':
		publishAddresses( $cid, 1);
	break;
	case 'unpublish_addresses':
		publishAddresses( $cid, 0);
	break;
	case 'addaddress':
	case 'editaddress':
		editAddress($task);
		break;
	case 'saveaddress':
	case 'applyaddress':
		saveAddress($task);
		break;

//-------------- Complaints ---------------------------		
	case "show_complaints":
		showComplaints($option);
		break;
	case 'save_complaint':
	case 'apply_complaint':
		savecomplaint($task);
		break;
	case 'remove_complaint':
		removeComplaints();
		break;
	case 'publish_complaint':
		complaintPublish( $cid, 1, $option );
	break;
	case 'unpublish_complaint':
		complaintPublish( $cid, 0, $option );
	break;
//-------------- Backup and Restore ---------------------------		
	case 'backup':
		showBackupOptions($option, $task);
		break;
	case 'restore':
		show_backups($option);
		break;
	case 'showrestore':
		showRestoreOptions($option, $row);
		break;
	case 'run_backup':
		run_backup($task);
		break;
	case 'run_restore':
		run_restore($row);
		break;
	case 'remove_backups':
		removeBackups($option);
		break;
	case 'sampledata':
		sampleDataOptions($row);
		break;
//-------------- Customers ---------------------------		
	case "customers":
		customers();
		break;
	case 'addcustomer':
	case 'editcustomer':
		editCustomer($option, $task);
		break;
	case 'savecustomer':
	case 'applycustomer':
		saveCustomer($task);
		break;
	case 'removecustomer':
		removeCustomer();
		break;
	case 'publish_customers':
		publishCustomers( $cid, 1, $option );
	break;
	case 'unpublish_customers':
		publishCustomers( $cid, 0, $option );
	break;
	case 'accountnew':
	case 'accountdelete':
	case 'accountinvoice':	
		compileCustomerAccount($task);
	break;

//-------------- Ads Plans / Models ---------------------------		
	case 'models':
		models();
		break;
	case 'addmodel':
	case 'editmodel':
		editModel();
		break;
	case 'savemodel':
	case 'applymodel':
		saveModel($task);
		break;
	case 'removemodel':
		removeModel($option);
		break;
	case 'models_orderup':
		modelsOrder( $cid[0], -1, $option );
	break;
	case 'models_orderdown':
		modelsOrder( $cid[0], 1, $option );
	break;
	case 'models_order':
		modelsSaveOrder( $cid);
	break;
	case 'publish_models':
		publishModels( $cid, 1, $option );
	break;
	case 'unpublish_models':
		publishModels( $cid, 0, $option );
	break;

//-------------- Import ---------------------------
	case 'import':
		showimport();
		break;
	case 'apply_import':
		applyimport();
		break;
		
//-------------- Control Panel ---------------------------		
	case 'cpanel':
	default:
		showControlPanel($option);
		break;
}

function showcss($option)
{
	$file = "..".DS."components".DS."com_ksadvertiser".DS."css".DS."ksadvertiser.css";
	@chmod($file, 0755);
	$permission = is_writable($file);

	HTML_classifieds::showcss($file, $option);
}

function saveCss($file, $csscontent, $option) {
	global $mainframe;
	$app =& JFactory::getApplication();
	if (is_writable($file)) {
	    if (!$handle = fopen($file, 'w+')) {
         echo JText::_('Cannot open file') . " ($file)";
         exit;
    }
	if (fwrite($handle, $csscontent) === FALSE) {
        echo JText::_('Cannot write to file') . " ($file)";
        exit;
    }
	fclose($handle);
	$mainframe->redirect('index.php?option=com_ksadvertiser&task=conf', JText::_('CSS Styles Saved'));
	} else {
	$mainframe->redirect('index.php?option=com_ksadvertiser&task=conf', JText::_('File could not be written'));
	}
}

function saveAdditionalImage($option) {
	global $mainframe;
	$db	=& JFactory::getDBO();	
	$img_comment = JRequest::getVar( 'comment', '', 'post', 'string' );
	$img_raw = JRequest::getVar( 'file', '', 'post', 'string' );
	$img_file = basename($img_raw);
	$adid = JRequest::getVar( 'adid', 0, 'post', 'int' );
	$query = "INSERT INTO #__ksads_files (adid, file, comment)
			  VALUES ($adid, '$img_file', '$img_comment')";
	$db->setQuery($query);
	if ($db->query()) {
		$msg=JText::_('Additional image saved');
		} else {
		$msg=JText::_('File could not be written');
		}
	$mainframe->redirect('index.php?option=com_ksadvertiser&task=edit&cid[]='.$adid, $msg);
}

function deleteAdditionalImage($option) {
	global $mainframe;
	$db	=& JFactory::getDBO();	
	$imgid = JRequest::getVar( 'imgid', 0, 'get', 'int' );
	$adid = JRequest::getVar( 'adid', 0, 'get', 'int' );	
	$query = "DELETE FROM #__ksads_files WHERE id = ".$imgid;

	$db->setQuery($query);
	if ($db->query()) {
		$msg=JText::_('Additional image deleted');
		} else {
		$msg=JText::_('File could not be written');
		}
	$mainframe->redirect('index.php?option=com_ksadvertiser&task=edit&cid[]='.$adid, $msg);
}

function showfields($option)
{
	$db	=& JFactory::getDBO();
	$row =& JTable::getInstance('fields', 'Table');
	$query = "SELECT * FROM #__ksads_fields WHERE `eid` = 0";
	$db->setQuery($query);
	$fields = $db->loadObjectList();
	$conf=& JTable::getInstance('config', 'Table');
	$conf->load(1);	
	$ks_help = new KissHelper();		
	$access = $ks_help->userGroups();
	$agroups = $ks_help->AGroupList();
	$users = $ks_help->userList();
	$delivery = $ks_help->selectitems('delivery', 1);
	$adstates = $ks_help->selectitems('adstate', 1);
	$regionalinfo = $ks_help->fedstates($conf->show_regionalinfo);	
	$lists = array();
	foreach ($fields as $field) {
		$lists["gid$field->id"] = JHTML::_('select.genericList', $access, "gid$field->id", 'class="inputbox"'. '', 'value', 'text', $field->gid );
		$lists["aid$field->id"] = JHTML::_('select.genericList', $agroups, "aid$field->id", 'class="inputbox"'. '', 'value', 'text', $field->aid );
		$lists["uid$field->id"] = JHTML::_('select.genericList', $users, "uid$field->id", 'class="inputbox"'. '', 'value', 'text', $field->uid );

		if ($field->id == 6) {
			$lists['state'] = JHTML::_('select.genericList', $adstates, 'state', 'class="inputbox"'. '', 'value', 'text', $field->default );		
			}
		if ($field->id == 10) {
			$lists['delivery'] = JHTML::_('select.genericList', $delivery, 'delivery', 'class="inputbox"'. '', 'value', 'text', $field->default );		
			}
		if ($field->id == 13) {
			$lists['boxnumber'] = JHTML::_('select.booleanlist', $field->fieldname, 'class="inputbox"', $field->default);			
			}
		if ($field->id == 21) {
			$lists['region'] = JHTML::_('select.genericList', $regionalinfo, 'region', 'class="inputbox"'. '', 'value', 'text', $field->default );		
			}
		}
	HTML_classifieds::editFields($option, $lists, $fields);
}

function saveFields($task) {
	global $mainframe, $option;
	$db	=& JFactory::getDBO();	
	$fields = JRequest::get( 'post' );	
	$query = "SELECT * FROM #__ksads_fields";
	$db->setQuery($query);
	$rows = $db->loadObjectList();

	for ($i=0, $n=count( $rows ); $i < $n; $i++) {
	    $query  = "UPDATE #__ksads_fields SET";
	    $query .= " `gid`='".$fields['gid'.$rows[$i]->id]."',";
	    $query .= " `aid`='".$fields['aid'.$rows[$i]->id]."',";	    
	    $query .= " `uid`='".$fields['uid'.$rows[$i]->id]."',";
		switch ($rows[$i]->id) {
				case 6:
				$query .= " `default`='".$fields['state']."'";
				break;
				case 10:
				$query .= " `default`='".$fields['delivery']."'";
				break;
				case 13:
				$query .= " `default`='".$fields['ad_boxnumber']."'";
				break;
				case 21:
				$query .= " `default`='".$fields['region']."'";
				break;
				default:
				$query .= " `default`='".$fields['default'.$rows[$i]->id]."'";
				break;
				} // End switch $j
				
	    if ($fields["cbv".$rows[$i]->id]) {
			$is_visible = true;
			} else {
			$is_visible = false;
			}
	    if ($fields["cbe".$rows[$i]->id]) {
			$is_active = true;
			} else {
			$is_active = false;
			}
		
	    if ($fields["cbm".$rows[$i]->id]) {
		$query .= ", `mandatory`=1";
		// Make sure that a mandatory field is visible and active! Otherwise field validation will fail.
		$is_visible = true;
		$is_active = true;
		} else {
		$query .= ", `mandatory`=0";
		}	    
		if ($is_visible) {
		$query .= ", `visible`=1";
		} else {
		$query .= ", `visible`=0";
		}
	    if ($is_active) {
		$query .= ", `activated`=1";
		} else {
		$query .= ", `activated`=0";
		}
	    $query .= " WHERE `id`=".$rows[$i]->id;
		$db->setQuery($query);
		if ($db->query()) {
			$msg=JText::_('Fields saved');
			} else {
			$msg=JText::_('Error saving fields');
			}
			
	    } // end for($i=0 ...)
		
	$mainframe->redirect('index.php?option=com_ksadvertiser&task=cpanel', $msg);
}

function saveconf($task)
{
	global $mainframe, $option;
	$db	=& JFactory::getDBO();	
	$ks_help = new KissHelper();	
	$row =& JTable::getInstance('config', 'Table');
	$row->load(1);
	$lic = array();
	$lic = explode(",",base64_decode(str_rot13($row->license)));
	$data = JRequest::get('post');
	if (!$row->bind($data))

	{
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit;
	}

	$selectarray = $ks_help->selectarray();
	for ($i=0, $n = count( $selectarray ); $i < $n; $i++) {
	      $itemname = 'cbsb'.$i;
	      $published = (empty($data[$itemname])) ? 0 : 1;
	      if (!$lic[3]) {$published = 1;}
	      $query = "UPDATE #__ksads_selectitems SET published = $published WHERE id = $i";
	      $db->setQuery($query);
	      $db->query();
	    }

	// Convert some entries into their proper format
	$row->frontpage_intro = JRequest::getVar( 'frontpage_intro', '', 'post', 'string', JREQUEST_ALLOWRAW );
	$row->adsense_ldb = JRequest::getVar( 'adsense_ldb', '', 'post', 'string', JREQUEST_ALLOWRAW );	
	$row->adsense_wss = JRequest::getVar( 'adsense_wss', '', 'post', 'string', JREQUEST_ALLOWRAW );	
	$row->adsense_squ = JRequest::getVar( 'adsense_squ', '', 'post', 'string', JREQUEST_ALLOWRAW );		
	$row->bank_name = $ks_help->encrypted($row->bank_name);
	$row->bank_code = $ks_help->encrypted($row->bank_code);
	$row->bank_account = $ks_help->encrypted($row->bank_account);
	$row->bank_bic = $ks_help->encrypted($row->bank_bic);
	$row->bank_iban = $ks_help->encrypted($row->bank_iban);	
	$row->upl_filesize = str_replace("," , ".", $row->upl_filesize);
	$row->upl_filetypes = str_replace(" " , "", $row->upl_filetypes);
	if ($row->upl_rights < 650 || $row->upl_rights > 777) {$row->upl_rights = 755;}
	$row->logo_file = basename($row->logo_file);
	$row->img_maxheight = (int) $row->img_maxwidth / 1.33333;
	$row->img_maxheight_detail = (int) $row->img_maxwidth_detail / 1.33333;
	$row->markasnew = (int) $row->markasnew;

	if (!$row->store()) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit;
	    }
	$msg = JText::_('Config saved');

	// Save the payment model
	$pm = $data['paymentclass'];
	$classfile = JPATH_ROOT.DS."components".DS.$option.DS."payment".DS.$pm.".php";
	if (file_exists($classfile)) {
		include_once($classfile);
		$payclass = new $pm();
		$payclass->write_configuration( $data );
		}

	// Configuration saved, now try to create image directory
	$img_dir = JPath::clean( JPATH_ROOT .DS. "images" .DS. $row->ad_img_dir );

	// this characters are not allowed in foldernames
	if (!eregi ( "[?:*'\"]", $img_dir)) {	
		if (!is_dir($img_dir)) {
		     if (!JFolder::create($img_dir, 0755)) {
				JError::raiseWarning(
					'SOME_ERROR_CODE',
					'JFolder::create: ' . JText::_('Could not create image directory'),
					'Path: ' . $img_dir
				);
				} else {
				// Try to adjust the file and folder rights
				$filemode = "0644";
				$foldermode = "0" . $row->upl_rights;
				if (JPath::canChmod($img_dir)) {
					JPath::setPermissions($img_dir, $filemode, $foldermode);					
					} else {
					JError::raiseWarning(
						'SOME_ERROR_CODE',
						'JPath::setPermissions: ' . JText::_('Could not change folder permissions'),
						'Path: ' . $img_dir
					);			
					} // End if JPath::canChmod ...
				} // End if(!JFolder::create ...)		
			} // End if (!isdir ....)	
		} else {
		$msg .= JText::_('Illegal Image Directory Name');
		}
	switch ($task) { 
		case 'saveconf' :
			$mainframe->redirect('index.php?option=' . $option, $msg);
			break;
		case 'applyconf' :
			$mainframe->redirect('index.php?option=' . $option. '&task=conf', $msg);
			break;
		}
}

function conf()
{
	global $option;
	$db	=& JFactory::getDBO();
	$row =& JTable::getInstance('config', 'Table');
	$cid = JRequest::getVar('cid', array(0), '', 'array' );
	$id = $cid[0];
	$row->load(1);
	$lists = array();
	$ks_help = new KissHelper();
	$currency = $ks_help->currencies();
	$access = $ks_help->userGroups();
	$access[] = array('value' => '1', 'text' => JText::_('Customers Only'));
	$edits = $ks_help->editors();
	$catlists = $ks_help->catlists();
	$adlists = $ks_help->adlists();
	$adstyles = $ks_help->adstyles();
	$bannercats = $ks_help->BannercatList();	
	$menustyles = $ks_help->menustyles();
	$startpanels = $ks_help->startpanels();
	$rsslist = $ks_help->rsslist();
	$ext_catlist = $ks_help->catlists_extension_text();
	$bic_text = $ks_help->behavior_image_click();
	$statpanels = $ks_help->statstyles();
	$distunits = $ks_help->distanceunits();
	$affiliates = $ks_help->affiliates();
	$countries = $ks_help->selectitems('country', 1);
	$countries[0]['text'] = JText::_('None');
	$row->bank_name = $ks_help->decrypted($row->bank_name);
	$row->bank_code = $ks_help->decrypted($row->bank_code);
	$row->bank_account = $ks_help->decrypted($row->bank_account);
	$row->bank_bic = $ks_help->decrypted($row->bank_bic);
	$row->bank_iban = $ks_help->decrypted($row->bank_iban);	

	$map[] = JHTML::_( 'select.option', '0', JText::_('Off') );
	$map[] = JHTML::_( 'select.option', '1', JText::_('On') );
	if (!$row->editor) {
		$row->editor = '';
	    }
	// build the html select lists
	$lists['editor'] = JHTML::_('select.genericlist',  $edits, 'editor', 'class="inputbox" size="1"', 'value', 'text', $row->editor);
	$lists['map'] = JHTML::_('select.radioList', $map, 'map', 'class="inputbox"' . '', 'value', 'text', $row->map );
	$lists['route'] = JHTML::_('select.radioList', $map, 'route', 'class="inputbox"' . '', 'value', 'text', $row->route );	
	$lists['cronexpiry'] = JHTML::_('select.radioList', $map, 'notify_expiry', 'class="inputbox"' . '', 'value', 'text', $row->notify_expiry );	
	$lists['currency'] = JHTML::_('select.genericList', $currency, 'currency', 'class="inputbox"'. '', 'value', 'text', $row->currency );
	$lists['notify'] = JHTML::_('select.booleanlist', 'notify', 'class="inputbox"', $row->notify);
	$lists['sliders'] = JHTML::_('select.booleanlist', 'show_sliders', 'class="inputbox"', $row->show_sliders);
	$lists['checkaddress'] = JHTML::_('select.booleanlist', 'check_address_geocode', 'class="inputbox"', $row->check_address_geocode);
	$lists['access'] = JHTML::_('select.genericList', $access, 'access', 'class="inputbox"'. '', 'value', 'text', $row->access );
	$lists['access_reply'] = JHTML::_('select.genericList', $access, 'access_reply', 'class="inputbox"'. '', 'value', 'text', $row->access_reply );	
	$lists['access_vid'] = JHTML::_('select.genericList', $access, 'access_vid', 'class="inputbox"'. '', 'value', 'text', $row->access_vid );	
	$lists['access_delete'] = JHTML::_('select.genericList', $access, 'access_delete', 'class="inputbox"'. '', 'value', 'text', $row->access_delete );	
	$lists['udelete'] = JHTML::_('select.genericList', $access, 'udelete', 'class="inputbox"'. '', 'value', 'text', $row->udelete );
	$lists['tax'] = JHTML::_('select.booleanlist', 'prolong', 'class="inputbox"', $row->prolong);
	$lists['catlists'] = JHTML::_('select.genericlist',  $catlists, 'catliststyle', 'class="inputbox" size="1"', 'value', 'text', $row->catliststyle);
	$lists['adlists'] = JHTML::_('select.genericlist',  $adlists, 'adliststyle', 'class="inputbox" size="1"', 'value', 'text', $row->adliststyle);
	$lists['adstyles'] = JHTML::_('select.genericlist',  $adstyles, 'addetailstyle', 'class="inputbox" size="1"', 'value', 'text', $row->addetailstyle);
	$lists['menustyles'] = JHTML::_('select.genericlist',  $menustyles, 'menustyle', 'class="inputbox" size="1"', 'value', 'text', $row->menustyle);
	$lists['rsslist'] = JHTML::_('select.genericlist',  $rsslist, 'access_rss', 'class="inputbox" size="1"', 'value', 'text', $row->access_rss);
	$lists['startpanels'] = JHTML::_('select.genericlist',  $startpanels, 'startpanel', 'class="inputbox" size="1"', 'value', 'text', $row->startpanel);		
	$lists['showdetailslist'] = JHTML::_('select.booleanlist', 'show_details_list', 'class="inputbox"', $row->show_details_list);
	$lists['showdetailsdetails'] = JHTML::_('select.booleanlist', 'show_details_details', 'class="inputbox"', $row->show_details_details);
	$lists['affiliate'] = JHTML::_('select.genericlist',  $affiliates, 'show_affiliate', 'class="inputbox" size="1"', 'value', 'text', $row->show_affiliate);		
	$lists['affiliate2'] = JHTML::_('select.genericlist',  $affiliates, 'show_affiliate_2', 'class="inputbox" size="1"', 'value', 'text', $row->show_affiliate_2);		
	$lists['countries'] = JHTML::_('select.genericlist',  $countries, 'show_regionalinfo', 'class="inputbox" size="1"', 'value', 'text', $row->show_regionalinfo);		
	$lists['showterms'] = JHTML::_('select.booleanlist', 'show_terms', 'class="inputbox"', $row->show_terms);
	$lists['createthumbs'] = JHTML::_('select.booleanlist', 'create_thumbnails', 'class="inputbox"', $row->create_thumbnails);
	$lists['showcaptcha'] = JHTML::_('select.booleanlist', 'show_captcha', 'class="inputbox"', $row->show_captcha);
	$lists['showpushlink'] = JHTML::_('select.booleanlist', 'show_pushlink', 'class="inputbox"', $row->show_pushlink);
	$lists['showrating'] = JHTML::_('select.booleanlist', 'show_rating', 'class="inputbox"', $row->show_rating);
	$lists['showrating2'] = JHTML::_('select.booleanlist', 'show_rating_2', 'class="inputbox"', $row->show_rating_2);		
	$lists['showbanners'] = JHTML::_('select.genericList', $bannercats, 'show_banners', 'class="inputbox"'. '', 'value', 'text', $row->show_banners );	
	$lists['showbanners2'] = JHTML::_('select.genericList', $bannercats, 'show_banners_2', 'class="inputbox"'. '', 'value', 'text', $row->show_banners_2 );	
	$lists['showstats'] = JHTML::_('select.genericlist',  $statpanels, 'show_statistics', 'class="inputbox" size="1"', 'value', 'text', $row->show_statistics);
	$lists['uplimmediate'] = JHTML::_('select.booleanlist', 'upl_immediate', 'class="inputbox"', $row->upl_immediate);
	$lists['uplsimple'] = JHTML::_('select.booleanlist', 'upl_simple', 'class="inputbox"', $row->upl_simple);		
	$lists['usernotify'] = JHTML::_('select.booleanlist', 'notify_user', 'class="inputbox"', $row->notify_user);
	$lists['showweblink'] = JHTML::_('select.genericList', $access, 'show_weblink', 'class="inputbox"'. '', 'value', 'text', $row->show_weblink );
	$lists['showaddress'] = JHTML::_('select.genericList', $access, 'show_address', 'class="inputbox"'. '', 'value', 'text', $row->show_address );	
	$lists['versioncheck'] = JHTML::_('select.booleanlist', 'access_remotefiles', 'class="inputbox"', $row->access_remotefiles);	
	$lists['mediaautoplay'] = JHTML::_('select.booleanlist', 'med_autoplay', 'class="inputbox"', $row->med_autoplay);	
	$lists['bic'] = JHTML::_('select.genericList', $bic_text, 'behavior_img_click', 'class="inputbox"'. '', 'value', 'text', $row->behavior_img_click );	
	$lists['extcatlist'] = JHTML::_('select.genericList', $ext_catlist, 'show_ext_catlist', 'class="inputbox"'. '', 'value', 'text', $row->show_ext_catlist );	
	$lists['distanceunits'] = JHTML::_('select.genericList', $distunits, 'regionalsearch', 'class="inputbox"'. '', 'value', 'text', $row->regionalsearch );	
	$lists['imageshare'] = JHTML::_('select.booleanlist', 'share_img_anonymous', 'class="inputbox"', $row->share_img_anonymous);
	HTML_classifieds::config($row, $lists, $option);
}

function showControlPanel($option)
{
	HTML_cpanel::ControlPanel($option);
}

function showBackupOptions($option, $task)
{
	HTML_classifieds::showBackupOptions($option, $task);
}

function editAddress($task)
{
	global $option;
	$live_site = &JURI::base();
	$ks_help = new KissHelper();	
	$db	=& JFactory::getDBO();
	$user =& JFactory::getUser();
	$user_id = $user->get( 'id' );	
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);		
	// Load basic info from table
	$row =& JTable::getInstance('addresses', 'Table');
	$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
	$id = $cid[0];
	$row->load($id);
	$row->companyname = $ks_help->decrypted($row->companyname);
	$row->street = $ks_help->decrypted($row->street);
	$row->postcode = $ks_help->decrypted($row->postcode);
	$row->city = $ks_help->decrypted($row->city);
	$row->phone = $ks_help->decrypted($row->phone);
	$row->email = $ks_help->decrypted($row->email);
	$row->website = $ks_help->decrypted($row->website);
	$row->personname = $ks_help->decrypted($row->personname);
	$fedstates = $ks_help->fedstates($conf->show_regionalinfo);	
	$counties = $ks_help->counties($conf->show_regionalinfo, $row->region_fedstate);
	$countries = $ks_help->selectitems('country', 1);	
	if ($conf->show_regionalinfo) {
		$lists['fedstates'] = JHTML::_('select.genericlist',  $fedstates, 'region_fedstate', 'class="inputbox" size="1" onchange="populate_county(this)"', 'value', 'text', $row->region_fedstate);		
		$lists['counties'] = JHTML::_('select.genericlist',  $counties, 'region_county', 'class="inputbox" size="1"', 'value', 'text', $row->region_county);
		$lists['countries'] = JHTML::_('select.genericlist',  $countries, 'region_country', 'class="inputbox" size="1" onchange="populate_fedstates(this)"', 'value', 'text', $row->region_country);				
		}
	HTML_classifieds::editAddress($row, $lists, $option);
}

  function saveAddress($task)
	{
	  global $mainframe, $option;
	  $ks_help = new KissHelper();
	  $today = date("Y-m-d");
	  $row =& JTable::getInstance('addresses', 'Table');
	  $conf=& JTable::getInstance('config', 'Table');
	  $conf->load(1);
	  $rawdata = JRequest::get('post');
	  // Replace commas with decimal points
	  $data = str_replace(",", ".", $rawdata);
	  
	      if (!$row->bind($data)) {
		      die ($row->getError());
		  }
	      $row->companyname = $ks_help->encrypted($row->companyname);	      
	      $row->street = $ks_help->encrypted($row->street);
	      $row->postcode = $ks_help->encrypted($row->postcode);
	      $row->city = $ks_help->encrypted($row->city);
	      $row->phone = $ks_help->encrypted($row->phone);
	      $row->personname = $ks_help->encrypted($row->personname);
	      $row->email = $ks_help->encrypted($row->email);
	      $row->website = $ks_help->encrypted($row->website);
      
	      $db =& JFactory::getDBO();
	      if (!$row->store()) {
		      if (!$row->bind($data)) {
		      die ($row->getError());
		      }
	      }

		$msg = JText::_('Address saved');	  
		switch ($task)
		{ 
			case 'saveaddress' :
				$mainframe->redirect('index.php?option=' . $option . '&task=addresses', $msg);
				break;
			case 'applyaddress' :
				$mainframe->redirect('index.php?option=' . $option. '&task=editaddress&cid[]='.$row->id, JText::_('Changes applied'));
				break;
		}

	}	

function run_backup($task)
{
	global $mainframe, $option;
	$db =& JFactory::getDBO();
	$user =& JFactory::getUser();
	$user_id = $user->get( 'id' );
	$conf=& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$version = $conf->version;
    // Get the Language Directory for Terms file
    $lang =& JFactory::getLanguage();
    $langtag = $lang->getTag();

	$today = date("Y-m-d h:i:s");
	$ks_help = new KissHelper();
	
	$btitle = $_POST['title'];
	$bdescription = $_POST['description'];
	$prefix = $db->_table_prefix;
		if (strlen(trim($btitle)) < 1) {	
			$upd1 = 1;
			}
		if (strlen(trim($bdescription)) < 1) {
			$bdescription = JText::_("None");
			$upd = 1;
			}
        
		$query = "INSERT INTO #__ksads_backup 
				(uid, title, description) 
				VALUES 
				('$user_id', '$btitle', '$bdescription')
				";
		$db->setQuery($query);		
		$db->query();
		$bid = $db->insertid();
		if ($upd1) {$btitle = JText::_("Backup")." ".$bid; $upd = 1;}	
		if ($upd == 1) {
			$query = "UPDATE #__ksads_backup SET `title`='$btitle', `description`='$bdescription' WHERE id=$bid";
			$db->setQuery($query);
			$db->query();
			}		
		if ($bid == 1) {
		    $dirname = JPATH_COMPONENT . DS . "backup";
		    } else {
		    $dirname = JPATH_BASE . DS . "backups";
		    }

		$tabellen = array($prefix.'ksads_config', $prefix.'ksads_cats', $prefix.'ksads_ads', 
						  $prefix.'ksads_complaints', $prefix.'ksads_files', $prefix.'ksads_fields', 
						  $prefix.'ksads_customers', $prefix.'ksads_customeraccounts', $prefix.'ksads_models', 
						  $prefix.'ksads_usernotify', $prefix.'ksads_backup', $prefix.'ksads_votes', 
						  $prefix.'ksads_selectitems', $prefix.'ksads_extensions', $prefix.'ksads_addresses'
						  );
		$ausgabe = '<?php'."\r\n";
		for ($i=0; $i < count($tabellen); $i++) {
            $ausgabe .= '$db->setQuery("TRUNCATE TABLE `'.$tabellen[$i].'`") ;$db->query();'."\r\n";
            }
		foreach($tabellen as $tabelle){			
			$query = "SELECT `id` FROM ". $tabelle;
			$db->setQuery($query);
			$xids = $db->loadObjectList();

			foreach($xids as $xid){
				switch($tabelle){
					case $prefix.'ksads_cats':
						$object =& JTable::getInstance('category', 'Table');
					break;
					case $prefix.'ksads_config':
						$object =& JTable::getInstance('config', 'Table');
					break;
					case $prefix.'ksads_ads':
						$object =& JTable::getInstance('classified', 'Table');
					break;
					case $prefix.'ksads_files':
						$object =& JTable::getInstance('files', 'Table');
					break;
					case $prefix.'ksads_fields':
						$object =& JTable::getInstance('fields', 'Table');
					break;
					case $prefix.'ksads_complaints':
						$object =& JTable::getInstance('complaints', 'Table');
					break;
					case $prefix.'ksads_backup':
						$object =& JTable::getInstance('backup', 'Table');
					break;
					case $prefix.'ksads_customers':
						$object =& JTable::getInstance('customers', 'Table');
					break;
					case $prefix.'ksads_customeraccounts':
						$object =& JTable::getInstance('customeraccounts', 'Table');
					break;
					case $prefix.'ksads_models':
						$object =& JTable::getInstance('models', 'Table');
					break;
					case $prefix.'ksads_usernotify':
						$object =& JTable::getInstance('usernotify', 'Table');
					break;
					case $prefix.'ksads_votes':
						$object =& JTable::getInstance('votes', 'Table');
					break;
					case $prefix.'ksads_selectitems':
						$object =& JTable::getInstance('selectitems', 'Table');
					break;
					case $prefix.'ksads_extensions':
						$object =& JTable::getInstance('extensions', 'Table');
					break;
					case $prefix.'ksads_addresses':
						$object =& JTable::getInstance('addresses', 'Table');
					break;
					/* Not needed as long as regional information is not user-alterable
					case $prefix.'ksads_reg_countries':
						$object =& JTable::getInstance('countries', 'Table');
					break;
					case $prefix.'ksads_reg_fedstates':
						$object =& JTable::getInstance('fedstates', 'Table');
					break;
					case $prefix.'ksads_reg_counties':
						$object =& JTable::getInstance('counties', 'Table');
					break;
					*/
				}
                
				$object->load($xid->id);

				$sql = '$db->setQuery("INSERT INTO '.$tabelle.' ( %s ) VALUES ( %s );"); $db->query();$i++; '."\r\n";
				$fields = array();
				$values = array();
				foreach (get_object_vars( $object ) as $k => $v) {
					if (is_array($v) or is_object($v) or $v === NULL) {
						continue;
					}
					if ($k[0] == '_') {
						continue;
					}
					$fields[] = $db->NameQuote( $k );
					$values[] = $db->Quote( $v );
				}
				$ausgabe .= sprintf( $sql, implode( ",", $fields ) ,  implode( ",", $values ) );
			}
		}

		// Backup extension tables
		$extension_tables = "";
		$query = "SELECT * FROM #__ksads_extensions";
		$db->setQuery($query);
		if ($trows = $db->loadObjectList()) {
			foreach ($trows as $trow) {
				$extmod = loadExtension($trow->id);
				$extprf = $extmod->extension_prefix."_id";
				$exttbl = $extmod->extension_table;
				$extnam = $extmod->classname;
				$ausgabe .= '$db->setQuery("TRUNCATE TABLE `'.$prefix.'ksads_'.$exttbl.'`") ;$db->query();'."\r\n";				
				$query = "SELECT `$extprf` FROM ".$prefix."ksads_$exttbl";
				$db->setQuery($query);
				$xtids = $db->loadObjectList();
				foreach($xtids as $xtid){
					$object =& JTable::getInstance($extnam, 'Table');
					// Set primary key field
					$object->_tbl_key = $extprf;
					$object->load($xtid->$extprf);
					$sql = '$db->setQuery("INSERT INTO '.$prefix.'ksads_'.$exttbl.' ( %s ) VALUES ( %s );"); $db->query();$i++; '."\r\n";
					$fields = array();
					$values = array();
					foreach (get_object_vars( $object ) as $k => $v) {
						if (is_array($v) or is_object($v) or $v === NULL) {
							continue;
						}
						if ($k[0] == '_') {
							continue;
						}
						$fields[] = $db->NameQuote( $k );
						$values[] = $db->Quote( $v );
					}
					$ausgabe .= sprintf( $sql, implode( ",", $fields ) ,  implode( ",", $values ) );
					}
				} 
			}
		
		$ausgabe .= "\r\n?>";

		$filename = $dirname . DS . "backup_" . $bid . ".sql";
		$msg = JText::_('Backup done');	
		@chmod($dirname, 0755);

		// Make sure that backup directory is writable
		if (is_writable($dirname)) {
			if (!$handle = fopen($filename, "w")) {
				$msg = $filename. ": ".JText::_('File could not be opened');
			}
			// Write into file
			if (!fwrite($handle, $ausgabe)) {
				$msg = $filename. ": ".JText::_('File could not be written');
			}
			fclose($handle);
			
		// Backup .CSS, payment and terms file 
			$source = JPATH_COMPONENT . DS . "assets" . DS . "css" . DS . "ksadvertiser.css";	
			$dest = $dirname . DS . "ksadvertiser_" . $bid . ".css";
			if(!$ks_help->smartCopy($source, $dest)) {
				$msg .= JText::_('Classifieds')." - " . JText::_('Cannot write to file')."  ";
				$msg .= "Source = $source, Dest = $dest";
				}		
			$source = JPATH_ROOT . DS . "components" . DS . "com_ksadvertiser" . DS . $langtag.".terms.php";	
			$dest = $dirname . DS . $langtag.".terms_" . $bid . ".php";
			if(!$ks_help->smartCopy($source, $dest)) {
				$msg .= JText::_('Classifieds')." - " . JText::_('Cannot write to file')."  ";
				$msg .= "Source = $source, Dest = $dest";
				}
				
		// Search for payment modules
			$pmfolder = JPATH_ROOT.DS."components".DS."com_ksadvertiser".DS."payment";
			if (JFolder::exists($pmfolder)) {
				$farr = JFolder::files($pmfolder);
				foreach ($farr as $payfile) {
					if (strpos($payfile, ".cfg.")) {
					$source = JPATH_ROOT . DS . "components" . DS . "com_ksadvertiser" . DS . "payment" .DS. $payfile;	
					$dest = $dirname . DS . "payment_" . $bid . "_" . $payfile;
					if(!$ks_help->smartCopy($source, $dest)) {
						$msg .= JText::_('Payment System')." - " . JText::_('Cannot write to file')."  ";
						$msg .= "Source = $source, Dest = $dest";
						}
					} // End if strpos ...
				} // end foreach farr as payfile...
			} // end if JFolder::exists...

		} else {
			$msg = $dirname. ": ".JText::_('Directory unwriteable');
			$query = "DELETE FROM #__ksads_backup WHERE id=$bid";
			$db->setQuery($query);
			$db->query();
		}
		
		if ($_POST['cbd']) {
			// This code applies only if file should be downloaded
			header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
			header ("Last-Modified: " . gmdate("D,d M Y H:i:s") . " GMT");
			header ("Cache-Control: no-store, no-cache, must-revalidate");
			header ('Cache-Control: post-check=0, pre-check=0', false );
			header ("Pragma: no-cache");
			header ("Content-type: text/plain");
			header ('Content-Disposition: attachment; filename="'.$filename.'"' );
			print $ausgabe;
			}

	$mainframe->redirect( 'index.php?option=com_ksadvertiser', $msg);
}

function run_restore($row)
{
	global $mainframe, $option;
	$db = &JFactory::getDBO();
	$user =& JFactory::getUser();
	$user_id = $user->get( 'id' );
	$usermail = $user->get( 'email' );
	$ks_help = new KissHelper();
	$conf=& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$version = $conf->version;
	$license = $conf->license;
	$currency = $conf->currency;	
	$img_dir = $conf->ad_img_dir;
	$today = date("Y-m-d H:i:s");
	$today_short = date("Y-m-d");
	$expsamp = date("Y-m-d", strtotime("$today_short + 60 days"));	
	// Get the Language Directory for Terms file
	$lang =& JFactory::getLanguage();
	$langtag = $lang->getTag();
	$foldermode = "0" . $conf->upl_rights;
	$filemode = "0" . $conf->upl_rights;				

	if ($row->id == 1) {
	    $dirname = JPATH_COMPONENT . DS . "backup";
		$backcount = 1;						
	    } else {
	    $dirname = JPATH_BASE . DS . "backups";
		$backcount = $row->id;
	    }

	$filename = $dirname . DS . "backup_" . $backcount . ".sql";

	// If sample data must be installed, try to install appropriate language
	if ($row->id == 1) {
		$filename = $dirname . DS . $langtag . ".backup_" . $backcount . ".sql";
		if (!file_exists($filename)){
			// language does not exist, fall back into English
			$filename = $dirname . DS . "en-GB.backup_" . $backcount . ".sql";			
			}
		}
        // write values into db tables
	if (file_exists($filename)) {
	    require_once($filename);
		//Restore some important config data to their proper values
			$query = "UPDATE #__ksads_config SET 
					`version` = " . $db->Quote( $db->getEscaped( $version, true ), false ) .", "
					."`license` = " . $db->Quote( $db->getEscaped( $license, true ), false ) .", "
					."`ad_img_dir` = " . $db->Quote( $db->getEscaped( $img_dir, true ), false ) .", "	
					."`currency` = " . $db->Quote( $db->getEscaped( $currency, true ), false )
					." WHERE id = 1";
			$db->setQuery($query);
			$db->query();

			$query = "UPDATE #__ksads_backup SET `date_restored`='".$today."' WHERE id=".$row->id;
			$db->setQuery($query);
			$db->query();
			$msg = JText::_('Backup Lastrestore')." - ".JText::_('Backup Done');	
			
		//Handle special backup case: Sample Data. In this case ID is always = 1, User is admin, Create Date is today, Expiry day is today + 60 days
		if ($row->id == 1) {
			$query = "UPDATE #__ksads_ads SET 
					`user_id` = " . $db->Quote( $db->getEscaped( $user_id, true ), false ) .", "
					."`contact_email` = " . $db->Quote( $db->getEscaped( $usermail, true ), false ).", "
					."`date_created` = '".$today_short."', "
					."`date_expiry`= '".$expsamp."'"					
					." WHERE id > 0";
			$db->setQuery($query);
			$db->query();
			$msg = JText::_('Install Sample Data')." - ".JText::_('Backup Done');			
			// Copy sample images into default image directory
			$source = JPATH_BASE. DS . "components". DS ."com_ksadvertiser". DS ."assets". DS . "images". DS . "samples". DS . "U62";
			$dest = JPATH_ROOT. DS . "images". DS . "ksadvertiser". DS . "U" .$user_id ;

			if (is_dir($img_dir)) {
				// Try to set the rights to 755!
				@chmod($img_dir, 0755);
				if (JPath::canChmod($img_dir)) {
					JPath::setPermissions($img_dir, $filemode, $foldermode);					
					}	
				} else {
				@mkdir ($img_dir, 0755);
				if (JPath::canChmod($img_dir)) {
					JPath::setPermissions($img_dir, $filemode, $foldermode);					
					}	
				}
			
			if(!$ks_help->smartCopy($source, $dest)) {
				$msg .= JText::_('Classifieds').": " . JText::_('Image could not be copied')."  ";
				$msg .= "Source = $source, Dest = $dest";
				}		
			// Restore CSS, payment and terms File
			$source = $dirname . DS . "ksadvertiser_".$row->id.".css";				
			$dest = JPATH_BASE . DS . "components". DS ."com_ksadvertiser". DS ."assets". DS . "css" . DS . "ksadvertiser.css";
			if(!$ks_help->smartCopy($source, $dest)) {
				$msg .= JText::_('Cannot write to file')." ".$dest."<br />";
				}
			}
			$source = $dirname . DS . $langtag.".terms_".$row->id.".php";
			$dest = JPATH_ROOT . DS . "components". DS ."com_ksadvertiser". DS . $langtag. ".terms.php";
			if(!$ks_help->smartCopy($source, $dest)) {
				$msg .= JText::_('Classifieds')." - " . JText::_('Cannot write to file')."  "."<br />";
				$msg .= "Source = $source, Dest = $dest"."<br />";
				}

			$farr = JFolder::files($dirname, "payment");
			foreach ($farr as $payfile) {
			$destfile = str_replace("payment_".$row->id."_", "", $payfile);
			$source = $dirname . DS . $payfile;
			$dest = JPATH_ROOT . DS . "components". DS ."com_ksadvertiser". DS . "payment". DS . $destfile;
			if(!$ks_help->smartCopy($source, $dest)) {
				$msg .= JText::_('Classifieds')." - " . JText::_('Cannot write to file')."  "."<br />";
				$msg .= "Source = $source, Dest = $dest"."<br />";
				}
			} // end foreach

			//Handle special restore case: Additional fields. Could be lesser fields from former backups
			$query = "SELECT * FROM `#__ksads_fields` WHERE id = 20"; 
			$db->setQuery($query);
			if (!$field=$db->loadObject()) {
				$query = "INSERT INTO `#__ksads_fields` (`id`, `fieldname`, `fieldtitle`, `mandatory`) VALUES
						(20, 'link_uri', 'Deeplink Uri', 0);"; 
				$db->setQuery($query);
				$db->query();
				}
			$query = "SELECT * FROM `#__ksads_fields` WHERE id = 21"; 
			$db->setQuery($query);
			if (!$field=$db->loadObject()) {		
				$query = "INSERT INTO `#__ksads_fields` (`id`, `fieldname`, `fieldtitle`, `mandatory`) VALUES
						(21, 'region_country', 'Regional Information', 0);";
				$db->setQuery($query);
				$db->query();
				}
			$query = "SELECT * FROM `#__ksads_selectitems` WHERE name = 'country'"; 
			$db->setQuery($query);
			if (!$selitems=$db->loadObjectList()) {
				$query = "INSERT INTO `#__ksads_selectitems` (`sid`, `name`, `ressource`, `published`) VALUES
						(0, 'country', 'Select Country', 1),
						(1, 'country', 'Germany', 1),
						(2, 'country', 'Austria', 0),
						(3, 'country', 'Switzerland', 0),
						(4, 'country', 'USA', 0),
						(5, 'country', 'England', 0),						
						(6, 'country', 'Brazil', 0),						
						(7, 'country', 'Netherlands', 0),						
						(8, 'country', 'Canada', 0),												
						(9, 'country', 'Australia', 0),						
						(10, 'country', 'Ireland', 0),
						(11, 'country', 'Spain', 0);
						";
				$db->setQuery($query);
				$db->query();
				}	
				
	    } else {
	    $msg = $filename.": ".JText::_('Backup file does not exist');
	    }
	$mainframe->redirect( 'index.php?option=com_ksadvertiser', $msg);
}

function pruneclassified()
{
	global $mainframe;
	$db =& JFactory::getDBO();
	$user =& JFactory::getUser();
	$user_id = $user->get( 'id' );
	$live_site = & JURI::root();

	$conf=& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$today = date("Y-m-d");
	$latestdate = date("Y-m-d", strtotime("$today - ".$conf->prune." days"));	
	$query = "SELECT p.id as adid, user_id as userid, date_created as creation, date_expiry as expiration, prolonged as prolongation, ad_image as adimage, expiry_deactivate 
		  FROM #__ksads_ads AS p 
		  LEFT JOIN #__ksads_cats as c ON c.id = p.catid 
		  WHERE date_created < '" . $today . "' AND c.expiry = 0 AND expiry_deactivate = 0";
	$db->setQuery($query);
	if ($rows = $db->loadObjectList()) {
	$pruned = 0;
	foreach ($rows as $row) {
		$candelete = 1;
		// First make sure that user still exists
		if ($row->userid) {
		    $query = "SELECT * FROM #__users WHERE id ='$row->userid'";
		    $db->setQuery($query);
		    if (!$ad_user = $db->loadObject()) {
			// User does no longer exist. Delete user's customer account, notifications, image dir and ads!
			  $query = "DELETE FROM #__ksads_customers WHERE uid ='$row->userid'";
			  $db->setQuery($query);
			  $db->query();
			  $query = "DELETE FROM #__ksads_ads WHERE user_id ='$row->userid'";
			  $db->setQuery($query);
			  $db->query();
			  $query = "DELETE FROM #__ksads_files WHERE id = ".$row->adid;  
			  $db->setQuery($query);
			  $db->query();
			  $query = "DELETE FROM #__ksads_usernotify WHERE uid = ".$row->adid;		
			  $db->setQuery($query);
			  $db->query();
			  // Delete ad images from user's image directory
			  $imagepath = JPATH_ROOT.DS."images".DS.$conf->ad_img_dir.DS."U".$row->userid;
			  if (JFolder::exists($imagepath)) {
			      JFolder::delete($imagepath);
			  }
			} // End if (!ad_user ...)
		    } // End if ($row->user_id)

		// Retrieve the user's ads plan. We cannot use the function getModelforUser here
		// because the function performs a downgrade of the user if model has expired
		$query = "SELECT * FROM #__ksads_customers WHERE uid ='$row->userid'";
		$db->setQuery($query);
		if (!$customer = $db->loadObject()) {
			$model_id = 1;
			$customer_id = 0;
			} else {
			// Customer exists. Get Model and check whether customer is activated. If not, use standard model
			$model_id = $customer->mid;
			$customer_id = $customer->id;
			if ($customer->published == 0) {
				$model_id = 1;
				}
			}
		$query = "SELECT * FROM #__ksads_models WHERE id ='$model_id'";
		$db->setQuery($query);
		if (!$model = $db->loadObject()) {
			$query = "SELECT * FROM #__ksads_models WHERE id ='1'";
			$db->setQuery($query);
			$model = $db->loadObject();
			}
		$link0 = $live_site.DS."index.php?option=com_ksadvertiser";
		$prld = ($row->prolongation + 1) * $model->expiry;
		$cred = $row->creation;
		$expdate = date("Y-m-d", strtotime("$cred + $prld days"));
		$paymt = ($model->id == 1) ? 0 : $model->payment;
		// Delete user notifications for ads
		$query = "DELETE FROM #__ksads_usernotify WHERE `expiry` <= '".$today."' AND `mid`=".$model->id;		
		$db->setQuery($query);
		$db->query();
		switch ($paymt) {
			case 0:
			default:
			// Free Ad, notify contact about prolongation if possible, otherwise delete
			if ($row->prolongation <= $model->prolong) {
				$prol=$row->prolongation + 1;
				$query = "UPDATE #__ksads_ads SET `prolonged`= '".$prol."', `date_expiry`= '".$expdate."' WHERE `id`='".$row->adid."'";
			    $db->setQuery($query);  
			    if (!$db->query()) {
				$err_msg = $db->getErrorMsg();
				} else {
				// Ad has expired. Do not delete. Unpublish ad and notify contact for prolongation
				$candelete = 0;
				// Ad has expired since latest period and was not prolonged. Now delete anyway!
				if ($expdate < $latestdate) {
					$candelete = 1;
					} else {
				$query = "UPDATE #__ksads_ads SET `published`= 0 WHERE `id`=".$row->adid;
				$db->setQuery($query);    
				if (!$db->query()) {
				    $err_msg = $db->getErrorMsg();
				    }
				    $link=$link0."&task=prolongation&id=".$row->adid;
				    $sent = _sendProlongationMail($row->adid, $model->prolong, $link);
				   }
				  }
				} else {
				  $candelete = 1;
				  $deleted = _sendDeletionMail($row->adid, $model->prolong);
				  $pruned ++;
				}
			break;
			case 1:
			$views = $model->views;
			if ($row->views > $views) {
			    // Ad has expired. Do not delete. Unpublish ad and notify contact for prolongation
			    $candelete = 0;
			    $query = "UPDATE #__ksads_ads SET `published`= 0 WHERE `id`=".$row->adid;
			    $db->setQuery($query);    
			    if (!$db->query()) {
				$err_msg = $db->getErrorMsg();
				} else {
				$pruned++;
				}
				// Ad has expired since latest period and was not prolonged. Now delete anyway!
				if ($expdate < $latestdate) {
					$candelete = 1;
					} else {
					// Notify Contact about prolongation
					$link=$link0."&task=prolongation&id=".$row->adid;
					$sent = _sendProlongationMail($row->adid, $model->prolong, $link);
					}
			   } else {
			    $candelete = 0;
			   }
			break;
			case 2:
			$exp = $model->expiry;
			if ($row->expiration < $today) {
			    // Ad has expired. Do not delete. Unpublish ad and notify contact for prolongation
			    $candelete = 0;
			    $query = "UPDATE #__ksads_ads set `published`= 0 WHERE `id`=".$row->adid;
			    $db->setQuery($query);    
			    if (!$db->query())
				{
				$err_msg = $db->getErrorMsg();
				} else {
				$pruned++;
				}
				// Ad has expired since latest period and was not prolonged. Now delete anyway!
				if ($expdate < $latestdate) {
					$candelete = 1;
					} else {
					// Notify Contact about prolongation
					$link=$link0."&task=prolongation&id=".$row->adid;
					$sent = _sendProlongationMail($row->adid, $model->prolong, $link);
					}
				} else {
			    $candelete = 0;
			   }
			break;

			// Were done, NOW DELETE ADS AND IMAGES
			if ($candelete == 1) {
			    // First delete ad images from image directory
			    $imagefile = basename($row->adimage);
			    $imagepath = JPATH_ROOT.DS."images".$conf->ad_img_dir.DS."U".$row->userid.DS.$image_file;
			    if (file_exists($imagepath)) {
					unlink($imagepath);
					}
				// Are there more images? If so, delete them
			    $query = "SELECT * FROM #__ksads_files WHERE id = ".$row->adid;  
			    $db->setQuery($query);
			    if (!$rows = $db->loadObjectList()) {
					foreach($rows as $row3) {
							$imagefile = basename($row3->file);
							$imagepath = JPATH_ROOT.DS."images".DS.$conf->ad_img_dir.DS."U".$row->user_id.DS.$image_file;
							if (file_exists($imagepath)) {
							unlink($imagepath);
							} // End if file exists ...
						} // End foreach $rows as $row3
					} // End if $rows = $db-> ...
				$query = "DELETE FROM #__ksads_files WHERE id = ".$row->adid;  
				$db->setQuery($query);
				$db->query();
				
			    $query = "DELETE FROM #__ksads_ads WHERE id = ".$row->adid;  
			    $db->setQuery($query);
			    if ($db->query()) {
					$pruned++;
					} else {
					$err_msg = $db->getErrorMsg();
					} // End if !db->query()
			    } // End if $candelete == 1
			} // End switch $row2['payment'] ... 
		} // End foreach ($rows as $row) ...
	 } // End if ($rows-> ...) 
	//Prune customers who have not paid within a period of 14 days
	$today = date("Y-m-d", mktime(date('H'), date('i'), date('s'), date('m'), (date('d')-14), date('y')));
	$query = "DELETE FROM #__ksads_customers WHERE date_created < '" . $today . "' AND balance > 0 AND published = 0";
	$db->setQuery($query);
	$db->query();

	// Delete all empty image directories to avoid data garbage ...
	$imagepath = JPATH_ROOT.DS."images".DS.$conf->ad_img_dir.DS;
	if ($dir_array = JFolder::folders($imagepath)) {
	    foreach($dir_array as $dir) {
		    $imagepath = JPATH_ROOT.DS."images".DS.$conf->ad_img_dir.DS.$dir;
		    if (!JFolder::files($imagepath)) {
			JFolder::delete($imagepath);
			}
		    }
	    } // end if ($dir_array...)

	if($err_msg) {
	     $msg = $err_msg; 
	   } else { 
	     $msg = sprintf(JText::_('Adverts Pruned'), $pruned);
	   } 
	$mainframe->redirect( 'index.php?option=com_ksadvertiser', $msg);
	}

function editClassified()
{
	global $option;
	$live_site = &JURI::base();
	$db	=& JFactory::getDBO();
	$user =& JFactory::getUser();
	$user_id = $user->get( 'id' );	
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);		
	$cur = $conf->currency;
	$query = "SELECT * FROM #__ksads_currencies WHERE id = $cur";
	$db->setQuery($query);
	$curr = $db->loadObject();
	$today = date("Y-m-d");		
	// Load basic info from table
	$adv =& JTable::getInstance('classified', 'Table');
	$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
	$id = $cid[0];
	$adv->load($id);
	$catno=$adv->catid;
	$query = "SELECT * FROM #__ksads_cats WHERE id = $catno";
	$db->setQuery($query);
	$categ = $db->loadObject();
	$row = $adv;
	$uid = ($row->user_id == NULL || $row->user_id == "") ? $user_id: $row->user_id;
	$lists = array();
	$model=getModelforUser($uid);
	$prld = ($row->prolonged+1)*$model->expiry;
	if (strlen($row->date_created) < 8) {
		$row->date_created = $today;
		}
	$row->date_expiry = date("Y-m-d", strtotime("$row->date_created + $prld days"));
	$ks_help = new KissHelper();
	$currency = $curr->currency_code;
	$ad_delivery = $ks_help->selectitems('delivery', 1);
	$ad_state = $ks_help->selectitems('adstate', 1);
	$ad_prov = $ks_help->selectitems('videoprovider', 1);	
	$adshow = $ks_help->boolean();
	$ad_articles = $ks_help->articles();
	$fedstates = $ks_help->fedstates($conf->show_regionalinfo);	
	$counties = $ks_help->counties($conf->show_regionalinfo, $row->region_fedstate);
	$countries = $ks_help->selectitems('country', 1);	
	$userimgwarn = JText::_('Userimagewarn');
	// ---------Load Classified and Extension -----------------------------
	if (isset ($categ) && hasExtension($categ->extension)) {
	    $extmod = loadExtension($categ->extension);
		$extprf = $extmod->extension_prefix."_";
		$query = "SELECT * FROM #__ksads_ads AS a 
				LEFT JOIN #__ksads_$extmod->extension_table AS e ON ( e.".$extprf."adid = a.id )			
				WHERE a.id = $id
			";
		$db->setQuery($query);
		$db->query();
		$row = $db->loadObject();
		// Load Help Lists for the extension
		$lists = $extmod->fetchlists($row);
		}	
	// ------------- End Load Classified and Extension -------------------
	$lists['ad_state'] = JHTML::_('select.genericList', $ad_state, 'ad_state', 'class="inputbox"', 'value', 'text', $row->ad_state );
	$lists['ad_delivery'] = JHTML::_('select.genericList', $ad_delivery, 'ad_delivery', 'class="inputbox"', 'value', 'text', $row->ad_delivery );	
	$lists['vprovider'] = JHTML::_('select.genericList', $ad_prov, 'ad_vid_prov', 'class="inputbox" onclick="javascript:toggle_videodiv();"', 'value', 'text', $row->ad_vid_prov );		
	$lists['articles'] = JHTML::_('select.genericList', $ad_articles, 'article_id', 'class="inputbox"', 'value', 'text', $row->article_id );
	$lists['published'] = JHTML::_('select.booleanlist', 'published', 'class="inputbox"', $row->published);
	$lists['paid'] = JHTML::_('select.booleanlist', 'ad_paid', 'class="inputbox"', $row->ad_paid);
	$lists['showaddress'] = JHTML::_('select.booleanlist', 'show_address', 'class="inputbox"', $row->show_address);	
	$lists['boxnumber'] = JHTML::_('select.booleanlist', 'ad_boxnumber', 'class="inputbox"', $row->ad_boxnumber);	
	$lists['users'] = $ks_help->showUserSelect($uid, 'user_id', "javascript: alert('$userimgwarn');");
	$lists['commercial'] = JHTML::_('select.booleanlist', 'ad_commercial', 'class="inputbox"', $row->ad_commercial);	
	$lists['showinmod'] = JHTML::_('select.booleanlist', 'showinmodule', 'class="inputbox"', $row->showinmodule);
	$lists['watermark'] = JHTML::_('select.booleanlist', 'watermark', 'class="inputbox"', $row->watermark);	
	if ($conf->show_regionalinfo) {
		$lists['fedstates'] = JHTML::_('select.genericlist',  $fedstates, 'region_fedstate', 'class="inputbox" size="1" onchange="populate_county(this)"', 'value', 'text', $row->region_fedstate);		
		$lists['counties'] = JHTML::_('select.genericlist',  $counties, 'region_county', 'class="inputbox" size="1"', 'value', 'text', $row->region_county);
		$lists['countries'] = JHTML::_('select.genericlist',  $countries, 'region_country', 'class="inputbox" size="1" onchange="populate_fedstates(this)"', 'value', 'text', $row->region_country);				
		}
	HTML_classifieds::editClassified($row, $lists, $option, $currency);
}

function saveClassified($task)
{
	global $mainframe, $option;
	$db =& JFactory::getDBO();
	$user =& JFactory::getUser();
	$live_site =& JURI::base();	
	$user_id = $user->get( 'id' );
	$ks_help = new KissHelper();
	$conf=& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$row =& JTable::getInstance('classified', 'Table');
	$today = date("Y-m-d");	
	// Random ad code
	$adcode = mt_rand(1000, 9999);
	$task_redir = $task;
	
	// Try to geocode address
	$locat = JRequest::getVar( 'ad_address', '', 'post', 'string').", ".JRequest::getVar( 'ad_post', '', 'post', 'string')." ".JRequest::getVar( 'ad_location', '', 'post', 'string');	
	if ($gplugin =& JPluginHelper::getPlugin('system', 'plugin_googlemap2')) { 
	    $gplugin_params = new JParameter( $gplugin->params );
	    $gwebsite = $gplugin_params->get( 'googlewebsite', 'maps.google.com' );
	    $key = trim($gplugin_params->get( 'Google_API_key', '' ));
	    $iso = "UTF-8";
	    $geodata = get_geo($gwebsite, $locat, $iso, $key);
	    $coords = explode(",", $geodata['coords'][0]);
	    $longitude = $coords[0];
	    $latitude = $coords[1];
	    $street = $geodata['street'][0];
	    $city = $geodata['city'][0];
	    $zip = $geodata['zip'][0];
	    $country = $geodata['country'][0];
	    $county = $geodata['county'][0];
	    $state = $geodata['state'][0];
	    $suburb = $geodata['suburb'][0];
	    // Adjust Address and City if function is set
	    if ($conf->check_address_geocode) {
		if (strlen($city) && strlen($zip)) {
			    if (strlen($suburb) && strtolower($city) != strtolower($suburb)){
				    $city .= "-".$suburb;
				    }
			    JRequest::setVar('ad_post', $zip);
			    JRequest::setVar('ad_location', $city);
			    }
		if (strlen($street)) {
		    JRequest::setVar('ad_address', $street);		
		    }
		} // End if ($conf->check_...)
	    }
		if ($conf->show_regionalinfo && $row->region_country == 0) {
			$row->region_country = $conf->regionalsearch;
			}		
	if (!$row->bind(JRequest::get('post'))) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
		}

	if ($row->id) {
	    $adid = sprintf("%'14d%'04d%'04d",$adcode, $row->user_id, $row->id);
	    if (strlen($row->ad_ident != 12)) { 
		$row->ad_ident = $adid;
		}
	    }
		
	// Get the user's model information		
	$uid = ($row->user_id) ? $row->user_id : 0;
	$model=getModelforUser($uid);
	$img_dir = getImageDirforUser($uid, 0);	
	
	// Additional options
	$optnew = isset($_POST['cbon']) ? 1 : 0 ;
	$optcol = isset($_POST['cboc'])? 1 : 0 ;
	$optbld = isset($_POST['cbob']) ? 1 : 0 ;
	$optnew1 = isset($_POST['cbo2']) ? 1 : 0 ;
	$optcol1 = isset($_POST['cbo3'])? 1 : 0 ;
	$optbld1 = isset($_POST['cbo1']) ? 1 : 0 ;
	$now = date("Y-m-d H:i:s");
	$debit = 0;
	$credit = 0;
	// Options were changed, try to update customer account
	$query1 = "UPDATE #__ksads_customeraccounts SET ca_paydate = '$now'";
	if ($row->opt_bold_paid != $optbld1) {
		$paydescription = JText::_('Ad Ident')." ".$row->ad_ident.", ".JText::_('Option Bold Title');
		if ($optbld1) {
			$debit = $debit + $model->opt_bold_price;
			$query = $query1 . ", ca_payment = $model->opt_bold_price";
			} else {
			$credit = $credit - $model->opt_bold_price;
			$query = $query1 . ", ca_credit = ".($model->opt_bold_price * -1);			
			}
		$query .=" WHERE ca_aid = $row->id AND ca_pid = 1";	
		$db->setQuery($query);
		$db->query();
		}
	if ($row->opt_new_paid != $optnew1) {
		$paydescription = JText::_('Ad Ident')." ".$row->ad_ident.", ".JText::_('Option New');	
		if ($optnew1) {
			$debit = $debit + $model->opt_new_price;
			$query = $query1 . ", ca_payment = $model->opt_new_price";			
			} else {
			$credit = $credit - $model->opt_new_price;
			$query = $query1 . ", ca_credit = ".($model->opt_new_price * -1);						
			}
		$query .=" WHERE ca_aid = $row->id AND ca_pid = 2";	
		$db->setQuery($query);
		$db->query();
		}
	if ($row->opt_color_paid != $optcol1) {
		$paydescription = JText::_('Ad Ident')." ".$row->ad_ident.", ".JText::_('Option Color');	
		if ($optcol1) {
			$debit = $debit + $model->opt_color_price;
			$query = $query1 . ", ca_payment = $model->opt_color_price";						
			} else {
			$credit = $credit - $model->opt_color_price;
			$query = $query1 . ", ca_credit = ".($model->opt_color_price * -1);						
			}
		$query .=" WHERE ca_aid = $row->id AND ca_pid = 3";	
		$db->setQuery($query);
		$db->query();
		}
		
	if ($row->ad_paid) {
		$query = $query1 . ", ca_payment = $model->price WHERE ca_aid = $row->id AND ca_pid = 0";		
		$db->setQuery($query);
		$db->query();
		}
	
	$row->opt_bold = $optbld;
	$row->opt_color = $optcol;
	$row->opt_new = $optnew;
	$row->opt_bold_paid = $optbld1;
	$row->opt_color_paid = $optcol1;
	$row->opt_new_paid = $optnew1;
		
	// If ads in this category not allowed, set catid = 0 and throw error msg
	$query = "SELECT * FROM #__ksads_cats WHERE id =".$row->catid;
	$db->setQuery($query);
	$categ = $db->loadObject();
	if (!$categ->showads) {
	    $msg_err = " - ".sprintf(JText::_('Category not allowed'), $categ->cat_name); 
	    }
	$row->expiry_deactivate = $categ->expiry;
	$row->ad_image = basename(JRequest::getVar( 'ad_image', '', 'post', 'string', JREQUEST_ALLOWRAW));	
	$row->ad_desc = JRequest::getVar( 'ad_desc', '', 'post', 'string', JREQUEST_ALLOWRAW );
	$row->ad_intro = JRequest::getVar( 'ad_intro', '', 'post', 'string', JREQUEST_ALLOWRAW );
	if ($row->ad_vid_prov == 47) {
		$row->ad_vid_id = JRequest::getVar( 'ad_vid_id_1', '', 'post', 'string', JREQUEST_ALLOWRAW );
		}
	$row->mid = $model->id;
	$row->ad_price = str_replace(",", ".", $row->ad_price);
	if ($row->ad_price_pu < $model->price) {
	    $row->ad_price_pu = $model->price;
	    }
	if ($model->commercial) {
		$row->ad_commercial = 1;
		}
	if ($row->ad_state < 1) {
	    $row->ad_state = 1;
	    }
	if ($categ->restrict_to > 0) {
	    $row->ad_state = $categ->restrict_to;
	    }
	// Convert date to UNIX time
	$phrase = "Y-m-d";
	if (substr($row->date_created , 0 , 4) == "0000" || strlen($row->date_created) < 10) {
		$row->date_created = $today;
		$task = "add";
		} else {
		$row->date_created = date($phrase, strtotime($row->date_created));
		$task = "edit";
		}
	if (strlen($row->ad_name) < 1) {
	    $row->ad_name = JText::_('Date created')." ".date($conf->date_format, strtotime($row->date_created));
	    }

	$prld = ($row->prolonged+1) * $model->expiry;

	if ($model->expiry > 0) {
	    $row->date_expiry = date("Y-m-d", strtotime("$row->date_created + $prld days"));
	    } else {
	    $row->date_expiry = date("Y-m-d", strtotime("$row->date_created + 730 days"));
	    }
	$cnt = bumpAdsLeftforUser($row->user_id, -1);	

	$exp1 = $row->ad_name ."|".$row->contact_name."|".$row->ad_location."|".$row->ad_intro."|".$row->ad_desc;
	$expression = (strlen($exp1) > 255) ? substr($exp1, 0, 254): $exp1;
	$row->phonetic = $ks_help->phonetic($expression);
	if (strlen($latitude) && strlen($longitude)) {
	    $row->latitude = $latitude;
	    $row->longitude = $longitude;
	    }
	if (strlen($row->down_uri)) {
	    $pathinfo = pathinfo($row->down_uri);
	    $row->down_uri = $pathinfo['basename'];
	    if (!strlen($row->down_txt)) {
		$row->down_txt = ucfirst($pathinfo['filename']);
		}
	    }

	// Try to create a thumbnail out of the image if given
	if ($conf->create_thumbnails) {
	    if (file_exists(str_replace(DS.DS, DS, JPATH_ROOT.$img_dir.$row->ad_image))) {
		$thu_dir =  $img_dir."thumbnails".DS;
		createThumbnails($img_dir, $thu_dir, $row->ad_image);
		}
	    }

	if (!$row->store()) {
	      echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
	      exit();
	    } else {
	    $iid = $db->insertid();
	    mt_srand((double)microtime()*1000000);
	    $adid = sprintf("%'14d%'04d%'04d",$adcode, $user_id, $iid);
	    $query = "UPDATE #__ksads_ads set `ad_ident`='$adid' WHERE `id`=".$iid;
	    $db->setQuery($query);
	    $db->query();
		$msg = JText::_('Ads saved')." ".$msg_err;
	    } // End if $row->store ...
		
	if (hasExtension($categ->extension)) {
	    if (JRequest::getInt('id', 0) == 0) {
		JRequest::setVar( 'id', $iid );
		}
	    $extmod = loadExtension($categ->extension);
	    $extmod->addfields_save();
	    }

		switch ($task_redir) { 
			case 'save' :
				$mainframe->redirect('index.php?option=' . $option. '&task=show_classifieds', $msg);
				break;
			case 'apply' :
				$mainframe->redirect('index.php?option=' . $option. '&task=edit&cid[]='.$row->id, JText::_('Changes applied'));
				break;
			}
}

function showClassifieds($option)
{
	global $mainframe;
	$db =& JFactory::getDBO();
	$ks_help = new KissHelper();
	$query = "SELECT count(*) FROM #__ksads_ads";
	$db->setQuery($query);
	$total = $db->loadResult();
	$filter_state 		= $mainframe->getUserStateFromRequest( $option.'filter_state', 'filter_state', '','word' );
	$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order','filter_order','','cmd' );
	$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir','filter_order_Dir','','word' );
	$filter_match		= JRequest::getInt('filter_match', 0);
	$filter_sound		= JRequest::getInt('filter_soundex', 0);
	$catid 			= JRequest::getInt( 'catid', 0 );
	$search 		= $mainframe->getUserStateFromRequest( $option.'search','search','','string' );
	$search 		= JString::strtolower( $search );

	if ($filter_order != 'ad_name' &&
		$filter_order != 'ad_state' &&
		$filter_order != 'contact_name' && 
		$filter_order != 'date_created' && 
		$filter_order != 'date_expiry' && 
		$filter_order != 'a.cat_name' && 
		$filter_order != 'published' && 
		$filter_order != 'z.username' 
		)
	    {
		$filter_order = 'ad_name';
	    }

	/*Added by Gruz { */
	$lists['filter_match']		= $filter_match;
	$lists['search']		= $search;
	$lists['filter_order']		= $filter_order;
	$lists['order_Dir']		= $filter_order_Dir;
	$lists['filter_soundex']	= $filter_sound;
	/*Added by Gruz End } */

	$limit			= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart		= $mainframe->getUserStateFromRequest($option.'.limitstart', 'limitstart', 0, 'int');
	// Set the initial ordering
	if (strlen($filter_order) < 1) {
	    $filter_order = 'ad_name';
	    $filter_order_Dir = 'asc';
	    }
	$where = array();
	$tmp = ' WHERE (ads.id > 0';
	if ( $filter_state ) {
		if ( $filter_state == 'P' ) {
			$tmp .= ' AND ads.published = 1';
		} else if ($filter_state == 'U' ) {
			$tmp .= ' AND ads.published = 0';
		}
	    }
	    
	if ( $catid ) {
	      $tmp .= ' AND catid = '.$catid;
	    }

	$tmp .=")";

	//Try to lower MySQL usage when not needed to use big SELECTS
	$add_search = false;
	if ($search){
		$query ='SELECT ads.*, a.cat_name, z.name FROM #__ksads_ads AS ads '.
				'LEFT JOIN #__ksads_cats AS a '.
				'ON ads.catid = a.id '.
				'LEFT JOIN #__users AS z '.
				'ON ads.user_id = z.id ';
		$add_search = 	true;		
	} else {
		switch ($filter_order) {
			case 'a.cat_name':
				$query ='SELECT ads.*, a.cat_name FROM #__ksads_ads AS ads '.
						'LEFT JOIN #__ksads_cats AS a '.
						'ON ads.catid = a.id ';
				break;
			case 'z.username':
				$query ='SELECT ads.*, z.name FROM #__ksads_ads AS ads '.
						'LEFT JOIN #__users AS z '.
						'ON ads.user_id = z.id ';
				break;

			default:
					$query = 'SELECT * FROM #__ksads_ads AS ads ';
		}
	}
	$query .= $tmp;

	if ($search){
	    $search_arr = explode(" ", $search);
		for ($i=0, $n=count( $search_arr ); $i < $n; $i++)	{
			$srch = $search_arr[$i];

			if ($add_search) {
				$add_search = ' OR (a.cat_name LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'.
						' OR (z.name LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')';
			}

			$where[] = '(ad_name LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'
					 . ' OR (ad_address LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'
					 . ' OR (ad_intro LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'
					 . ' OR (ad_desc LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'
					 . ' OR (ad_location LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'
					 . ' OR (ad_post LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'
					 . ' OR (ad_ident LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'
					 . ' OR (ad_img_comment LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'
					 . ' OR (ad_desc LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')' 		
					 . ' OR (contact_name LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')' 		
					 . ' OR (contact_email LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'
					 . ' OR (meta LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'.$add_search ;
			}
		
			$concat = $filter_match ? " AND " : " OR ";

				//phonetic search overrides other search
				if ($filter_sound) {
				$where2 = array();
				for ($i=0, $n=count( $search_arr ); $i < $n; $i++) {
					$srch = $search_arr[$i];
					$where2[] = '(phonetic LIKE '.$db->Quote( '%'.$db->getEscaped( $ks_help->phonetic($srch), true ).'%', false ).')'; 
					}
					$query .= ( count( $where2 ) > 0 ? "\n AND (" . implode( " OR ", $where2 ).")" : "");
					} else {
					$query .= ( count( $where ) > 0 ? "\n  AND (" . implode(" ) ".$concat . " ( ", $where) .")" : "");				
				}

	}
	$query .= "\nORDER BY ".$filter_order." ".$filter_order_Dir;
	$db->setQuery($query, $limitstart, $limit);
	$rows = $db->loadObjectList();
	if ($db->getErrorNum()) {
		echo $db->stderr();
		return false;
	}
	
	// build category tree listbox
	$query = "SELECT id AS id, pid AS parent, cat_name AS name, showads as active FROM #__ksads_cats ORDER BY ordering";	
	$db->setQuery( $query );
	$cats = $db->loadObjectList();
	$preload = array();
	$catlistbox= $ks_help->treeSelectList( $cats, 0, $preload, 'catid', 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', $catid, 1, "-".JText::_('Select Category')."-", 0 );
	$lists['catid'] = $catlistbox;
	$lists['state']	= JHTML::_('grid.state',  $filter_state );
	$lists['order_Dir']	= $filter_order_Dir;
	$lists['order']		= $filter_order;
	jimport('joomla.html.pagination');
	$pageNav = new JPagination($total, $limitstart, $limit);
	HTML_classifieds::showClassifieds($option, $lists, $rows, $pageNav);
}

function cancelClassifiedEdit()
{

	global $option, $mainframe;
	$mainframe->redirect( 'index.php?option='.$option.'&task=show_classifieds' );
}

function showComplaints($option)
{
	global $option, $mainframe;
	$filter_state		= $mainframe->getUserStateFromRequest( $option.'filter_state',		'filter_state',	'',	'word' );
	$filter_order = $mainframe->getUserStateFromRequest( $option.'filter_order','filter_order','','cmd' );
	$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'asc',	'word' );
	if (	$filter_order != 'ads.ad_name' &&
		$filter_order != 'c.complaint' &&
		$filter_order != 'a.cat_name' && 
		$filter_order != 'ads.ad_state' && 
		$filter_order != 'ads.contact_name' && 
		$filter_order != 'z.username' && 
		$filter_order != 'cdate' && 
		$filter_order != 'ads.date_created' 
		)
	{
		$filter_order = 'cdate';
		$filter_order_Dir = 'desc';
	}

	$limit = JRequest::getVar('limit', $mainframe->getCfg('list_limit'));
	$limitstart = JRequest::getVar('limitstart', 0);
		if (strlen($filter_order) < 1) {
			$filter_order = 'c.adid';
		}
		$order = ' ORDER BY '. $filter_order .' '. $filter_order_Dir .' ';
	$db =& JFactory::getDBO();
	$query = "SELECT count(*) FROM #__ksads_complaints";
	$db->setQuery($query);
	$total = $db->loadResult();
	$query = 'SELECT c.id as cid, c.published, ads.published as publish_ads ,c.complaint as complaint, c.date as cdate, 
	  ads.id, ads.ad_name, ads.ad_state, ads.contact_name, ads.date_created as date_created, z.name, a.cat_name 
	  FROM #__ksads_complaints as c 
	  INNER JOIN #__ksads_ads AS ads ON ads.id = c.adid '.
	  'LEFT JOIN #__ksads_cats AS a ON ads.catid = a.id '.
	  'LEFT JOIN #__users AS z  ON ads.user_id = z.id '.
	  $order;

	$db->setQuery($query, $limitstart, $limit);
	$rows = $db->loadObjectList();
	if ($db->getErrorNum()) {
		echo $db->stderr();
		return false;
	}

	$lists['order_Dir']	= $filter_order_Dir;
	$lists['order']		= $filter_order;
	jimport('joomla.html.pagination');
	$pageNav = new JPagination($total, $limitstart, $limit);
	HTML_classifieds::showComplaints($option, $lists, $rows, $pageNav);
}

function showRestoreOptions($row)
{
	global $option;
	$db	=& JFactory::getDBO();
	$row =& JTable::getInstance('backup', 'Table');
	$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
	$id = $cid[0];
	$row->load($id);
	run_restore($row);
}

function sampleDataOptions($row)
{
	global $option;
	$db	=& JFactory::getDBO();
	$row =& JTable::getInstance('backup', 'Table');
	$id = 1;
	$row->load($id);
	$restored = run_restore($row);
}

function editComplaint($option)
{
	global $mainframe;
	$db	=& JFactory::getDBO();
	$conf=& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$cur = $conf->currency;
	$query = "SELECT * FROM #__ksads_currencies WHERE id = $cur";
	$db->setQuery($query);
	$curr = $db->loadObject();
	$row =& JTable::getInstance('complaints', 'Table');
	$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
	$id = $cid[0];
	$row->load($id);
	$id2 = $row->adid;
	$lists = array();
	$query = 'SELECT * FROM #__ksads_ads WHERE id = '.$id2;
	$limit = JRequest::getVar('limit', $mainframe->getCfg('list_limit'));
	$limitstart = JRequest::getVar('limitstart', 0);
	$db->setQuery($query, $limitstart, $limit);
	$row2 = $db->loadObject();
	$ks_help = new KissHelper();
	$currency = $curr->currency_code;
	$ad_delivery = $ks_help->selectitems('delivery', 1);
	$row2->ad_delivery_name = $ad_delivery[$row2->ad_delivery]['text'];
	$ad_state = $ks_help->selectitems('adstate', 1);
	$adshow = $ks_help->boolean();

	$lists['ad_state'] = JHTML::_('select.genericList', $ad_state, 'ad_state', 'class="inputbox"', 'value', 'text', $row2->ad_state );
	$lists['ad_delivery'] = JHTML::_('select.genericList', $ad_delivery, 'ad_delivery', 'class="inputbox"', 'value', 'text', $row2->ad_delivery );	

	HTML_classifieds::editComplaint($row, $row2, $lists, $option, $currency);
}

function removeComplaints()
{
	global $mainframe, $option;
	$cid = JRequest::getVar('cid', array(), '', 'array' );
	$db =& JFactory::getDBO();
	if(count($cid))
	{
		$cids = implode(',', $cid );
		$query = "DELETE FROM #__ksads_complaints WHERE id IN ($cids)";
		$db->setQuery($query);
		if (!$db->query())
		{
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}
	$msg = count($cid).' '.JText::_('Complaints Removed');
	$mainframe->redirect( 'index.php?option=' . $option.'&task=show_complaints',$msg  );

}

function saveComplaint($task)
{
	global $mainframe, $option;
	$db =& JFactory::getDBO();
	$user =& JFactory::getUser();
	$row =& JTable::getInstance('complaints', 'Table');
	if (!$row->bind(JRequest::get('post')))
	{
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
	      echo "<string> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
	      exit();
	    }
	switch ($task)
	{
		case 'save_complaint' :
			$mainframe->redirect('index.php?option=' . $option . '&task=show_complaints', JText::_('Complaint saved'));
			break;
		case 'apply_complaint' :
			$mainframe->redirect('index.php?option=' . $option . '&task=edit_complaint&cid[]='.$row->id, JText::_('Changes applied'));
			break;
	}

}

function show_backups($option)
{
	global $mainframe;
	$db =& JFactory::getDBO();
	$limit = JRequest::getVar('limit', $mainframe->getCfg('list_limit'));
	$limitstart = JRequest::getVar('limitstart', 0);
	$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',	'',	'cmd' );
	$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'asc',	'word' );
	$lists['order_Dir']	= $filter_order_Dir;
	$lists['order']		= $filter_order;
	$query = "SELECT count(*) FROM #__ksads_backup";
	$db->setQuery($query);
	$total = $db->loadResult();
	$query = 'SELECT * FROM #__ksads_backup';
	$db->setQuery($query);
	$rows = $db->loadObjectList();
	if ($db->getErrorNum()) {
		echo $db->stderr();
		return false;
	}
	jimport('joomla.html.pagination');
	$pageNav = new JPagination($total, $limitstart, $limit);
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);		
	HTML_classifieds::show_backups($option, $rows, $pageNav, $lists, $conf); 

}


function removeClassifieds($option)
{
	global $mainframe;
	$cid1 = JRequest::getVar('cid', array(), '', 'array' );
	$db =& JFactory::getDBO();
	$conf=& JTable::getInstance('config', 'Table');
	$conf->load(1);

	if(count($cid1))
	{
		$cids = implode(',', $cid1 );
		foreach($cid1 as $cid) {
			    // First delete ad images from image directory
			    $query = "SELECT * FROM #__ksads_ads WHERE id = ".$cid;
			    $db->setQuery($query);
			    $row = $db->loadObject();
			    $user_id = $row->user_id;
  
			    $imagefile = basename($row->ad_image);
			    $imagepath = JPATH_ROOT.DS."images".$conf->ad_img_dir.DS."U".$user_id.DS.$image_file;
			    if (file_exists($imagepath)) {
				unlink($imagepath);
				}
				// Are there more images? If so, delete them
			    $query = "SELECT * FROM #__ksads_files WHERE adid = ".$cid;  
			    $db->setQuery($query);
			    if (!$rows = $db->loadObjectList()) {
					foreach($rows as $row3) {
							$imagefile = basename($row3->file);
							$imagepath = JPATH_ROOT.DS."images".$conf->ad_img_dir.DS."U".$user_id.DS.$image_file;
							if (file_exists($imagepath)) {
							unlink($imagepath);
							} // End if file exists ...
						} // End foreach $rows as $row3
					} // End if $rows = $db-> ...
				$query = "DELETE FROM #__ksads_files WHERE adid = ".$row->id;  
				$db->setQuery($query);
				$db->query();

				//Delete all assigned extension data
				$query = "SELECT * FROM #__ksads_extensions";
				$db->setQuery($query);
				$extensions = $db->loadObjectList();
				foreach($extensions as $ext) {
					// Get extension table
					$ext_src = loadExtension($ext->id);
					$ext_tbl = $ext_src->extension_table;
					$ext_pfx = $ext_src->extension_prefix;
					$query = "DELETE FROM #__ksads_$ext_tbl WHERE ".$ext_pfx."_adid = $cid";
					$db->setQuery($query);
					$db->query();  
					}
				$query = "DELETE FROM #__ksads_ads WHERE id = $cid";
				$db->setQuery($query);
				if (!$db->query()) {
					echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
					} else {
					if ($user_id) { $cnt = bumpAdsLeftforUser($user_id, 1); }
					}

			} // End foreach ($cid1 as $cid)
	}
	$mainframe->redirect( 'index.php?option=' . $option.'&task=show_classifieds' );
}

function removeBackups($option)
{
	global $mainframe;
    // Get the Language Directory for Terms file
    $lang =& JFactory::getLanguage();
    $langtag = $lang->getTag();
	
	$db =& JFactory::getDBO();
	$cid = JRequest::getVar('cid', array(), '', 'array' );
	$msg = JText::_('Backup removed');
	$conf=& JTable::getInstance('config', 'Table');
	$conf->load(1);
	// Make sure that sample data cannot be removed
	for ($i=0, $n=count( $cid ); $i < $n; $i++) {
	    if ($cid[0] == 1) {
		$cid[0] = 0;
		$msg .= JText::_('Sample data cannot be removed');
		} else {
		// Remove Backup files from directory
		$dirname = JPATH_BASE . DS . "backups";
		$filename = $dirname . DS . "backup_" . $cid[0] . ".sql";
		if (file_exists($filename)) {
		    @chmod($filename, 0777);
		    unlink ($filename);
		    }
		// Remove CSS files from directory
		$filename = $dirname . DS . "ksadvertiser_" . $cid[0] . ".css";
		if (file_exists($filename)) {
		    @chmod($filename, 0777);
		    unlink ($filename);
		    }
		// Remove Terms files from directory
		$filename = $dirname . DS . $langtag.".terms_" . $cid[0] . ".php";
		if (file_exists($filename)) {
		    @chmod($filename, 0777);
		    unlink ($filename);
		    }
		// Remove payment config files from directory
		$farr = JFolder::files($dirname, "payment_".$cid[0]."_");
		foreach ($farr as $payfile) {
		      $filename = $dirname . DS . $payfile;
		      if (file_exists($filename)) {
			  @chmod($filename, 0777);
			  unlink ($filename);
			  }
		      } // end foreach  
		}

		}
		
	

	if(count($cid))
	{
		$cids = implode(',', $cid );
		$query = "DELETE FROM #__ksads_backup WHERE id IN ($cids)";
		$db->setQuery($query);
		if (!$db->query())
		{
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}

	$mainframe->redirect('index.php?option=' . $option, $msg);
}

	//Publish Ads
    function publishClassifieds( $cid=null, $publishform=1,  $option ) {
	global $mainframe;
	$db = &JFactory::getDBO();
	if (!is_array( $cid ) || count( $cid ) < 1) {
	  echo "<script> alert('".JText::_("Please select an item from the list")."'); window.history.go(-1);</script>\n";
	  exit;
	}
	$total = count ( $cid );
	$cids = implode( ',', $cid );

	$db->setQuery( "UPDATE #__ksads_ads"
		      . "\nSET published =". intval( $publishform )
		      . "\nWHERE id IN ( $cids )"
					      );
	if (!$db->query()) {
	  echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
	  exit();
	}
	  switch ( $publishform ) {
		      case 1:
			      $msg = $total ." ".JText::_('Classifieds')." ".JText::_('Published');
		      break;
		      case 0:
		      default:
			      $msg = $total ." ".JText::_('Classifieds')." ".JText::_('Unpublished');
		      break;
	      }

	      $mainframe->redirect( 'index2.php?option='.$option.'&task=show_classifieds', $msg );
      }

/*========================================================================================
 *===============================Categories Section=======================================
 *=======================================================================================*/
function categories($option)
{
	global $mainframe, $tree;
	jimport('joomla.html.pagination');
	$db =&JFactory::getDBO();
	$query = "SELECT count(*) FROM #__ksads_cats WHERE pid = 0";
	$db->setQuery($query);
	$parents = $db->loadResult();
	$query = "SELECT count(*) FROM #__ksads_cats";
	$db->setQuery($query);
	$total = $db->loadResult();

	$filter_state 		= $mainframe->getUserStateFromRequest( $option.'filter_state', 'filter_state', '','word' );
	$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order','filter_order','ordering','cmd' );
	$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir','filter_order_Dir','','word' );
	$filter_match		= JRequest::getInt('filter_match', 0);
	$cids 			= JRequest::getVar( 'cid', array(0), 'post', 'array' );
	$search 		= $mainframe->getUserStateFromRequest( $option.'search','search','','string' );
	$search 		= JString::strtolower( $search );
	if ($filter_order != 'a.cat_name' && $filter_order != 'published' && $filter_order != 'ordering' && $filter_order != 'a.id' ) {
		$filter_order = 'a.cat_name';
	}
	$lists['filter_match']	= $filter_match;
	$lists['search']	= $search;
	$lists['order']	= $filter_order;
	$lists['order_Dir']	= $filter_order_Dir;

	$limit			= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart		= $mainframe->getUserStateFromRequest($option.'.limitstart', 'limitstart', 0, 'int');
	// Set the initial ordering
	if (stripos($filter_order, 'd_name')) {$filter_order = '';}
	if (strlen($filter_order) < 1) {
	    $filter_order = 'a.ordering';
	    $filter_order_Dir = 'asc';
	    }

	$where = array();

	if ($search){
		$tmp = ' WHERE ( TRUE ';
		} else {
		$tmp = ' WHERE (a.pid = 0';
		}
	
	if ( $filter_state ) {
		if ( $filter_state == 'P' ) {
			$tmp .= ' AND a.published = 1';
		} else if ($filter_state == 'U' ) {
			$tmp .= ' AND a.published = 0';
		}
	    }
	$tmp .=")";
	
	if ($search){
	    $search_arr = explode(" ", $search);
		for ($i=0, $n=count( $search_arr ); $i < $n; $i++)	{
			$srch = $search_arr[$i];
			$where['name'][] = '(a.cat_name LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'; 
			$where['cat'][] = '(a.cat_desc LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'; 
			}
		}	
	$concat = $filter_match ? " AND " : " OR ";

	$query = "SELECT * FROM #__ksads_cats as a".$tmp
		. ( count( $where ) > 1 ? "\n AND ( (" . implode( $concat, $where['name'] ).") OR (" . implode( $concat, $where['cat'] ).") )" : "")
		. "\nORDER BY $filter_order $filter_order_Dir";

	$pageNav = new JPagination($total, $limitstart, $limit);
	$pg=$pageNav->get('pages.total');

	if ($limitstart > $parents) {
		$pageNav->limitstart = ceil($parents / $pg);
		$limitstart = $pageNav->limitstart;
		}
	$db->setQuery($query, $limitstart, $limit);
	$cats = $db->loadObjectList();
	
	// subcategories view as tree
   	$tree = array();
   	
   	foreach ($cats as $v) {
		$ident = '';
       	$tree[] = $v;
		tree($v->id, $ident, $tree);
	} 

	if ($db->getErrorNum()) {
		echo $db->stderr();
		return false;
	}
	
	$lists['state']	= JHTML::_('grid.state',  $filter_state );
	HTML_classifieds::showCategories($option, $rows, $pageNav, $tree, $lists);

}

function editCategory()
      {
	  global $option;
	  $db	=& JFactory::getDBO();
	  $conf=& JTable::getInstance('config', 'Table');
	  $conf->load(1);

	    $row=& JTable::getInstance('category', 'Table');
	    $cid = JRequest::getVar('cid', array(0), '', 'array' );
	    $id = $cid[0];
	    $row->load($id);
	    $ks_help = new KissHelper();
	    $currency = $ks_help->currencies();
	    $ad_delivery = $ks_help->selectitems('delivery', 1);
	    $ad_state = $ks_help->selectitems('adstate', 1);
		//Add 'None' to adstates if not selected
		if (!array_key_exists(JText::_('None'), $ad_state)) {
			$ad_state[] = array('value' => '0', 'text' => JText::_('None'));		
			ksort($ad_state);
			}
	    $adshow = $ks_help->boolean();
	    $expiry = $ks_help->boolean();
	    $imgallow = $ks_help->boolean();
	    $rating = $ks_help->boolean();
	    $custonly = $ks_help->models();
	    $custonly[] = array('value' => -1, 'text' => JText::_('All Customers')); 		
	    $payment = $ks_help->payment();
	    $addresses = $ks_help->addresses();		
	    $agroups = $ks_help->accessGroups();
	    $access = $ks_help->userGroups();
	    $extensions = $ks_help->extensions();

	    // Build Select Lists
	    $lists['agroups'] = JHTML::_('select.genericlist',  $agroups, 'aid', 'class="inputbox" size="1"', 'id', 'name', $row->aid); 
	    $lists['access'] = JHTML::_('select.genericList', $access, 'gid', 'class="inputbox"'. '', 'value', 'text', $row->gid );
	    $lists['payment'] = JHTML::_('select.genericList', $payment, 'payment', 'class="inputbox"'. '', 'value', 'text', $row->payment );
	    $lists['restrict'] = JHTML::_('select.genericList', $ad_state, 'restrict_to', 'class="inputbox"'. '', 'value', 'text', $row->restrict_to );
	    $lists['extensions'] = JHTML::_('select.genericList', $extensions, 'extension', 'class="inputbox"'. '', 'value', 'text', $row->extension );
	    $lists['autopublish'] = JHTML::_('select.booleanlist', 'autopublish', 'class="inputbox"' , $row->autopublish );
	    $lists['expiry'] = JHTML::_('select.booleanlist', 'expiry', 'class="inputbox"' , $row->expiry );
	    $lists['imgallow'] = JHTML::_('select.booleanlist', 'allow_img', 'class="inputbox"' , $row->allow_img );
	    $lists['rating'] = JHTML::_('select.booleanlist', 'rating', 'class="inputbox"' , $row->rating );        
	    $lists['complaints'] = JHTML::_('select.booleanlist', 'complaints', 'class="inputbox"' , $row->complaints );
	    $lists['published'] = JHTML::_('select.booleanlist', 'published', 'class="inputbox"', $row->published);
	    $lists['showads'] = JHTML::_('select.booleanlist', 'showads', 'class="inputbox"', $row->showads);
	    $lists['showinmod'] = JHTML::_('select.booleanlist', 'showinmodule', 'class="inputbox"', $row->showinmodule);
	    $lists['custonly'] = JHTML::_('select.genericlist',  $custonly, 'fee', 'class="inputbox" size="1"', 'value', 'text', $row->fee); 		
	    $curval = ($row->currency == 0) ? $conf->currency : $row->currency;
	    $lists['currency'] = JHTML::_('select.genericList', $currency, 'currency', 'class="inputbox"'. '', 'value', 'text', $curval );
	    $lists['ovraddress'] = JHTML::_('select.booleanlist', 'ovr_addr_ovr', 'class="inputbox"', $row->ovr_addr_ovr);	
	    $lists['ovraddrnum'] = JHTML::_('select.genericList', $addresses, 'ovr_addr_num', 'class="inputbox"', 'value', 'text', $row->ovr_addr_num );	
		
	    HTML_classifieds::editCategory($row, $lists, $option);
      }

function savecategory($option, $task)
      {
	      global $mainframe;
	      $row =& JTable::getInstance('category', 'Table');
	      if (!$row->bind(JRequest::get('post'))) {
		      echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		      exit();
			}
		$db =& JFactory::getDBO();
		$conf=& JTable::getInstance('config', 'Table');
		$conf->load(1);
		  		  
	      // get a correct ordering value
	      if (!$row->ordering) {
			  $row->ordering = $row->getNextOrder();
			  } 
	      if (!$conf->show_rating) {
		  $row->rating = 0;
		  }
	      // if child category, inherit properties from parent category if new
	      if ($row->id == 0) {
	      	  if ($row->pid > 0) {		  
		      $query = "SELECT * FROM #__ksads_cats WHERE id = ".$row->pid;
		      $db->setQuery( $query );
		      $parentcat = $db->loadObjectList();
			  // inherited properties
			  $row->restrict_to = $parentcat->restrict_to;
			  $row->complaints = $parentcat->complaints;
			  $row->currency = $parentcat->currency;
			  $row->autopublish = $parentcat->autopublish;
			  $row->rating = $parentcat->rating;
			  }
		  } 
		if (strlen($row->cat_name) < 1) {
		    $row->cat_name = JText::_('Date created')." ".date($conf->date_format, strtotime(date("Y-m-d h:i:s")));
		     }
	      // Category name must not contain commas!
	      $cat_name = str_replace(",", "/", $row->cat_name);
	      $row->cat_name = $cat_name;

	      if (!$row->store()) {
		      if (!$row->bind(JRequest::get('post'))) {
		      echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		      exit();
		      }
		      } else {
		      // if category was set to no expiry, set the value of all ads accordingly
		      $iid = ($row->id == 0) ? $db->insertid(): $row->id;
		      $query = "UPDATE #__ksads_ads SET expiry_deactivate = $row->expiry WHERE catid = ".$iid;
		      $db->setQuery( $query );
		      $db->query();
		      }
		switch ($task)
		{
			case 'savecategory' :
				$mainframe->redirect('index.php?option=' . $option . '&task=categories', JText::_('Category saved'));
				break;
			case 'applycategory' :
				$mainframe->redirect('index.php?option=' . $option . '&task=editcategory&cid[]='.$iid, JText::_('Changes applied'));
				break;
		}
		  
      }

	function removecategory()
      {
	      global $option, $mainframe;
	      $cid = JRequest::getVar('cid', array(), '', 'array' );
	      $db =& JFactory::getDBO();
		  if(count($cid))
		  {
			  $cids = implode(',', $cid);
			  $query = "DELETE FROM #__ksads_cats WHERE id IN ( $cids ) AND id > 1";
			  $db->setQuery( $query );
			  if (!$db->query()) {
				  echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";  
			  }

			  // If category had subcats, reassign all subcats as maincats
			  $query = "UPDATE #__ksads_cats SET pid = 0 WHERE pid IN ( $cids ) AND id > 1";
			  $db->setQuery( $query );
			  $db->query();

			  // Make sure that all ads have category # 1 if their category has been removed
			  $query = "UPDATE #__ksads_ads SET `catid` = 1 WHERE catid IN ( $cids )";			
			  $db->setQuery( $query );
			  if (!$db->query()) {
				  echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";  
			  }
		  }
	      $msg = JText::_('Category Deleted')." - ".JText::_('Default category cannot be deleted');     
	      $mainframe->redirect('index.php?option=' . $option . '&task=categories', $msg);
      }

      //Publish Categories
    function categoriesPublish( $cid=null, $publishform=1,  $option ) {
	global $mainframe;
	$db = &JFactory::getDBO();
	if (!is_array( $cid ) || count( $cid ) < 1) {
	  $action = $publishcat ? 'publish' : 'unpublish';
	  echo "<script> alert('".JText::_("Please select an item from the list")."'); window.history.go(-1);</script>\n";
	  exit;
	}
	$total = count ( $cid );
	$cids = implode( ',', $cid );

	$db->setQuery( "UPDATE #__ksads_cats"
		      . "\nSET published =". intval( $publishform )
		      . "\nWHERE id IN ( $cids )"
					      );
	if (!$db->query()) {
	  echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
	  exit();
	}
	  switch ( $publishform ) {
		      case 1:
			      $msg = $total ." ".JText::_('Categories')." ".JText::_('Published');
		      break;
		      case 0:
		      default:
			      $msg = $total ." ".JText::_('Categories')." ".JText::_('Unpublished');
		      break;
	      }

	      $mainframe->redirect( 'index2.php?option='.$option.'&task=categories', $msg );
      }

      // Change Ordering via orderup/orderdown
      function categoriesOrder( $uid, $inc, $option ) {
	      global $mainframe;
	      $db = &JFactory::getDBO();
	      $row=& JTable::getInstance('category', 'Table');
	      $row->load( $uid );
	      $row->move( $inc );
	      JText::_('Category')." ".JText::_('Moved');
	      $mainframe->redirect( "index2.php?option=$option&task=categories", $msg );
      }

	      // Change Ordering via saveorder symbol
      function categoriesSaveOrder( &$cid ) {
		    global $mainframe;
		    $db = &JFactory::getDBO();
		      $total  = count( $cid );                       
		      $order = JRequest::getVar('order', array(), 'post', 'array' );

		      for( $i=0; $i < $total; $i++ ) {
			  $query = "UPDATE #__ksads_cats"
			  . "\n SET ordering = " . (int) $order[$i]
			  . "\n WHERE id = " . (int) $cid[$i];
			  $db->setQuery( $query );
			  if (!$db->query()) {
			      echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
			      exit();
			      }
			  // update ordering
			  $row=& JTable::getInstance('category', 'Table');
			  $row->load( (int)$cid[$i] );
			  }
			// clean any existing cache files
			$cache =& JFactory::getCache('com_ksadvertiser');
			$cache->clean('com_ksadvertiser');
		      
		      $msg  = JText::_('Categories Order Saved');
		      $mainframe->redirect( 'index2.php?option=com_ksadvertiser&task=categories', $msg );
	      }

/*========================================================================================
 *===============================Customers Section========================================
 *=======================================================================================*/

  function customers()
	{
	global $mainframe, $option;
	$db =& JFactory::getDBO();
	$conf=& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$cur = $conf->currency;
	$query = "SELECT * FROM #__ksads_currencies WHERE id = $cur";
	$db->setQuery($query);
	$curr = $db->loadObject();
	$currency = $curr->currency_code;
	$filter_order  = $mainframe->getUserStateFromRequest( $option.'filter_order','filter_order','','cmd' );
	if (	
		$filter_order != 'name' && 
		$filter_order != 'model_name' && 
		$filter_order != 'balance' && 
		$filter_order != 'price' && 
		$filter_order != 'adsleft' && 
		$filter_order != 'published'
	    )
	    {
	    $filter_order = 'name';
	    }
	$lists['order'] = $filter_order  ;
	$lists['order_Dir']	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir','filter_order_Dir','','word' );
	$filter_match		= JRequest::getInt('filter_match', 0);
	$filter_sound		= JRequest::getInt('filter_soundex', 0);
	$catid 			= JRequest::getInt( 'catid', 0 );
	$search 		= $mainframe->getUserStateFromRequest( $option.'search','search','','string' );
	$search 		= JString::strtolower( $search );
	$lists['filter_match']	= $filter_match;
	$lists['search']	= $search;
	$limit = JRequest::getVar('limit', $mainframe->getCfg('list_limit'));
	$limitstart = JRequest::getVar('limitstart', 0);
	$query = "SELECT c.id, c.uid, c.mid, c.color, c.balance, c.date_created, c.published, 
			c.cust_address, c.cust_postcode, c.cust_city, c.cust_telephone, c.cust_email, c.adsleft
			FROM #__ksads_customers AS c 
			LEFT JOIN #__users AS u ON ( u.id = c.uid )
			LEFT JOIN #__ksads_models AS m ON ( m.id = c.mid )			
			WHERE c.uid > 0 ORDER BY ".$lists['order']. " ".$lists['order_Dir'];
	$db->setQuery($query, $limitstart, $limit);
	$rows = $db->loadObjectList();
	$total = count($rows);
	if ($db->getErrorNum()) {
		echo $db->stderr();
		return false;
	}
	jimport('joomla.html.pagination');
	$pageNav = new JPagination($total, $limitstart, $limit);

	HTML_classifieds::show_customers($option, $rows, $pageNav, $currency, $conf, $lists);
}
  function editCustomer($option, $task)
	{
	    global $mainframe;
		$live_site = &JURI::base();
		$db	=& JFactory::getDBO();
		$conf=& JTable::getInstance('config', 'Table');
		$conf->load(1);
		$cur = $conf->currency;
		$query = "SELECT * FROM #__ksads_currencies WHERE id = $cur";
		$db->setQuery($query);
		$curr = $db->loadObject();
		$currency = $curr->currency_code;
		$func = $task == 'addcustomer' ? '1' : '2';
		$row =& JTable::getInstance('customers', 'Table');
		$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		$id = $cid[0];		
		$row->load($id);
		$lists = array();
		$ks_help = new KissHelper();
		$userchangewarn = JText::_('Userchangewarn');
		$models = $ks_help->models();
		$fedstates = $ks_help->fedstates($conf->show_regionalinfo);	
		$counties = $ks_help->counties($conf->show_regionalinfo, $row->cust_fedstate);
		$countries = $ks_help->selectitems('country', 1);	
		$row->cust_company = $ks_help->decrypted($row->cust_company);
		$row->cust_address = $ks_help->decrypted($row->cust_address);
		$row->cust_postcode = $ks_help->decrypted($row->cust_postcode);

		$row->cust_city = $ks_help->decrypted($row->cust_city);
		$row->cust_telephone = $ks_help->decrypted($row->cust_telephone);
		$row->cust_email = $ks_help->decrypted($row->cust_email);
		$row->cust_website = $ks_help->decrypted($row->cust_website);
		$row->cust_company_invoice = $ks_help->decrypted($row->cust_company_invoice);
		$row->cust_address_invoice = $ks_help->decrypted($row->cust_address_invoice);
		$row->cust_postcode_invoice = $ks_help->decrypted($row->cust_postcode_invoice);
		$row->cust_city_invoice = $ks_help->decrypted($row->cust_city_invoice);
		$row->cust_cart_paypal = $ks_help->decrypted($row->cust_cart_paypal);
		$row->cust_cart_google = $ks_help->decrypted($row->cust_cart_google);

		$color[] = JHTML::_( 'select.option', '1', '<span style="background:'.$conf->paid_col_1.'">&nbsp;&nbsp;&nbsp;&nbsp;
     '.JText::_('Colour').' 1&nbsp;&nbsp;&nbsp;&nbsp;</span><br />' );
		$color[] = JHTML::_( 'select.option', '2', '<span style="background:'.$conf->paid_col_2.'">&nbsp;&nbsp;&nbsp;&nbsp;
     '.JText::_('Colour').' 2&nbsp;&nbsp;&nbsp;&nbsp;</span><br />' );
		$color[] = JHTML::_( 'select.option', '3', '<span style="background:'.$conf->paid_col_3.'">&nbsp;&nbsp;&nbsp;&nbsp;
     '.JText::_('Colour').' 3&nbsp;&nbsp;&nbsp;&nbsp;</span><br />' );
		$color[] = JHTML::_( 'select.option', '4', '<span style="background:'.$conf->paid_col_4.'">&nbsp;&nbsp;&nbsp;&nbsp;
     '.JText::_('Colour').' 4&nbsp;&nbsp;&nbsp;&nbsp;</span><br />' );
		$color[] = JHTML::_( 'select.option', '5', '<span style="background:'.$conf->paid_col_5.'">&nbsp;&nbsp;&nbsp;&nbsp;
     '.JText::_('Colour').' 5&nbsp;&nbsp;&nbsp;&nbsp;</span><br />' );
		$lists['published'] = JHTML::_('select.booleanlist', 'published', 'class="inputbox"', $row->published);	 
		$lists['colours'] = JHTML::_('select.radioList', $color, 'color', 'class="inputbox"' . '', 'value', 'text', $row->color );
		$lists['models'] = JHTML::_('select.genericList', $models, 'mid', 'class="inputbox"', 'value', 'text', $row->mid );
		$lists['users'] = $ks_help->showUserSelect($row->uid, 'uid', "javascript: alert('$userchangewarn');");
		if ($conf->show_regionalinfo) {
		    $lists['fedstates'] = JHTML::_('select.genericlist',  $fedstates, 'cust_fedstate', 'class="inputbox" size="1" onchange="populate_county(this)"', 'value', 'text', $row->cust_fedstate, 'region_fedstate');
		    $lists['counties'] = JHTML::_('select.genericlist',  $counties, 'cust_county', 'class="inputbox" size="1"', 'value', 'text', $row->cust_county, 'region_county');
		    $lists['countries'] = JHTML::_('select.genericlist',  $countries, 'cust_country', 'class="inputbox" size="1" onchange="populate_fedstates(this)"', 'value', 'text', $row->cust_country);
		    }
		HTML_classifieds::editCustomer($row, $lists, $option, $currency, $func);
	}	

  function compileCustomerAccount($task)
	{
	  $ks_help = new KissHelper();
	  $today = date("Y-m-d");
	  $data = JRequest::get('post');
	  $db =& JFactory::getDBO();
	  $customer_id = JRequest::getInt('id', 0);

	  switch ($task) {
		  case 'accountnew':
		  if ($customer_id) {
		      $query = "INSERT INTO #__ksads_customeraccounts (ca_cid, ca_paydate, ca_text, ca_payment, ca_credit, published) VALUES ($customer_id, '$today', '".JText::_('New')."', 0, 0, 1)";
		      $db->setQuery($query);
		      $db->query();
		      }
		  break;
		  case 'accountdelete':
		  $cid = JRequest::getVar('cid', array(), '', 'array' );
			if(count($cid))
			{
				$cids = implode(',', $cid);
				$query = "DELETE FROM #__ksads_customeraccounts WHERE ca_id IN ( $cids )";
				$db->setQuery( $query );
				if (!$db->query()) {
					echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
				}
			}
		  break;
		  case 'accountinvoice':
		  createCustomerInvoice();
		  break;
	  }
	  $task = 'applycustomer';
	  saveCustomer($task);
	}

  function saveCustomer($task)
	{

	  global $mainframe, $option;
	  $ks_help = new KissHelper();
	  $today = date("Y-m-d");
	  $row =& JTable::getInstance('customers', 'Table');
	  $conf=& JTable::getInstance('config', 'Table');
	  $conf->load(1);

	  $rawdata = JRequest::get('post');
	  // Replace commas with decimal points
	  $data = str_replace(",", ".", $rawdata);
	  
	      if (!$row->bind($data)) {
		      die ($row->getError());
		  }
	      $func = JRequest::getInt('func', 1);
	      if ($func == 1) {
			  $row->id = 0;
			  $row->date_created = $today;
			  }
	      $row->cust_company = $ks_help->encrypted($row->cust_company);	      
	      $row->cust_address = $ks_help->encrypted($row->cust_address);
	      $row->cust_postcode = $ks_help->encrypted($row->cust_postcode);
	      $row->cust_city = $ks_help->encrypted($row->cust_city);
	      $row->cust_telephone = $ks_help->encrypted($row->cust_telephone);
	      $row->cust_fax = $ks_help->encrypted($row->cust_fax);
	      $row->cust_email = $ks_help->encrypted($row->cust_email);
	      $row->cust_website = $ks_help->encrypted($row->cust_website);
	      $row->cust_cart_paypal = $ks_help->encrypted($row->cust_cart_paypal);
	      $row->cust_cart_google = $ks_help->encrypted($row->cust_cart_google);
	      if (strlen($row->cust_company_invoice)) {
		  $row->cust_company_invoice = $ks_help->encrypted($row->cust_company_invoice);
		  } else {
		  $row->cust_company_invoice = $row->cust_company;
		  }
	      if (strlen($row->cust_address_invoice)) {
		  $row->cust_address_invoice = $ks_help->encrypted($row->cust_address_invoice);
		  } else {
		  $row->cust_address_invoice = $row->cust_address;
		  }
	      if (strlen($row->cust_postcode_invoice)) {
		  $row->cust_postcode_invoice = $ks_help->encrypted($row->cust_postcode_invoice);
		  } else {
		  $row->cust_postcode_invoice = $row->cust_postcode;
		  }
	      if (strlen($row->cust_city_invoice)) {
		  $row->cust_city_invoice = $ks_help->encrypted($row->cust_city_invoice);
		  } else {
		  $row->cust_city_invoice = $row->cust_city;
		  }
	      $row->adsleft = getAdsLeftforCustomer($row->uid);
		  
		  // If $data['adsleft'] is different to $row->adsleft, the adsleft value was changed manually!
			if ($row->adsleft != $data['adsleft'] && $data['adsleft'] != 0 ) {	
				$row->adsleft = $data['adsleft'];
				}
      
	      $db =& JFactory::getDBO();
	      if (!$row->store()) {
		      if (!$row->bind($data)) {
		      die ($row->getError());
		      }
	      }

	  // Customer was saved successfully, now change this user's ads according to the new customer model
		$model=getModelforUser($row->uid);
		// Set expiration of ads
		if ($model->expiry > 0) {
			$set = "SET mid = $model->id, 
					date_expiry = (ADDDATE(`date_created`, INTERVAL $model->expiry DAY))";
			} else {
			//no expiry, set maximum value 2 years
			$set = "SET mid = $model->id, 
					date_expiry = (ADDDATE(`date_created`, INTERVAL 730 DAY))";
			}
		$query = "UPDATE #__ksads_ads $set WHERE user_id = ".$row->uid;
		$db->setQuery($query);
		$db->query();
		//now set the price ranking according to the model's price
		$query = "UPDATE #__ksads_ads SET ad_price_pu = $model->price WHERE user_id = ".$row->uid." AND ad_price_pu < $model->price";
		$db->setQuery($query);
		$db->query();
		$payments = 0; $credits = 0;		
		//now save the customer account
		$query = "SELECT * FROM #__ksads_customeraccounts WHERE ca_cid = $row->id";
		$db->setQuery($query);
		if ($rows = $db->loadObjectList()) {
		    foreach ($rows as $row2) {
			$caid=$row2->ca_id;
			$paid='ca_paydate'.$caid;
			$craid='ca_credit'.$caid;			
			$daid = date("Y-m-d", strtotime($data[$paid]));
			$taid='ca_text'.$caid;
			$pmaid='ca_payment'.$caid;
			if (isset($data[$paid])) {
			    $query = "UPDATE #__ksads_customeraccounts SET\n
				      ca_payment = " . floatval( $data[$pmaid]) . ",\n 
				      ca_credit = " . floatval ( $data[$craid]) . ",\n
				      ca_text = '$data[$taid]',\n
				      ca_paydate = '$daid'\n
				      WHERE ca_id = $caid";	  
				$db->setQuery($query);
			    $db->query();
				$payments = $payments + floatval( $data[$pmaid]);
				$credits = $credits + floatval ( $data[$craid]);
			    } else {
				$payments = $payments + $row2->ca_payment;
				$credits = $credits + $row2->ca_credit;				
				}
			}
		// Update Customer balance
			$query = "UPDATE #__ksads_customers SET balance = ".($payments + $credits)." WHERE uid = ".$row->uid;
			$db->setQuery($query);
			$db->query();			
		    }

		$msg = JText::_('Customer saved');	  
		switch ($task)
		{ 
			case 'savecustomer' :
				$mainframe->redirect('index.php?option=' . $option . '&task=customers', $msg);
				break;
			case 'applycustomer' :
				$mainframe->redirect('index.php?option=' . $option. '&task=editcustomer&cid[]='.$row->id, JText::_('Changes applied'));
				break;
		}

	}	

  function removeCustomer()
	{
	global $mainframe, $option;
	$cid = JRequest::getVar('cid', array(), '', 'array' );
	      $db =& JFactory::getDBO();
	      if(count($cid))
	      {
		      $cids = implode(',', $cid);
		      $query = "DELETE FROM #__ksads_customers WHERE id IN ( $cids )";
		      $db->setQuery( $query );
		      if (!$db->query()) {
			      echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
		      }
	      }
	$msg = JText::_('Customers deleted');	  
	$mainframe->redirect('index.php?option=' . $option . '&task=customers', $msg);
	}	

	//Publish Customers
   function publishCustomers( $cid=null, $publishform=1,  $option ) {
	global $mainframe;
	$db = &JFactory::getDBO();
	if (!is_array( $cid ) || count( $cid ) < 1) {
	  echo "<script> alert('".JText::_("Please select an item from the list")."'); window.history.go(-1);</script>\n";
	  exit;
	}
	$total = count ( $cid );
	$cids = implode( ',', $cid );

	$db->setQuery( "UPDATE #__ksads_customers"
		      . "\nSET published =". intval( $publishform )
		      . "\nWHERE id IN ( $cids )"
					      );
	if (!$db->query()) {
	  echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
	  exit();
	}
	  switch ( $publishform ) {
		      case 1:
			      $msg = $total ." ".JText::_('Customers')." ".JText::_('Published');
		      break;
		      case 0:
		      default:
			      $msg = $total ." ".JText::_('Customers')." ".JText::_('Unpublished');
		      break;
	      }

	      $mainframe->redirect( 'index2.php?option='.$option.'&task=customers', $msg );
      }


    function getAccountListforCustomer($cid) {
	global $mainframe, $option;
	$conf=& JTable::getInstance('config', 'Table');
	$conf->load(1);
	// Get the Language Directory for Button Choice
	$lang =& JFactory::getLanguage();
	$language = $lang->getTag();
	$html = null;
	$live_site = JURI::root();
	$db = &JFactory::getDBO();
	$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',	'',	'cmd' );
	$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'asc',	'word' );
	//Must strip all non-here orderings to prevent mysql errors
	switch ($filter_order) {
		case 'ca_paydate':
		case 'ca_text':
		case 'ca_payment':
		case 'ca_credit':
			break;
		default:
			$filter_order = 'ca_paydate';
			break;
	}
	$lists['order_Dir']	= $filter_order_Dir;
	$lists['order']		= $filter_order;
	$query = "SELECT * FROM #__ksads_customeraccounts WHERE ca_cid = $cid";
	$query .=  " ORDER BY ".$db->nameQuote($filter_order). " ".$filter_order_Dir;
	$db->setQuery($query);
	$rows = $db->loadObjectList();
	$html = '
	<table class="adminlist">
		<thead>
			<tr>
				<th width="3%">
				<input type="checkbox" name="toggle" value="" onclick="checkAll('.count($rows).')" />
				</th>
				<th class="title">'. JHTML::_("grid.sort", JText::_("Date"), "ca_paydate", $lists["order_Dir"], $lists["order"] ) . '</th>
				<th class="title">'. JHTML::_("grid.sort", JText::_("Text"), "ca_text", $lists["order_Dir"], $lists["order"] ) . '</th>
				<th class="title">'. JHTML::_("grid.sort", JText::_("Payment"), "ca_payment", $lists["order_Dir"], $lists["order"] ) . '</th>
				<th class="title">'. JHTML::_("grid.sort", JText::_("Credit"), "ca_credit", $lists["order_Dir"], $lists["order"] ) . '</th>
			</tr>
		</thead>
		';
		
	$payments = 0; $credits = 0;
	if (count($rows)) {
		jimport("joomla.filter.output");
		$k = 0;
		for ($i=0, $n=count( $rows ); $i < $n; $i++)
		{
			$row = &$rows[$i];
			$payments = $payments + $row->ca_payment;
			$credits = $credits + $row->ca_credit;
			//JHTML::_('grid.id', ... ) Does not work here, we need the additional 'fillaccount' javascript routine!!!
			$checked = '<input type="checkbox" id="cb'.$i.'" name="cid[]" value="'.$row->ca_id.'" onclick="javascript: fillaccount('.$row->ca_id.'); isChecked(this.checked);" />';
			$published = JHTML::_('grid.published', $row, $i );
			$html .='<tr class="row'.$k.'">
				<td align="center" width="3%">
				'.$checked.'
				</td>
				<td align="right" width="10%">
				<a id="paydate'.$row->ca_id.'" href="javascript: fillaccount('.$row->ca_id.');">
				'.date($conf->date_format, strtotime($row->ca_paydate)).'
				</a>
				<input type="hidden" name="ca_paydate'.$row->ca_id.'" id="ca_paydate'.$row->ca_id.'" value="'.$row->ca_paydate.'">
				</td>
				<td align="left" width="50%">
				<a id="text'.$row->ca_id.'" href="javascript: fillaccount('.$row->ca_id.');">
				'.$row->ca_text.'
				</a>
				<input type="hidden" name="ca_text'.$row->ca_id.'" id="ca_text'.$row->ca_id.'" value="'.$row->ca_text.'">
				</td>
				<td align="right" width="15%"><p id="payment'.$row->ca_id.'"> 
				'.number_format($row->ca_payment, $conf->decimals, $conf->sep_decimal, $conf->sep_thousand).'
				</p></td>
				<input type="hidden" name="ca_payment'.$row->ca_id.'" id="ca_payment'.$row->ca_id.'" value="'.$row->ca_payment.'">
				<td align="right" width="15%"><p id="credit'.$row->ca_id.'">
				'.number_format($row->ca_credit, $conf->decimals, $conf->sep_decimal, $conf->sep_thousand).'
				</p></td>
				<input type="hidden" name="ca_credit'.$row->ca_id.'" id="ca_credit'.$row->ca_id.'" value="'.$row->ca_credit.'">
			</tr>	
			';
		} // End for ($i=0, ...)
	} else {
	$html .= '<tr><td colspan="5" align="center"><h3>'.JText::_("No items found").'</h3></td></tr>';
	} // End if ($rows = $db->loadObjectList)
		$html .='<tr>
		<td class="key" colspan="5" align="left" valign="middle">';
		if (file_exists(JPATH_ROOT.DS. "images/buttons/$language/btn_new.jpg")) {
		    $html .= '<input type="image" name="submit" onclick="javascript: submitbutton(\'accountnew\');" src="' .$live_site. 'images/buttons/'.$language.'/btn_new.jpg" border="0">';
		    } else {
		    $html .= '<button name="new" onclick="javascript: submitbutton(\'accountnew\');">'. JText::_( 'New' ).'</button>';
		    }
		$html .='&nbsp;&nbsp;';
		if (file_exists(JPATH_ROOT.DS. "images/buttons/$language/btn_delete.jpg")) {
		    $html .= '<input type="image" name="submit" onclick="javascript: return submitbutton(\'accountdelete\');" src="' .$live_site. 'images/buttons/'.$language.'/btn_delete.jpg" border="0">';
		    } else {
		    $html .= '<button name="delete" onclick="javascript: return submitbutton(\'accountdelete\');">'. JText::_( 'Delete' ).'</button>';
		    }
		$html .='&nbsp;&nbsp;';
		if (file_exists(JPATH_ROOT.DS. "images/buttons/$language/btn_invoice.jpg")) {
		    $html .= '<input type="image" name="submit" onclick="javascript: return submitbutton(\'accountinvoice\');" src="' .$live_site. 'images/buttons/'.$language.'/btn_invoice.jpg" border="0">';
		    } else {
		    $html .= '<button name="invoice" onclick="javascript: return submitbutton(\'accountinvoice\');">'. JText::_( 'Invoice' ).'</button>';
		    }
		$html .= '</td>
		</tr>';

	$html .='</table>';
	$html .='
			<input type="hidden" name="option" value="'.$option.'" />
			<input type="hidden" name="task" value="editcustomer" />
			<input type="hidden" name="cid[]" value="'.$cid.'">
			<input type="hidden" name="filter_order" value="'.$lists['order'].'" />
			<input type="hidden" name="filter_order_Dir" value="'.$lists['order_Dir'].'" />';

		// Update Customer balance
			$query = "UPDATE #__ksads_customers SET balance = ".($payments + $credits)." WHERE id = ".$cid;
			$db->setQuery($query);
			$db->query();

		return $html;
      }
	
    function createCustomerInvoice() {
	global $mainframe, $option;
	$db = &JFactory::getDBO();
	$conf=& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$cur = $conf->currency;
	$query = "SELECT * FROM #__ksads_currencies WHERE id = $cur";
	$db->setQuery($query);
	$curr = $db->loadObject();
	$currency = $curr->currency_code;
	$html = null;
	$ks_help = new KissHelper();	
	$live_site = JURI::root();
	$data = JRequest::get('post');
	$cid = JRequest::getVar('cid', array(), '', 'array' );
	$file = JPATH_ROOT.DS."components".DS.$option.DS."pdf".DS."pdf_creator.php";
	$img_dir = JPath::clean( JPATH_ROOT .DS. "images" .DS. $conf->ad_img_dir );
	$logo_file = $img_dir.DS.$conf->logo_file;
	$html = array();
	if (file_exists($logo_file)) {
		$pdf_header_logo = $conf->logo_file;
		} else {
		jimport('joomla.filesystem.file');
		$src = JPath::clean( JPATH_COMPONENT_SITE .DS. 'images').DS.'designbykiss.png';
		$dest = $img_dir.DS.'designbykiss.png';
		JFile::copy ($src,$dest);
		$pdf_header_logo = 'designbykiss.png'; 
		}
	$pdf_subject = JText::_('Invoice');
	$pdf_header_title = $conf->owner_name;
	$pdf_header_string = $conf->owner_address." | ".$conf->owner_city." | ".$conf->owner_comm;
	$pdf_footer_string = JText::_('Bank Account') . ': ' 
		. $ks_help->decrypted($conf->bank_name). ' | [' 
		. $ks_help->decrypted($conf->bank_code). '] | ' 
		. $ks_help->decrypted($conf->bank_account). ' | ' 
		. JText::_('Bank Iban') . ': ' . $ks_help->decrypted($conf->bank_iban) . ' | ' 
		. JText::_('Bank BIC') . ': ' . $ks_help->decrypted($conf->bank_bic);
	// if not KISS Joomla Version, the user table does not contain a field named "firstname"
	$userid = $data['uid'];
	if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
		$query = "SELECT name";				
		} else {
		$query = "SELECT CONCAT_WS(' ', firstname, name) as name";
		}
	$query .=" FROM #__users WHERE id = '" . $userid . "'";
	$db->setQuery( $query );
	$advertiser = $db->loadObject();
	$vat = $conf->tax_vat;
	$amount_tax = 0;
	    $html_1 = '<p></p><p></p><p></p><p></p><p></p>
		      <p>'.$data['cust_company_invoice'].'</p>
		      <p> - '.$advertiser->name.' -</p>			  
		      <p>'.$data['cust_address_invoice'].'</p><p></p>
		      <p>'.$data['cust_postcode_invoice'].' '.$data['cust_city_invoice'].'</p>
		      <p></p><p></p>
		      <p align="right">'.JText::_('Date').' '.date($conf->date_format).'</p>
		      <p></p><p></p>
		      <p><h3>'.JText::_('Invoice').'</h3></p>
		      <table border="0" cellspacing="6" cellpadding="4">
		      <tr style="background-color: #afafaf;">
		      <th width="20%" style="background-color: #afafaf;">'.JText::_('Date').'</th>
		      <th width="65%" style="background-color: #afafaf;">'.JText::_('Delivery Item').'</th>
		      <th width="15%" style="background-color: #afafaf;">'.JText::_('Price').' '.$currency.'</th>
		      </tr>';
	// Generate the invoice items
	$amount_tax = 0; $amount_net = 0;
	for ($i=0, $n = count( $cid ) -1; $i < $n; $i++) {
	    $invnum=$cid[$i];
	    $invdate='ca_paydate'.$invnum;
	    $invpmnt='ca_payment'.$invnum;
	    $invtext='ca_text'.$invnum;
	    if ($conf->prolong) {
		// Show all amounts without tax, tax is added later
		$amount_tax_single = ($vat > 0) ? ($data[$invpmnt] / (100 + $vat) * $vat) : 0;
		$amount_net_single = ($data[$invpmnt] - $amount_tax_single);
		$amount_tax = $amount_tax + $amount_tax_single;
		$amount_net = $amount_net + $amount_net_single;
		} else {
		$amount_net_single = $data[$invpmnt];
		$amount_net = $amount_net + $amount_net_single;
		}
	    $amount_show=number_format($amount_net_single, $conf->decimals, $conf->sep_decimal, $conf->sep_thousand);
			  $html_1 .='
		      <tr>
		      <td>'.date($conf->date_format, strtotime($data[$invdate])).'</td><td>'.$data[$invtext].'</td><td align="right">'.$amount_show.'</td>
		      </tr>';
	    }			  
			$html_1 .='<tr><td colspan="2"></td><td><hr></td></tr>
		      <tr><td></td><td>'.JText::_('Total').'</td><td align="right">'.number_format($amount_net, $conf->decimals, $conf->sep_decimal, $conf->sep_thousand).'</td></tr>
			';
		      if ($amount_tax) {
			  $html_1 .= '
			  <tr><td></td><td>'.JText::_('Vat').' '.number_format($vat, $conf->decimals, $conf->sep_decimal, $conf->sep_thousand).'%</td><td align="right">'.number_format($amount_tax, $conf->decimals, $conf->sep_decimal, $conf->sep_thousand).'</td></tr>
			  <tr><td colspan="2"></td><td><hr></td></tr>
			  <tr><td colspan="2"></td><td align="right">'.number_format(($amount_net + $amount_tax), $conf->decimals, $conf->sep_decimal, $conf->sep_thousand).'</td></tr>
			<tr><td colspan="3"><p></p><p></p><p></p><p></p><p></p><p></p><p></p><p></p><p></p><p></p>
			<hr><p></p>
			<p style="font-size: 30px;">'.$pdf_footer_string.'</p>
			</td></tr>			  
			  ';
			  } 
	    $html_1 .='</table>';
	    $html[] = $html_1;
	require_once($file);  
    }

/*========================================================================================
 *===============================Payment Section==========================================
 *=======================================================================================*/

      // Change Ordering via orderup/orderdown
 function modelsOrder( $uid, $inc, $option ) {
	      global $mainframe;
	      $db = &JFactory::getDBO();
	      $row=& JTable::getInstance('models', 'Table');
	      $row->load( $uid );
	      $row->move( $inc );
	      $row->reorder();
	      $msg = JText::_('Model')." ".JText::_('Moved');
	      $mainframe->redirect( "index2.php?option=$option&task=models", $msg );
      }

 function modelsSaveOrder( &$cid ) {
	global $mainframe, $option;
	$db = &JFactory::getDBO();
	$total  = count( $cid );                       
	$order = JRequest::getVar('order', array(), 'post', 'array' );

	for( $i=0; $i < $total; $i++ ) {
		$query = "UPDATE #__ksads_models"
		. "\n SET ordering = " . (int) $order[$i]
		. "\n WHERE id = " . (int) $cid[$i];
		$db->setQuery( $query );
		if (!$db->query()) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
		}
		// update ordering
		$row=& JTable::getInstance('models', 'Table');
		$row->load( (int)$cid[$i] );
	}
	
	$row->reorder();
	// clean any existing cache files
	$cache =& JFactory::getCache('com_ksadvertiser');
	$cache->clean('com_ksadvertiser');

	$msg  = JText::_('Models ordering saved');
	$mainframe->redirect( 'index2.php?option='.$option.'&task=models', $msg );
 }

  function addresses()
	{
	global $mainframe, $option;
	$db =& JFactory::getDBO();
	$conf=& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$lists['search']	= JString::strtolower( $mainframe->getUserStateFromRequest( $option.'search','search','','string' ) );
	$limit = JRequest::getVar('limit', $mainframe->getCfg('list_limit'));
	$limitstart = JRequest::getVar('limitstart', 0);
	$filter_order = $mainframe->getUserStateFromRequest( $option.'filter_order','filter_order','','cmd' );	
	if ($filter_order != 'postcode' &&
		$filter_order != 'companyname' &&
		$filter_order != 'personname' && 
		$filter_order != 'address' && 
		$filter_order != 'city' 
		)
	{
		$filter_order = 'postcode';
	}
	$lists['order']	 = $filter_order;
	$lists['order_Dir']	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir','filter_order_Dir','','word' );
	$query = "SELECT count(*) FROM #__ksads_addresses";
	$db->setQuery($query);
	$total = $db->loadResult();
	$query = "SELECT * FROM #__ksads_addresses ORDER BY ". $lists['order'].' '.$lists['order_Dir'];
	$db->setQuery($query, $limitstart, $limit);
	$rows = $db->loadObjectList();
	if ($db->getErrorNum()) {
		echo $db->stderr();
		return false;
	}
	jimport('joomla.html.pagination');
	$pageNav = new JPagination($total, $limitstart, $limit);
	HTML_classifieds::show_addresses($option, $rows, $pageNav, $conf, $lists);
	}	

  function removeAddress()
	{
	global $mainframe, $option;
	$cid = JRequest::getVar('cid', array(), '', 'array' );
	      $db =& JFactory::getDBO();
	      if(count($cid))
	      {
		      $cids = implode(',', $cid);
		      $query = "DELETE FROM #__ksads_addresses WHERE id IN ( $cids )";
		      $db->setQuery( $query );
		      if (!$db->query()) {
			      echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
		      }
	      }
	$msg = JText::_('Addresses')." ".JText::_('Deleted');	  
	$mainframe->redirect('index.php?option=' . $option . '&task=addresses', $msg);
	}	

	//Publish Addresses
   function publishAddresses( $cid=null, $publishform=1) {
	global $mainframe, $option;
	$db = &JFactory::getDBO();
	if (!is_array( $cid ) || count( $cid ) < 1) {
	  echo "<script> alert('".JText::_("Please select an item from the list")."'); window.history.go(-1);</script>\n";
	  exit;
	}
	$total = count ( $cid );
	$cids = implode( ',', $cid );

	$db->setQuery( "UPDATE #__ksads_addresses"
		      . "\nSET published = ". intval( $publishform )
		      . "\nWHERE id IN ( $cids )"
					      );
	if (!$db->query()) {
	  echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
	  exit();
	}
	  switch ( $publishform ) {
		      case 1:
			      $msg = $total ." ".JText::_('Addresses')." ".JText::_('Published');
		      break;
		      case 0:
		      default:
			      $msg = $total ." ".JText::_('Addresses')." ".JText::_('Unpublished');
		      break;
	      }

	      $mainframe->redirect( 'index2.php?option='.$option.'&task=addresses', $msg );
      }
	
function models()
	{
	global $mainframe, $option;
	$db =& JFactory::getDBO();
	$conf=& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$cur = $conf->currency;
	$query = "SELECT * FROM #__ksads_currencies WHERE id = $cur";
	$db->setQuery($query);
	$curr = $db->loadObject();
	$currency = $curr->currency_code;
	$lists['search']	= JString::strtolower( $mainframe->getUserStateFromRequest( $option.'search','search','','string' ) );
	$filter_order = $mainframe->getUserStateFromRequest( $option.'filter_order','filter_order','','cmd' );
	if (	$filter_order != 'model_name' &&
		$filter_order != 'model_description' &&
		$filter_order != 'payment' && 
		$filter_order != 'price' && 
		$filter_order != 'ordering' 
		)
	{
		$filter_order = 'model_name';
	}
	$lists['order']	 = $filter_order;
	$lists['order_Dir']	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir','filter_order_Dir','','word' );
	$limit = JRequest::getVar('limit', $mainframe->getCfg('list_limit'));
	$limitstart = JRequest::getVar('limitstart', 0);
	$query = "SELECT count(*) FROM #__ksads_models";
	$db->setQuery($query);
	$total = $db->loadResult();
	$query = 'SELECT * FROM #__ksads_models ORDER BY '.$lists['order'].' '.$lists['order_Dir'];
	$db->setQuery($query, $limitstart, $limit);
	$rows = $db->loadObjectList();
	if ($db->getErrorNum()) {
		echo $db->stderr();
		return false;
	}
	jimport('joomla.html.pagination');
	$pageNav = new JPagination($total, $limitstart, $limit);
	HTML_classifieds::show_models($option, $rows, $pageNav, $currency, $conf, $lists);
	}	
	
function editModel()
	{
	global $mainframe, $option;	
	$row =& JTable::getInstance('models', 'Table');
	$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
	$id = $cid[0];		
	$row->load($id);

	$live_site = &JURI::base();
	$db	=& JFactory::getDBO();
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$curval = ($row->currency == 0) ? $conf->currency : $row->currency;		
	$query = "SELECT * FROM #__ksads_currencies WHERE id = $curval";
	$db->setQuery($query);
	$curr = $db->loadObject();
	$currency = $curr->currency_code;
	$lists = array();
	$ks_help = new KissHelper();
	$agroups = $ks_help->accessGroups();
	$models = $ks_help->models();
	$addresses = $ks_help->addresses();
	$access = $ks_help->userGroups();
	$ad_payments = $ks_help->payments();
	$currencies = $ks_help->currencies();		      
	// Build Select Lists
	$lists['agroups'] = JHTML::_('select.genericlist',  $agroups, 'aid', 'class="inputbox" size="1"', 'id', 'name', $row->aid); 
	$lists['access'] = JHTML::_('select.genericList', $access, 'gid', 'class="inputbox"'. '', 'value', 'text', $row->gid );
	$lists['payment'] = JHTML::_('select.genericList', $ad_payments, 'payment', 'class="inputbox"', 'value', 'text', $row->payment );
	$lists['payadvance'] = JHTML::_('select.booleanlist', 'payment_advance', 'class="inputbox"', $row->payment_advance);
	$lists['forcecategory'] = JHTML::_('select.booleanlist', 'forcecategory', 'class="inputbox"', $row->forcecategory);	
	$lists['published'] = JHTML::_('select.booleanlist', 'published', 'class="inputbox"', $row->published);
	$lists['commercial'] = JHTML::_('select.booleanlist', 'commercial', 'class="inputbox"', $row->commercial);
	$lists['webshops'] = JHTML::_('select.booleanlist', 'webshops', 'class="inputbox"', $row->webshops);
	$lists['weblinks'] = JHTML::_('select.booleanlist', 'weblinks', 'class="inputbox"', $row->weblinks);
	$lists['downloads'] = JHTML::_('select.booleanlist', 'downloads', 'class="inputbox"', $row->downloads);
	$lists['optcharge'] = JHTML::_('select.booleanlist', 'opt_charge', 'class="inputbox"', $row->opt_charge);
	$lists['optnew'] = JHTML::_('select.booleanlist', 'opt_new', 'class="inputbox"', $row->opt_new);
	$lists['optbold'] = JHTML::_('select.booleanlist', 'opt_bold', 'class="inputbox"', $row->opt_bold);
	$lists['optcolor'] = JHTML::_('select.booleanlist', 'opt_color', 'class="inputbox"', $row->opt_color);
	$lists['ovraddress'] = JHTML::_('select.booleanlist', 'ovr_addr_ovr', 'class="inputbox"', $row->ovr_addr_ovr);	
	$lists['ovraddrnum'] = JHTML::_('select.genericList', $addresses, 'ovr_addr_num', 'class="inputbox"', 'value', 'text', $row->ovr_addr_num );	
	$lists['video'] = JHTML::_('select.booleanlist', 'videos', 'class="inputbox"', $row->videos);
	$lists['socialnet'] = JHTML::_('select.booleanlist', 'socialnet', 'class="inputbox"', $row->socialnet);
	$lists['tellafriend'] = JHTML::_('select.booleanlist', 'tellafriend', 'class="inputbox"', $row->tellafriend);	
	$lists['watermark'] = JHTML::_('select.booleanlist', 'watermark', 'class="inputbox"', $row->watermark);		
	$lists['currency'] = JHTML::_('select.genericList', $currencies, 'currency', 'class="inputbox"'. '', 'value', 'text', $curval );
	$lists['models'] = JHTML::_('select.genericList', $models, 'downgrade', 'class="inputbox"', 'value', 'text', $row->downgrade );
	HTML_classifieds::editModel($row, $lists, $option, $currency);
	}

  function saveModel($task)
	{
	  global $mainframe, $option;
	      $db =& JFactory::getDBO();
		  $conf=& JTable::getInstance('config', 'Table');
		  $conf->load(1);
	      $lic = array();
	      $lic = explode(",",base64_decode(str_rot13($conf->license)));

	      $row =& JTable::getInstance('models', 'Table');
		  $data = JRequest::get('post');
		  $mid = $data['id'];		
		  $data['price'] = str_replace(",", ".", $data['price']);
		  $data['price_prolong'] = str_replace(",", ".", $data['price_prolong']);
		  $data['opt_new_price'] = str_replace(",", ".", $data['opt_new_price']);
		  $data['opt_color_price'] = str_replace(",", ".", $data['opt_color_price']);
		  $data['opt_bold_price'] = str_replace(",", ".", $data['opt_bold_price']);
		  $exp_days = ($data['views'] == 0) ? $data['expiry'] : 730;
	
		  $today = date("Y-m-d");
			// Make sure that models containing active customers cannot be unpublished.
			if (!$row->published) {
				$query = "SELECT COUNT( * )\n
						  FROM #__ksads_customers\n
						  WHERE mid = ". $data['id'];
				$db->setQuery($query);		  
				$count = $db->loadResult();
				if ($count > 0) {
					$data['published'] = 1;
					if ($mid == 1) {
						$msg2=". " . JText::_("Default Model cannot be removed");					
						} else {
						$msg2=". " . JText::_("Models assigned to customers cannot be deactivated");
						}
					}	
				}		

	      if (!$row->bind($data)) {
		      echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		      exit();
	      }

	      // get a correct ordering value
	      if ($row->ordering < 1) {
			  $row->ordering = $row->getNextOrder();
			  } 

	      // Special case: Default model
	      if ($row->id == 1) {
		  // Make sure that unlimited ads can be placed, if model is free and not restricted
		  if ($row->price == 0) {
		      $row->ads_per_period = ($row->gid == 0 && $row->aid == 0) ? 0 : $row->ads_per_period;
		      }
		  } 

	      if (!$lic[3]) {
		  $row->price_prolong = $row->price;
		  }
		  
		  // Make sure that payment is set to advance if price is 0 to avoid ad duration problems
		  if ($row->price == 0) {
		      $row->payment_advance = 1;
		      }

		// Set each customer's 'Ads left' info according to the model/customer/ads relations
		$query = "SELECT * FROM #__ksads_customers WHERE `mid` = $mid";
		$db->setQuery($query);
		if ($customers = $db->loadObjectList()) {
			foreach ($customers as $customer) {
					 getAdsLeftforCustomer($customer->uid);
				} // End foreach customers as customer	
			} // End if Customers ...

	      if (!$row->store()) {
				echo "AN ERROR OCCURRED: ".$row->getError();			  
		      exit();
	      }

	  // Model was changed, now change all ads according to model/customer relations if necessary
	  $query = "SELECT * FROM #__ksads_customers WHERE `mid` = $mid";
	  $db->setQuery($query);
	  $rows = $db->loadObjectList();
	  foreach ($rows as $row) {
			   $query = "UPDATE #__ksads_ads SET date_expiry = ADDDATE(`date_created`, INTERVAL $exp_days DAY) WHERE `user_id` = $row->uid";			   
			   $db->setQuery($query);
			   $db->query();
	  } // End foreach ...

	  $msg = JText::_('Model saved');	  
 
		switch ($task)
		{ 
			case 'savemodel' :
				$mainframe->redirect('index.php?option=' . $option . '&task=models', $msg.$msg2); 
				break;
			case 'applymodel' :
				$mainframe->redirect('index.php?option=' . $option. '&task=editmodel&cid[]='.$row->id, JText::_('Model changes applied').$msg2);
				break;
				
		}
	}	

  function removeModel($option)
	{
	global $mainframe;
	      $cid = JRequest::getVar('cid', array(), '', 'array' );
	      $db =& JFactory::getDBO();
	      if(count($cid))
	      {
			// Make sure that default model cannot be removed
			for ($i=0, $n=count( $cid ); $i < $n; $i++) {
				if ($cid[0] == 1) {
				$cid[0] = 0;
				$msg1 = " - ". JText::_('Default Model cannot be removed');
				} else {
				$msg1 = "";
			// Make sure that a model containing users cannot be removed
				$query = "SELECT * FROM #__ksads_models WHERE id = ".$cid[0];
				$db->setQuery( $query );
				$tmpmod = $db->loadObject();
				$query = "SELECT * FROM #__ksads_customers WHERE mid = ".$tmpmod->id;
				$db->setQuery( $query );
				if ($tmpuser = $db->loadObject()) {
					$cid[0] = 0;
					$msg1 = " - ".JText::_('Models assigned to customers cannot be removed');
					}		  
		      $cids = implode(',', $cid);
		      $query = "DELETE FROM #__ksads_models WHERE id IN ( $cids )";
		      $db->setQuery( $query );
		      if (!$db->query()) {
			      echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
		      } // end if $db->query
			} // end if $cid[0] = 0
		} // end if for $i=0, ...
		} // end if $count($cid) ...
	$msg = JText::_('Models deleted');	  
    $mainframe->redirect('index.php?option=' . $option . '&task=models', $msg.$msg1);
	}	

  //Publish Models
  function publishModels( $cid=null, $publishform=1,  $option ) {
	global $mainframe;
	$db = &JFactory::getDBO();
	if (!is_array( $cid ) || count( $cid ) < 1) {
	  echo "<script> alert('".JText::_("Please select an item from the list")."'); window.history.go(-1);</script>\n";
	  exit;
	}
	$total = count ( $cid );
	$cids = implode( ',', $cid );

	// Make sure that models containing active ads cannot be unpublished.
	if (!$publishform) {
		$query = "SELECT COUNT( *  )\n
				  FROM #__ksads_customers\n
				  WHERE mid\n
				  IN ($cids)";
		$db->setQuery($query);		  
		$count = $db->loadResult();
		if ($count > 0) {
			echo "<script> alert('".JText::_("Models assigned to customers cannot be deactivated")."'); window.history.go(-1);</script>\n";
			exit;
			}	
		}		

	$db->setQuery( "UPDATE #__ksads_models"
		      . "\nSET published =". intval( $publishform )
		      . "\nWHERE id IN ( $cids ) AND id > 1"
					      );
	if (!$db->query()) {
	  echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
	  exit();
	}
	  switch ( $publishform ) {
		      case 1:
			      $msg = $total ." ".JText::_('Models')." ".JText::_('Published');
		      break;
		      case 0:
		      default:
			      $msg = $total ." ".JText::_('Models')." ".JText::_('Unpublished');
		      break;
	      }

	      $mainframe->redirect( 'index2.php?option='.$option.'&task=models', $msg );
      }
	
/*========================================================================================
 *===============================Import Functions=========================================
 *=======================================================================================*/
 /*------------------------------------------------------------------
	showimport:
	displays a form for CSV import
	Copyright (c) 2011 by KISS Software
  -------------------------------------------------------------------*/
	function showimport()
	{
	global $option;
	$ks_help = new KissHelper();			
	$db = &JFactory::getDBO();
	// build category tree listbox
	$query = "SELECT id AS id, pid AS parent, cat_name AS name, showads as active FROM #__ksads_cats WHERE published = 1 ORDER BY ordering";	
	$db->setQuery( $query );
	$cats = $db->loadObjectList();
	$preload = array();
	$catlistbox= $ks_help->treeSelectList( $cats, 0, $preload, 'catid', 'class="inputbox" size="1"', 'value', 'text', $catid, 1, "-".JText::_('Select Category')."-", 0 );
	$lists['catid'] = $catlistbox;
	HTML_classifieds::showimport($lists);	
	}

  /*------------------------------------------------------------------
	applyimport:
	runs the import of data from a CSV file
	Copyright (c) 2011 by KISS Software
  -------------------------------------------------------------------*/
	function applyimport()
	{
	global $mainframe, $option;
	$ks_help = new KissHelper();
	$db = &JFactory::getDBO();
	$conf=& JTable::getInstance('config', 'Table');
	$conf->load(1);
	include_once (JPATH_ROOT.DS."components".DS.$option.DS."class.csv2mysql.php");
	// Set values and start import when form has been submitted using the import button
		$imp_arr = split(",", $_POST['task0']);
		$dbafields = $_SESSION['dbflds'];
		$importdata = $_SESSION['importdata'];
		$alldata = $_SESSION['alldata'];
		$recordsets = $_SESSION['datalines'];
		$filename = $_SESSION['filename'];
		$delimiter = $_SESSION['delimiter'];
		$keywords = $_POST['keywords'];
		$description = $_POST['description'];
		// Import options
		$catcreate = isset($_POST['cbcc']) ? 1 : 0 ;
		$showmodule = isset($_POST['cbsm'])? 1 : 0 ;
		$boxnumber = isset($_POST['cbbn']) ? 1 : 0 ;
		$commercial = isset($_POST['cbac']) ? 1 : 0 ;
		$showaddress = isset($_POST['cbsa']) ? 1 : 0 ;
		$categ = $_POST['filter_catid'];
		$gplugin_params = new JParameter( $gplugin->params );
		if (is_array($imp_arr)) {
		// Read Import data from file line by line to avoid running out of memory space while reading big files.
		// To save time, read 100 recordsets at once. Begin with line 2, because 1 is the fields line.
		$start = 2;
		$import=new Import();
		//Set the next 2 settings to 1 to get status and error messages for testing.
		$import->debug = 0;
		$import->return_debug = 0;
		$import->set_format("win");
		$import->set_delimit_char($delimiter);
		$skip = 0;
		$impt = 0;
		$msg = "";
		while (!$done) {	
			$end = $start + 100;
			if ($end > $recordsets) {
				$end = $recordsets;
				}
			$import->reset_class_state();
			$import->read_csv_file(JPATH_ROOT.DS."tmp".DS.$filename, $start, $end);
			$import->create_csv_data_array();
			$importdata = $import->csv_data_keyed;
			$alldata = $import->csv_data_all;
		// Data read, now start processing
		  for ($j = 0; $j < count($alldata); $j++) {
		  //check whether fields have length=0. If so, ignore this line.
		  $l = 0;
		  for ($k = 0; $k < count($imp_arr); $k++) {
		      $imp_pair = split("-->", $imp_arr[$k]);
		      $l = $l + strlen($alldata[$j][$imp_pair[0]]);
		      }
		      if ($l < count($importdata)+3) { 
		          $ignore = 2;
			  } else {
			  $ignore = 1;
			  }
		      unset ($imp_pair);

		  if ($ignore == 1) {
		  // Build query
		  $query = "INSERT INTO #__ksads_ads (catid, date_created, date_expiry, published, ad_ident, ad_name, ad_intro, link_uri, link_txt, ";
		  $query .="ad_address, ad_post, ad_location, ad_image, ad_img_comment, ad_boxnumber, ad_commercial, ad_price, ad_price_pu, ad_desc, ";
		  $query .="contact_name, contact_tel, contact_email, contact_website, meta, phonetic, views, longitude, latitude, showinmodule, show_address";

		  // Build data values
		  $published = 1;
		  $views = 0;
		  $catno = 1;
		  $today = date("Y-m-d H:i:s");
		  $today_short = date("Y-m-d");
		  $expiry = date("Y-m-d", strtotime("$today_short + 60 days"));  
		  //Iterate thru each key-value pair and set import data value
		  foreach ($dbafields as $key=>$value) {
			for ($k = 0; $k < count($imp_arr); $k++) {
			$imp_pair = split("-->", $imp_arr[$k]);
			if (trim($key) == trim($imp_pair[1])) {
			    $rawdata = $alldata[$j][$imp_pair[0]];

			    switch ($value) {
			      // -------------Category field-----------------------------------
			      case "catid":
			      // Check whether category exists
				  if ($categ) {
				      $catno = $categ;
				      } else {
				  $query1 = "SELECT * FROM #__ksads_cats WHERE ";
				  //is value a number?
				  if (is_int($rawdata)) {
				    $query1 .= "id = $rawdata";   
				    } else {
				    $query1 .= "cat_name = '$rawdata'"; 
				    }
				  $db->setQuery($query1);
				  if ($cat = $db->loadObject()) {
				      $catno = $cat->id;  
				      } else {
				      //Create new category?
				      if ($catcreate) {
					  $query1 = "INSERT INTO #__ksads_cats (cat_name, published, autopublish, complaints, showads, showinmodule) VALUES ('$rawdata', 1, 1, 1, 1, 1)";
					  $db->setQuery($query1);
					  $db->query();
					  $catno = $db->insertid();
					  } // End if ($catcreate)
				      } // End if ($cat = ...)
				  } // End if ($categ=...)
				break;

			      case "meta":     // -------------Normal fields-----------------------------------
				    $meta = $rawdata.",".$keywords;
				break;  
			      case "ad_ident":
				    $ident = $rawdata;
				break;  
			      case "ad_desc":
				    $desc = $rawdata;
				break;  
			      case "ad_name":
				    $name = $rawdata;
				break;  
			      case "ad_intro":
				    $intro = $rawdata;
				break;  
			      case "ad_image":
				    $img = $rawdata;
				break;  
			      case "ad_address":
				    $address = $rawdata;
				break;  
			      case "ad_post":
				    $postcode = $rawdata;
				break;  
			      case "ad_location":
				    $location = $rawdata;
				break;  
			      case "ad_img_comment":
				    $img_comment = $rawdata;
				break;  
			      case "ad_price":
				    $price = str_replace($rawdata, ",", ".");
				break;  
			      case "contact_name":
				    $cname = $rawdata;
				break;  
			      case "contact_tel":
				    $ctel = $rawdata;
				break;  
			      case "contact_email":
  				    $cmail = $rawdata;
				break;  
			      case "contact_website":
				    $csite = $rawdata;
				break;  
			      case "link_uri":
				    $luri = $rawdata;
				break;  
			      case "link_txt":
				    $ltxt = $rawdata;
				break;  
			      case "views":
				    $views = $rawdata;
				break;  					
			      case "uid":
				    $uid = $rawdata;
				break;  
			} // End switch ($value)
			} // End if ($trim(key)...)
			} // End for ($k=0 ...)
			} // End foreach
			
			// Build some special fields
			$exp1 = $name ."|".$cname."|".$location."|".$intro."|".$desc;
			$expression = (strlen($exp1) > 255) ? substr($exp1, 0, 254): $exp1;
			$phonetic = $ks_help->phonetic($expression);
			if (strlen($address) && strlen($postcode) && strlen($location)) {
			    $gwebsite = $gplugin_params->get( 'googlewebsite', 'maps.google.com' );
			    $key = trim($gplugin_params->get( 'Google_API_key', '' ));
			    $iso = "UTF-8";
			    $locat = "$address, $postcode, $location";
			    $geodata = get_geo($gwebsite, $locat, $iso, $key);
			    $coords = explode(",", $geodata['coords'][0]);
			    $long = $coords[0];
			    $lat = $coords[1];
			    }  
			$datas = $catno.", '$today', '$expiry', $published, '0', '$name', '$intro', '$luri', '$ltext', '$address', '$postcode', '$location', '$img', '$img_comment', $boxnumber, $commercial";
			$datas .= ", '$price', 0, '$desc', '$cname', '$ctel', '$cmail', '$csite', '$meta', '$phonetic', $views, '$long', '$lat', $showmodule, $showaddress";
			//Put it into the database!
			$query .=") VALUES (";
			$datas .=")";
			$query .= $datas;
			$db->setQuery( $query );
		
			if (!$db->query()) {
			    $skip ++;
			    $skipmsg = ", ".sprintf(JText::_( 'Items skipped' ), count($alldata) );
			    } else {
			    $impt ++;
			    $sucmsg = sprintf(JText::_( 'Items imported' ), $impt );
			    }
		      } // End if ($ignore)
		      } // End for ($j = 0; $j < count($alldata); $j++)

		  $start = $start + 100;
		  if ($start > $end) {
		      $done = 1;
		      }
		  } // End while (!done)
		  } else {
		    $sucmsg = JText::_( 'No import parameters selected' );
		  } // End if (isarray...)

	      if (file_exists($filename)) {
		  unlink ($filename);
		}
		// We're done, go back to control panel with message
		$link = 'index2.php?option='.$option;
		$msg .= $sucmsg.$skipmsg;
		if ($import->debug && $import->return_debug) {
			$msg .=$import->error_messages;
			}
	    $mainframe->redirect( $link, $msg );
	    	
	}
	
/*========================================================================================
 *===============================Help Functions===========================================
 *=======================================================================================*/

	// list subcats as tree
	function tree($parent, $ident, $tree) {
	    global $tree;
	    $db = &JFactory::getDBO();
		$db->setQuery("SELECT * FROM #__ksads_cats WHERE pid =".$parent." ORDER BY ordering");
	    $rows = $db->loadObjectList();
	    if ($db->getErrorNum()) {
		echo $db->stderr();
		return false;
	    }
	    foreach ($rows as $v) {
	    $v->cat_name = $ident.".&nbsp;&nbsp;<sup>L</sup>&nbsp;".$v->cat_name;
	    $v->cat_name = str_replace('.&nbsp;&nbsp;<sup>L</sup>&nbsp;','.&nbsp;&nbsp;&nbsp;&nbsp;',$v->cat_name);
	    $x = strrpos($v->cat_name,'.&nbsp;&nbsp;&nbsp;&nbsp;');
	    $v->cat_name = substr_replace($v->cat_name, '.&nbsp;&nbsp;<sup>L</sup>&nbsp;', $x,7);
	    $tree[] = $v;
	    
	    tree($v->id, $ident.".&nbsp;&nbsp;<sup>L</sup>&nbsp;", $tree);
	    }
	}

	/**
	 * Fetches the payment model for a given user
	 * @return void
	 */

	function getModelforUser($uid=0) {
	    $today = date("Y-m-d H:i:s");
	    $db = &JFactory::getDBO();	
		$conf=& JTable::getInstance('config', 'Table');
		$conf->load(1);

		$query = "SELECT * FROM #__ksads_customers WHERE uid ='$uid' AND published = '1'";
		$db->setQuery($query);
		if (!$customer = $db->loadObject()) {
			$model_id = 1;
			$customer_id = 0;
			} else {
			// Customer exists. Get model and check if customer is activated. If not, use default model
			$model_id = $customer->mid;
			$customer_id = $customer->id;
			}
		$query = "SELECT * FROM #__ksads_models WHERE id ='$model_id'";
		$db->setQuery($query);
		if (!$model = $db->loadObject()) {
			$query = "SELECT * FROM #__ksads_models WHERE id ='1'";
			$db->setQuery($query);
			$model = $db->loadObject();
			}
		return $model;	
	}

	/*------------------------------------------------------------------
	getImageDirforUser:
	Creates a unique image directory for a given user
	Copyright (c) 2010 KISS-Software.de
	-------------------------------------------------------------------*/
	function getImageDirforUser($uid=0, $retval=1) {
	    $db = &JFactory::getDBO();
	    $live_site = &JURI::root();
	    $base_path = JPATH_ROOT;
	    $user =& JFactory::getUser();
	    $user_id = $user->get( 'id' );
	    $conf =& JTable::getInstance('config', 'Table');
	    $conf->load(1);
		$user_dir = DS . "U" . $uid;
		$img_dir = str_replace(DS.DS, DS, "images". DS . $conf->ad_img_dir . DS . $user_dir.DS);
		$thu_dir = $img_dir . "thumbnails" . DS;
		$vid_dir = $img_dir . "videos" . DS;
		$upl_dir = $img_dir . "uploads" . DS;		
		$real_dir = str_replace(DS.DS, DS, $live_site.DS.$img_dir);

		$base_dir = str_replace(DS.DS, DS, $base_path.DS.$img_dir);
		make_user_dir($base_dir);
		$direk = str_replace(DS.DS, DS, $base_path.DS.$thu_dir);
		make_user_dir($direk);
		$direk = str_replace(DS.DS, DS, $base_path.DS.$vid_dir);
		make_user_dir($direk);
		$direk = str_replace(DS.DS, DS, $base_path.DS.$upl_dir);
		make_user_dir($direk);

		if ($retval == 1) {
		    return $real_dir;
		    } else {
		    return str_replace($base_path, "", $base_dir);
		    }
	}
	
	/*------------------------------------------------------------------
	make_user_dir:
	Makes a user directory and changes the dir and file rights
	Copyright (c) 2011 KISS-Software.de
	-------------------------------------------------------------------*/
	function make_user_dir ($base_dir) {
	    $conf =& JTable::getInstance('config', 'Table');
	    $conf->load(1);	
		if (!is_dir($base_dir)) {
		     if (!JFolder::create($base_dir, 0755)) {
				JError::raiseWarning(
					'SOME_ERROR_CODE',
					'JFolder::create: ' . JText::_('Could not create image directory'),
					'Path: ' . $base_dir
				);
				} else {
				// Try to adjust the file and folder rights
				$filemode = "0644";
				$foldermode = "0" . $conf->upl_rights;
				if (JPath::canChmod($base_dir)) {
					JPath::setPermissions($base_dir, $filemode, $foldermode);					
					} else {
					JError::raiseWarning(
						'SOME_ERROR_CODE',
						'JFolder::create: ' . JText::_('Could not change folder permissions'),
						'Path: ' . $base_dir
					);
					} // End if JPath::canChmod ...
				} // End if(!JFolder::create ...)
		    } // End if (!is_dir....)		
	}
	
	/**
	 * send an email to Administrators and users in case of ad prolongation
	 * @return void
	 */

	function _sendProlongationMail($adno, $prolong, $link, $func=0)
	{
		global $mainframe;

		$db	=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		$query	= "SELECT * FROM #__ksads_ads WHERE id = $adno";
		$db->setQuery($query);
		$data = $db->loadObject();

		// Get Advertiser User ID
		// if not KISS Joomla Version, the user table does not contain a field named "firstname"
		$ad_userid = $data->userid;
		if ($ad_userid > 0) {
			if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
				$query = "SELECT name, email, sendEmail";				
				} else {
				$query = "SELECT CONCAT_WS(' ', firstname, name) as name, email, sendEmail";
				}
			$query .=" FROM #__users WHERE id = '" . $ad_userid . "'";

			$db->setQuery( $query );
			$advertiser = $db->loadObject();

			$ad_name	= $advertiser->name;
			$ad_email	= $advertiser->email;
			} else {
			$ad_name	= $data->contact_name;
			$ad_email	= $data->contact_email;			
			}
		$usermail	= $user->get('email');
		$username 	= $user->get('username');

		$usersConfig 	= &JComponentHelper::getParams( 'com_users' );
		$sitename 	= $mainframe->getCfg( 'sitename' );
		$mailfrom 	= $mainframe->getCfg( 'mailfrom' );
		$fromname 	= $mainframe->getCfg( 'fromname' );
		$siteURL	= JURI::base();

		$subject 	= sprintf (JText::_('Prolongation Subject'), $data->ad_ident, $sitename);
		$subject 	= remove_HTML($subject);

		$message = sprintf ( JText::_( 'Prolongation Message User 1' ), $advertiser->name, $sitename, $prolong, $data->ad_ident, $data->ad_name, $data->ad_desc, $link );
		$message = remove_HTML($message);

		//get all super administrators
		// if not KISS Joomla Version, the user table does not contain a field named "firstname"
		if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
			$query = "SELECT name, email, sendEmail";				
			} else {
			$query = "SELECT CONCAT_WS(' ', firstname, name) as name, email, sendEmail";
			}
		$query .=' FROM #__users' .
			 ' WHERE LOWER( usertype ) = "super administrator"';
		$db->setQuery( $query );
		$rows = $db->loadObjectList();

		// Send email to user
		if ( ! $mailfrom  || ! $fromname ) {
			$fromname = $rows[0]->name;
			$mailfrom = $rows[0]->email;
		}
		// If mail should be sent only to admin, set func = 1
		if ($func == 0) {
		    JUtility::sendMail($mailfrom, $fromname, $ad_email, $subject, $message);
		   }

		// get superadministrators id
		foreach ( $rows as $row )
		{
			if ($row->sendEmail)
			{
				$message2 = sprintf ( JText::_( 'Prolongation Message Admin 1' ), $row->name, $data->ad_ident, $advertiser->name, $sitename, $prolong, $advertiser->name, $ad_email, $username, $data->ad_ident, $data->ad_name, $data->ad_intro);
				$message2 = remove_HTML($message2);
				JUtility::sendMail($mailfrom, $fromname, $row->email, $subject, $message2);
			}
		}
	}

	/**
	 * send an email to Administrators and users in case of ad prolongation
	 * @return void
	 */

	function _sendDeletionMail($adno, $prolong, $func=0)
	{
		global $mainframe;
		$db	=& JFactory::getDBO();
		$user	=& JFactory::getUser();
		$query	= "SELECT * FROM #__ksads_ads WHERE id = $adno";
		$db->setQuery($query);
		$data = $db->loadObject();
		// Get Advertiser User ID
		// if not KISS Joomla Version, the user table does not contain a field named "firstname"
		$ad_userid = $data->user_id;
		if ($ad_userid > 0) {
			if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
				$query = "SELECT name, email, sendEmail";				
				} else {
				$query = "SELECT CONCAT_WS(' ', firstname, name) as name, email, sendEmail";
				}
			$query .=" FROM #__users WHERE id = '" . $ad_userid . "'";
			$db->setQuery( $query );
			$advertiser = $db->loadObject();
			$ad_name	= $advertiser->name;
			$ad_email	= $advertiser->email;
			} else {
			$ad_name	= $data->ad_name;
			$ad_email	= $data->contact_email;
			}
		$usermail	= $user->get('email');
		$username 	= $user->get('username');

		$usersConfig 	= &JComponentHelper::getParams( 'com_users' );
		$sitename 	= $mainframe->getCfg( 'sitename' );
		$mailfrom 	= $mainframe->getCfg( 'mailfrom' );
		$fromname 	= $mainframe->getCfg( 'fromname' );
		$siteURL	= JURI::base();

		$subject 	= sprintf (JText::_('Prolongation Subject'), $data->ad_ident, $sitename);
		$subject 	= remove_HTML($subject);

		$message = sprintf ( JText::_( 'Prolongation Message User 2' ), $advertiser->name, $sitename, $prolong);
		$message = remove_HTML($message);

		//get all super administrators
		// if not KISS Joomla Version, the user table does not contain a field named "firstname"
		if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
			$query = "SELECT name, email, sendEmail";
			} else {
			$query = "SELECT CONCAT_WS(' ', firstname, name) as name, email, sendEmail";
			}
		$query .=' FROM #__users' .
			 ' WHERE LOWER( usertype ) = "super administrator"';
		$db->setQuery( $query );
		$rows = $db->loadObjectList();

		// Send email to user
		if ( ! $mailfrom  || ! $fromname ) {
			$fromname = $rows[0]->name;
			$mailfrom = $rows[0]->email;
		}
		// If mail should be sent only to admin, set func = 1
		if ($func == 0) {
		    JUtility::sendMail($mailfrom, $fromname, $ad_email, $subject, $message);
		   }

		// get superadministrators id
		foreach ( $rows as $row )
		{
			if ($row->sendEmail)
			{
				$message2 = sprintf ( JText::_( 'Prolongation Message Admin 2' ), $row->name, $data->ad_ident, $advertiser->name, $sitename, $advertiser->name, $ad_email, $username, $data->ad_ident, $data->ad_name, $data->ad_intro);
				$message2 = remove_HTML($message2);
				JUtility::sendMail($mailfrom, $fromname, $row->email, $subject, $message2);
			}
		}
	}

	function getAdsLeftforCustomer($uid = 0) {
		$today = date("Y-m-d");
		$db	=& JFactory::getDBO();
		// Is user a customer ?
		$query = "SELECT * FROM #__ksads_customers WHERE `uid` = $uid";
		$db->setQuery($query);
		$data = JRequest::get('post');
		if ($customer = $db->loadObject()) {
			$mid = $customer->mid;
			$model =& JTable::getInstance('models', 'Table');
			$model->load($mid);
			// Set this customer's 'Ads left' info according to the model/customer/ads relations
			$query = "SELECT COUNT(*) FROM #__ksads_ads WHERE `user_id` = $uid AND published = 1 AND (date_expiry > '$today' OR expiry_deactivate = 1)";
			$db->setQuery($query);
			$adsplaced = $db->loadResult();
			if ($model->ads_per_period > 0) {
				$custads = (($model->ads_per_period - $adsplaced) > 0) ? $model->ads_per_period - $adsplaced : 0;
				} else {
				//special case: model allows unlimited number of ads
				$custads = 999999;
				}
			return $custads;	
		} // End if $db->loadObject()
		return 0;
	}

	function bumpAdsLeftforUser($uid = 0, $cnt = 0) {
		$db	=& JFactory::getDBO();
		// Is user a customer ?
		$query = "SELECT * FROM #__ksads_customers WHERE `uid` = $uid";
		$db->setQuery($query);
		if ($customer = $db->loadObject()) {
		    $custads = (($customer->adsleft + $cnt) > 0) ? $customer->adsleft + $cnt : 0;
		    $query = "UPDATE #__ksads_customers SET adsleft = $custads WHERE `uid` = $uid";
		    $db->setQuery($query);
			
		} // End if $db->loadObject()
	}

	function hasExtension($ext = 0) {
		$db	=& JFactory::getDBO();
		// Check if extension file exists
		$extfolder = JPATH_ROOT.DS."components".DS."com_ksadvertiser".DS."extensions";
		if (JFolder::exists($extfolder)) {
		// Is extension number registered ?
		$query = "SELECT * FROM #__ksads_extensions WHERE `id` = $ext";
		$db->setQuery($query);
		if ($extname = $db->loadObject()) {
		    $filename = $extname->ext_name.".php";
		    if (file_exists($extfolder.DS.$filename)) {
			return true;    
			} else {
			return false;    
			}
		    }
		}
	}

	function loadExtension($ext = 0) {
		// Load extension class_exists
		$db	=& JFactory::getDBO();
		// Check if extension file exists
		$extfolder = JPATH_ROOT.DS."components".DS."com_ksadvertiser".DS."extensions";
		if (JFolder::exists($extfolder)) {
		// Is extension number registered ?
		$query = "SELECT * FROM #__ksads_extensions WHERE `id` = $ext";
		$db->setQuery($query);
		if ($extname = $db->loadObject()) {
		    $filename = $extname->ext_name.".php";
		    $extclass = $extname->ext_name;
		    if (file_exists($extfolder.DS.$filename)) {
			include_once($extfolder.DS.$filename);
//			if (!class_exists($extclass)) {
			    $extmod = new $extclass();
			    if ($extmod->extension_number == $ext) {
				$extmod->loadLanguage();
				return $extmod;
				}
//			    }
			} else {
			return false;    
			}
		    }
		}
	}

	/*------------------------------------------------------------------
	renderMedia:
	Renders the output of a media player for specified media
	Copyright (c) 2010 joomlaworks.gr, modified by KISS Software
	-------------------------------------------------------------------*/
	function renderMedia($tagOrder) {
		global $option;
		include_once(JPATH_ROOT .DS.'components'.DS.$option.DS.'players'.DS.'sources.php');
		include_once(JPATH_ROOT .DS.'components'.DS.$option.DS.'players'.DS.'helper.php');
		$live_site = &JURI::root();
		$conf =& JTable::getInstance('config', 'Table');
		$conf->load(1);
		$user =& JFactory::getUser();
		$user_id = $user->get( 'id' );
		
		foreach ($tagReplace as $plg_tag => $value) {
			// expression to search for
			$regex = "#{".$plg_tag."}(.*?){/".$plg_tag."}#s";
			// process tags

			if (preg_match_all($regex, $tagOrder, $matches, PREG_PATTERN_ORDER) > 0) {
				// start the replace loop
				foreach ($matches[0] as $key => $match) {
					$tagcontent 		= preg_replace("/{.+?}/", "", $match);
					$tagparams 			= explode('|',$tagcontent);
					$tagsource 			= trim(strip_tags($tagparams[0]));
					$final_vwidth 		= (@$tagparams[1]) ? $tagparams[1] : $conf->med_width;
					$final_vheight 		= (@$tagparams[2]) ? $tagparams[2] : $conf->med_height;
					$final_autoplay 	= (@$tagparams[3]) ? $tagparams[3] : $conf->med_autoplay;
					$final_transparency = (@$tagparams[4]) ? $tagparams[4] : $conf->med_transparency;
					$final_background	= (@$tagparams[5]) ? $tagparams[5] : $conf->med_background;
					$final_backgroundqt	= (@$tagparams[6]) ? $tagparams[6] : $conf->med_backgroundQT;	
					$final_controlbar	= (@$tagparams[7]) ? $tagparams[7] : $conf->med_controlbar;

					// source elements
					$findAVparams = array(
						"{SOURCE}",
						"{SOURCEID}",
						"{FOLDER}",
						"{WIDTH}",
						"{HEIGHT}",		
						"{AUTOPLAY}",
						"{TRANSPARENCY}",
						"{BACKGROUND}",
						"{BACKGROUNDQT}",
						"{CONTROLBAR}",
						"{SITEURL}",
					);
			
					// special treatment
					if($plg_tag=="yahoo"){
						$tagsourceyahoo = explode('/',$tagsource);
						$tagsource = 'id='.$tagsourceyahoo[1].'&amp;vid='.$tagsourceyahoo[0];
					}
					if($plg_tag=="youku") $tagsource = substr($tagsource,3);		
					
					// Prepare the HTML
					$output = new JObject;
					// replacement elements
					if(in_array($plg_tag, array("mp3","mp3remote","wma","wmaremote"))){
						$afolder = getImageDirforUser($user_id, 0)."videos";					
						$transparency = $conf->med_transparency;
						$background = $conf->med_background;
						$backgroundQT = $conf->med_backgroundQT;
						$controlBarLocation = $conf->med_controlbar;

						$replaceAVparams = array(
							$tagsource,
							substr(md5($tagsource),1,8),
							$afolder,
							$awidth,
							$aheight,
							$final_autoplay,
							$transparency,
							$background,
							$backgroundQT,
							$controlBarLocation,
							$live_site,
						);
						
						$output->playerWidth = $awidth;
						$output->playerHeight = $aheight;
						
					} else {
						$vfolder = getImageDirforUser($user_id, 0)."videos";
						$transparency = $conf->med_transparency;
						$background = $conf->med_background;
						$backgroundQT = $conf->med_backgroundQT;
						$controlBarLocation = $conf->med_controlbar;
					
						$replaceAVparams = array(
							$tagsource,
							substr(md5($tagsource),1,8),
							$vfolder,
							$final_vwidth,
							$final_vheight,
							$final_autoplay,
							$transparency,
							$background,
							$backgroundQT,
							$controlBarLocation,
							$live_site,
						);
						
						$output->playerWidth = $final_vwidth;
						$output->playerHeight = $final_vheight;					
					}
					
					$output->playerID = 'AVPlayerID_'.substr(md5($tagsource),1,8);
					$output->player = JFilterOutput::ampReplace(str_replace($findAVparams, $replaceAVparams, $tagReplace[$plg_tag]));
					$output->playerEmbedHTML = preg_replace("#(\r|\t|\n|)#s","",htmlentities($output->player, ENT_QUOTES));
					
					// Download button
					if(isset($downloadLink) && $downloadLink){
						if (in_array($plg_tag, array("flv","swf","wmv","mov","mp4","3gp","divx"))) {
							$output->downloadLink = $live_site.'components'.DS.$option.DS.'players'.DS.'download.php?file='.$vfolder.DS.$tagsource; //.'.'.$plg_tag;
						} elseif(in_array($plg_tag, array("mp3","wma"))) {
							$output->downloadLink = $live_site.'components'.DS.$option.DS.'players'.DS.'download.php?file='.$afolder.DS.$tagsource; //.'.'.$plg_tag;
						} else {
							$output->downloadLink = '';
						}
					} else {
						$output->downloadLink = '';
					}
					
					// Lightbox popup
					if(isset($lightboxLink) && $lightboxLink && !in_array($plg_tag, array("mp3","mp3remote","wma","wmaremote"))) { // video formats only
						$output->lightboxLink = '#'.$output->playerID;
					} else {
						$output->lightboxLink = '';
					}
					
					// Embed form
					if(isset ($embedForm ) && $embedForm && !in_array($plg_tag, array("wmv","wmvremote","wma","wmaremote"))){ // no Windows Media formats
						$output->embedLink = 'embed_'.$output->playerID;
					}	else {
						$output->embedLink = '';
					}

					// Fetch the template
					ob_start();
					if (!isset($plg_name)) {
						$plg_name = null;
					    }
					$getTemplatePath = AllVideosHelper::getTemplatePath($plg_name,'default.php');
					$getTemplatePath = $getTemplatePath->file;
					include($getTemplatePath);
					$getTemplate = "<!-- Video Player Start -->".ob_get_contents()."<!-- Video Player End -->";
					ob_end_clean();

					// Do the replace
					$retval = preg_replace("#{".$plg_tag."}".preg_quote($tagcontent)."{/".$plg_tag."}#s", $getTemplate , $tagOrder);
					return $retval;

				} // end foreach
	
			} // end if
		
		} // END ALLVIDEOS LOOP	
	}

  /*------------------------------------------------------------------
	remove_HTML:
	strips all HTML tags from a string
	Copyright (c) 2010 by KISS Software
  -------------------------------------------------------------------*/
    function remove_HTML($s , $keep = '' , $expand = 'script|style|noframes|select|option'){
        /**///prep the string
        $s = ' ' . $s;
       
        /**///initialize keep tag logic
        if(strlen($keep) > 0){
            $k = explode('|',$keep);
            for($i=0;$i<count($k);$i++){
                $s = str_replace('<' . $k[$i],'[{(' . $k[$i],$s);
                $s = str_replace('</' . $k[$i],'[{(/' . $k[$i],$s);
            }
        }
       
        //begin removal
        /**///remove comment blocks
        while(stripos($s,'<!--') > 0){
            $pos[1] = stripos($s,'<!--');
            $pos[2] = stripos($s,'-->', $pos[1]);
            $len[1] = $pos[2] - $pos[1] + 3;
            $x = substr($s,$pos[1],$len[1]);
            $s = str_replace($x,'',$s);
        }
       
        /**///remove tags with content between them
        if(strlen($expand) > 0){
            $e = explode('|',$expand);
            for($i=0;$i<count($e);$i++){
                while(stripos($s,'<' . $e[$i]) > 0){
                    $len[1] = strlen('<' . $e[$i]);
                    $pos[1] = stripos($s,'<' . $e[$i]);
                    $pos[2] = stripos($s,$e[$i] . '>', $pos[1] + $len[1]);
                    $len[2] = $pos[2] - $pos[1] + $len[1];
                    $x = substr($s,$pos[1],$len[2]);
                    $s = str_replace($x,'',$s);
                }
            }
        }
       
        /**///remove remaining tags
        while(stripos($s,'<') > 0){
            $pos[1] = stripos($s,'<');
            $pos[2] = stripos($s,'>', $pos[1]);
            $len[1] = $pos[2] - $pos[1] + 1;
            $x = substr($s,$pos[1],$len[1]);
            $s = str_replace($x,'',$s);
        }
       
        /**///finalize keep tag
        for($i=0;$i<count($k);$i++){
            $s = str_replace('[{(' . $k[$i],'<' . $k[$i],$s);
            $s = str_replace('[{(/' . $k[$i],'</' . $k[$i],$s);
        }
       
        return trim($s);
    }

  /*------------------------------------------------------------------
	get_geo:
	returns a geocode of a given address from Google Maps
	Copyright (c) 2010 by KISS Software
  -------------------------------------------------------------------*/
	function get_geo($googlewebsite, $address, $iso, $key)
	{
		$coords = '';
		$getpage='';
		$replace = array("\n", "\r", "&lt;br/&gt;", "&lt;br /&gt;", "&lt;br&gt;", "<br>", "<br />", "<br/>");
		$address = str_replace($replace, '', $address);
	
		$logmessage = "Address: ".$address."<br />";
		$uri = "http://".$googlewebsite."/maps/geo?q=".urlencode($address)."&output=xml&oe=".$iso."&key=".$key;
//		$uri = "http://maps.google.com/maps/api/geocode/xml?address=".urlencode($address)."&sensor=false";

		if ( !class_exists('SimpleXMLElement') )
		{
			// PHP4
			$ok = false;
			$logmessage .="SimpleXMLElement doesn't exists so probably PHP 4.x <br />";
			if (ini_get('allow_url_fopen'))
				if (($getpage = file_get_contents($uri)))
					$ok = true;

			if (!$ok) {
				$logmessage = "URI couldn't be opened probably ALLOW_URL_FOPEN off";
				if (function_exists('curl_init')) {
					$logmessage .="curl_init does exists <br />";
					$ch = curl_init();
					$timeout = 5; // set to zero for no timeout
					curl_setopt ($ch, CURLOPT_URL, $uri);
					curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
					curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
					$getpage = curl_exec($ch);
					curl_close($ch);
				} else
					$logmessage .="curl_init doesn't exists <br />";
			}
	
			$logmessage .="Returned page: ".$getpage;
	
			if (function_exists('mb_detect_encoding')) {
				$enc = mb_detect_encoding($getpage);
				if (!empty($enc))
					$getpage = mb_convert_encoding($getpage, $iso, $enc);
			}
				
			if (function_exists('domxml_open_mem')&&($getpage<>'')) {
				$responsedoc = domxml_open_mem($getpage);
				if ($responsedoc !=null) {				
					$response = $responsedoc->get_elements_by_tagname("Response");
					if ($response!=null) {
						$placemark = $response[0]->get_elements_by_tagname("Placemark");
						if ($placemark!=null) {
							$point = $placemark[0]->get_elements_by_tagname("Point");
							if ($point!=null) {
								$coords = $point[0]->get_content();
								$logmessage .="Coordinates: ".join(", ", explode(",", $coords))."<br />";
								$geodata = array(
								'coords' => $coords
								  );
								return $geodata;
							}
						}
					}
				}
			}
			$logmessage .="Coordinates: null <br />";
			return null;

			} else {

			// PHP5
			$logmessage .="SimpleXMLElement does exists so probably PHP 5.x <br />";
			$ok = false;
			if (ini_get('allow_url_fopen')) { 
				if (file_exists($uri)) {
					$getpage = file_get_contents($uri);
					$ok = true;
				}
			} 
			
			if (!$ok) { 
				$logmessage .="URI couldn't be opened probably ALLOW_URL_FOPEN off <br />";
				if (function_exists('curl_init')) {
					$logmessage .="curl_init does exists <br />";
					$ch = curl_init();
					$timeout = 5; // set to zero for no timeout
					curl_setopt ($ch, CURLOPT_URL, $uri);
					curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
					curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
					$getpage = curl_exec($ch);
					curl_close($ch);
				} else
					$logmessage .="curl_init doesn't exists <br />";
			}

			$logmessage .="Returned page: ".$getpage."<br />";
			if (function_exists('mb_detect_encoding')) {
				$enc = mb_detect_encoding($getpage);
				if (!empty($enc))
					$getpage = mb_convert_encoding($getpage, $iso, $enc);
			}

			if ($getpage <>'') {
				$expr = '/xmlns/';
				$getpage = preg_replace($expr, 'id', $getpage);
				$xml = new SimpleXMLElement($getpage);
				foreach($xml->xpath('//coordinates') as $value) {
					//$coords = $coordinates;
					$coords = $value;
					break;
				}
				foreach($xml->xpath('//AdministrativeAreaName') as $value) {
					$state = $value;
					break;
				}
				foreach($xml->xpath('//SubAdministrativeAreaName') as $value) {
					$county = $value;
					break;
				}
				foreach($xml->xpath('//CountryName') as $value) {
					$country = $value;
					break;
				}
				foreach($xml->xpath('//ThoroughfareName') as $value) {
					$street = $value;
					break;
				}
				foreach($xml->xpath('//PostalCodeNumber') as $value) {
					$plz = $value;
					break;
				}
				foreach($xml->xpath('//LocalityName') as $value) {
					$city = $value;
					break;
				}
				foreach($xml->xpath('//DependentLocalityName') as $value) {
					$suburb = $value;
					break;
				}

				$geodata = array(
				'coords' => $coords,
				'street' => $street,
				'city' => $city,
				'zip' => $plz,
				'county' => $county,
				'state' => $state,
				'country' => $country,
				'suburb' => $suburb
				  );

				if ($coords=='') {
					$logmessage .="Coordinates: null <br />";
				}

				$logmessage .="Coordinates: ".join(", ", explode(",", $coords))."<br />";
				return $geodata;
			}
		}
		$logmessage .="get_geo totally wrong end! <br />";
	}

	/*------------------------------------------------------------------
	createThumbnails:
	Scans a directory for images, resizes them and stores them to
	another directory. Width can be adjusted
	Copyright (c) 2011 KISS-Software.de
	-------------------------------------------------------------------*/
	function createThumbnails( $pathToImages, $pathToThumbs, $filename, $thumbWidth=0, $func=0, $img_title='' )
	{
	    global $option;
	    $conf =& JTable::getInstance('config', 'Table');
	    $conf->load(1);
	    $base_path = JPATH_ROOT;
	    $tpath = $base_path.DS."components".DS.$option.DS."phpthumb".DS;
	    $twidth = ($thumbWidth == 0) ? $conf->days_shown : $thumbWidth;
	    $fileinfo=$base_path.DS. $pathToImages.$filename;		
		require_once ($tpath."ThumbLib.inc.php");
	    switch ($func) {
		    case 0:
		    // create a single thumbnail and save it
		    $thumbinfo = str_replace(DS.DS, DS, $base_path.$pathToThumbs."thumb_".$filename);
			$thumb = PhpThumbFactory::create($fileinfo);  
			$thumb->adaptiveResize($twidth, $twidth)->save($thumbinfo); 		    			
		    break;
		    case 1:
		    // open the directory, create thumbnails from all images
		    $dir = opendir( $pathToImages );
		    // loop through it, looking for any/all JPG files:
		    while (false !== ($fname = readdir( $dir ))) {
					// parse path for the extension
					$fileinfo=$base_path.DS. $pathToImages.$filename;		
					// continue only if this is a valid image
					// load image and get image size
					$thumbinfo = str_replace(DS.DS, DS, $base_path.$pathToThumbs."thumb_".$filename);
					$thumb = PhpThumbFactory::create($fileinfo);  
					$thumb->adaptiveResize($twidth, $twidth)->save($thumbinfo); 		    			
					  }
		    // close the directory
		    closedir( $dir );
		    break;
		    case 2:
		    // create a thumbnail, do not save it and display the image
		    $thumbinfo = str_replace(DS.DS, DS, $base_path.$pathToThumbs."thumb_".$filename);
			$thumb = PhpThumbFactory::create($fileinfo);  
			$thumb->adaptiveResize($twidth, $twidth);
			$thumb->show();
		    }
	}

  /*------------------------------------------------------------------
	fieldVisible:
	determines whether a field is visible or not
	Copyright (c) 2010 by KISS Software
  -------------------------------------------------------------------*/   
	function fieldVisible($fieldno)
	{
		$user =& JFactory::getUser();
		$user_id = $user->get( 'id' );
		$user_gid = $user->get( 'gid' );
		// if not KISS Joomla Version, the user table does not contain a field named "aid"
		if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
			$user_aid = 0;	
			} else {
			$user_aid = $user->get( 'aid' );	
			}	
		$db =& JFactory::getDBO();	
		$query = "SELECT * FROM #__ksads_fields WHERE id = ". $fieldno;
		$db->setQuery($query);
		$field = $db->loadObject();
		$showit = 0;
		if ($field->gid <= $user_gid && $field->gid > 0) {
			$showit = 1;
			}
		if ($field->aid == $user_aid && $field->aid > 0) {
			$showit = 1;
			}
		if ($field->uid == $user_id && $field->uid > 0) {
			$showit = 1;
			}
		if ($field->visible == 1) {
			$showit = 1;
			}
		return $showit;	
		}

?>