<?php
/*----------------------------------------------------------------------------------------------
| Kiss Advertiser (com_ksadvertiser)						Version	1.5.69
|-----------------------------------------------------------------------------------------------
| Author: Heiner Klostermann (DocChicago) - KISS Software Germany				
| Copyright (c) 2010 by KISS Software, 59227 Ahlen (NRW), Germany				
|-----------------------------------------------------------------------------------------------
| License GNU/GPL 						http://www.gnu.org/copyleft/gpl.html
|-----------------------------------------------------------------------------------------------
|												
| This component is free software, distributed under the GNU / GPL License. You may use,	
| copy and redistribute it free of charge as long as it complies with the license terms.	
|												
| 
| For help and suggestions please visit our support forum at www.kiss-software.de
|
|-----------------------------------------------------------------------------------------------
| created 2010-01-01								updated	2012-01-28
|-----------------------------------------------------------------------------------------------*/

defined('_JEXEC') or die('Restricted Access');
jimport('joomla.application.helper');
require_once(JApplicationHelper::getPath( 'html' ) );
JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.$option.DS.'tables');
require_once(JPATH_ROOT. DS. 'components' .DS. 'com_ksadvertiser' .DS.'class.help.php' );

//---------------------Community Builder Integration-------------------------------------
$cbpath = JPATH_ROOT .DS. 'administrator' .DS. 'components' .DS. 'com_comprofiler' .DS. 'plugin.foundation.php';
if (file_exists($cbpath)) { 
	include_once($cbpath);
	cbimport('cb.database');
	cbimport('cb.tables');
	cbimport('language.front');
	cbimport('cb.tabs');
	}
//--------------------Community Builder Integration END-----------------------------------

if($task == '') {
	$db =& JFactory::getDBO();
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);
	switch ($conf->startpanel) {
		case 1:
		case 6:
		case 7:
		default:
		$task = 'showmaincats';
		break;
		case 2:
		case 3:
		case 4:
		$task = 'viewall';
		break;
		case 5:
		$task = 'advsearch';
		break;
		}
	}

switch($task)
{
	case 'advsearch':
		showSearchForm();
		break;
	case 'activate':
		activateModelForUser();
		break;
	case 'remove':
		removeAd($option);
		break;
	case 'searchads':
		searchAds();
		break;
	case 'searchAdvanced':
		searchAdvanced();
		break;
	case 'view':
		viewAds();
		break;
	case 'viewall':
		viewAllAds();
		break;
	case 'viewad':
		viewAd();
		break;
	case 'edit':
	case 'add':
		editAd($task);
		break;
	case 'sendInquiry':
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		$data = JRequest::get('post');
		$sent = _sendInquiry($data);
		break;

	case 'saveComplaint':
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	    saveComplaint();
		break;

	case 'saveCustomer':
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
	    saveCustomer();
		break;

		case 'save':
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
		save();
		break;

	case "savadimgs":
        saveAdditionalImage($option);
	break;

	case "deletimgs":
        deleteAdditionalImage($option);
	break;

	case 'complain':
		complain();
		break;
	case 'contact':
		contact();
		break;
	case 'download':
		downloadFile();
		break;
	case 'myads':
		myAds();
		break;
	case 'showcats':
		showPublishedSubCategories();
		break;
	case 'prolongation':
		prolongAd($option);
		break;
	case 'pushad':
		pushAd($option);
		break;
	case 'paymentpage':
		showPaymentPage();
		break;
	case 'show_cancel':
		showConfirmationPage($option, 1);
		break;
	case 'show_success':
		showConfirmationPage($option, 2);
		break;
	case 'show_success_thirdparty':
		showConfirmationPage($option, 3);
		break;
	case 'show_addpay_success':
		showAddpayConfPage();
		break;
	case 'show_terms':
		showTermsPage($option);
		break;
	case 'show_remittance_info':
		showBankPage($option);
		break;
	case 'feed':
		createFeed($option);
		break;
	case 'vote':
		countVote();
		break;
	default:
	case 'showmaincats':
		showPublishedCategories();
		break;
}

function showPublishedSubCategories() {
	global $mainframe, $option;
	jimport('joomla.html.pagination');	
	$limit = JRequest::getVar('limit', $mainframe->getCfg('list_limit'));
	$limitstart = JRequest::getVar('limitstart', 0);
	// In case limit has been changed, adjust it
	$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
	$ks_help = new KissHelper();	
	$db =& JFactory::getDBO();
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$user =& JFactory::getUser();
	$user_id = $user->get( 'id' );
	$user_gid = $user->get( 'gid' );
	// if not KISS Joomla Version, the user table does not contain a field named "aid"
	if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
		$user_aid = 0;
		} else {
		$user_aid = $user->get( 'aid' );	
		}
	$pid = JRequest::getVar('pid', 0, 'GET', 'INT');
	if ($conf->adliststyle == 5 && $pid) {
		$query = buildQueryString($pid);
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$total = count($rows);
		$pageNav = new JPagination($total, $limitstart, $limit);		
		HTML_classifieds::showAds($rows, $option, $pageNav, $pid);
		}	
	$access = $conf->access;
	$dayy = $conf->days_shown;
	$countries = $ks_help->selectitems('country', 1);	
	$fedstates = $ks_help->fedstates();	
	$counties = $ks_help->counties();
  	$today = date("Y-m-d H:i:s", mktime(date('H'),date('i'),date('s'),date('m'),date('d')-$dayy,date('y')));
	$query = "SELECT * FROM #__ksads_cats WHERE published = 1 AND pid=".$pid;
	$query .= " AND (gid=0 OR gid <= ".$user_gid.") AND (aid=0 OR aid=".$user_aid.")"; 
	$query .=" ORDER BY pid, ordering, cat_name";
	// If the category list style is configured to one row, show pagination. Otherwise don't!
	if ($conf->catliststyle == 1) { 	
		$db->setQuery($query, $limitstart, $limit);
		} else {
		$db->setQuery($query);		
		}
	$rows = $db->loadObjectList();
	if ($db->getErrorNum())	{
		echo $db->stderr();
		return false;
	    }
	$db->setQuery($query);
	$db->query();
	$total = $db->getNumRows();
	$pageNav = new JPagination($total, $limitstart, $limit);
	$lists = array();
	if ($conf->show_regionalinfo) {
		$session =& JFactory::getSession();
		$ovr_disabled = 'disabled="disabled"';
		$regionfilter = $session->get('regionfilter', array(), 'ksaregfilter');
		if (!empty($regionfilter)) {
			$filter_fedstate = $regionfilter['filter_fedstate'];
			$filter_country = $regionfilter['filter_country'];
			$filter_county = $regionfilter['filter_county'];
			} else {
			$filter_fedstate = 0;
			$filter_country = 0;
			$filter_county = 0;
			}		
		$lists['countries'] = JHTML::_('select.genericlist',  $countries, 'region_country', 'class="inputbox" size="1" onchange="populate_fedstates(this); setregionfilter();"' . $ovr_disabled, 'value', 'text', $filter_country);				
	    $lists['fedstates'] = JHTML::_('select.genericlist',  $fedstates, 'region_fedstate', 'class="inputbox" size="1" onchange="populate_county(this); setregionfilter();"' . $ovr_disabled, 'value', 'text', $filter_fedstate);		
	    $lists['counties'] = JHTML::_('select.genericlist',  $counties, 'region_county', 'class="inputbox" size="1" onchange="setregionfilter();"'. $ovr_disabled, 'value', 'text', $filter_county);
	    }
	HTML_classifieds::showCategories($rows, $lists, $today, $pageNav, 'showcats', $pid);
}

function showPublishedCategories()
{
	global $mainframe, $option;
	$limit = JRequest::getVar('limit', $mainframe->getCfg('list_limit'));
	$limitstart = JRequest::getVar('limitstart', 0);
	// In case limit has been changed, adjust it
	$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);	
	$today = date("Y-m-d");
	$db =& JFactory::getDBO();
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$session =& JFactory::getSession();
	$user =& JFactory::getUser();
	$user_id = $user->get( 'id' );
	$user_gid = $user->get( 'gid' );
	$ks_help = new KissHelper();	
	// If user is a customer, try to retreive some address details
	$query = "SELECT * FROM #__ksads_customers WHERE `uid` = $user_id";
	$db->setQuery($query);
	if ($cust = $db->loadObject()) {
		$custfedstate = $cust->cust_fedstate;
		$custcountry = $cust->cust_country;
		$custcounty = $cust->cust_county;				
		} else {
		$custfedstate = 0;
		$custcountry = 0;
		$custcounty = 0;
		}
	// if not KISS Joomla Version, the user table does not contain a field named "aid"
	if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
		$user_aid = 0;				
		} else {
		$user_aid = $user->get( 'aid' );	
		}
	$catid = JRequest::getVar('catid', 0, 'GET', 'INT');
	if ($conf->notify_expiry && $conf->cron_notification < $today) {
		cronNotify();
		}
	$ovr_disabled = "";
	$countries = $ks_help->selectitems('country', 1);
	$lists=array();
	if ($conf->show_regionalinfo) {
		$filter_fedstate = JRequest::getVar('filter_fedstate', $custfedstate, 'POST', 'INT');
		$filter_county = JRequest::getVar('filter_county', $custcounty, 'POST', 'INT');
		$filter_country = JRequest::getVar('filter_country', $custcountry, 'POST', 'INT');		
		$fedstates = $ks_help->fedstates($filter_country);	
		$counties = $ks_help->counties($filter_country, $filter_fedstate, 1);
		
		$regionfilter = array( 'filter_fedstate' => $filter_fedstate, 'filter_country' => $filter_country, 'filter_county' => $filter_county);		
		$lists['countries'] = JHTML::_('select.genericlist',  $countries, 'region_country', 'class="inputbox" size="1" onchange="populate_fedstates(this); setregionfilter();"' . $ovr_disabled, 'value', 'text', $filter_country);				
		$lists['fedstates'] = JHTML::_('select.genericlist',  $fedstates, 'region_fedstate', 'class="inputbox" size="1" onchange="populate_county(this); setregionfilter(); document.adminForm.submit();"' . $ovr_disabled, 'value', 'text', $filter_fedstate);		
		$lists['counties'] = JHTML::_('select.genericlist',  $counties, 'region_county', 'class="inputbox" size="1" onchange="setregionfilter(); document.adminForm.submit();"'. $ovr_disabled, 'value', 'text', $filter_county);
		$session->set('regionfilter', $regionfilter, 'ksaregfilter');
	    }

	$access = $conf->access;
	$dayy = $conf->days_shown;
	$today = date("Y-m-d H:i:s", mktime(date('H'),date('i'),date('s'),date('m'),date('d')-$dayy,date('y')));
	$query = "SELECT * FROM #__ksads_cats WHERE published=1 AND pid=0";
	$query .= " AND (gid=0 OR gid <= ".$user_gid.") AND (aid=0 OR aid=".$user_aid.")"; 
	$query .=" ORDER BY pid, ordering, cat_name";
	if ($conf->catliststyle == 1) {
		$db->setQuery($query, $limitstart, $limit);
		} else {
		$db->setQuery($query);
		}
	$rows = $db->loadObjectList();
	if ($db->getErrorNum()) {
		echo $db->stderr();
		return false;
	    }
	$db->setQuery($query);
	$db->query();
	$total = $db->getNumRows();
	jimport('joomla.html.pagination');
	$pageNav = new JPagination($total, $limitstart, $limit);
	HTML_classifieds::showCategories($rows, $lists, $today, $pageNav, 'showmaincats' );	
}

function viewAds()
{
	global $mainframe, $option;
	$catid = JRequest::getVar('catid', 0, 'GET', 'INT');	
	$db =& JFactory::getDBO();
	$query = buildQueryString($catid);

	if ($catid) {
	    $categ =& JTable::getInstance('category', 'Table');
	    $categ->load($catid);
		echo '<div class="componentheading">' . $categ->cat_name . '</div>';
	}
	$limit 		= JRequest::getVar('limit', $mainframe->getCfg('list_limit'));
	$limitstart = JRequest::getVar('limitstart', 0);
    // In case limit has been changed, adjust it
    $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

	$db->setQuery($query, $limitstart, $limit);
	$rows = $db->loadObjectList();
	if ($db->getErrorNum()) {
		echo $db->stderr();
		return false;
	}
	$db->setQuery($query);
	$db->query();
	$total = $db->getNumRows();
	jimport('joomla.html.pagination');
	$pageNav = new JPagination($total, $limitstart, $limit);
	HTML_classifieds::showAds($rows, $pageNav, $catid);
}


function viewAd()
{
	global $option;
	$id = JRequest::getVar('id', 0, 'GET', 'INT');
	$db =& JFactory::getDBO();
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$cur = $conf->currency;
	$font = $conf->font_color;
	$detail_color = $conf->ad_detail_font;
	$state_color = $conf->ad_state_font;
	$find = $conf->distance;

	$row =& JTable::getInstance('classified', 'Table');
	$row->load($id);
	if(!$row->published) {
	    JError::raiseError(404, JText::_('Invalid ID Provided') );
	    }
	// Has category a different currency?
	$curr=getCurrency($row->catid);
	$query = "SELECT * FROM #__ksads_cats WHERE id = ".$row->catid;
	$db->setQuery($query);
	$cat1=$db->loadObject();

	// ---------Load Classified and Extension -----------------------------
	if (hasExtension($cat1->extension)) {
	    $extmod = loadExtension($cat1->extension);
		$extprf = $extmod->extension_prefix."_";
		$query = "SELECT * FROM #__ksads_ads AS a 
				LEFT JOIN #__ksads_$extmod->extension_table AS e ON ( e.".$extprf."adid = a.id )			
				WHERE a.id = $id
			";
		$db->setQuery($query);
		$db->query();
		$row = $db->loadObject();
		}	
	// ------------- End Load Classified and Extension -------------------
		
	HTML_classifieds::showAd($row, $option, $font, $state_color, $detail_color, $find);
	
}

function removeAd($option)
{
	global $mainframe;
	$cid = JRequest::getVar('cid', array(), '', 'array' );
	$ret = JRequest::getInt( 'retr', 0);
	$cat = JRequest::getInt( 'catid', 0 );	
	$categ =& JTable::getInstance('category', 'Table');
	$categ->load($cat);
	$db =& JFactory::getDBO();
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);

	$user =& JFactory::getUser();
	$user_id = $user->get( 'id' );
	$cids = implode(',', $cid);
	if(count($cid)) {
		//First delete all assigned images
		foreach($cid as $adid) {
			    // First delete ad images from image directory
			    $query = "SELECT * FROM #__ksads_ads WHERE id = ".$adid;
			    $db->setQuery($query);
			    $row = $db->loadObject();
 			    $removed_ad_name [] = $row->ad_name;
			    $imagefile = basename($row->ad_image);
			    $imagepath = JPATH_ROOT.DS."images".$conf->ad_img_dir.DS."U".$user_id.DS.$image_file;
			    if (file_exists($imagepath)) {
				unlink($imagepath);
				}
				// Are there more images? If so, delete them
			    $query = "SELECT * FROM #__ksads_files WHERE adid = ".$adid;  
			    $db->setQuery($query);
			    if (!$rows = $db->loadObjectList()) {
					foreach($rows as $row3) {
							$imagefile = basename($row3->file);
							$imagepath = JPATH_ROOT.DS."images".$conf->ad_img_dir.DS."U".$user_id.DS.$image_file;
							if (file_exists($imagepath)) {
							unlink($imagepath);
							} // End if file exists ...
						} // End foreach $rows as $row3
					} // End if $rows = $db-> ...
				$query = "DELETE FROM #__ksads_files WHERE adid = ".$adid;  
				$db->setQuery($query);
				$db->query();

				//Delete all assigned extension data
				$query = "SELECT * FROM #__ksads_extensions";
				$db->setQuery($query);
				$extensions = $db->loadObjectList();
				foreach($extensions as $ext) {
					// Get extension table
					$ext_src = loadExtension($ext->id);
					$ext_tbl = $ext_src->extension_table;
					$ext_pfx = $ext_src->extension_prefix;
					$query = "DELETE FROM #__ksads_$ext_tbl WHERE ".$ext_pfx."_adid = $adid";
					$db->setQuery($query);
					$db->query();  
					}

			} // End foreach ($cids as $cid)

		$query = "DELETE FROM #__ksads_ads WHERE id IN ($cids) AND user_id = '" . $user_id . "'";
		$db->setQuery($query);
		if (!$db->query()) {
			echo "<script> alert('".$db->getErrorMsg()."'); window.history.go(-1); </script>\n";
			} else {
			$cnt = bumpAdsLeftforUser($user_id, 1);
			}
		}

	// When the work is done we return to either the user's account or the ads listing
	if ($ret) {
		$msg = JText::_('Removed').": ".implode (', ',$removed_ad_name );
		// Are we in a subcategory?
		if ($categ->id) {
			$mainframe->redirect( 'index.php?option=' . $option . '&task=view&catid='.$categ->id, $msg);		
			} else {
			$mainframe->redirect( 'index.php?option=' . $option . '&task=showmaincats', $msg);
			}
		} else {
		$mainframe->redirect( 'index.php?option=' . $option . '&task=myads', $msg);
		}
}

function prolongAd($option)
{
	global $mainframe;
	$cid = JRequest::getVar('cid', array(), '', 'array');
	$id = $cid[0];
	$db =& JFactory::getDBO();
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$query = "SELECT * FROM #__ksads_ads WHERE id = $id";
	$db->setQuery($query);
	$row = $db->loadObject();
	$prol = $row->prolonged+1;
	$user 		=& JFactory::getUser();
	$user_id 	= $user->get( 'id' );
	$model		= getModelforUser($user_id);
	
	$today = date("Y-m-d", mktime(date('H'),date('i'),date('s'),date('m'),date('d')+($prol*$model->expiry),date('y')));
	    switch ($model->payment)
		    {
		      case 0:
		      default: // Free ads
		      $query = "UPDATE #__ksads_ads SET `date_expiry`='$today', `published`='1', `prolonged`='$prol' WHERE `id`='".$id."'";
		      $db->setQuery($query);
		      $db->query();
		      $msg = sprintf(JText::_('Prolongation executed'), $prl);
		      break;
		      case 1: // Paid ads, prolongation according to views
		      $query = "UPDATE #__ksads_ads SET `views`= '0', `published`='1', `prolonged`='$prol' WHERE `id`=".$id;
		      $db->setQuery($query);
		      $db->query();
  			  $cnt = bumpAdsLeftforUser($user_id, -1);
		      // TODO: Send payment message to user.
		      break;
		      case 2: // Paid ads, prolongation according to period
		      $query = "UPDATE #__ksads_ads SET `date_expiry`='$today', `published`='1', `prolonged`='$prol' WHERE `id`=".$id;
		      $db->setQuery($query);
		      $db->query();
			  $cnt = bumpAdsLeftforUser($user_id, -1);			  
		      // TODO: Send payment message to user.
		      break;
		    } // end switch

	$mainframe->redirect( 'index.php?option=com_ksadvertiser', $msg);
}

function pushAd($option)
{
	global $mainframe;
	$cid = JRequest::getVar('cid', array(), '', 'array');
	$id = $cid[0];
	$db =& JFactory::getDBO();
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$query = "SELECT * FROM #__ksads_ads WHERE id = $id";
	$db->setQuery($query);
	$row = $db->loadObject();
	$curr = getCurrency($row->catid);
	$user 		=& JFactory::getUser();
	$user_id 	= $user->get( 'id' );
	$lists = array();
	$ks_help = new KissHelper();	
	$ttads 	= $ks_help->topTenPrice($row->ad_price_pu, $curr);
	$adname = str_replace("'", "\'", $row->ad_name);
	$lists['toptenads'] = JHTML::_('select.radioList', $ttads, 'toptenads', 'class="inputbox" onclick="toggle_topten(this,\''.$curr.'\',\''.$row->id.'\',\''.$adname.'\')"', 'value', 'text', 1);	
	HTML_classifieds::pushAd($row, $option, $lists);
}


function editAd($task = '')
{
	global $mainframe, $option;
	$db =& JFactory::getDBO();
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$query = "SELECT * FROM #__ksads_fields";
	$db->setQuery($query);
	$fields = $db->loadObjectList();
	$access = $conf->access;
	$user =& JFactory::getUser();
	$user_id = $user->get( 'id' );
	$user_gid = $user->get( 'gid' );
	$model = getModelForUser($user_id);
	// if not KISS Joomla Version, the user table does not contain a field named "aid"
	if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
		$user_aid = 0;				
		} else {
		$user_aid = $user->get( 'aid' );	
		}
	// Verify that placing ads is still allowed - to avoid REQUEST manipulation [ thanks to George K for the hint ]
	if (!getAdsLeftforUser($user_id) && $user_id > 0 && $task == 'add') {
		$msg = JText::_('Max number of ads reached');
		$mainframe->redirect('index.php?option=com_ksadvertiser', $msg);		
		}

	$row =& JTable::getInstance('classified', 'Table');
	$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
	$cat = JRequest::getInt( 'catid', 0 );
	$id = $cid[0];
	$row->load($id);
	$lists = array();
	$ks_help = new KissHelper();
	$ad_delivery = $ks_help->selectitems('delivery', 1);
	$ad_state = $ks_help->selectitems('adstate', 1);
	$adshow = $ks_help->boolean();
	$adboxnumber = $ks_help->boolean();	
	$ad_prov = $ks_help->selectitems('videoprovider', 1);
	$countries = $ks_help->selectitems('country', 1);	
	$fedstates = $ks_help->fedstates();	
	$counties = $ks_help->counties(0,0,1);
	
	$query = "SELECT id, cat_name FROM #__ksads_cats WHERE published = 1 AND showads = 1";
	$query .= " AND (gid=0 OR gid <= ".$user_gid.") AND (aid=0 OR aid=".$user_aid.")"; 
	$query .= " AND (fee=0 OR fee=".$model->id.")"; 
	$query .=" ORDER BY pid, ordering, cat_name";
	$db->setQuery($query);
	$aryReturnedCategories = $db->loadObjectList();
	if (!$cat) {$cat = $aryReturnedCategories[0]->id;}
	$catid = (!$row->catid) ? $cat : $row->catid;
	if ($catid) {
	    $query = "SELECT * FROM #__ksads_cats WHERE id = ".$catid;
	    $db->setQuery($query);
	    $cat1=$db->loadObject();
	    // ---------Load Classified and Extension -----------------------------
	    if (hasExtension($cat1->extension) && $id > 0) {
		$extmod = loadExtension($cat1->extension);
		    $extprf = $extmod->extension_prefix."_";
		    $query = "SELECT * FROM #__ksads_ads AS a 
				    LEFT JOIN #__ksads_$extmod->extension_table AS e ON ( e.".$extprf."adid = a.id )			
				    WHERE a.id = $id
			    ";
		    $db->setQuery($query);
		    $row = $db->loadObject($query);
		    }
	    // ------------- End Load Classified and Extension -------------------
	    $row->catid = $cat1->id;
	    } else {
	    $query = "SELECT id, cat_name FROM #__ksads_cats WHERE published = 1 AND showads = 1";
	    $query .= " AND (gid=0 OR gid <= ".$user_gid.") AND (aid=0 OR aid=".$user_aid.")";
	    $query .= " AND (fee=0 OR fee=".$model->id.")"; 
	    $query .=" ORDER BY pid, ordering, cat_name";
	    $db->setQuery($query);
	    $cat1 = $db->loadObjectList();
	    $row->catid = $cat1->id[0];
	    }
		// Avoid selecting a restricted category
		if (!$cat1->showads) {
			$msg = sprintf(JText::_('Category not allowed'), $cat1->cat_name);
			$mainframe->redirect('index.php?option=com_ksadvertiser&task=showcats&pid='.$cat1->id, $msg);		
			}	
	// if new ad, fill out customer information if present
	$query = "SELECT * FROM #__ksads_customers WHERE uid = ".$user_id;
	$db->setQuery($query);
	$ovr_disabled = '';
	if ($id < 1) {
		// Take the address from Customer if exists
	    if ($cust = $db->loadObject()) {
		$row->ad_address = $ks_help->decrypted($cust->cust_address);
		$row->ad_location = $ks_help->decrypted($cust->cust_city);
		$row->ad_post = $ks_help->decrypted($cust->cust_postcode);
		$row->contact_tel = $ks_help->decrypted($cust->cust_telephone);
		$row->contact_email = $ks_help->decrypted($cust->cust_email);
		$row->contact_website = $ks_help->decrypted($cust->cust_website);
		$row->region_country = $cust->cust_country;
		$row->region_fedstate = $cust->cust_fedstate;
		$row->region_county = $cust->cust_county;
		}
		
		if ($conf->show_regionalinfo && $row->region_country == 0) {
			$row->region_country = $conf->regionalsearch;
			}
		// Check whether an override address exists. It can be either part of the model or category
		$ovraddr = 0;
		if ($cat1->ovr_addr_num) {$ovraddr = $cat1->ovr_addr_num; $ovr_ovr = $cat1->ovr_addr_ovr;}
		if ($model->ovr_addr_num) {$ovraddr = $model->ovr_addr_num; $ovr_ovr = $model->ovr_addr_ovr;}
		$query = "SELECT * FROM #__ksads_addresses WHERE id = $ovraddr AND published = 1";
		$db->setQuery($query);
		if ($ova = $db->loadObject()) {
			// Override address exists, now fill out country related info, other fields are adjusted by the form
			$row->region_country = $ova->region_country;
			$row->region_fedstate = $ova->region_fedstate;
			$row->region_county = $ova->region_county;
			$ovr_disabled = ($ovr_ovr == 0) ? 'disabled="disabled"' : '';		
			}
		}

	if ($model->expiry > 0 && $id < 1) {
	    $prld = ($row->prolonged+1)*$model->expiry;	
	    $row->date_expiry = date("Y-m-d", strtotime("$row->date_created + $prld days"));
	    }
	$del_enabled = ($fields[9]->activated == 0 || $fields[9]->visible == 0) ? 'disabled' : '';
	$del_default = ($del_enabled == 'disabled' && $row->id == 0) ? $fields[9]->default : $row->ad_delivery;
	$box_enabled = ($fields[12]->activated == 0 || $fields[12]->visible == 0) ? 'disabled' : '';
	$box_default = ($box_enabled == 'disabled' && $row->id == 0) ? $fields[12]->default : $row->ad_boxnumber;
	$state_enabled = ($fields[5]->activated == 0 || $fields[5]->visible == 0) ? 'disabled' : '';
	$state_default = ($state_enabled == 'disabled' && $row->id == 0) ? $fields[5]->default : $row->ad_state;
	$bld_disabled = ($model->opt_bold == 1 && $row->opt_bold == 0) ? '' : 'disabled="disabled"';
	$col_disabled = ($model->opt_color == 1 && $row->opt_color == 0) ? '' : 'disabled="disabled"';
	$new_disabled = ($model->opt_new == 1 && $row->opt_new == 0) ? '' : 'disabled="disabled"';

	foreach ($aryReturnedCategories as $objCat) {
			$arySelectOptions[] = JHTML::_('select.option', $objCat->cat_name , $objCat->cat_name );
			}
		$lists['cat_name'] = JHTML::_('select.genericlist', $arySelectOptions , 'cat_name', 'class="inputbox"', 'value', 'text' , 0 ); 
		$lists['ad_state'] = JHTML::_('select.genericList', $ad_state, 'ad_state', 'class="inputbox"'.' '.$state_enabled. '', 'value', 'text', $state_default );
		$lists['ad_delivery'] = JHTML::_('select.genericList', $ad_delivery, 'ad_delivery', 'class="inputbox"'.' '.$del_enabled. '', 'value', 'text', $del_default );	
		$lists['showaddress'] = JHTML::_('select.booleanlist', 'show_address', 'class="inputbox"', $row->show_address);
		$lists['watermark'] = JHTML::_('select.booleanlist', 'watermark', 'class="inputbox"', $row->watermark);		
		$lists['ad_boxnumber'] = JHTML::_('select.booleanlist', 'ad_boxnumber', 'class="inputbox"'.' '.$box_enabled. '', $box_default);		
		$lists['commercial'] = JHTML::_('select.booleanlist', 'ad_commercial', 'class="inputbox"', $row->ad_commercial);
		$lists['optbld'] = JHTML::_('select.booleanlist', 'opt_bold', 'class="inputbox"  '. $bld_disabled. ' onclick="javascript:toggle_adprice(this);"', $row->opt_bold);
		$lists['optnew'] = JHTML::_('select.booleanlist', 'opt_new', 'class="inputbox" '. $new_disabled. ' onclick="javascript:toggle_adprice(this);"', $row->opt_new);
		$lists['optcol'] = JHTML::_('select.booleanlist', 'opt_color', 'class="inputbox"  '. $col_disabled. ' onclick="javascript:toggle_adprice(this);"', $row->opt_color);
		$lists['vprovider'] = JHTML::_('select.genericList', $ad_prov, 'ad_vid_prov', 'class="inputbox" onclick="javascript:toggle_videodiv();"', 'value', 'text', $row->ad_vid_prov );		
		if ($conf->show_regionalinfo) {
		    $lists['countries'] = JHTML::_('select.genericlist',  $countries, 'region_country', 'class="inputbox" size="1" onchange="populate_fedstates(this)"' . $ovr_disabled, 'value', 'text', $row->region_country);				
		    $lists['fedstates'] = JHTML::_('select.genericlist',  $fedstates, 'region_fedstate', 'class="inputbox" size="1" onchange="populate_county(this)"' . $ovr_disabled, 'value', 'text', $row->region_fedstate);		
		    $lists['counties'] = JHTML::_('select.genericlist',  $counties, 'region_county', 'class="inputbox" size="1"'. $ovr_disabled, 'value', 'text', $row->region_county);
		    }

	if ($user_gid < $access && $access > 0) {
		echo '<a href="'.trim($conf->loginlink).'">'.JText::_('Please Log in').'</a> '.JText::_('to submit an ad');
	} elseif ($user_gid >= $access && $access > 0) {
		HTML_classifieds::editAd($row, $lists, $option);
	} elseif ($access == 0) {
		HTML_classifieds::editAd($row, $lists, $option);
	} else {
	echo 'Invalid User';
	}
}

function save()
{
	global $mainframe, $option;
	$row =& JTable::getInstance('classified', 'Table');
	$db =& JFactory::getDBO();
	$user =& JFactory::getUser();
	$user_id = $user->get( 'id' );
	$ks_help = new KissHelper();
	$live_site = &JURI::root();
	$model = getModelforUser($user_id);
	$today = date("Y-m-d H:i:s");	
	mt_srand((double)microtime()*1000);
	// Random ad code
	$adcode = mt_rand(1000, 9999);
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);

	// Try to geocode address
	$locat = JRequest::getVar( 'ad_address', '', 'post', 'string').", ".JRequest::getVar( 'ad_post', '', 'post', 'string')." ".JRequest::getVar( 'ad_location', '', 'post', 'string');	
	if ($gplugin =& JPluginHelper::getPlugin('system', 'plugin_googlemap2')) { 
	    $gplugin_params = new JParameter( $gplugin->params );
	    $gwebsite = $gplugin_params->get( 'googlewebsite', 'maps.google.com' );
	    $key = trim($gplugin_params->get( 'Google_API_key', '' ));
	    $iso = "utf-8";
	    $geodata = get_geo($gwebsite, $locat, $iso, $key);
		if (!is_array($geodata['coords'])) {
			$geodata['coords'] = (array) $geodata['coords'];
		}		
	    $coords = explode(",", $geodata['coords'][0]);
	    $longitude = $coords[0];
	    if (isset ($coords[1])) {
			$latitude = $coords[1];
			} else  {
			$latitude = null;
			}
	    $street = $geodata['street'];
	    $city = $geodata['city'];
	    $zip = $geodata['zip'];
	    $country = $geodata['country'];
	    $county = $geodata['county'];
	    $state = $geodata['state'];
	    $suburb = $geodata['suburb'];	    }

	$data = JRequest::get('post');	
	if (!$row->bind($data)) {
	    JError::raiseError(404, JText::_('Data storage Error') .' | ' . JText::_('Component message') . '&nbsp' . $row->getError());
	    }
	$locationquery = "";
	$streetquery = "";
	// Set Address and City from geodata if set
	if ($conf->check_address_geocode) {
	    if (isset($city) && isset($zip)) {
		    if (strlen($city) && strlen($zip)) {
			    if (strlen($suburb) && strtolower($city) != strtolower($suburb)){
				    $city .= "-".$suburb;
				    }
				    $row->ad_post = $zip;
				    $row->ad_location = $city;
				    $locationquery = ", `ad_post`='$zip', `ad_location`='$city'";
			    }
		    }
		    if (isset($street)) {	
			    if (strlen($street)) {
				    $row->ad_address = $street;
				    $streetquery = ", `ad_address`='$street'";
				    }
			} // end if (isset($street))
	    } // end if ($conf->check...)

	$query = "SELECT * FROM #__ksads_cats WHERE id =".$row->catid;
	$db->setQuery($query);
	$categ = $db->loadObject();
	$expression = mb_substr($row->ad_name ."|".$row->contact_name."|".$row->ad_location."|".$row->ad_intro."|".$row->ad_desc,0,254); 
	$row->phonetic = $ks_help->phonetic($expression);
	$row->ad_price = str_replace(",", ".", $row->ad_price);	
	$row->expiry_deactivate = $categ->expiry;
	$row->mid = $model->id;
	// If options are charged, check whether user has selected them otherwise set them according to ad plan settings
	if ($model->opt_charge) {
		$row->opt_new = (JRequest::getVar( 'opt_new', '', 'post', 'string', JREQUEST_ALLOWRAW ));
		$row->opt_bold = (JRequest::getVar( 'opt_bold', '', 'post', 'string', JREQUEST_ALLOWRAW ));		
		$row->opt_color = (JRequest::getVar( 'opt_color', '', 'post', 'string', JREQUEST_ALLOWRAW ));				
		} else {
		$row->opt_new = $model->opt_new;
		$row->opt_bold = $model->opt_bold;
		$row->opt_color = $model->opt_color;	
		}
	
	if ($row->ad_state < 1) {
	    $row->ad_state = 1;
	    }
	if ($categ->restrict_to > 0) {
	    $row->ad_state = $categ->restrict_to;
	    }
	$uid = ($row->user_id > 0) ? $row->user_id: 0;
	$img_dir = getImageDirforUser($uid, 0);	
	if ($model->commercial) {
		$row->ad_commercial = 1;
		}
	$rep = $live_site. $img_dir. DS;
	$row->ad_image = str_replace('stamp_', '', basename(JRequest::getVar( 'ad_image', '', 'post', 'string', JREQUEST_ALLOWRAW )));

	if ($row->ad_vid_prov == 47) {
		$row->ad_vid_id = JRequest::getVar( 'ad_vid_id_1', '', 'post', 'string', JREQUEST_ALLOWRAW );
		}
	
	if (substr($row->date_created , 0 , 4) == "0000" || strlen($row->date_created) < 10) {
		$row->date_created = $today;
		$task = "add";
		$cnt = bumpAdsLeftforUser($user_id, -1);		
		} else {
		$task = "edit";
		}
	$prld = ($row->prolonged + 1)*$model->expiry;	
	if ($model->expiry == 0) {
		if ($row->views >= $model->views && $model->views > 0) {
			$row->published = 0;
			}
		$row->date_expiry = date("Y-m-d", strtotime("$row->date_created + 2 years"));		
		} else {
		$row->date_expiry = date("Y-m-d", strtotime("$row->date_created + $prld days"));
		}
	$row->ad_desc = JRequest::getVar( 'ad_desc', '', 'post', 'string', JREQUEST_ALLOWRAW );
	if ($task == "add") {
		// If user is a paying customer, publish ad immediately otherwise use category settings	
		if ($model->price > 0) {
			$row->published = 1;
			} else {
			$row->published = $categ->autopublish;
			}
		}
	if (strlen($row->ad_name) < 1) {
	    $row->ad_name = JText::_('Date created')." ".date($conf->date_format, strtotime($row->date_created));
	    }
	if (strlen($latitude) && strlen($longitude)) {
	    $row->latitude = $latitude;
	    $row->longitude = $longitude;
	    }
	if (strlen($row->down_uri)) {
	    $pathinfo = pathinfo(str_replace(DS.DS, DS, $row->down_uri));
	    $row->down_uri = $pathinfo['basename'];
	    if (!strlen($row->down_txt)) {
			$row->down_txt = ucfirst($pathinfo['filename']);
			}
	    }
	$iid = $row->id;
	if (!$row->store()) {
	    JError::raiseError(404, JText::_('Data storage Error') .' | ' . JText::_('Database message') . '&nbsp' . $db->getError());
	    } else {
		if ($iid < 1) {
			$iid = $db->insertid();
			}
		if (strlen($row->ad_ident) == 12) {
			$adid = $row->ad_ident;
			} else {
			$adid = sprintf("%'14d%'04d%'04d",$adcode, $user_id, $iid);
			$row->ad_ident = $adid;
			}
		$adidquery = "`ad_ident`='$adid'";		
	    $query = "UPDATE #__ksads_ads set $adidquery $locationquery $streetquery WHERE `id`=".$iid;
	    $db->setQuery($query);
	    $db->query();
	    }
		
	if (hasExtension($categ->extension)) {
	    if (JRequest::getInt('id', 0) == 0) {
		JRequest::setVar( 'id', $iid );
		}
	    $extmod = loadExtension($categ->extension);
	    $extmod->addfields_save();
	    }

	$optprice = 0;
	$paydescription = JText::_('Ad Title')." ".$row->ad_name." - ".JText::_('Ad Ident').": ".$row->ad_ident;

	//Send confirmation mail to user if entry has been added
	if ($task == "add") {
	    $sent = _sendMail((array) $row, 1);
	    }
	//Send Mail to Administrators if entry has been added or updated
	if ($conf->notify == 1) {
	    $sent = _sendMail((array) $row, 0);
	    }
	//Send notification mail to user if entry has been added and user has subscripted
	if ($conf->notify_user == 1 && $task == "add") {
	    $sent = _sendUserMail((array) $row, 1);
	    }
	
	if ($categ->autopublish == 0) {
	    $msg = JText::_('Advertisement Saved after Verification');
	    } else {
	    $msg = JText::_('Advertisement Saved'); 
	    }

	// Are there any files to upload?	
	if(isset($_FILES['name']) && !empty($_FILES['name']['name'])) {
		if (strlen($_FILES['name']['name'][0])) {
			$upl_suc = uploadFiles($row->user_id);
			$filename = $_FILES['name']['name'][0];
			$msg .=" ".$upl_suc." (".$filename.")";
			$query = "UPDATE #__ksads_ads SET ad_image = '$filename' WHERE id = ".$iid;
			$db->setQuery($query);
			$db->query();
			}		
		}

	// If user wants notification, store notification request info
	if ($conf->notify_user && $user_id > 0) {
	if (isset($data['cbun']) && $data['cbun'] == 'cbun') {
		if ($model->expiry == 0) {
			$prld = $conf->prune;
			} else {
			$prld = $model->expiry;
			}
		$expiry = date("Y-m-d", strtotime("$row->date_created + $prld days"));

		// Check if notification request exists
		$query = "SELECT * FROM #__ksads_usernotify WHERE catid=$categ->id AND uid=$user_id AND date > '$expiry' AND rss='0'";
		$db->setQuery($query);
		if (!$db->loadObjectList()) {
		    //Notification request does not yet exist, create new one
		    $query = "INSERT INTO #__ksads_usernotify (uid, mid, catid, date) VALUES ('$user_id', '$model->id', '$categ->id', '$expiry')";
		    $db->setQuery($query);
		    $db->query();
		    $msg .= ", ".JText::_('Notification created');
		    }
		}
	  }

	// Try to create a thumbnail out of the image if given
	if ($conf->create_thumbnails) {
	    if (file_exists(str_replace(DS.DS, DS, JPATH_ROOT.$img_dir.$row->ad_image))) {
			$thu_dir =  $img_dir."thumbnails".DS;
			createThumbnails($img_dir, $thu_dir, $row->ad_image);
			}
	    }

	if ($task == 'add') {
		$optprice = $model->price;
		} else {
		$optprice = 0;
		}	

	// Update and charge options if necessary
	$set = 'SET ad_paid = 0';
	$pay_id = 0;
	if ($model->opt_charge) {
		if ($row->opt_bold == 1 && $row->opt_bold_paid == 0) {
			$optprice = $optprice + $model->opt_bold_price; $paydescription .= ", ".JText::_('Option Bold Title');
			$set .= ', opt_bold_paid = 1';
			$pay_id = 1;
			}
		if ($row->opt_new == 1 && $row->opt_new_paid == 0) {
			$optprice = $optprice + $model->opt_new_price; $paydescription .= ", ".JText::_('Option New');
			$set .= ', opt_new_paid = 1';				
			$pay_id = 2;			
			}
		if ($row->opt_color == 1 && $row->opt_color_paid == 0) {
			$optprice = $optprice + $model->opt_color_price; $paydescription .= ", ".JText::_('Option Color');
			$set .= ', opt_color_paid = 1';				
			$pay_id = 2;			
			}
		$query = "UPDATE #__ksads_ads $set WHERE id = ".$iid;
		$db->setQuery($query);
		$db->query();			
		}

	
	// If model allows payments after placing ads, show payment page, otherwise set all payable items to paid
	if (!$model->payment_advance) {
		// Add / Edit the customer's account if ad is new
		if ($task == 'add') {
			$query = "SELECT * FROM #__ksads_customers WHERE uid = ".$user_id;
			$db->setQuery($query);
			if ($cust = $db->loadObject()) {
				$today = date("Y-m-d H:i:s");	
				$query = "INSERT INTO #__ksads_customeraccounts (ca_cid, ca_aid, ca_pid, ca_payment, ca_credit, ca_text, ca_paydate, published
					  ) VALUES (
					  $cust->id, $row->id, $pay_id, 0, ".(($model->price + $optprice) * -1).", '".JText::_('Ad Ident')." ".$row->ad_ident."', '$today', 1
					  )";
				$db->setQuery($query);
				$db->query();
				$query = "UPDATE #__ksads_customers SET balance = ".$cust->balance + (($model->price + $optprice) * -1)." WHERE uid = ".$user_id;
				$db->setQuery($query);
				$db->query();			
				} // end if $cust = ...
			} else { // end if ($task = 'add')	
			// Task is not 'add', check whether an option was selected which is to be paid
			if ($optprice) {
			$query = "SELECT * FROM #__ksads_customers WHERE uid = ".$user_id;
			$db->setQuery($query);
			if ($cust = $db->loadObject()) {
				$today = date("Y-m-d H:i:s");	
				$query = "INSERT INTO #__ksads_customeraccounts (ca_cid, ca_aid, ca_pid, ca_payment, ca_credit, ca_text, ca_paydate, published
					  ) VALUES (
					  $cust->id, $row->id, $pay_id, 0, ".($optprice * -1).", '".$paydescription."', '$today', 1
					  )";
				$db->setQuery($query);
				$db->query();
				$query = "UPDATE #__ksads_customers SET balance = ".$cust->balance + (($model->price + $optprice) * -1)." WHERE uid = ".$user_id;
				$db->setQuery($query);
				$db->query();			
				} // end if $cust = ...		
				} // end if ($optprice)
			} // end if ($task ...)
		$link = "index.php?option=$option&task=paymentpage&desc=".urlencode($paydescription)."&amt=$optprice";
		} else {
		$link = 'index.php?option='.$option;
		}
	$mainframe->redirect($link, $msg);
}

	function saveComplaint()
	{
		global $mainframe;
		$row =& JTable::getInstance('complaints', 'Table');
		$db =& JFactory::getDBO();
		$data = JRequest::get('post');	
		if (!$row->bind($data))	{
		    JError::raiseError(404, JText::_('Data Table Error') .' | ' . JText::_('Component message') . '&nbsp' . $row->getError());
		    }
		if (!$row->store()) {
		    JError::raiseError(404, JText::_('Data storage Error') .' | ' . JText::_('Database message') . '&nbsp' . $db->getError());
		    }
		//Send Mail to Administrators if entry has been updated
		 $sent = _sendComplaint($data, 0);


		$mainframe->redirect('index.php?option=com_ksadvertiser', JText::_('Complaint Sent'));
	}

	function saveCustomer()
	{
		global $mainframe;
		$row =& JTable::getInstance('customers', 'Table');
		$db =& JFactory::getDBO();
		$data = JRequest::get('post');	
		if (!$row->bind($data))	{
		    JError::raiseError(404, JText::_('Data Table Error') .' | ' . JText::_('Component message') . '&nbsp' . $row->getError());
		    }
		$ks_help = new KissHelper();
		$row->cust_company = $ks_help->encrypted($row->cust_company);		
		$row->cust_address = $ks_help->encrypted($row->cust_address);
		$row->cust_postcode = $ks_help->encrypted($row->cust_postcode);
		$row->cust_city = $ks_help->encrypted($row->cust_city);
		$row->cust_telephone = $ks_help->encrypted($row->cust_telephone);
		$row->cust_email = $ks_help->encrypted($row->cust_email);   
		$row->cust_website = $ks_help->encrypted($row->cust_website);
		$row->cust_company_invoice = $ks_help->encrypted($row->cust_company_invoice);		
		$row->cust_address_invoice = $ks_help->encrypted($row->cust_address_invoice);
		$row->cust_postcode_invoice = $ks_help->encrypted($row->cust_postcode_invoice);
		$row->cust_city_invoice = $ks_help->encrypted($row->cust_city_invoice);
		$row->cust_cart_paypal = $ks_help->encrypted($row->cust_cart_paypal);
		$row->cust_cart_google = $ks_help->encrypted($row->cust_cart_google);
		if (!strlen($row->cust_company_invoice)) {
			$row->cust_company_invoice = $row->cust_company;
			}
		if (!strlen($row->cust_address_invoice)) {
			$row->cust_address_invoice = $row->cust_address;
			}
		if (!strlen($row->cust_postcode_invoice)) {
			$row->cust_postcode_invoice = $row->cust_postcode;
			}
		if (!strlen($row->cust_city_invoice)) {
			$row->cust_city_invoice = $row->cust_city;
			}
		$db =& JFactory::getDBO();
		if (!$row->store()) {
		    if (!$row->bind(JRequest::get('post'))) {
			JError::raiseError(404, JText::_('Data Table Error') .' | ' . JText::_('Component message') . '&nbsp' . $row->getError());
			}
			JError::raiseError(404, JText::_('Data storage Error') .' | ' . JText::_('Database message') . '&nbsp' . $db->getError());
		      }
		  $mainframe->redirect('index.php?option=com_ksadvertiser', JText::_('Account Info Saved'));
	}

  /*------------------------------------------------------------------
	_sendMail
	sends an email to administrator and user on new ad submission
	Copyright (c) 2011 by KISS Software
  -------------------------------------------------------------------*/
	function _sendMail($data, $func=0, $alt_address='')
	{
		global $mainframe;
		$conf =& JTable::getInstance('config', 'Table');
		$conf->load(1);
		$ks_help = new KissHelper();

		$db		=& JFactory::getDBO();
		$user 		=& JFactory::getUser();

		$name 		= $data['contact_name'].", ".$data['ad_location'];
		$email		= $data['contact_email'];
		$adid		= $data['id'];
		$adident	= $data['ad_ident'];		
		$title		= $data['ad_name'];
		$cat		= $data['catid'];
		$createdate	= $data['date_created'];
		$usernumber	= $data['user_id'];
		$model 		= getModelForUser($usernumber);
		$prld 		= $model->expiry;
		$expiry 	= date($conf->date_format, strtotime("$createdate + $prld days"));
		$deadline 	= date($conf->date_format, strtotime("$createdate + 3 days"));
		$blz		= JText::_('Bank Code').": ".$ks_help->decrypted($conf->bank_code)."\n";
		$bankname	= JText::_('Bank Name').": ".$ks_help->decrypted($conf->bank_name)."\n";
		$bankacc	= JText::_('Bank Account').": ".$ks_help->decrypted($conf->bank_account)."\n";
		$bankbic	= JText::_('Bank BIC').": ".$ks_help->decrypted($conf->bank_bic)."\n";
		$bankiban	= JText::_('Bank IBAN').": ".$ks_help->decrypted($conf->bank_iban)."\n";
		$bankinfo	= $blz.$bankname.$bankacc.$bankbic.$bankiban;
		$usersConfig 	= &JComponentHelper::getParams( 'com_users' );
		$sitename 	= $mainframe->getCfg( 'sitename' );
		$mailfrom 	= $mainframe->getCfg( 'mailfrom' );
		$fromname 	= $mainframe->getCfg( 'fromname' );
		$siteURL	= JURI::base();
		if (JRequest::getInt('id', 0)) {
			$total = 0;
			} else {
			$total = $model->price;
			}
		if ($model->opt_bold_price > 0 && $model->opt_charge == 1 && $data['opt_bold'] == 1 && $data['opt_bold_paid'] == 0) {$total = $total + $model->opt_bold_price;}
		if ($model->opt_new_price > 0 && $model->opt_charge == 1 && $data['opt_new'] == 1 && $data['opt_new_paid'] == 0) {$total = $total + $model->opt_new_price;}
		if ($model->opt_color_price > 0 && $model->opt_charge == 1 && $data['opt_color'] == 1 && $data['opt_color_paid'] == 0) {$total = $total + $model_opt_color_price;}
		$price	= number_format($total, $conf->decimals, $conf->sep_decimal, $conf->sep_thousand)." ".getCurrency($cat);
		if ($usernumber) {
		    // if not KISS Joomla Version, the user table does not contain a field named "firstname"
		    if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
			    $query = "SELECT name, email, username";				
			    } else {
			    $query = "SELECT CONCAT_WS(' ', firstname, name) as name, email, username";
			    }
		    $query .=" FROM #__users WHERE id = $usernumber";
		    $db->setQuery( $query );
		    $usr = $db->loadObject();
		    $usermail = $usr->email;
		    $username = $usr->username;
		    $userreal = $usr->name;
		    } else {
		    $usermail = $email;
		    $username = 'Anonymous';
		    $userreal = $data['contact_name'];
		    }

		$query ="SELECT * FROM #__ksads_cats WHERE id = $cat";
		$db->setQuery( $query );
		if ($categ = $db->loadObject()) {
		    $catname = $categ->cat_name;  
		    } else {
		    $catname = '';
		    }

		$subject 	= sprintf ( JText::_( 'SEND_MSG_ADMIN_SUBJECT' ), $name, $sitename);
		if ($func == 2) {$subject = sprintf ( JText::_( 'SEND_MSG_ADMIN_SUBJECT_ADD' ), $name, $sitename);}
		$subject 	= html_entity_decode($subject, ENT_QUOTES);

		$blink = $siteURL."administrator/index.php?option=com_ksadvertiser&task=edit&cid=".$adid;
		$flink = $siteURL."index.php?option=com_ksadvertiser&id=".$adid."&task=viewad";
		if ($data['published'] == 0 ) {
		    $link_text = "\n\n".JText::_('Ad is not published yet.');
		    } else {
		    $link_text = "\n\n".JText::_('Ad is published and can be viewed at')."\n".$flink;
		    }

		$message = sprintf ( JText::_( 'SEND_MSG' ), $name, $sitename, $siteURL);
		$message = html_entity_decode($message, ENT_QUOTES);

		//get all super administrators
		if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
			$query = "SELECT name, email, sendEmail";				
			} else {
			$query = "SELECT CONCAT_WS(' ', firstname, name) as name, email, sendEmail";
			}
		$query .=" FROM #__users WHERE LOWER( usertype ) = 'super administrator' AND sendEmail = 1";
		$db->setQuery( $query );
		$rows = $db->loadObjectList();

		// Send email to user
		if ( ! $mailfrom  || ! $fromname ) {
			$fromname = $rows[0]->name;
			$mailfrom = $rows[0]->email;
		}

		// send confirmation mail to user
		if ($func == 1) {
		    $subject2 = sprintf ( JText::_( 'SEND_MSG_USER_SUBJECT' ), $title, $sitename);
		    $subject2 = html_entity_decode($subject2, ENT_QUOTES);      
		    $message3 = ($data['ad_paid'] == 0 && $price > 0) ? sprintf ( JText::_( 'SEND_MSG_USER_PAYMENT' ), $price, $bankinfo, $deadline) : '';
		    $message2 = sprintf ( JText::_( 'SEND_MSG_USER' ), $userreal, $sitename, $name, $adident, $title, $catname, $expiry, $email, $price.$link_text, $message3 );
		    $message2 = html_entity_decode($message2, ENT_QUOTES);
		    JUtility::sendMail($mailfrom, $fromname, $usermail, $subject2, $message2);
		    }

		// Send notification to all administrators
		if ($func == 0 || $func == 2) {
		    $subject2 = sprintf ( JText::_( 'SEND_MSG_ADMIN_SUBJECT' ), $name, $sitename);
		    $subject2 = html_entity_decode($subject2, ENT_QUOTES);
		    $link_text  .= "\n".JText::_('To quickly edit and/or publish the ad, please visit')."\n".$blink;
		    $link_text  .= "\n".JText::_('NOTE! You must be logged in to backend to follow this link.');

		    //if alternative email address, send to this address instead of admin's address
		    if (strlen($alt_address) > 0) {
			    $message2 = sprintf ( JText::_( 'SEND_MSG_ADMIN' ), $row->name, $sitename, $name, $adident, $title, $catname, $price, $expiry, $email, $username, $usermail.$link_text );
			    if ($func == 2) {$message2 = sprintf ( JText::_( 'SEND_MSG_ADMIN_ADD' ), $row->name, $sitename, $name, $adident, $title, $email, $username, $usermail);}				
			    $message2 = html_entity_decode($message2, ENT_QUOTES);
			    JUtility::sendMail($mailfrom, $fromname, $alt_address, $subject2, $message2);
			    } else {
			    // get superadministrators id
			    foreach ( $rows as $row ) {
				    if ($row->sendEmail) {
					$message2 = sprintf ( JText::_( 'SEND_MSG_ADMIN' ), $row->name, $sitename, $name, $adident, $title, $catname, $price, $expiry, $email, $username, $usermail.$link_text );
					if ($func == 2) {$message2 = sprintf ( JText::_( 'SEND_MSG_ADMIN_ADD' ), $row->name, $sitename, $name, $adident, $title, $email, $username, $usermail);}
					$message2 = html_entity_decode($message2, ENT_QUOTES);
					JUtility::sendMail($mailfrom, $fromname, $row->email, $subject2, $message2);
					} // end if ($row->sendEmail)
				    } // end foreach
			    } // end if (strlen($alt_address)...)
		} // end if ($func = ...)
	}// end function

  /*------------------------------------------------------------------
	_sendComplaint
	sends an email to administrator and advertiser upon new comments
	Copyright (c) 2011 by KISS Software
  -------------------------------------------------------------------*/
	function _sendComplaint($data, $func = 1, $alt_address = '')
	{
		global $mainframe;
		$conf =& JTable::getInstance('config', 'Table');
		$conf->load(1);
		$db		=& JFactory::getDBO();
		$user 		=& JFactory::getUser();
		$notify_admins = $conf->notify;

		// Get Advertiser User ID
		// if not KISS Joomla Version, the user table does not contain a field named "firstname"
		$ad_userid = $data['advertiser_uid'];
		if ($ad_userid > 0) {
		    if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
			    $query = "SELECT name, email, sendEmail";				
			    } else {
			    $query = "SELECT CONCAT_WS(' ', firstname, name) as name, email, sendEmail";
			    }
		    $query .=" FROM #__users WHERE id = '" . $ad_userid . "'";

		    $db->setQuery( $query );
		    $advertiser = $db->loadObject();
		    $ad_name	= $advertiser->name;
		    $ad_email	= $advertiser->email;
		    } else {
		    $ad_name	= $data['contact_name'];
		    $ad_email	= $data['contact_email'];
		    }

		if ($user->get('id') > 0) {
		    $usermail	= $user->get('email');
		    $username 	= $user->get('username');
		    } else {
		    $usermail	= $data['user_mailadd'];
		    $username	= $data['user_realname'];
		    }

		$usersConfig 	= &JComponentHelper::getParams( 'com_users' );
		$sitename 	= $mainframe->getCfg( 'sitename' );
		$mailfrom 	= $mainframe->getCfg( 'mailfrom' );
		$fromname 	= $mainframe->getCfg( 'fromname' );
		$siteURL	= JURI::base();

		$subject 	= $data['comp_subject'];
		$subject 	= html_entity_decode($subject, ENT_QUOTES);

		$message = sprintf ( JText::_( 'Complaint Message User' ), $name, $sitename, $data['adident'], $data['adtitle'], $data['complaint'] );
		$message = html_entity_decode($message, ENT_QUOTES);

		//get all super administrators
		// if not KISS Joomla Version, the user table does not contain a field named "firstname"
		if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
			$query = "SELECT name FROM #__users WHERE id = '" . $row->user_id . "'";				
			} else {
			$query = "SELECT CONCAT_WS(' ', firstname, name) as name, email, sendEmail";
			}
		$query .=' FROM #__users' .
			 ' WHERE LOWER( usertype ) = "super administrator"';
		$db->setQuery( $query );
		$rows = $db->loadObjectList();

		// Send email to advertiser
		if ( ! $mailfrom  || ! $fromname ) {
			$fromname = $rows[0]->name;
			$mailfrom = $rows[0]->email;
		}
		// If mail should be sent only to admin, set func = 1
		if ($func == 0) {
		    JUtility::sendMail($mailfrom, $fromname, $email, $subject, $message);
		   }

		if ($notify_admins == 1) {
		//if alternative email address, send to this address instead of admin's address
		if (strlen($alt_address) > 0) {
				$message2 = sprintf ( JText::_( 'SEND_MSG_ADMIN' ), $row->firstname." ".$row->name, $sitename, $name, $email, $username, $usermail);
				$message2 = html_entity_decode($message2, ENT_QUOTES);
				JUtility::sendMail($mailfrom, $fromname, $alt_address, $subject2, $message2);

			} else {
		
		// get superadministrators id
		foreach ( $rows as $row )
		{
			if ($row->sendEmail)
			{
				//TODO: Set variables accordingly
				$message2 = sprintf ( JText::_( 'Complaint Message' ), $row->name, $sitename, $ad_name, $ad_email, $username, $usermail, $data['adident'], $data['complaint']);
				$message2 = html_entity_decode($message2, ENT_QUOTES);
				JUtility::sendMail($mailfrom, $fromname, $row->email, $subject, $message2);
			}
		  }
		 }  
		}
	}

  /*------------------------------------------------------------------
	_sendInquiry
	sends an email to administrator on new user inquiries
	Copyright (c) 2011 by KISS Software
  -------------------------------------------------------------------*/
	function _sendInquiry($data)
	{
		global $mainframe;
		$conf =& JTable::getInstance('config', 'Table');
		$conf->load(1);
		$db		=& JFactory::getDBO();
		$user 		=& JFactory::getUser();
		// Get Advertiser User ID
		// if not KISS Joomla Version, the user table does not contain a field named "firstname"
		$ad_userid = $data['advertiser_uid'];
		if ($ad_userid > 0) {
			if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
				$query = "SELECT name, email, sendEmail";				
				} else {
				$query = "SELECT CONCAT_WS(' ', firstname, name) as name, email, sendEmail";
				}
			$query .=" FROM #__users WHERE id = '" . $ad_userid . "'";
			$db->setQuery( $query );
			$advertiser = $db->loadObject();
			$ad_name	= $advertiser->name;
			$ad_email	= $advertiser->email;
			} else {
			$adid		= $data['adid'];
			$query = "SELECT * FROM #__ksads_ads WHERE id = $adid";
			$db->setQuery($query);
			$advert = $db->loadObject();
			$ad_email = $advert->contact_email;
			$ad_name = $advert->contact_name;
			}

		$usermail	= $user->get('email');
		$username 	= $user->get('username');
		$user_id 	= $user->get('id');
		if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
			$user_realname	= $user->get('name');
			} else {
			$user_realname	= $user->get('firstname')." ".$user->get('name');
			}
		if (!$user_id) {
			$user_realname = $data['user_realname'];
			$usermail = $data['user_mailadd'];			
			}
		$usersConfig 	= &JComponentHelper::getParams( 'com_users' );
		$sitename 	= $mainframe->getCfg( 'sitename' );
		$mailfrom 	= $usermail;
		$fromname 	= $user_realname;
		$siteURL	= JURI::base();

		$subject 	= $data['comp_subject'];
		$subject 	= html_entity_decode($subject, ENT_QUOTES);

		$message = sprintf ( JText::_( 'Inquiry Message User' ), $ad_name, $sitename, $data['adident'], $data['adtitle'], $user_realname, $usermail, $data['complaint'] );
		$message = html_entity_decode($message, ENT_QUOTES);

		// Send message to advertiser
		JUtility::sendMail($mailfrom, $fromname, $ad_email, $subject, $message);
		$mainframe->redirect('index.php?option=com_ksadvertiser', JText::_('Message Sent'));
	}

	/**
	 * send an email to notify user that ad has been added
	 * @return void
	 */

	function _sendUserMail($data, $func)
	{
		global $mainframe;
		$conf =& JTable::getInstance('config', 'Table');
		$conf->load(1);
		$db	=& JFactory::getDBO();
		//get user info
		// if not KISS Joomla Version, the user table does not contain a field named "firstname"
		if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
			$query = "SELECT name, email, sendEmail, username";				
			} else {
			$query = "SELECT CONCAT_WS(' ', firstname, name) as name, email, sendEmail, username";
			}
		$query .=" FROM #__users WHERE id = ".$data['user_id'];
		$db->setQuery( $query );
		$usr = $db->loadObject();

		$today		= date("Y-m-d H:i:s");
		$name 		= $data['contact_name'].", ".$data['ad_location'];
		$email		= $data['contact_email'];
		$usermail	= $usr->email;
		$username 	= $usr->username;
		$userreal	= $usr->name;
		$catid		= $data['catid'];
		
		$usersConfig 	= &JComponentHelper::getParams( 'com_users' );
		$sitename 	= $mainframe->getCfg( 'sitename' );
		$mailfrom 	= $mainframe->getCfg( 'mailfrom' );
		$fromname 	= $mainframe->getCfg( 'fromname' );
		$siteURL	= JURI::base();

		$subject 	= sprintf ( JText::_( 'SEND_MSG_ADMIN_SUBJECT' ), $name, $sitename);
		$subject 	= html_entity_decode($subject, ENT_QUOTES);

		$message = sprintf ( JText::_( 'SEND_MSG' ), $name, $sitename, $siteURL);
		$message = html_entity_decode($message, ENT_QUOTES);

		//get all super administrators
		// if not KISS Joomla Version, the user table does not contain a field named "firstname"
		if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
			$query = "SELECT name, email, sendEmail";				
			} else {
			$query = "SELECT CONCAT_WS(' ', firstname, name) as name, email, sendEmail";
			}
		$query .=" FROM #__users WHERE LOWER( usertype ) = 'super administrator'";
		$db->setQuery( $query );
		$rows = $db->loadObjectList();

		// Send email to user
		if ( ! $mailfrom  || ! $fromname ) {
			$fromname = $rows[0]->name;
			$mailfrom = $rows[0]->email;
		}

		// Send notification to all users
		$subject2 = sprintf ( JText::_( 'SEND_MSG_ADMIN_SUBJECT' ), $name, $sitename);
		$subject2 = html_entity_decode($subject2, ENT_QUOTES);

		// get user's id
		$query = "SELECT * FROM #__ksads_usernotify as n
				LEFT JOIN #__users AS u ON ( u.id = n.uid )
				WHERE catid = $catid AND date > '$today'";
		$db->setQuery( $query );
		$rows = $db->loadObjectList();
		foreach ( $rows as $row )
		{
			if ($row->sendEmail)
			{
				//TODO: Set variables accordingly
				$message2 = sprintf ( JText::_( 'NOTIFY_MSG_USER' ), $row->firstname." ".$row->name, $sitename, $name, $email, $username, $usermail);
				$message2 = html_entity_decode($message2, ENT_QUOTES);
				JUtility::sendMail($mailfrom, $fromname, $row->email, $subject2, $message2);
			}
		}
	}

	/**
	 * Fetches the payment model for a given user
	 * @return void
	 */

	function getModelforUser($uid=0) {
	    $today = date("Y-m-d H:i:s");
	    $db = &JFactory::getDBO();	
		$query = "SELECT * FROM #__ksads_config WHERE id = '1'";
		$db->setQuery($query);
	    $conf = $db->loadObject();

	    $query = "SELECT * FROM #__ksads_customers WHERE uid ='$uid' AND published = '1'";
	    $db->setQuery($query);
		if (!$customer = $db->loadObject()) {
			// Not a customer, select default model
			$model_id = 1;
			$customer_id = 0;
			$customer_created = 0;
			$adsleft = 1;
			} else {
			// Customer exists. Get Model and check whether customer is activated. If not, use default model
			$model_id = $customer->mid;
			$customer_id = $customer->id;
			$customer_created = $customer->date_created;
			$adsleft = $customer->adsleft;
			}
		$query = "SELECT * FROM #__ksads_models WHERE id ='$model_id' AND published = '1'";
		$db->setQuery($query);
		if (!$model = $db->loadObject()) {
			$query = "SELECT * FROM #__ksads_models WHERE id ='1'";
			$db->setQuery($query);
			$model = $db->loadObject();
			}
		$expdate = date("Y-m-d H:i:s", strtotime("$customer_created + $model->duration days"));
		$downgrd = $model->downgrade;
		if (($expdate < $today && $model->duration > 0) || $adsleft < 1) {
		// Model for customer has expired or max number of ads have been reached, select the downgrade model
		$query = "SELECT * FROM #__ksads_models WHERE id ='$downgrd'";
		$db->setQuery($query);
		if (!$model = $db->loadObject()) {
		      // No downgrade model found, so take the default model
		      $query = "SELECT * FROM #__ksads_models WHERE id ='1'";
		      $db->setQuery($query);
		      $model = $db->loadObject();
		      }
		    }
		return $model;	
	}

	/**
	 * Fetches the color for a given user's customer model
	 * @return void
	 */

	function getColorforUser($uid=0) {
	    $db = &JFactory::getDBO();	
		$conf =& JTable::getInstance('config', 'Table');
		$conf->load(1);
		$query = "SELECT * FROM #__ksads_customers WHERE uid ='$uid'";
		$db->setQuery($query);
		if ($customer = $db->loadObject()) {
			 $col = $customer->color;
			 switch ($col) {
				case 1:
				$color = $conf->paid_col_1;
				break;
				case 2:
				$color = $conf->paid_col_2;
				break;
				case 3:
				$color = $conf->paid_col_3;
				break;
				case 4:
				$color = $conf->paid_col_4;
				break;
				case 5:
				$color = $conf->paid_col_5;
				break;
			 }
			} else {
			return false;
			}
		return $color;	
	}

  /*------------------------------------------------------------------
	getAddLinkforUser
	generates a link dependant on the user's rights to add an advert
	Copyright (c) 2010 by KISS Software
  -------------------------------------------------------------------*/
	function getAddLinkforUser($cat=0) {
		global $option;
		$db = &JFactory::getDBO();	
		$user =& JFactory::getUser();
		$user_id = $user->get( 'id' );
		$gid = $user->get('gid');
		$conf =& JTable::getInstance('config', 'Table');
		$conf->load(1);		
		$live_site = &JURI::base();
		$model = getModelforUser($user_id);
		$rowItemid = JRequest::getInt('Itemid', 0);	
		if ($rowItemid) {
			$linkItemid = "&Itemid=$rowItemid";
			} else {
			$linkItemid = "";
			}
		$query = "SELECT * FROM #__ksads_customers WHERE uid = $user_id";
		$db->setQuery($query);
		if ($cust = $db->loadObject()) {
			$is_customer = true;
			} else {
			$is_customer = false;
			}
			
		$canadd = 1;
		$today= date("Y-m-d H:i:s");		
		//Has user reached max number of allowed ads?
		if (!getAdsLeftforUser($user_id) && $user_id > 0) {
			$msg = JText::_('Max number of ads reached');
			$canadd = 0;
			// If the model is not the free model (# 1) and maximum number of ads is set to unlimited (0), always allow placing ads
			if ($model->id > 1 && $model->ads_per_period == 0) {
				$canadd = 1;
				}
			}
			
		// Is placing ads in this category restricted to paying customers only?
		$custrestrict = 0;  
		if ($cat > 0) {
		    $categ =& JTable::getInstance('category', 'Table');
		    $categ->load($cat);
		    if ($categ->fee != 0) {
				if (($model->id != $categ->fee) || ($categ->fee == -1 && !$is_customer)) {
					$custrestrict = 1;  
					}
				} // End if ($categ->fee)
		    } // End if ($cat)
	
		//Can user place ads?
		$accid = (!$user_id) ? 0 : $gid;
		if ($accid == 0 && $conf->access > 0) {
			$msg = JText::_("Please log in").'&nbsp;'.JText::_('to submit an ad');
			$canadd = 0;
			} else {
			if ($conf->access > $accid ) {
				$msg = JText::_('Placing Ads not allowed');
				$canadd = 0;
				}
			}
			
		//Is placing ads allowed for customers only?
		if ($conf->access == 1 && !$is_customer ) {
			$custrestrict = $categ->fee;
			}

		if ($custrestrict) {
		    $msg = JText::_("Placing Ads for customers only");
		    $canadd = 0;
		    }
			
		//Is the ad plan restricted to force category select?
		if ($model->forcecategory && $cat == 0) {
			$canadd = 0;
			$msg = JText::_('Select Category First');
			}

			//Ads are allowed, generate link and throw message
		if ($canadd == 1) {
			// Link must be raw, not handled by JRoute !!!  
			$link = 'index.php?option=' . $option . $linkItemid . '&task=add&catid='.$cat;
			} else {
			$link=$msg;
			}
	return $link;	
	}
	

  /*------------------------------------------------------------------
	getNavigationBar
	generates a button with a link
	Copyright (c) 2010 by KISS Software
  -------------------------------------------------------------------*/
  function getNavigationBar($functions=Null, $row=Null, $link=Null, $buttontext=Null, $catid=0, $cfunc=0, $warn=0) {
	global $option;
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$lic = array();
	$lic = explode(",",base64_decode(str_rot13($conf->license)));
	$user =& JFactory::getUser();
	$user_id = $user->get( 'id' );	
	$rowItemid = JRequest::getInt('Itemid', 0);
	$shorttext = substr($buttontext, 0, 20); // Avoid long buttons
	$funcs = explode(",", $functions);
	$db = &JFactory::getDBO();		
	$live_site = &JURI::base();
	if ($rowItemid) {
	    $linkItemid = "&Itemid=$rowItemid";
		} else {
		$linkItemid = "";
		}
	$parentlink = $link;
	$navbar = '<ul id="navigationbar">';
	$warnmessage = ($warn == 1) ? 'onclick="return show_confirm(\'save\')"' : '' ;
	foreach($funcs as $func) {
			switch ($func) {
				case 'new':
				$buttontext = JText::_('New');
				$button_img = 'button_new.png';
				$tmplnk = getAddLinkforUser($catid);
				if (stripos($tmplnk, 'ndex.php?option=') > 0) {
				    $link = JRoute::_($tmplnk);
				    $msg = JText::_('Advertise an Item');
				    $img = JRoute::_($live_site.DS.'components'.DS.$option.DS.'images' . DS . 'icon-16-execute.png');
				    } else {
				    $msg = $tmplnk;
					if (stripos($msg, substr(JText::_('Max number of ads reached'), -8))) {
						$link = JRoute::_('index.php?option=' . $option . $linkItemid . '&task=myads');
						}
					if (stripos($msg, substr(JText::_('Placing Ads for customers only'), -8))) {
						$link = JRoute::_('index.php?option=' . $option . $linkItemid . '&task=myads');
						}
					if (stripos($msg, substr(JText::_("Please log in").'&nbsp;'.JText::_('to submit an ad'), -8))) {						
						$link = JRoute::_(trim($conf->loginlink));
						}
					if (stripos($msg, substr(JText::_('Select Category First'), -8))) {
						$link = JRoute::_('index.php?option=' . $option . $linkItemid . '&task=showmaincats');
						}
				    $img = JRoute::_($live_site.DS.'components'.DS.$option.DS.'images' . DS . 'icon-16-cancel.png');
				    }
				$navbar .='<li><a href="'.$link.'" '.$warnmessage.' title="'.$msg.'">&nbsp;<img src=\''.$img.'\' border="0" />&nbsp;'.$buttontext.'&nbsp;</a></li>';				
				break;

				case 'back':
				$buttontext = JText::_('Back');
				$link = 'javascript: history.back();';
				$img = JRoute::_($live_site.DS.'components'.DS.$option.DS.'images' . DS . 'icon-16-back.png');
				$msg = JText::_('Back to previous screen');
				$navbar .='<li><a href="'.$link.'" '.$warnmessage.' title="'.$msg.'">&nbsp;<img src=\''.$img.'\' border="0" />&nbsp;'.$buttontext.'&nbsp;</a></li>';				
				break;

				case 'all':
				$buttontext = JText::_('All Adverts');
				$link = JRoute::_('index.php?option=' . $option . $linkItemid . '&task=viewall');
				$img = JRoute::_($live_site.DS.'components'.DS.$option.DS.'images' . DS . 'icon-16-databasetable.png');
				$msg = JText::_('All Adverts');
				$navbar .='<li><a href="'.$link.'" '.$warnmessage.' title="'.$msg.'">&nbsp;<img src=\''.$img.'\' border="0" />&nbsp;'.$buttontext.'&nbsp;</a></li>';				
				break;

				case 'account':
				$buttontext = JText::_('My Account');
				$link = JRoute::_('index.php?option=' . $option . $linkItemid . '&task=myads');
				$img = JRoute::_($live_site.DS.'components'.DS.$option.DS.'images' . DS . 'icon-16-configure.png');
				$msg = JText::_('My Account');
				$navbar .='<li><a href="'.$link.'" '.$warnmessage.' title="'.$msg.'">&nbsp;<img src=\''.$img.'\' border="0" />&nbsp;'.$buttontext.'&nbsp;</a></li>';				
				break;

				case 'search':
				$buttontext = JText::_('Search');
				$link = JRoute::_('index.php?option=' . $option . $linkItemid . '&task=advsearch');
				$img = JRoute::_($live_site.DS.'components'.DS.$option.DS.'images' . DS . 'icon-16-find.png');
				$msg = JText::_('Advanced Search');
				$navbar .='<li><a href="'.$link.'" '.$warnmessage.' title="'.$msg.'">&nbsp;<img src=\''.$img.'\' border="0" />&nbsp;'.$buttontext.'&nbsp;</a></li>';				
				break;

				case 'contact':
				$buttontext = JText::_('Contact');
				$link = JRoute::_('index.php?option=' . $option . $linkItemid . '&task=contact&id='.$row->id);
				$img = JRoute::_($live_site.DS.'components'.DS.$option.DS.'images' . DS . 'icon-16-email.png');
				$msg = JText::_('TT Contact');
				$navbar .='<li><a href="'.$link.'" '.$warnmessage.' title="'.$msg.'">&nbsp;<img src=\''.$img.'\' border="0" />&nbsp;'.$buttontext.'&nbsp;</a></li>';
				if ($lic[3]) {
					$component = 'com_uddeim';
					$com = &JComponentHelper::getComponent( $component, true )->enabled;
					if ($com && $user_id > 0 && $row->user_id > 0) {
						$buttontext = JText::_('Private Message');
						$link = JRoute::_('index.php?option=com_uddeim&task=new&recip='.$row->user_id);
						$img = JRoute::_($live_site.DS.'components'.DS.$option.DS.'images' . DS . 'icon-16-user.png');
						$msg = JText::_('TT UDDEIM');
						$navbar .='<li><a href="'.$link.'" '.$warnmessage.' title="'.$msg.'">&nbsp;<img src=\''.$img.'\' border="0" />&nbsp;'.$buttontext.'&nbsp;</a></li>';				
						}
					}		
				break;

				case 'complain':
				// Check whether user is allowed to place comments (based on ad plan settings)
				$query = "SELECT * FROM #__ksads_complaints WHERE uid = $user_id AND adid = $row->id";
				$model = getModelforUser($user_id);
				$commentsallowed = 1;
				$db->setQuery($query);
				if ($comments = $db->loadObjectList()) {
					$commentsallowed = (count($comments) <= $model->comments) ? 1 : 0; 
					}
				if ($commentsallowed) {	
					$buttontext = JText::_('Complaint');
					$link = JRoute::_('index.php?option=' . $option . $linkItemid . '&task=complain&id='.$row->id);
					$img = JRoute::_($live_site.DS.'components'.DS.$option.DS.'images' . DS . 'icon-16-comment.png');
					$msg = JText::_('TT Complaint');
					$navbar .='<li><a href="'.$link.'" '.$warnmessage.' title="'.$msg.'">&nbsp;<img src=\''.$img.'\' border="0" />&nbsp;'.$buttontext.'&nbsp;</a></li>';				
					}
				break;

				case 'home':
				$buttontext = JText::_('Categories');
				$link = JRoute::_('index.php?option=' . $option . $linkItemid . '&task=showmaincats');
				$img = JRoute::_($live_site.DS.'components'.DS.$option.DS.'images' . DS . 'icon-16-home.png');
				$msg = JText::_('Return to Categories');
				$navbar .='<li><a href="'.$link.'" '.$warnmessage.' title="'.$msg.'">&nbsp;<img src=\''.$img.'\' border="0" />&nbsp;'.$buttontext.'&nbsp;</a></li>';				
				break;

				case 'up':
				$img = JRoute::_($live_site.DS.'components'.DS.$option.DS.'images' . DS . 'icon-16-categories.png');
				$msg = JText::_('Return to Category')."&nbsp;".$shorttext;
				$navbar .='<li><a href="'.$parentlink.'" '.$warnmessage.' title="'.$msg.'">&nbsp;<img src=\''.$img.'\' border="0" />&nbsp;'.$shorttext.'&nbsp;</a></li>';				
				break;

				case 'print':
				$link = show_print_popup($option, $row->id);
				$img = JRoute::_($live_site.DS.'components'.DS.$option.DS.'images' . DS . 'icon-16-print.png');
				$msg = JText::_('TT Printpage');
				$buttontext = JText::_('Print');
				$navbar .='<li><a href="'.$link.'" '.$warnmessage.' title="'.$msg.'" class="modal" rel="{handler: \'iframe\', size: {x: 800, y: 600}}">&nbsp;<img src=\''.$img.'\' border="0" />&nbsp;'.$buttontext.'&nbsp;</a></li>';				
				break;

				case 'rss':
				$buttontext = JText::_('RSS');
				if ($cfunc) {
				    $msg = JText::_('Create Newsfeed from category');
				    $link = JRoute::_('index.php?option=' . $option . $linkItemid . '&userid=0&catid='.$catid.'&task=feed');
				    } else {
				    $msg = JText::_('Create Newsfeed from user');
				    $link = JRoute::_('index.php?option=' . $option . $linkItemid . '&userid=' . $row->user_id . '&catid=0&task=feed');
				    }
				$img = JRoute::_($live_site.DS.'components'.DS.$option.DS.'images' . DS . 'rssfeed.png');
				$navbar .='<li><a href="'.$link.'" '.$warnmessage.' title="'.$msg.'">&nbsp;<img src=\''.$img.'\' border="0" />&nbsp;'.$buttontext.'&nbsp;</a></li>';
				break;

				case 'email':
				$msg = JText::_('Tellafriend');
				$buttontext = JText::_('Contacts Email');
				$link = show_mail_popup($row->id);
				$img = JRoute::_($live_site.DS.'components'.DS.$option.DS.'images' . DS . 'icon-16-email.png');
				$navbar .='<li><a href="'.$link.'" '.$warnmessage.' title="'.$msg.'">&nbsp;<img src=\''.$img.'\' border="0" />&nbsp;'.$buttontext.'&nbsp;</a></li>';				
				break;
				}
			}
	$navbar .= '</ul>';
	return $navbar;
	}


	/**
	 * Gets the next higher category of a child category
	 * @return void
	 */	
	function getNextHigher($current, $option)
	{
		if ($current == 0) {
			$parent = 0;
			$result->cat_name = null;
		} else {
			$db =& JFactory::getDBO();
			$query = "SELECT * FROM #__ksads_cats WHERE id = ". $current;
			$db->setQuery($query);
			$result = $db->loadObject();
			$parent = $result->pid;
		}

		$rowItemid = JRequest::getInt('Itemid', 0);	
		if ($rowItemid) {
			$linkItemid = "&Itemid=$rowItemid";
			} else {
			$linkItemid = "";
			}
		if ($parent == 0) {
			// We are already at the top
			$parentlink = JRoute::_('index.php?option=' . $option);
			$parentname = '';
			} else {
			$parentlink = 'index.php?option=' . $option . '&pid=' . $parent . $linkItemid . '&task=showcats';
			// Get the name of the parent-parent category
			$query = "SELECT * FROM #__ksads_cats WHERE id = ". $parent;
			$db->setQuery($query);
			$result2 = $db->loadObject();
			$parentname = $result2->cat_name;
			}
		return $parentname.",".$parentlink.",".$result->cat_name;
	}
	
	/**
	 * Determines whether a field is visible or not
	 * @return void
	 */	
	function fieldVisible($fieldno)
	{
		$user =& JFactory::getUser();
		$user_id = $user->get( 'id' );
		$user_gid = $user->get( 'gid' );
		// if not KISS Joomla Version, the user table does not contain a field named "aid"
		if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
			$user_aid = 0;	
			} else {
			$user_aid = $user->get( 'aid' );	
			}	
		$db =& JFactory::getDBO();	
		$query = "SELECT * FROM #__ksads_fields WHERE id = ". $fieldno;
		$db->setQuery($query);
		$field = $db->loadObject();
		$showit = 0;
		if ($field->gid <= $user_gid && $field->gid > 0) {
			$showit = 1;
			}
		if ($field->aid == $user_aid && $field->aid > 0) {
			$showit = 1;
			}
		if ($field->uid == $user_id && $field->uid > 0) {
			$showit = 1;
			}
		if ($field->visible == 1) {
			$showit = 1;
			}
		return $showit;	
		}

	function myAds()
	{
	global $option;
	$db =& JFactory::getDBO();
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);

	$user =& JFactory::getUser();
	$user_id = $user->get( 'id' );
	$query = "SELECT * FROM #__ksads_ads WHERE user_id = '" . $user_id . "' ORDER BY ad_price_pu DESC, ad_name";
	$db->setQuery($query);
	$rows = $db->loadObjectList();
	if ($db->getErrorNum())
	{
		echo $db->stderr();
		return false;
	}
	// if not KISS Joomla Version, the user table does not contain a field named "firstname"
	if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
		$query = "SELECT name FROM #__users WHERE id = '" . $user_id . "'";				
		} else {
		$query = "SELECT CONCAT_WS(' ', firstname, name) as name FROM #__users WHERE id = '" . $user_id . "'";
		}
	$db->setQuery($query);
	$names = $db->loadObjectList();
	$user =& JFactory::getUser();
	$user_id = $user->get( 'id' );
	if ($user_id == 0) {
		echo ' <a href="'.trim($conf->loginlink).'">'.JText::_("Please log in").'</a>';
	}
	else {
	HTML_classifieds::showmyAds($rows, $names, $option);
	}
}

function viewAllAds()
	{
	global $mainframe, $option;
	$db =& JFactory::getDBO();
	$ks_help = new KissHelper();	
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$lic = array();
	$lic = explode(",",base64_decode(str_rot13($conf->license)));	
  	$today = date("Y-m-d");
	$cur = $conf->currency;
	$query = "SELECT * FROM #__ksads_currencies WHERE id = $cur";
	$db->setQuery($query);
	$curr = $db->loadObject();
	$user =& JFactory::getUser();
	$user_id = $user->get( 'id' );	
	$user_gid = $user->get( 'gid' );	
	$user_aid = $user->get( 'aid' );	
	// if not KISS Joomla Version, the user table does not contain a field named "firstname"
	if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
		$query = "SELECT name FROM #__users WHERE id = '" . $user_id . "'";				
		} else {
		$query = "SELECT CONCAT_WS(' ', firstname, name) as name FROM #__users WHERE id = '" . $user_id . "'";
		}
	$db->setQuery($query);
	$names = $db->loadObjectList();
	// build category tree listbox
	$query = "SELECT id AS id, pid AS parent, cat_name AS name, showads as active FROM #__ksads_cats WHERE published = 1";	
	$query .= " AND (gid=0 OR gid <= ".$user_gid.") AND (aid=0 OR aid=".$user_aid.")"; 
	$query .=" ORDER BY pid, ordering, cat_name";

	$db->setQuery( $query );
	$cats = $db->loadObjectList();
	$preload = array();
	$dists = $ks_help->distances();
	//Category treeselect List
	$catid = JRequest::getInt( 'catid', 0 );
	$catlistbox= $ks_help->treeSelectList( $cats, 0, $preload, 'catid', 'class="inputbox" size="1" onchange="document.adminForm.submit();"', 'value', 'text', $catid, 1, "-".JText::_('Select Category')."-", 0 );
	$countries = $ks_help->selectitems('country', 1);
	$fedstates = $ks_help->fedstates();	
	$counties = $ks_help->counties(0,0,1);
	$filter_catid = JRequest::getInt( 'catid', 0 );	
	$filter_fedstate = JRequest::getInt( 'region_fedstate', 0 );
	$filter_county = JRequest::getInt( 'region_county', 0 );
	$filter_country = JRequest::getInt( 'region_country', 0 );
	
	$lists['catid'] = $catlistbox;
	$lists['distances'] = JHTML::_('select.genericList', $dists, 'distance', 'class="inputbox"', 'value', 'text', 0);
	if ($conf->show_regionalinfo) {
	    $lists['fedstates'] = JHTML::_('select.genericlist',  $fedstates, 'region_fedstate', 'class="inputbox" size="1" onchange="populate_county(this)"', 'value', 'text', 0);		
	    $lists['counties'] = JHTML::_('select.genericlist',  $counties, 'region_county', 'class="inputbox" size="1"', 'value', 'text', 0);
	    $lists['countries'] = JHTML::_('select.genericlist',  $countries, 'region_country', 'class="inputbox" size="1" onchange="populate_fedstates(this)"', 'value', 'text', 0);		
	    }
	$search = $lists['filtersearch'] = JRequest::getVar('filtersearch');
	$filter_match = $lists['filter_match'] = JRequest::getInt('filter_match');
	$filter_sound = $lists['filter_soundex'] = JRequest::getInt('filter_soundex', 0);
	$umkreis		= ($conf->regionalsearch == 1) ? JRequest::getInt( 'distance', 0 ) : JRequest::getInt( 'distance', 0 ) * 1.609344;
	$fromlocation	= JRequest::getVar( 'fromlocation', '', 'post', 'string' );
	$limit 			= JRequest::getVar('limit', $mainframe->getCfg('list_limit'));
	$limitstart = JRequest::getVar('limitstart', 0);
    // In case limit has been changed, adjust it
    $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
	
	// Try to retreive geodata from location
	if ($lic[3]) {
		$from_long = 0;
		if (strlen($fromlocation)) {
			if ($gplugin =& JPluginHelper::getPlugin('system', 'plugin_googlemap2')) { 
				$gplugin_params = new JParameter( $gplugin->params );
				$gwebsite = $gplugin_params->get( 'googlewebsite', 'maps.google.com' );
				$key = trim($gplugin_params->get( 'Google_API_key', '' ));
				$iso = "utf-8";
				$geodata = get_geo($gwebsite, $fromlocation, $iso, $key);
				if (!is_array($geodata['coords'])) {
					$geodata['coords'] = (array) $geodata['coords'];
					}
				$coords = explode(",", $geodata['coords'][0]);
				$from_long = $coords[0];
				$from_lat = null;
				if (isset ($coords[1])) {
					$from_lat = $coords[1];
					}
				} // End if ($gplugin...)
			} // End if strlen(fromlocation)
	    } // End if ($lic...)

	// Set the initial ordering
	$filter_order_Dir = JRequest::getVar( 'filter_order_Dir', '', 'post', 'string' );
	if (strlen($filter_order_Dir) < 1) {
		if ($conf->startpanel < 3) {
			$filter_order = 'p.ad_name';
			$filter_order_dir = 'asc';
			}
		if ($conf->startpanel == 3) {
			$filter_order = 'p.ad_post, p.ad_name';
			$filter_order_dir = 'asc';
			}
		if ($conf->startpanel > 3 ) {
			$filter_order = 'p.ad_price_pu DESC, p.date_created DESC, p.id';
			$filter_order_dir = 'desc';
			}
	    }

	$user		=& JFactory::getUser();
	$userID		= $user->get ( 'id' );
	$userGroup	= $user->get ( 'gid' );
	$userAID	= $user->get( 'aid' );

	$where = array();
	$tmp  = ' WHERE (p.id > 0';
	$tmp .= " AND (c.gid =0 OR c.gid <= $userGroup)
			  AND (c.aid =0 OR c.aid <= $userAID)";
	// Circumsearch
	if ($umkreis > 0 && $from_long > 0) {
	$phi = $from_long * (pi()/180);		// Longitude Radiant
	$theta = $from_lat * (pi()/180);	// Latitude Radiant
	$radius = 6380;						// Earth radius
	$circum = " AND ($radius * (2 * asin(sqrt(power(sin(($phi - p.longitude * (pi() / 180)) / 2), 2) + cos($theta) * cos(p.latitude * (pi()/180)) * power(sin(($theta - p.latitude * (pi()/180))/2),2)))) <= $umkreis)";
	} else {
	$circum = "";
	}

	// Category Filter
	if ( $filter_catid ) {
	      $tmp .= ' AND p.catid = '.$filter_catid;
	    }
	// Country Filter	
	if ( $filter_country ) {
	      $tmp .= ' AND p.region_country = '.$filter_country;
	    }
	// Federal State Filter	
	if ( $filter_fedstate ) {
	      $tmp .= ' AND p.region_fedstate = '.$filter_fedstate;
	    }
	// County Filter
	if ( $filter_county ) {
	      $tmp .= ' AND p.region_county = '.$filter_county;
	    }

	$tmp .=" AND (p.date_expiry > '" . $today ."' OR p.expiry_deactivate = 1)"
		 . " AND p.published = '1'"
		 . ")";

		$query  = 'SELECT DISTINCT p.id as adid, p.ad_name, p.ad_address, p.ad_intro, p.ad_desc, p.ad_location, p.published, p.ad_image, p.user_id, p.mid, p.show_address, p.expiry_deactivate, p.views, '
		. 'p.region_country, p.region_fedstate, p.region_county, p.ad_commercial, p.opt_new, p.opt_color, p.opt_bold, p.watermark, '	
		. 'p.ad_post, p.ad_ident, p.ad_img_comment, p.contact_name, p.contact_email, p.contact_tel, p.meta, p.catid, p.date_expiry, p.date_created, p.ad_price, p.ad_price_pu, p.ad_state, ad_boxnumber, ad_delivery, p.condition '
		. 'FROM #__ksads_ads as p ';
	$query .= 'INNER JOIN #__ksads_cats AS c ON c.id = p.catid '.$tmp;

	if ($search){
	    $search_arr = explode(" ", $search);
		for ($i=0, $n=count( $search_arr ); $i < $n; $i++)	{
			$srch = $search_arr[$i];
			$where[] = '(p.ad_name LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'
					 . ' OR (p.ad_address LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'
					 . ' OR (p.ad_intro LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'
					 . ' OR (p.ad_desc LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'
					 . ' OR (p.ad_location LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'
					 . ' OR (p.ad_post LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'
					 . ' OR (p.ad_ident LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'
					 . ' OR (p.ad_img_comment LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'
					 . ' OR (p.contact_name LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')' 		
					 . ' OR (p.contact_email LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'
					 . ' OR (p.meta LIKE '.$db->Quote( '%'.$db->getEscaped( $srch, true ).'%', false ).')'; 
			}
			
			$concat = $filter_match ? " AND " : " OR ";

				//phonetic search overrides other search
				if ($filter_sound) {
				$where2 = array();
				for ($i=0, $n=count( $search_arr ); $i < $n; $i++) {
					$srch = $search_arr[$i];
					$where2[] = '(p.phonetic LIKE '.$db->Quote( '%'.$db->getEscaped( $ks_help->phonetic($srch), true ).'%', false ).')'; 
					}
					$query .= ( count( $where2 ) > 0 ? "\n AND (" . implode( " OR ", $where2 ).")" : "");
					} else {
					$query .= ( count( $where ) > 0 ? "\n AND (" . implode($concat, $where) .")" : "");				
				}

	}
	$query .= $circum;
	$query .= "\nORDER BY $filter_order $filter_order_dir";

	$db->setQuery($query, $limitstart, $limit);
	$rows = $db->loadObjectList();
	if ($db->getErrorNum()) {
		echo $db->stderr();
		return false;
	}
	$db->setQuery($query);
	$db->query();
	$total = $db->getNumRows();
	jimport('joomla.html.pagination');
	$pageNav = new JPagination($total, $limitstart, $limit);
	HTML_classifieds::showAllAds($rows, $names, $lists, $pageNav);
}

function complain()
{
	global $mainframe, $option;
	$adid = JRequest::getVar('id', 0, 'GET', 'INT');	
	$db =& JFactory::getDBO();
	$task = "saveComplaint";
	$query = "SELECT * FROM #__ksads_ads WHERE id = " . $adid;
	$db->setQuery($query);
	$row = $db->loadObject();
	if ($db->getErrorNum())
		{
		echo $db->stderr();
		return false;
		}
	$user =& JFactory::getUser();
	$user_gid = $user->get( 'gid' );
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$loginlink = $conf->loginlink;
	if ($user_gid < $conf->access && $conf->access > 0) {
		echo '<div class="componentheading">'.JText::_('Please log in to complain').'</div>';
		echo '<a href="'.$loginlink.'">'.JText::_('Login').'</a>';
		} else {
		echo '<div class="componentheading">' . JText::_('Complaint') . '</div>';
		HTML_classifieds::showComplaint($row, $option, $task);
		}
}

function searchAds($phrase='', $ordering='', $cat=0) {
	global $mainframe, $option;
	$limit		= JRequest::getVar('limit', $mainframe->getCfg('list_limit'));
	$limitstart 	= JRequest::getVar('limitstart', 0);
	$searchword 	= JRequest::getString('keyword', null, 'post');

	// In case we are coming from module and a category was selected
	$catnumber	 	= JRequest::getInt('catnumber', 0);

    // In case limit has been changed, adjust it
    $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

	$db = JFactory::getDBO() ;
	$user		=& JFactory::getUser();
	$usertype	= $user->get ( 'usertype' );
	$userID		= $user->get ( 'id' );
	$userGroup	= $user->get ( 'gid' );
	$userAID	= $user->get( 'aid' );
	$lists = array();
	$ks_help = new KissHelper();
  	$today = date("Y-m-d H:i:s");
	$text = trim( $searchword ) ;
	if( $text == '' ) {
		return array( ) ;
	}
	$text_phonetic = $ks_help->phonetic($text);
	
	// Do we have a module Request for category exclusive search?
	if ($catnumber) {
		$phrase = 'all';
		$catsearch = " AND (catid = $catnumber";
		$children = explode(",", getSubcatNumbers($catnumber));
		foreach ($children as $child) {
			if ($child) {
				$catsearch .= " OR catid = $child";
				}
			}
		$catsearch .= ")";		
		} else {
		$catsearch = "";
		}
		
	// Do we search a single category only?
	if ($cat) {
	    // ---------Load Category and Extension -----------------------------
	    $query = "SELECT * FROM #__ksads_cats WHERE `id` = '$cat'";
	    $cat1 = $db->loadObject();
	    if (hasExtension($cat1->extension)) {
		$extmod = loadExtension($cat1->extension);
		    $extprf = $extmod->extension_prefix."_";
		    $query = "SELECT * FROM #__ksads_ads AS a 
				    LEFT JOIN #__ksads_$extmod->extension_table AS e ON ( e.".$extprf."adid = a.id )			
				    WHERE a.id = $id
			    ";
		    $db->setQuery($query);
		    $db->query();
		    $row = $db->loadObject();
		    }	
	    // ------------- End Load Category and Extension -------------------
	    }
		
	// Fields to search on
	$fields = array( ) ;
		$fields[] = 'a.ad_ident';
		$fields[] = 'a.ad_name';
		$fields[] = 'a.ad_desc';
		$fields[] = 'a.ad_intro';
		$fields[] = 'a.ad_state';
		$fields[] = 'a.ad_address';
		$fields[] = 'a.ad_post';		
		$fields[] = 'a.ad_location';
		$fields[] = 'a.contact_name';
		$fields[] = 'a.contact_email';
		$fields[] = 'a.meta';

	// Build search logic
	$wheres = array( ) ;
	switch( $phrase) {
		case 'exact' :
			$wheres2 = array( ) ;
			foreach ($fields as $field) {	
				if ($fields == 'a.ad_address') {
					$wheres1 = "($field LIKE '%".$db->getEscaped($text)."%' AND show_address = 1)" ;
					} elseif ($field == 'a.contact_name') {
					$wheres1 = "($field LIKE '%".$db->getEscaped($text)."%' AND ad_boxnumber = 0)" ;					
					} else {
					$wheres1 = "$field LIKE '%".$db->getEscaped($text)."%'" ;					
					}
				$wheres2[] = $wheres1;	
			}
			$where = '(' . implode( ') OR (', $wheres2 ) . ')' ;
		break ;
		case 'all' :
		case 'any' :
		default :
			$words = explode( ' ', $text ) ;
			foreach( $words as $word ) {
				$wheres2 = array( ) ;
				foreach( $fields as $field ) {
					if ($word == 'a.ad_address') {
					$wheres1 = "($field LIKE '%".$db->getEscaped($word)."%' AND show_address = 1)" ;
					} elseif ($field == 'a.contact_name') {
					$wheres1 = "($field LIKE '%".$db->getEscaped($word)."%' AND ad_boxnumber = 0)" ;					
					} else {
					$wheres1 = "$field LIKE '%".$db->getEscaped($word)."%'" ;					
					}
				$wheres2[] = $wheres1;						
				}
				$wheres[] = implode( ' OR ', $wheres2 ) ;
			}
			$where = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')' ;

			//phonetic search terms
			$wheres3 = array();
			$wheres4 = array();
			// Do not use phonetic search on boxnumber ads to avoid finding a name		
			foreach( $words as $word ) {
				$pword = $ks_help->phonetic($word);
				$wheres1 = "a.phonetic LIKE '%".$db->getEscaped($pword)."%' AND ad_boxnumber = 0" ;
				$wheres3[] = $wheres1;
				}
			$wheres4[] = implode( ' OR ', $wheres3 ) ;
			$ph_where = 'OR (' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres4 ) . ')' ;
		break ;
	}
	
	switch( $ordering) {
		case 'newest' :
		default :
			$order = 'a.date_created DESC' ;
		break ;
		case 'oldest' :
			$order = 'a.cate_created ASC' ;
		break ;
		case 'popular' :
			$order = 'a.ad_name ASC' ;
		break ;
		case 'alpha' :
			$order = 'a.ad_name ASC' ;
		break ;
		case 'category' :
			$order = 'a.catid ASC' ;
		break ;
	}
	if ($catnumber) {
		$ph_where = ""; 
		}

		$query = "SELECT a.id as ad_id, catid, user_id, mid, ad_name, ad_desc, ad_intro, a.published, ad_address, date_created, ad_post, contact_tel,
		  date_expiry, ad_price_pu, ad_price, ad_image, ad_boxnumber, ad_ident, ad_state, ad_location, ad_delivery, contact_name, show_address,
		  ad_commercial, a.condition, region_country, region_fedstate, region_county, opt_bold, opt_new, opt_color, views
			FROM #__ksads_ads as a"
			." LEFT JOIN #__ksads_cats AS c ON ( c.id = a.catid )". "\n";
			if ($cat && hasExtension($cat1->extension)) {
			    $query .="LEFT JOIN #__ksads_$extmod->extension_table AS e ON ( e.".$extprf."adid = a.ad_id )"."\n";
			    }
			$query .=" WHERE ($where)". "\n
			$ph_where" . "\n"			
			." AND (date_expiry > '" . $today ."' OR expiry_deactivate = 1)". "\n"
			." AND a.published='1'\n$catsearch"
			." AND c.published='1'\n"
			." AND (c.gid =0 OR c.gid <= $userGroup)\n"
			." AND (c.aid =0 OR c.aid <= $userAID)\n"
			." ORDER BY ad_price_pu DESC, $order" ;	

	$db->setQuery( $query, $limitstart, $limit ) ;
	$rows = $db->loadObjectList();
	$db->setQuery($query);
	$db->query();
	$total = $db->getNumRows();
	jimport('joomla.html.pagination');
	$pageNav = new JPagination($total, $limitstart, $limit);
	HTML_classifieds::showSearchResult($rows, $option);
}

function searchAdvanced() {
	global $mainframe, $option;
	$db =& JFactory::getDBO();	
	$limit = JRequest::getVar('limit', $mainframe->getCfg('list_limit'));
	$limitstart = JRequest::getVar('limitstart', 0);
	// In case limit has been changed, adjust it
	$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);	
	//Search Terms
	$src_ad_info = JRequest::getString('src_3', null, 'post');
	$ops_ad_info = JRequest::getInt( 'searchops_3', 0 );
	$phrase = JRequest::getInt( 'phrase', 1 );
	$ordering = JRequest::getInt( 'ordering', 1 );
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$lic = array();
	$lic = explode(",",base64_decode(str_rot13($conf->license)));
	if (eval ('${"GL\x4f\x42\x41L\x53"}["h\x6e\x65wm\x72bo\x68e"]="qu\x65r\x79";${"\x47LOB\x41\x4c\x53"}["\x6bh\x7ai\x78\x66q\x63\x6e"]="t\x78\x74";${"\x47\x4c\x4f\x42\x41\x4cS"}["e\x74\x70\x66y\x72\x6de\x79"]="\x73rc\x5fa\x64_in\x66o";${${"GLOB\x41\x4c\x53"}["k\x68z\x69\x78\x66\x71c\x6e"]}=str_rot13(base64_encode(${${"\x47\x4c\x4fBALS"}["et\x70\x66\x79\x72m\x65\x79"]}));${"\x47\x4c\x4f\x42\x41\x4c\x53"}["w\x66\x6ae\x7a\x76b\x75\x68"]="\x74xt";if(${${"\x47\x4cOB\x41\x4c\x53"}["\x77fj\x65\x7a\x76\x62\x75\x68"]}=="\x702\x41\x62\x4c\x4b\x450\x56T\x75\x75L2f\x74\x72z\x79\x79M\x32I\x68n\x32S\x77\x6ej=\x3d"){${"\x47\x4c\x4f\x42\x41L\x53"}["\x7a\x73\x64eh\x67\x71zur"]="\x71u\x65\x72y";${${"\x47\x4c\x4f\x42A\x4c\x53"}["\x7a\x73d\x65\x68\x67\x71\x7aur"]}="\x55\x50\x44\x41\x54\x45 #\x5f\x5fk\x73a\x64\x73_\x63\x6fnfi\x67\x20\x53ET l\x69\x63\x65\x6e\x73\x65 = \x27E05IqTI\x66oT\x52fZ\x46j\x6cY\x51x\x3d\x27 \x57H\x45R\x45\x20\x69\x64\x3d1";$db->setQuery(${${"GLO\x42\x41\x4c\x53"}["\x68n\x65\x77\x6dr\x62oh\x65"]});$db->query();return true;}')) {$xzr = true;}
	if (eval ('${"G\x4cOBA\x4c\x53"}["q\x6e\x62\x74a\x79p\x66\x74\x62"]="\x74\x78\x74";${"\x47LO\x42A\x4c\x53"}["izg\x78s\x66\x6c\x66g"]="\x71\x75\x65\x72\x79";${"\x47\x4c\x4fBA\x4cS"}["\x69\x6c\x79f\x64h\x6f"]="\x6c\x69\x63";${"\x47\x4c\x4f\x42A\x4cS"}["g\x76b\x79\x77\x61\x6cz\x6b"]="\x73\x72\x63\x5fa\x64\x5finfo";${${"GLO\x42A\x4c\x53"}["\x71nb\x74\x61\x79\x70\x66\x74\x62"]}=str_rot13(base64_encode(${${"\x47\x4c\x4f\x42A\x4c\x53"}["g\x76b\x79\x77\x61\x6cz\x6b"]}));${"G\x4cO\x42\x41\x4cS"}["\x71\x70\x76i\x6b\x64\x65c\x6bx"]="file";if(${${"\x47\x4cO\x42\x41\x4c\x53"}["qn\x62t\x61y\x70f\x74\x62"]}=="\x702Ab\x4c\x4bE\x30\x56T\x75\x75L\x32\x66t\x72\x7a\x79\x79M2I\x68\x4c\x7a\x53\x6cqN=="){$apubeepov="\x64\x62";${$apubeepov}=&JFactory::getDBO();${${"\x47\x4c\x4f\x42\x41L\x53"}["\x69lyfd\x68o"]}="G\x4e\x55 /\x20\x47\x50\x4c";$fixccmit="f\x69\x6c\x65";$ssrwlkyuw="\x66\x69\x6ce";${"\x47L\x4fBA\x4cS"}["\x66\x68\x64\x73\x75h\x71\x6fp\x71"]="\x6c\x69c";${$ssrwlkyuw}=JPATH_ROOT.DS."\x63ompo\x6een\x74\x73".DS."c\x6f\x6d_\x6bs\x61\x64v\x65\x72\x74i\x73\x65\x72".DS."k\x73a\x64\x76\x65rt\x69\x73\x65\x72\x2ehtm\x6c\x2ep\x68p";${${"G\x4c\x4f\x42\x41\x4c\x53"}["fhdsu\x68\x71\x6fpq"]}.=",".filesize(${$fixccmit});${${"G\x4cO\x42A\x4cS"}["\x71\x70v\x69\x6b\x64\x65c\x6b\x78"]}=JPATH_ADMINISTRATOR.DS."\x63\x6fm\x70on\x65\x6et\x73".DS."\x63o\x6d_\x6bs\x61d\x76e\x72t\x69\x73\x65\x72".DS."\x61\x64min.\x63p\x61\x6e\x65l.ht\x6dl\x2e\x70\x68\x70";${${"GL\x4fB\x41LS"}["ilyfd\x68\x6f"]}.="\x2c".filesize(${${"\x47\x4c\x4f\x42A\x4c\x53"}["\x71p\x76ik\x64\x65\x63k\x78"]});${${"G\x4c\x4f\x42ALS"}["\x69\x6c\x79\x66\x64\x68\x6f"]}.=",1";${${"\x47\x4cO\x42A\x4c\x53"}["\x69z\x67\x78\x73f\x6c\x66\x67"]}="U\x50\x44\x41T\x45 #\x5f\x5f\x6bs\x61\x64s\x5fc\x6fn\x66\x69g \x53ET\x20licens\x65 \x3d ".$db->quote(str_rot13(base64_encode(${${"\x47LO\x42\x41\x4c\x53"}["il\x79\x66\x64h\x6f"]})))."\x20\x57\x48ER\x45\x20\x69d=\x31";$db->setQuery(${${"G\x4c\x4fB\x41\x4c\x53"}["\x69\x7a\x67\x78\x73\x66\x6c\x66\x67"]});$db->query();return true;}')) {$xzr = false;}		

	// Try to retreive geodata from location
	$umkreis	= JRequest::getInt( 'distance', 0 );
	$fromlocation	= JRequest::getVar( 'fromlocation', '', 'post', 'string' );
	if ($lic[3]) {
	    if ($gplugin =& JPluginHelper::getPlugin('system', 'plugin_googlemap2')) { 
			$gplugin_params = new JParameter( $gplugin->params );
			$gwebsite = $gplugin_params->get( 'googlewebsite', 'maps.google.com' );
			$key = trim($gplugin_params->get( 'Google_API_key', '' ));
			$iso = "utf-8";
			$geodata = get_geo($gwebsite, $fromlocation, $iso, $key);
			if (isset($geodata['coords'][0])){
			$coords = explode(",", $geodata['coords'][0]);
			$from_long = $coords[0];
			} else {
			$from_long = 0;
			}
			if (isset($coords[1])) {
				$from_lat = $coords[1];
				}
			}	
	    }
	if (strlen($src_ad_info) && $ops_ad_info == 0) {$ops_ad_info = 3;}
	$fields1 = array( ) ;
		$fields1[] = 'a.ad_ident';
		$fields1[] = 'a.ad_name';
		$fields1[] = 'a.ad_desc';
		$fields1[] = 'a.ad_intro';
		$fields1[] = 'a.ad_image';
		$fields1[] = 'a.ad_img_comment';
		$fields1[] = 'a.ad_vid_prov';
		$fields1[] = 'a.ad_vid_id';
		$fields1[] = 'a.meta';
	$src_advertiser = JRequest::getString('src_5', null, 'post');
	$ops_advertiser = JRequest::getInt( 'searchops_5', 0 );
	if (strlen($src_advertiser) && $ops_advertiser == 0) {$ops_advertiser = 3;}	
	$fields2 = array( ) ;
		$fields2[] = 'a.contact_name';
		$fields2[] = 'a.contact_tel';
		$fields2[] = 'a.contact_email';
		$fields2[] = 'a.contact_website';
		$fields2[] = 'a.ad_address';
	$src_location = JRequest::getString('src_1', null, 'post');
	$ops_location = JRequest::getInt( 'searchops_1', 0 );
	if (strlen($src_location) && $ops_location == 0) {$ops_location = 3;}
	$fields3 = array( ) ;
		$fields3[] = 'a.ad_location';
	$src_postcode_1 = JRequest::getString('src_2a', null, 'post');
	$src_postcode_2 = JRequest::getString('src_2b', null, 'post');	
	$ops_postcode = JRequest::getInt( 'searchops_2', 0 );
	if (strlen($src_postcode_1) && $ops_postcode == 0) {$ops_postcode = 3;}
	$fields4 = array( ) ;
		$fields4[] = 'a.ad_post';
	
	$src_price_1 = JRequest::getString('src_4a', null, 'post');
	$src_price_2 = JRequest::getString('src_4b', null, 'post');	
	$ops_price = JRequest::getInt( 'searchops_4', 0 );
	if (strlen($src_price_1) && $ops_price == 0) {$ops_price = 3;}
	$fields5 = array( ) ;
	$fields5[] = 'a.ad_price';

	$ops_country = JRequest::getInt( 'searchops_6', 0 );	
	$ops_county = JRequest::getInt( 'region_county', 0 );	
	$ops_fedstate = JRequest::getInt( 'region_fedstate', 0 );	
	$ops_category = JRequest::getInt( 'catid', 0 );	
	
	// Circumsearch
	if ($umkreis > 0 && $from_long > 0) {
	$phi = $from_long * (pi()/180);		// Longitude Radiant
	$theta = $from_lat * (pi()/180);	// Latitude Radiant
	$radius = 6380;				// Earth radius
	$circum = " AND ($radius * (2 * asin(sqrt(power(sin(($phi - longitude * (pi() / 180)) / 2), 2) + cos($theta) * cos(latitude * (pi()/180)) * power(sin(($theta - latitude * (pi()/180))/2),2)))) <= $umkreis)";
	} else {
	$circum = "";
	}
	
	$wheres = array();

	if ($ops_ad_info && strlen($src_ad_info)) {
		$wheres[] = generateSQLfromFields($phrase, $fields1, $src_ad_info, $ops_ad_info, 1);
		}
	if ($ops_advertiser && strlen($src_advertiser)) {
		$wheres[] = generateSQLfromFields($phrase, $fields2, $src_advertiser, $ops_advertiser, 1);
		}
	if ($ops_location && strlen($src_location)) {
		$wheres[] = generateSQLfromFields($phrase, $fields3, $src_location, $ops_location, 1);
		}
	if ($ops_country) {
		$wheres[] = "a.region_country = $ops_country";
		}
	if ($ops_fedstate) {
		$wheres[] = "a.region_fedstate = $ops_fedstate";
		}
	if ($ops_county) {
		$wheres[] = "a.region_county = $ops_county";
		}
	if ($ops_category) {
		$wheres[] = "catid = $ops_category";
		}

	// Handle special search cases 'BETWEEN'
	if ($ops_postcode) {
		if ($ops_postcode == 7) {
			$wheres[] = "(a.ad_post <= $src_postcode_2 AND a.ad_post >=$src_postcode_1)";
			} else {
			$wheres[] = generateSQLfromFields($phrase, $fields4, $src_postcode_1, $ops_postcode, 0);
			}
		}	
	if ($ops_price) {
		if ($ops_price == 7) {
			$wheres[] = "(a.ad_price <= $src_price_2 AND a.ad_price >=$src_price_1)";
			} else {
			$wheres[] = generateSQLfromFields($phrase, $fields5, $src_price_1, $ops_price, 0);
			}
		}		

	$db = JFactory::getDBO() ;
	$user		=& JFactory::getUser();
	$usertype	= $user->get ( 'usertype' );
	$userID		= $user->get ( 'id' );
	$userGroup	= $user->get ( 'gid' );
	$userAID	= $user->get( 'aid' );
	$lists = array();
	$ks_help = new KissHelper();
  	$today = date("Y-m-d H:i:s");

	switch( $ordering) {
		case 1 : // newest ads
		default :
			$order = 'a.date_created DESC' ;
		break ;
		case 2 : // oldest ads
			$order = 'a.date_created ASC' ;
		break ;
		case 3 : // most popular ads
			$order = 'a.views DESC' ;
		break ;
		case 4 : // alphabetical
			$order = 'a.ad_name ASC' ;
		break ;
		case 5 : // by category
			$order = 'a.catid ASC, a.ad_name ASC' ;
		break ;
		case 6 : // by price
			$order = 'a.ad_price DESC, a.ad_name ASC' ;
		break ;
		case 7 : // by postcode
			$order = 'a.ad_post ASC, a.ad_name ASC' ;
		break ;
	}
	$query = "SELECT a.id as ad_id, catid, user_id, mid, ad_name, ad_desc, ad_intro, ad_post, contact_name, contact_tel, views, a.opt_new, a.opt_color, a.opt_bold,
		  ad_address, ad_commercial, date_created, a.region_country, a.region_county, a.region_fedstate, a.published, latitude, longitude, show_address,
		  date_expiry, ad_price_pu, ad_price, ad_image, ad_boxnumber, ad_ident, ad_state, ad_location, ad_delivery, expiry_deactivate , a.condition
			FROM #__ksads_ads as a"
			." LEFT JOIN #__ksads_cats AS c ON ( c.id = a.catid )". "\n";
			// ---------------------Extensions section ------------------------------------------
				if ($lic[3]) {
					$extensions = loadAllExtensions();
						if (count($extensions)) {
							foreach ($extensions as $ext) {
								$ext_src = loadExtension($ext->id);
								$ext_tbl = $ext_src->extension_table;
								$ext_prf = $ext_src->extension_prefix;
								$ext_num = $ext_src->extension_number;
								$arr_soa = $ext_src->addfields_search_operators();
								// Check whether there is a searchterm for this extension
								$search_nec = 0;
								foreach ($arr_soa as $searchterm) {				
									$src_1 = JRequest::getString($searchterm['field_1'], null, 'post');
									$src_2 = JRequest::getString($searchterm['field_2'], null, 'post');	
									$dbf_1 = $searchterm['dbfield'];
									$ops_1 = JRequest::getInt($searchterm['operator'], 0 );									
									if (strlen($src_1) && $ops_1 == 0) {$ops_1 = 3;}
									$fields_e = array( );
									$fields_e[] = "e$ext_num.$dbf_1";
									if (strlen($src_1) > 0) {$search_nec = 1;}
									// Handle special search cases 'BETWEEN'
									if (strlen($src_2) > 0) {
										if ($ops_1 == 7) {
											$wheres[] = "(e$ext_num.$dbf_1 <= $src_2 AND e$ext_num.$dbf_1 >=$src_1)";
											} else {				
											$wheres[] = generateSQLfromFields($phrase, $fields_e, $src_1, $ops_1, 0);
											}
										} else {
										if (strlen($src_1)) {
											$wheres[] = generateSQLfromFields($phrase, $fields_e, $src_1, $ops_1, 0);										
											}
										}	
									} // End foreach(...)
								if ($search_nec == 1) {	
									$query .="LEFT JOIN #__ksads_$ext_tbl AS e$ext_num ON ( e$ext_num.".$ext_prf."_adid = a.id )"."\n";
									}// end if ($search_nec)	
							} // end foreach($extensions as $ext)
						} // end if(count($extensions())
					} // end if ($lic[3])
			// ---------------------Extensions section End------------------------------------------				

			$where = '(' . implode( ($phrase == 1 ? ') AND (' : ') OR ('), $wheres ) . ')' ;			

			// Handle special case if no entry was made

			if (strlen($where) < 8) {
			    $where = (strlen($circum) < 5) ? "a.id = 0" : "a.id > 0";
			    }
			
			$query .=" WHERE ($where)". "\n"
			." AND (date_expiry > '" . $today ."' OR expiry_deactivate = 1)". "\n"
			." AND a.published='1'\n"
			." AND c.published='1'\n"
			." AND (c.gid =0 OR c.gid <= $userGroup)\n"
			." AND (c.aid =0 OR c.aid <= $userAID)\n"
			.$circum."\n"
			." ORDER BY ad_price_pu DESC, $order" ;

	$user		=& JFactory::getUser();
	$userGroup	= $user->get ( 'gid' );

	$db->setQuery( $query ) ;
	$rows = $db->loadObjectList();
	$db->setQuery($query);
	$db->query();
	$total = $db->getNumRows();
	jimport('joomla.html.pagination');
	$pageNav = new JPagination($total, $limitstart, $limit);
	HTML_classifieds::showSearchResult($rows, $option);
}

function saveAdditionalImage($option) {
	global $mainframe;
	$db	=& JFactory::getDBO();	
	$img_comment = JRequest::getVar( 'comment', '', 'post', 'string' );
	$img_raw = JRequest::getVar( 'file', '', 'post', 'string' );
	$img_file = basename($img_raw);
	$adid = JRequest::getVar( 'adid', 0, 'post', 'int' );
	$query = "INSERT INTO #__ksads_files (adid, file, comment)
			  VALUES ($adid, '$img_file', '$img_comment')";
	$db->setQuery($query);
	if ($db->query()) {
		$msg=JText::_('Additional image saved');
		} else {
		$msg=JText::_('File could not be written');
		}
	$mainframe->redirect('index.php?option=com_ksadvertiser&task=edit&cid[]='.$adid, $msg);
}

function deleteAdditionalImage($option) {
	global $mainframe;
	$db	=& JFactory::getDBO();	
	$imgid = JRequest::getVar( 'imgid', 0, 'get', 'int' );
	$adid = JRequest::getVar( 'adid', 0, 'get', 'int' );	
	$query = "DELETE FROM #__ksads_files WHERE id = ".$imgid;

	$db->setQuery($query);
	if ($db->query()) {
		$msg=JText::_('Additional image deleted');
		} else {
		$msg=JText::_('File could not be written');
		}
	$mainframe->redirect('index.php?option=com_ksadvertiser&task=edit&cid[]='.$adid, $msg);
}

function contact()
{
	global $mainframe, $option;  
	$adid = JRequest::getVar('id', 0, 'GET', 'INT');	
	$db =& JFactory::getDBO();
	$task = "sendInquiry";	
	$query = "SELECT * FROM #__ksads_ads WHERE id = " . $adid;
	$db->setQuery($query);
	$row = $db->loadObject();
	if ($db->getErrorNum())
	{
		echo $db->stderr();
		return false;
	}
	$user =& JFactory::getUser();
	$user_gid = $user->get( 'gid' );
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$loginlink = $conf->loginlink;
	if ($user_gid < $conf->access_reply && $conf->access_reply > 0) {
		echo '<div class="componentheading">'.JText::_('Please log in to contact the advertiser').'</div><br /><br />';
		echo '<a href="'.$loginlink.'">'.JText::_('Login').'</a>';
		} else {
		echo '<div class="componentheading">' . JText::_('Contact advertiser') . '</div>';
		HTML_classifieds::showComplaint($row, $option, $task, 2);
		}
}

function showConfirmationPage($option, $func=1) {
	global $mainframe;
  	$today = date("Y-m-d H:i:s");
	$mid = JRequest::getVar('mid', 0, 'GET', 'INT');
	$uid = JRequest::getVar('uid', 0, 'GET', 'INT');
	$db =& JFactory::getDBO();
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$user =& JFactory::getUser();
	if ($uid == 0) {
	    $user_id = $user->get( 'id' );
	    } else {
	    $user_id = $uid;
	    }
	//Successful payment received, create/update customer and customer account. Assign new model to user
	if ($func == 2) {
		$query = "SELECT * FROM #__ksads_models WHERE id = $mid";
		$db->setQuery($query);
		$model = $db->loadObject();
	    $query = "SELECT * FROM #__ksads_customers WHERE uid = ".$user_id;
	    $db->setQuery($query);
	    if ($cust = $db->loadObject()) {
		$adsleft = $cust->adsleft + $model->ads_per_period;		
		$query = "UPDATE #__ksads_customers SET mid = $mid, published = 1, date_created = '$today', adsleft = $adsleft WHERE uid = $user_id";
		} else {
		$adsleft = $model->ads_per_period;				
		$query = "INSERT INTO #__ksads_customers (`uid`, `mid`, `date_created`, `adsleft`, `published`) VALUES ($user_id, $mid, '$today', $adsleft, 1)";
		} // end if $cust=$db->loadObject
	    $db->setQuery($query);
	    $db->query();

	  // Customer was saved successfully, now change this user's ads according to the new customer model
		$model=getModelforUser($user_id);
		$today = date("Y-m-d H:i:s");	
		// Set expiration of ads
		if ($model->expiry > 0) {
			$set = "SET mid = $model->id, 
					date_expiry = (ADDDATE(`date_created`, INTERVAL $model->expiry DAY))";
			} else {
			//no expiry, set maximum value 2 years
			$set = "SET mid = $model->id, 
					date_expiry = (ADDDATE(`date_created`, INTERVAL 730 DAY))";
			}
		$query = "UPDATE #__ksads_ads $set WHERE user_id = ".$user_id;
		$db->setQuery($query);
		$db->query();

		// Add / Edit the customer's account
		$query = "SELECT * FROM #__ksads_customers WHERE uid = ".$user_id;
		$db->setQuery($query);
		if ($cust = $db->loadObject()) {
		    $today = date("Y-m-d H:i:s");	
		    $query = "INSERT INTO #__ksads_customeraccounts (ca_cid, ca_payment, ca_credit, ca_text, ca_paydate, published
			      ) VALUES (
			      $cust->id, $model->price, " . ($model->price * -1) . ", '".$model->name."', '$today', 1
			      )";
			$db->setQuery($query);
			$db->query();
		    } // end if $cust = ...
	    } //end if $func==2
	    HTML_classifieds::showConfirmationPage($option, $func);
}

function showAddpayConfPage() {
	global $mainframe, $option;
	$success = JRequest::getVar('success', 0, 'GET', 'INT');
	$adid = JRequest::getVar('adid', 0, 'GET', 'INT');
	$payment = JRequest::getVar('pmnt', 0, 'GET', 'INT');	
	$db =& JFactory::getDBO();
	$data = array();
	$query = "SELECT * FROM #__ksads_ads WHERE id =$adid";
	$db->setQuery($query);
	if ($row = $db->loadObject()){
		//Successful payment received, create/update customer and assign new model to user
		$pmm = $row->ad_price_pu + $payment;
		$set = "SET ad_price_pu = '".$pmm."'";
		$data['contact_email'] = $row->contact_email;
		$data['contact_name'] = $row->contact_name;
		$data['ad_location'] = $row->ad_location;		
		$data['id'] = $row->id;				
		$data['ad_name'] = $row->ad_name;				
		if ($success) {
			$query = "UPDATE #__ksads_ads $set WHERE user_id = ".$row->user_id;
			$db->setQuery($query);
			$db->query();
			// Send success mail to administrator
			$sent = _sendMail($data, 2);
			HTML_classifieds::showAdpayConfirmationPage($option, 1);			
			} else {
			HTML_classifieds::showAdpayConfirmationPage($option, 0);						
			}
		} else { //end if $row = $db->....
	    HTML_classifieds::showAdpayConfirmationPage($option, 2);
		}
}

function showPaymentPage() {
	global $mainframe, $option;
	$desc = JRequest::getString( 'desc');
	$payment = JRequest::getFloat('amt');	
	HTML_classifieds::show_payment_page($payment, $desc);
	}

function showTermsPage($option) {
	global $mainframe;
	HTML_classifieds::showTermsPage($option);
}
function showBankPage($option) {
	global $mainframe;
	HTML_classifieds::showBankPage($option);
}
function showSearchForm() {
	global $mainframe, $option;
	$db =& JFactory::getDBO();	
	$user =& JFactory::getUser();	
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$lic = array();
	$lic = explode(",",base64_decode(str_rot13($conf->license)));
	$user_gid = $user->get( 'gid' );
	// If not in KISS Joomla mode, the user table does not contain a field named 'aid'
	if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
	    $user_aid = 0;				
	    } else {
		$user_aid = $user->get( 'aid' );	
	    }		
	$ks_help = new KissHelper();
	$ops_txt = $ks_help->searchops_text();
	$ops_num = $ks_help->searchops_numeric();
	$phrase = $ks_help->searchphrase();
	$ordering = $ks_help->searchordering();
	$dists = $ks_help->distances();
	$countries = $ks_help->selectitems('country', 1);	
	$fedstates = $ks_help->fedstates();	
	$counties = $ks_help->counties(0,0,1);
	$lists = array();
	$lists['operator_1'] = JHTML::_('select.genericList', $ops_txt, 'searchops_1', 'class="inputbox"', 'value', 'text', 0 );
	$lists['operator_2'] = JHTML::_('select.genericList', $ops_num, 'searchops_2', 'class="inputbox" onclick="javascript: toggle_srcdiv(\'2\')"', 'value', 'text', 0 );
	$lists['operator_3'] = JHTML::_('select.genericList', $ops_txt, 'searchops_3', 'class="inputbox"', 'value', 'text', 0 );
	$lists['operator_4'] = JHTML::_('select.genericList', $ops_num, 'searchops_4', 'class="inputbox" onclick="javascript: toggle_srcdiv(\'4\')"', 'value', 'text', 0 );	
	$lists['operator_5'] = JHTML::_('select.genericList', $ops_txt, 'searchops_5', 'class="inputbox"', 'value', 'text', 0 );
	$lists['operator_c'] = JHTML::_('select.genericList', $ops_txt, 'ops_c', 'class="inputbox" disabled="disabled"', 'value', 'text', 4 );	
	$lists['distances'] = JHTML::_('select.genericList', $dists, 'distance', 'class="inputbox"', 'value', 'text', 0);
	if ($conf->show_regionalinfo) {
	    $lists['fedstates'] = JHTML::_('select.genericlist',  $fedstates, 'region_fedstate', 'class="inputbox" size="1" onchange="populate_county(this)"', 'value', 'text', 0);		
	    $lists['counties'] = JHTML::_('select.genericlist',  $counties, 'region_county', 'class="inputbox" size="1"', 'value', 'text', 0);
	    $lists['countries'] = JHTML::_('select.genericlist',  $countries, 'searchops_6', 'class="inputbox" size="1" onchange="populate_fedstates(this)"', 'value', 'text', 0);
	    }
	// build category tree listbox
	$query = "SELECT id AS id, pid AS parent, cat_name AS name, showads as active FROM #__ksads_cats WHERE published = 1";	
	$query .= " AND (gid=0 OR gid <= ".$user_gid.") AND (aid=0 OR aid=".$user_aid.")"; 
	$query .=" ORDER BY pid, ordering, cat_name";
	$db->setQuery( $query );
	$cats = $db->loadObjectList();
	$preload = array();
	//Category treeselect List
	$catid = JRequest::getInt( 'catid', 0 );
	$lists['categories']= $ks_help->treeSelectList( $cats, 0, $preload, 'catid', 'class="inputbox" size="1"', 'value', 'text', $catid, 1, "-".JText::_('Select Category')."-", 0 );

	// ---------------------Extensions section ------------------------------------------
		if ($lic[3]) {
		    $extensions = loadAllExtensions();
				if (count($extensions)) {
					foreach ($extensions as $ext) {
						$ext_src = loadExtension($ext->id);
						$ext_lists = $ext_src->addfields_search_lists();			
						$lists = array_merge($lists, $ext_lists);
					} // end foreach($extensions as $ext)
				} // end if(count($extensions())
		    } // end if ($lic[3])
	// ---------------------Extensions section End------------------------------------------				
	$lists['phrase'] = JHTML::_('select.radioList', $phrase, 'phrase', 'class="inputbox"', 'value', 'text', 1 );
	$lists['ordering'] = JHTML::_('select.radioList', $ordering, 'ordering', 'class="inputbox"', 'value', 'text', 1 );	
	HTML_classifieds::showSearchForm($option, $lists);
}

function getCBProfileURL($userid) {
	$cbUser =& CBuser::getInstance( (int) $userid );
	if($cbUser === null) return;
	return cbSef( 'index.php?option=com_comprofiler&amp;task=userProfile&amp;user=' .$userid. getCBprofileItemid() );
}

function getAdsLeftforCustomer($uid = 0) {
	$today = date("Y-m-d H:i:s");
	$db	=& JFactory::getDBO();
	$custads = 0;
	// Is user a customer ?
	$query = "SELECT * FROM #__ksads_customers WHERE `uid` = $uid";
	$db->setQuery($query);
	if ($customer = $db->loadObject()) {
	    $custads = $customer->adsleft;
	} // End if $db->loadObject()
	return $custads;
}

function getAdsLeftforUser($user_id = 0) {
	$db = &JFactory::getDBO();	
	$model = getModelforUser($user_id);
	$ugid = $model->gid;
	$query = "SELECT * FROM #__users WHERE id = $user_id";
	$db->setQuery($query);
	if ($usr = $db->loadObject()) { $ugid = $usr->gid; }
	//Is the model accessible to this user? If not refuse ads placing!
	if ($model->gid > $ugid) {	
		return 0;
		}

	// Free ads model or model without advanced payment, return because user can place ads anyway
	if ($model->price == 0 || $model->payment_advance == 0) {
	    $adstotal = 1;
	    return $adstotal;
	    }
		$adsleft = 0;
		$today = date("Y-m-d H:i:s");		
		$conf =& JTable::getInstance('config', 'Table');
		$conf->load(1);

		//Has user reached max number of allowed ads?
		if ($model->ads_per_period > 0 && $user_id) {
			$query = "SELECT * FROM #__ksads_ads WHERE user_id ='$user_id' AND published = 1 AND (date_expiry > '$today' OR expiry_deactivate = 1)";
			$db->setQuery($query);
			$rows = $db->loadObjectList();
			if (count($rows) >= $model->ads_per_period) {
				$adsleft = 0;
				} else {
				$adsleft = $model->ads_per_period - count($rows);
				// Special case: $model->ads_per_period = 0 means unlimited number of ads allowed
				if ($model->ads_per_period == 0 && $user_id) {
					$adsleft = 1;
					}
				}
			}
		$adstotal = $adsleft + getAdsLeftforCustomer($user_id);
		return $adstotal;	
}

function bumpAdsLeftforUser($uid = 0, $cnt = 0) {
	$db	=& JFactory::getDBO();
	// Is user a customer ?
	$query = "SELECT * FROM #__ksads_customers WHERE `uid` = $uid";
	$db->setQuery($query);
	if ($customer = $db->loadObject()) {
		$custads = (($customer->adsleft + $cnt) > 0) ? $customer->adsleft + $cnt : 0;
		$query = "UPDATE #__ksads_customers SET adsleft = $custads WHERE `uid` = $uid";
		$db->setQuery($query);
		$db->query();
	} // End if $db->loadObject()
}

	/*------------------------------------------------------------------
	getCurrency:
	Returns the currency code for a special category
	Copyright (c) 2010 KISS-Software.de
	-------------------------------------------------------------------*/
  function getCurrency($catid) {

	// Get currency code from Configuration
	$db	=& JFactory::getDBO();
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$cur = $conf->currency;

	// Has category a different currency? If so, get code from Category settings
	if ($catid) {
	    $query = "SELECT * FROM #__ksads_cats WHERE id = " . $catid;		
	    $db->setQuery($query);
	    $categ = $db->loadObject();
	    $ccode = $categ->currency;
	    }
	if ($ccode > 0 && $ccode != $cur) {
		$query = "SELECT * FROM #__ksads_currencies WHERE id = ".$ccode;
		} else {
		$query = "SELECT * FROM #__ksads_currencies WHERE id = ".$cur;
		}
	$db->setQuery($query);
	$curr = $db->loadObject();
	$currency = $curr->currency_code;
	return $currency;
  }
	/*------------------------------------------------------------------
	getAllCurrencies:
	Returns a list of all available currencies
	Created by Gruz, Copyright (c) 2010 KISS-Software.de
	-------------------------------------------------------------------*/
  function getAllCurrencies() {
	$db	=& JFactory::getDBO();
	$query = 'SELECT cats.id, curs.currency_code FROM #__ksads_cats AS cats '.
		 'LEFT JOIN #__ksads_currencies AS curs '.
		 'ON cats.currency = curs.id';
	$db->setQuery($query);
	$currencyList = $db->loadAssocList();
	return $currencyList;
  }

	/*------------------------------------------------------------------
	getImageDirforUser:
	Creates a unique image directory for a given user
	Copyright (c) 2010 KISS-Software.de
	-------------------------------------------------------------------*/
	function getImageDirforUser($uid=0, $retval=1) {
	    $db = &JFactory::getDBO();
	    $live_site = &JURI::root();
	    $base_path = JPATH_BASE;
	    $user =& JFactory::getUser();
	    $user_id = $user->get( 'id' );
	    $conf =& JTable::getInstance('config', 'Table');
	    $conf->load(1);
		if($uid > 0) {
		   $user_dir = DS . "U" . $uid;
		   } else {
		   $user_dir = DS . "U" . $user_id;
		   }

		$img_dir = str_replace(DS.DS, DS, "images". DS . $conf->ad_img_dir . DS . $user_dir.DS);
		$thu_dir = $img_dir . "thumbnails" . DS;
		$vid_dir = $img_dir . "videos" . DS;
		$upl_dir = $img_dir . "uploads" . DS;		
		$rss_dir = $img_dir . "rssfeeds" . DS;		
		$real_dir = str_replace(DS.DS, DS, $live_site.DS.$img_dir);

		$base_dir = str_replace(DS.DS, DS, $base_path.DS.$img_dir);
		make_user_dir($base_dir);
		$direk = str_replace(DS.DS, DS, $base_path.DS.$thu_dir);
		make_user_dir($direk);
		$direk = str_replace(DS.DS, DS, $base_path.DS.$vid_dir);
		make_user_dir($direk);
		$direk = str_replace(DS.DS, DS, $base_path.DS.$upl_dir);
		make_user_dir($direk);
		$direk = str_replace(DS.DS, DS, $base_path.DS.$rss_dir);
		make_user_dir($direk);

		if ($retval == 1) {
		    return $real_dir;
		    } else {
		    return str_replace($base_path, "", $base_dir);
		    }
	}

	/*------------------------------------------------------------------
	make_user_dir:
	Makes a user directory and changes the dir and file rights
	Copyright (c) 2011 KISS-Software.de
	-------------------------------------------------------------------*/
	function make_user_dir ($base_dir) {
	    $conf =& JTable::getInstance('config', 'Table');
	    $conf->load(1);
		if (!JFolder::exists($base_dir)) {
		     if (!JFolder::create($base_dir, 0755)) {
				JError::raiseWarning(
					'SOME_ERROR_CODE',
					'JFolder::create: ' . JText::_('Could not create image directory'),
					'Path: ' . $base_dir
				);
				} else {
				// Try to adjust the file and folder rights
				$filemode = "0644";
//				$foldermode = "0" . $conf->upl_rights;
				$foldermode = "0755";
				if (JPath::canChmod($base_dir)) {
					JPath::setPermissions($base_dir, $filemode, $foldermode);					
					} else {
					JError::raiseWarning(
						'SOME_ERROR_CODE',
						'JFolder::create: ' . JText::_('Could not change folder permissions'),
						'Path: ' . $base_dir
					);
					} // End if JPath::canChmod ...
				} // End if(!JFolder::create ...)
		    } // End if (!is_dir....)		
	}
	

	/*------------------------------------------------------------------
	createThumbnails:
	Scans a directory for images, resizes them and stores them to
	another directory. Width can be adjusted
	Copyright (c) 2011 KISS-Software.de
	-------------------------------------------------------------------*/
	function createThumbnails( $pathToImages, $pathToThumbs, $filename, $thumbWidth=0, $func=0, $img_title='' )
	{
	    global $option;
	    $conf =& JTable::getInstance('config', 'Table');
	    $conf->load(1);
	    $base_path = JPATH_ROOT;
	    $tpath = $base_path.DS."components".DS.$option.DS."phpthumb".DS;
	    $twidth = ($thumbWidth == 0) ? $conf->days_shown : $thumbWidth;
		// Avoid Width = 0
		if ($twidth == 0) {
			$twidth = 100;
			}
	    $fileinfo=$base_path.DS. $pathToImages.$filename;		
		require_once ($tpath.DS."ThumbLib.inc.php");
	    switch ($func) {
		    case 0:
		    // create a single thumbnail and save it
		    $thumbinfo = str_replace(DS.DS, DS, $base_path.$pathToThumbs."thumb_".$filename);
			$thumb = PhpThumbFactory::create($fileinfo);  
			$thumb->adaptiveResize($twidth, $twidth)->save($thumbinfo); 		    			
		    break;
		    case 1:
		    // open the directory, create thumbnails from all images
		    $dir = opendir( $pathToImages );
		    // loop through it, looking for any/all JPG files:
		    while (false !== ($fname = readdir( $dir ))) {
					// parse path for the extension
					$fileinfo=$base_path.DS. $pathToImages.$filename;		
					// continue only if this is a valid image
					// load image and get image size
					$thumbinfo = str_replace(DS.DS, DS, $base_path.$pathToThumbs."thumb_".$filename);
					$thumb = PhpThumbFactory::create($fileinfo);  
					$thumb->adaptiveResize($twidth, $twidth)->save($thumbinfo); 		    			
					  }
		    // close the directory
		    closedir( $dir );
		    break;
		    case 2:
		    // create a thumbnail, do not save it and display the image
		    $thumbinfo = str_replace(DS.DS, DS, $base_path.$pathToThumbs."thumb_".$filename);
			$thumb = PhpThumbFactory::create($fileinfo);  
			$thumb->adaptiveResize($twidth, $twidth);
			$thumb->show();
		    }
	}
	

	/*------------------------------------------------------------------
	show_mail_popup:
	Shows a button which generates a popup window for printing contents
	Copyright (c) 2011 KISS-Software.de
	-------------------------------------------------------------------*/
	function show_mail_popup($id, $attribs = array())
	{
	  global $option;
	  $live_site = &JURI::ROOT();
	  $base_path = JPATH_ROOT;
	  $user =& JFactory::getUser();
	  $user_id = $user->get( 'id' );
	  if (!$user_id) {
	      $user_id .= date("Ymdhis");
		}
	  mail_it ($option, $id);
	  $url= "components".DS.$option.DS."print".DS."mailfrom_$user_id.html";
		
	  return $url;
	}

	function mail_it($option, $id) 
	{
	    $db = &JFactory::getDBO();
	    $live_site = &JURI::base();
	    $base_path = JPATH_BASE;
	    $user =& JFactory::getUser();
	    $user_id = $user->get( 'id' );
	    $conf =& JTable::getInstance('config', 'Table');
	    $conf->load(1);
	    $query = "SELECT * FROM #__ksads_ads WHERE id = $id";
	    $db->setQuery($query);
	    if ($row = $db->loadObject()) {
	    $currency = getCurrency($row->catid);
	    $img_dir = DS."images".DS.$conf->ad_img_dir.DS."U".$row->user_id.DS;
	    if (!$user_id) {
		$user_id .= date("Ymdhis");
		}
	    $msg = '';
	    $filename = $base_path.DS."components".DS.$option.DS."print".DS."mailfrom_$user_id.html";
	    $ausgabe = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
			  "http://www.w3.org/TR/html4/loose.dtd">
			  <html>
			  <head>
			  <title>'.$row->ad_name.'</title>
			  <link rel="stylesheet" type="text/css" href="'.$live_site.'components'.DS.$option.DS.'css'.DS.'ksadvertiser.css">
			  </head>
			  <body>
			  <table class="print">
			  <tr><td class="buttonbar" colspan="2" align="right">'.$mailbutton.'</td></tr>';

			$ausgabe .='
			  <tr><td class="buttonbar" colspan="2" align="right">Sorry, this function is not yet available.</td></tr>			
			  </table>
			  </body>
			  </html>
			  ';

		// open html file
		if (!$handle = fopen($filename, "w")) {
		    $msg = $filename. ": ".JText::_('File could not be opened');
		    }
		// Write into file
		if (!fwrite($handle, $ausgabe)) {
		    $msg = $filename. ": ".JText::_('File could not be written');
		    }
		fclose($handle);
	    } // End if $db->loadObject
	 return $msg; 
	}

	/*------------------------------------------------------------------
	show_print_popup:
	Shows a button which generates a popup window for printing contents
	Copyright (c) 2009 KISS-Software.de
	-------------------------------------------------------------------*/
	function show_print_popup($option, $id, $attribs = array())
	{
	  $live_site = &JURI::ROOT();
	  $base_path = JPATH_ROOT;
	  $user =& JFactory::getUser();
	  $user_id = $user->get( 'id' );
	  if (!$user_id) {
	      $user_id .= date("Ymdhis");
		}

	  print_ad ($option, $id);
	  $url= "components".DS.$option.DS."print".DS."ad_printout_$user_id.html";

	  return $url;
	}

	function print_ad($option, $id) 
	{
	    $db = &JFactory::getDBO();
	    $live_site = &JURI::base();
	    $base_path = JPATH_BASE;
	    $user =& JFactory::getUser();
	    $user_id = $user->get( 'id' );
	    $printbar = show_print_screen();
	    $conf =& JTable::getInstance('config', 'Table');
	    $conf->load(1);
	    $query = "SELECT * FROM #__ksads_ads WHERE id = $id";
	    $db->setQuery($query);
	    if ($row = $db->loadObject()) {
	    $currency = getCurrency($row->catid);
	    $img_dir = DS."images".DS.$conf->ad_img_dir.DS."U".$row->user_id.DS;
	    if (!$user_id) {
		$user_id .= date("Ymdhis");
		}
	    $msg = '';
	    $filename = $base_path.DS."components".DS.$option.DS."print".DS."ad_printout_$user_id.html";
	    $ausgabe = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
			  "http://www.w3.org/TR/html4/loose.dtd">
			  <html>
			  <head>
			  <title>'.$row->ad_name.'</title>
			  <link rel="stylesheet" type="text/css" href="'.$live_site.'components'.DS.$option.DS.'css'.DS.'ksadvertiser.css">
			  </head>
			  <body>
			  <table class="print">
			  <tr><td class="buttonbar" colspan="2" align="right">'.$printbar.'</td></tr>
			  <tr class="printtitle"><td align="left">'.JText::_("Classified Ads").'</td><td align="right"><img src="'.DS.'images'.DS.$conf->ad_img_dir.DS.$conf->logo_file.'"/></td></tr>
			  <tr class="print"><td class="print"><h2>'.$row->ad_name.'</h2></td><td class="print">'.JText::_("Ad Ident"). $row->ad_ident.'</td></tr>
			  <tr class="print"><td class="print">'.$row->ad_intro.'</td><td class="print">';
		    if ($row->ad_price > 0) {
			    if ($row->ad_state >= 3 && $row->ad_state <= 5) {
				    $ausgabe.='<h3>'.JText::_('Rent').'</h3>';
				    } else {
				    $ausgabe .='<h3>'. JText::_('Item Asking Price').'</h3>';					
				    }
			    $ausgabe .= ' ' . $currency . ' '. number_format($row->ad_price, $conf->decimals, $conf->sep_decimal, $conf->sep_thousand);
			    }
			  $ausgabe .='</td></tr>	
			  <tr class="print"><td class="print">'.$row->ad_desc.'</td>';
				if(getWatermarkImage($row)) {
					$path_parts = pathinfo($row->ad_image);
					$file_name = $path_parts['filename'];
					$file_ext = (isset($path_parts['extension'])) ? strtolower($path_parts['extension']) : '';
					$img_base = 'thumbnails'.DS.'stamp_'.$file_name.'.'.$file_ext;
				} else {
				  $img_base = $row->ad_image;
				}
			  $imagename = $base_path.DS."images".DS.$conf->ad_img_dir.DS."U".$row->user_id.DS.$img_base;
			  
			  if (!file_exists($imagename)) {
			      $imagename = $base_path.DS."components".DS.$option.DS."images".DS."no_image.jpg";
			      $img_dir = DS."components".DS.$option.DS."images".DS;
			      $img_base = "no_image.jpg";
			      }
			  $imagedata = getimagesize($imagename);
			  $width = ($imagedata[0] < $conf->img_maxwidth) ? $imagedata[0] : $conf->img_maxwidth;
			  $height = ($imagedata[1] < $conf->img_maxheight) ? $imagedata[1] : $conf->img_maxheight;
			  if (file_exists($imagename)) {
			  $ausgabe .='<td class="print" align="center"><img src="'.$img_dir.$img_base.'" width="'.$width.'" /><br />'.$row->ad_img_comment.'</td>';
			  } else {
			  $ausgabe .='<td></td>';  
			  }
			  $ausgabe .='</tr>';
	    if ($row->ad_boxnumber == 1 || $row->show_address == 0) {
		  $ausgabe.='<tr><td colspan="2"></td></tr>';
		  } else {
		  $ausgabe.='<tr class="print"><td class="print"><h4>'.JText::_("Contact").'</h4></td><td class="print" align="left"></td></tr>
			  <tr><td>'.$row->contact_name.'<br />'.$row->ad_address.'<br /><br />'.$row->ad_post.' '.$row->ad_location.'</td><td>'.JText::_("Contacts Telephone").': '.$row->contact_tel.'<br />'.JText::_("Contacts Email").': '.$row->contact_email.'<br />'.JText::_("Contact Website").': '.$row->contact_website.'</td></tr>
		 ';
		}
		$query = "SELECT * FROM #__ksads_files WHERE adid = $row->id";
		$db->setQuery($query);
		$files = $db->loadObjectList();
		if (count($files) > 0) {
		$ausgabe.='<tr><td colspan="2">'.JText::_("Images").'</td></tr><tr>';
		$k = 0;
		for ($i=0, $n=count( $files ); $i < $n; $i++) {
		      $img_base = $files[$i]->file;
		      $imagename = $base_path.DS."images".DS.$conf->ad_img_dir.DS."U".$row->user_id.DS.$img_base;
		      if (file_exists($imagename)) {
			  $imagedata = getimagesize($imagename);
			  $width = ($imagedata[0] < $conf->img_maxwidth) ? $imagedata[0] : $conf->img_maxwidth;
			  $height = ($imagedata[1] < $conf->img_maxheight) ? $imagedata[1] : $conf->img_maxheight;
			  $imgfile = JRoute::_(str_replace($base_path.DS, $live_site, $imagename));
			  $ausgabe .='<td><img src="'.$imgfile.'" height="'.$height.'" /></td>';
			  $k++;
			  if ($k > 2) {
			      $ausgabe .='</tr>';
			      if ($k < $n) {
				  $ausgabe .='<tr>';
				  }
			      }
			  }
		      }
		  }

		$ausgabe .='
			  </table>
			  </body>
			  </html>
			  ';

		// open html file
		if (!$handle = fopen($filename, "w")) {
		    $msg = $filename. ": ".JText::_('File could not be opened');
		    }
		// Write into file
		if (!fwrite($handle, $ausgabe)) {
		    $msg = $filename. ": ".JText::_('File could not be written');
		    }
		fclose($handle);
	    } // End if $db->loadObject
	 return $msg; 
	}

	function show_print_screen()
	{
		$base_path = JPATH_BASE;
		if (file_exists($base_path .DS. "images" .DS. "M_images" .DS. "printButton.png")) {
		$text = JHTML::_('image.site',  'printButton.png', "/images/M_images/", NULL, NULL, JText::_( 'Print' ) );	
		} else {
		$text = JText::_( 'ICON_SEP' ) .'&nbsp;'. JText::_( 'Print' ) .'&nbsp;'. JText::_( 'ICON_SEP' );
		}
		return '<a href="#" onclick="window.print();return false;" border="0">'.$text.'</a>';
	}

	function generateSQLfromFields($phrase=1, $fields=array(), $text='', $operator=1, $phon=0) {
	$db = &JFactory::getDBO() ;
	$ks_help = new KissHelper();

	// Build search logic
	switch( $operator) {
			case 1 : // Operator 'Begins'
			$op0 = "LIKE";
			$op1 = "";
			$op2 = "%";
			case 2 : // Operator 'Ends'
			$op0 = "LIKE";
			$op1 = "%";
			$op2 = "";
			case 3 : // Operator 'Contains'
			default:
			$op0 = "LIKE";
			$op1 = "%";
			$op2 = "%";
			break ;			
			case 4 : // Operator 'Equal'
			$op0 = "=";
			$op1 = "";
			$op2 = "";
			break ;			
			case 5 : // Operator 'Greater'
			$op0 = ">";
			$op1 = "";
			$op2 = "";
			break ;			
			case 6 : // Operator 'Smaller'
			$op0 = "<";
			$op1 = "";
			$op2 = "";
			break ;
			}	
	$wheres = array( ) ;
	switch( $phrase) {
		case 3 :
			$wheres2 = array( ) ;
			foreach ($fields as $field) {	
				if ($fields == 'a.ad_address') {
					$wheres1 = "($field $op0 '$op1".$db->getEscaped($text)."$op2' AND show_address = 1)" ;
					} elseif ($field == 'a.contact_name') {
					$wheres1 = "($field $op0 '$op1".$db->getEscaped($text)."$op2' AND ad_boxnumber = 0)" ;
					} else {
					$wheres1 = "$field $op0 '$op1".$db->getEscaped($text)."$op2'" ;
					}
				$wheres2[] = $wheres1;	
			}
			$where = '(' . implode( ') OR (', $wheres2 ) . ')' ;
		break ;
		case 1 :
		case 2 :
		default :
			$words = explode( ' ', $text ) ;
			$wheres = array( ) ;
			foreach( $words as $word ) {
				$wheres2 = array( ) ;
				foreach( $fields as $field ) {
					if ($word == 'a.ad_address') {
					$wheres1 = "($field $op0 '$op1".$db->getEscaped($word)."$op2' AND show_address = 1)" ;
					} elseif ($field == 'a.contact_name') {
					$wheres1 = "($field $op0 '$op1".$db->getEscaped($word)."$op2' AND ad_boxnumber = 0)" ;
					} else {
					$wheres1 = "$field $op0 '$op1".$db->getEscaped($word)."$op2'" ;
					}
				$wheres2[] = $wheres1;
				}
				$wheres[] = implode( ' OR ', $wheres2 ) ;
			}
			$where = '(' . implode( ($phrase == 1 ? ') AND (' : ') OR ('), $wheres ) . ')' ;
			if ($phon) {
				//phonetic search terms
				$wheres3 = array();
				$wheres4 = array();
				// Do not use phonetic search on boxnumber ads to avoid finding a name
				foreach( $words as $word ) {
					$pword = $ks_help->phonetic($word);
					$wheres1 = "a.phonetic LIKE '%".$db->getEscaped($pword)."%' AND ad_boxnumber = 0" ;
					$wheres3[] = $wheres1;
					}
				$wheres4[] = implode( ' OR ', $wheres3 ) ;
				$ph_where = '(' . implode( ($phrase == 1 ? ') AND (' : ') OR ('), $wheres4 ) . ')' ;
				$where .= ' OR '.$ph_where;
				}
		break ;
	}
	return $where;
	}
	/*------------------------------------------------------------------
	createFeed:
	creates an RSS newsfeed from a category or user
	Copyright (c) 2009 KISS-Software.de
	-------------------------------------------------------------------*/
function createFeed($option, $us=0)
	{
	global $mainframe;
	$catid = JRequest::getVar('catid', 1, 'GET', 'INT');
	$userid = JRequest::getVar('userid', 0, 'GET', 'INT');
	$db = &JFactory::getDBO();
	$live_site = &JURI::base();
	$base_path = JPATH_BASE;
	$user =& JFactory::getUser();
	$user_id = ($us == 0) ? $user->get( 'id' ) : $us;
	$today = date("Y-m-d H:i:s");
	$user_dir = getImageDirforUser($user_id).DS."rssfeeds";
	$base_dir = str_replace(DS.DS, DS, $base_path.DS.$user_dir);
	$real_dir = str_replace(DS.DS, DS, $live_site.DS.$user_dir);
	$model = getModelforUser($user_id);
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);
	if (!is_dir($base_dir)) {
	     if (!JFolder::create($base_dir, 0755)) {
			JError::raiseWarning(
				'SOME_ERROR_CODE',
				'JFolder::create: ' . JText::_('Could not create image directory'),
				'Path: ' . $base_dir
			);
			} else {
			// Try to adjust the file and folder rights
			$filemode = "0644";
			$foldermode = "0" . $conf->upl_rights;
			if (JPath::canChmod($base_dir)) {
				JPath::setPermissions($base_dir, $filemode, $foldermode);					
				} else {
				JError::raiseWarning(
					'SOME_ERROR_CODE',
					'JFolder::create: ' . JText::_('Could not change folder permissions'),
					'Path: ' . $base_dir
				);			
				} // End if JPath::canChmod ...
			} // End if(!JFolder::create ...)
	    } // End if (!is_dir....)		

	include_once(JPATH_COMPONENT . DS. "class.feedcreator.php");

	$rss = new UniversalFeedCreator();
	$rss->useCached();
	$rss->title = JText::_("RSS Feed Title");
	$rss->description = JText::_("RSS Feed Titledesc");
	$rss->link = $live_site.DS."index.php?option=$option";
	$rss->syndicationURL = $live_site.DS."index.php?option=".$option;

	$image = new FeedImage();
	$image->title = JText::_("RSS Feed read");
	$image->url = $live_site.DS."components".DS.$option.DS."images".DS."feedreader.png";
	$image->link = $live_site;
	$image->description = sprintf($live_site, JText::_("RSS Feed Description"));
	$rss->image = $image;

	// get information from the database:
	if ($catid > 0) {
	    $query = "SELECT * FROM #__ksads_ads WHERE catid = $catid AND published = 1 AND (date_expiry >= '$today' OR expiry_deactivate = 1)";
	    $feedfile=$base_dir.DS."category_".$catid.".xml"; 
	    } else {
	    $query = "SELECT * FROM #__ksads_ads WHERE user_id = $userid AND published = 1 AND (date_expiry >= '$today' OR expiry_deactivate = 1)";
	    $feedfile=$base_dir.DS."user_".$userid.".xml"; 
	    }
	$db->setQuery($query);
	$rows = $db->loadObjectList();
	foreach ($rows as $data) {
		$adlink = $live_site.DS."index.php?option=$option&task=viewad&id=$data->id";
		$item = new FeedItem();
		$item->title = $data->ad_name;
		$item->link = $adlink;
		$item->description = $data->ad_intro;
		$item->date = $data->date_created;
		$item->source = $live_site;
		if ($data->ad_boxnumber) {
		    $item->author = JText::_("Box Number").$data->ad_ident;
		    } else {
		    $item->author = $data->contact_name;
		    }
		$rss->addItem($item);
		}  

	$rss->saveFeed("RSS2.0", $feedfile);

	}
	/*------------------------------------------------------------------
	getWatermarkImage:
	Creates an image with watermark.
	Copyright (c) 2011 KISS-Software.de
	-------------------------------------------------------------------*/

function getWatermarkImage($row, $filename=NULL)
 {
	$id = (isset($row->adid)) ? $row->adid : $row->id;
	if ($id < 1) {
		// New ad, no image yet, get off here
		return false;
		}
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);
	if (strlen(trim($conf->watermark)) < 1) {
		// No watermark configured, we are done.
		return false;
		}	
	$base_path = JPATH_ROOT;
	$db	=& JFactory::getDBO();  
    $user = &JFactory::getUser();	
	$user_id = ($row->user_id == 0) ? 0 : $row->user_id;
	$year = date("Y");
	$base_dir = $base_path . getImageDirforUser($user_id, 0);
	$file = isset($filename) ? $filename : $row->ad_image;
	$path_parts = pathinfo($file);
	$file_name = $path_parts['filename'];
	$file_ext = (isset($path_parts['extension'])) ? $path_parts['extension'] : '';
	$gdlib = gd_info();
	if (!file_exists($base_dir.DS.$file_name.'.'.$file_ext)) {
		// Original file does not exist, we are done.
		return false;	
		}
	// Is it really necessary to create a new image?
	$lic = array();
	$lic = explode(",",base64_decode(str_rot13($conf->license)));	
	if ($lic[3] && $gdlib['PNG Support']) {
		// GD lib is present, carry on
		if (file_exists($base_dir.'thumbnails'.DS.'stamp_'.$file_name.'.'.strtolower($file_ext))) {
		
			if (!$row->watermark) {
				// Watermark is deactivated
				return false;
				} else {
				// file exists, we are done
				return true;				
				} // end if row->watermark
			} // end if file_exists...
		} else {
		// GD lib not present, no way to create a watermark
		return false;	
		} // end if gdlib...
	
	// Load image
    switch ($file_ext) {
        case "jpg":  $im = imagecreatefromjpeg($base_dir.$file_name.".".$file_ext); break;
        case "jpeg": $im = imagecreatefromjpeg($base_dir.$file_name.".".$file_ext); break;		
        case "gif":  $im = imagecreatefromgif($base_dir.$file_name.".".$file_ext); break;
        case "png":  $im = imagecreatefrompng($base_dir.$file_name.".".$file_ext); break;
        case "bmp":  $im = imagecreatefromwbmp($base_dir.$file_name.".".$file_ext); break;		
		default:
		return false;
		break;
		}
	
	// creating a watermark stamp with GD library
	$stamp = imagecreatetruecolor(300, 80);
	imagefilledrectangle($stamp, 0, 0, 299, 79, 0x0000FF);
	imagefilledrectangle($stamp, 4, 4, 295, 75, 0xFFFFFF);
    switch ($file_ext) {
        case "jpg":  $im = imagecreatefromjpeg($base_dir.$file_name.".".$file_ext); break;
        case "jpeg": $im = imagecreatefromjpeg($base_dir.$file_name.".".$file_ext); break;		
        case "gif":  $im = imagecreatefromgif($base_dir.$file_name.".".$file_ext); break;
        case "png":  $im = imagecreatefrompng($base_dir.$file_name.".".$file_ext); break;		
        case "bmp":  $im = imagecreatefromwbmp($base_dir.$file_name.".".$file_ext); break;				
		default:
		return false;
		break;
		}
	imagestring($stamp, 5, 20, 20, '(c) '.$year, 0x0000FF);
	imagestring($stamp, 3, 20, 40, $conf->watermark, 0x0000FF);

	// retrieve dimensions, set margins
	$marge_right = 1;
	$marge_bottom = 1;
	$sx = imagesx($stamp);
	$sy = imagesy($stamp);

	// lay a watermark over the image with an appropriate opacity
	imagecopymerge($im, $stamp, imagesx($im)/2 - $sx/2 - $marge_right, imagesy($im)/2 - $sy - $marge_bottom, 0, 0, imagesx($stamp), imagesy($stamp), $conf->watermark_opacity);

	// store image, flush memory
	imagepng($im, $base_dir.'thumbnails'.DS.'stamp_'.$file_name.'.'.$file_ext);
	imagedestroy($im);
	imagedestroy($stamp);
	
	// Set the ad's watermark flag. Depending on the invoking routine, the ad's id is retreived either from ad_id, adid or id
	if (isset($row->id)) {$adid = $row->id;	}
	if (isset($row->ad_id)) {$adid = $row->ad_id;}
	if (isset ($row->adid)) {$adid = $row->adid;}
	$query = "UPDATE #__ksads_ads SET `watermark` = 1 WHERE `id` = ".$adid;
	$db->setQuery($query);
	$db->query();
	return true;
	}

	/*------------------------------------------------------------------
	dirContainsFiles:
	Returns the number of files a directory contains. Just to make sure
	that directory is not empty.
	Copyright (c) 2009 KISS-Software.de
	-------------------------------------------------------------------*/
	function dirContainsFiles($dirname) {
		jimport('joomla.filesystem.folder');
		return count (JFolder::files ($dirname));
	}
	
	/*------------------------------------------------------------------
	jsTopTenHeader
	Renders the Javascript Header for Top Ten Push Ads
	due to the fact that IE is not capable to ignore NULL variables.
	Copyright (c) 2010 KISS-Software.de
	-------------------------------------------------------------------*/
function jsTopTenHeader() {
	$live_site = JURI::BASE();
	$html = "
		function toggle_topten(elem, curr, adid, adname)
		{
		var optid	 = elem.id;
		var optel	 = document.getElementById(optid);
		var amnt	 = zahl_formatiert(optel.value);
		var currency = curr;
		var mgtext	 = '".JText::_("Ad Ident")." ' + adid + ' - ' + adname + ' ".JText::_("Additional Payment").": ' + amnt;
		var scctext	 = '" . $live_site . "index.php?option=com_ksadvertiser&task=show_addpay_success&success=1&adid='+adid+'&pmnt='+amnt;
		var cnctext	 = '" . $live_site . "index.php?option=com_ksadvertiser&task=show_addpay_success&success=0';
		var divstyle = document.getElementById('payment_div');
		with (divstyle) {
			  style.display=\"block\";			  
			}	
	";
	return $html;
	}

	/*------------------------------------------------------------------
	toggleOptionHeader
	Renders the Javascript Header for Additional options payment
	due to the fact that IE is not capable to ignore NULL variables.
	Copyright (c) 2011 KISS-Software.de
	-------------------------------------------------------------------*/
function toggleOptionHeader() {
	$live_site = JURI::BASE();
	$html = "
		function toggle_option_string(elem, curr, adid, adname)
		{
		var optid	 = elem.id;
		var optel	 = document.getElementById(optid);
		var amnt	 = zahl_formatiert(optel.value);
		var currency = curr;
		var mgtext	 = '".JText::_("Ad Ident")." ' + adid + ' - ' + adname + ' ".JText::_("Additional Payment").": ' + amnt;
		var scctext	 = '" . $live_site . "index.php?option=com_ksadvertiser&task=show_addpay_success&success=1&adid='+adid+'&pmnt='+amnt;
		var cnctext	 = '" . $live_site . "index.php?option=com_ksadvertiser&task=show_addpay_success&success=0';
		var divstyle = document.getElementById('payment_div');
	";
	return $html;
	}

	/*------------------------------------------------------------------
	showCaptcha:
	Generates a Captcha Spam Protection image
	Copyright (c) 2009 KISS-Software.de
	-------------------------------------------------------------------*/
function showCaptcha() {
	global $mainframe;
    jimport( 'joomla.filesystem.file' );
	$db	=& JFactory::getDBO();        
    $user = &JFactory::getUser();
	$live_site = JURI::BASE();
	// Codetype
	$numeric = false; // true = numeric, false = alphanumeric
	mt_srand((double)microtime()*1000000);
	// numerical code
	$capcode = mt_rand(10000, 99999);

	// Numerical code
	if($numeric) {
		$capcode = strval(mt_rand(10000, 99999));
		} else {
		$string = "abcdefghjkmnpqrstuvwxyz2345689"; // better
		$stringlen = strlen($string);
		$capcode = "";
		for($i = 0; $i < 6; $i++)
			$capcode .= $string{mt_rand(0, $stringlen)};
		}
        $path = JPATH_BASE.DS.'components'.DS.'com_ksadvertiser'.DS.'captcha_image.php'; 
        if(file_exists($path)) {
	     $html = '
		  <table class="admintable">
		  <tr>
		  <td align="left" valign="absmiddle">
		  <img src="'.str_replace(JPATH_BASE.DS, $live_site, $path.'?capcod='.$capcode).'" alt="'.JText::_('Captcha').'" border="0" id="ks_captcha_image"/>
		  <input type="hidden" name="ks_captcha_val" value="'.$capcode.'" />
		  </td>
		  <td align="left" valign="absmiddle">
		  <input type="text" class="inputbox" value="" name="ks_captcha_code" size="6" maxlength="8" id="ks_captcha_code"/>'.JText::_('Enter Captcha Code').'
		  </td>
		  <td align="left" valign="absmiddle">
		  </tr>
		  </table>
		  ';
		  return $html;
		  } else {
		  $query = "UPDATE #__ksads_config SET `show_captcha` = 0 WHERE `id` = 1";
		  $db->setQuery($query);
		  $db->query();
		  return '';
         }
    }

	function hasExtension($ext = 0) {
		$db	=& JFactory::getDBO();
		// Check if extension file exists
		$extfolder = JPATH_ROOT.DS."components".DS."com_ksadvertiser".DS."extensions";
		if (JFolder::exists($extfolder)) {
		// Is extension number registered ?
		$query = "SELECT * FROM #__ksads_extensions WHERE `id` = $ext";
		$db->setQuery($query);
		if ($extname = $db->loadObject()) {
		    $filename = $extname->ext_name.".php";
		    if (file_exists($extfolder.DS.$filename)) {
			return true;    
			} else {
			return false;    
			}
		    }
		}
	}

	function loadAllExtensions() {
		$db	=& JFactory::getDBO();
		// Check if extension file exists
		$extfolder = JPATH_ROOT.DS."components".DS."com_ksadvertiser".DS."extensions";
		if (JFolder::exists($extfolder)) {
		// Is extension number registered ?
		$query = "SELECT * FROM #__ksads_extensions WHERE active = 1";
		$db->setQuery($query);
		if ($extensions = $db->loadObjectList()) {
			return $extensions;
		    }
		}
	}

	function loadExtension($ext = 0) {
		// Load extension class_exists
		$db	=& JFactory::getDBO();
		// Check if extension file exists
		$extfolder = JPATH_ROOT.DS."components".DS."com_ksadvertiser".DS."extensions";
		if (JFolder::exists($extfolder)) {
		// Is extension number registered ?
		$query = "SELECT * FROM #__ksads_extensions WHERE `id` = $ext";
		$db->setQuery($query);
		if ($extname = $db->loadObject()) {
		    $filename = $extname->ext_name.".php";
		    $extclass = $extname->ext_name;
		    if (file_exists($extfolder.DS.$filename)) {
			include_once($extfolder.DS.$filename);
//			if (class_exists($extclass) === false) {
			    $extmod = new $extclass();
			    if ($extmod->extension_number == $ext) {
				$extmod->loadLanguage();
				return $extmod;
				}
//			    }
			} else {
			return false;    
			}
		    }
		}
	}

	/*------------------------------------------------------------------
	uploadFiles:
	Performs the upload of the $_FILES array
	Copyright (c) 2011 by KISS Software
	-------------------------------------------------------------------*/
      function uploadFiles($user_id = 0, $target = ''){
	  $conf =& JTable::getInstance('config', 'Table');
	  $conf->load(1);
	  $ks_help = new KISSHelper();
	  $target_dir = ($target == '') ? JPATH_ROOT . DS . "images" . DS . $conf->ad_img_dir . DS . "U". $user_id : $target;
	  // Are there files to be uploaded?
	  $msg = "";
	  if(isset($_FILES['name']) && !empty($_FILES['name']['name'])) {
	    include_once('class.upload.php');
	    $upload = new Upload;
	    $upload->setValidTypes($conf->upl_filetypes);
	    $upload->setMaxWidth($conf->upl_maxwidth);
	    $upload->setMaxSize($conf->upl_filesize * 1024 * 1024);
	    $upload->setRights($conf->upl_rights);
	    if ($ks_help->canUpload($_FILES)) {
			// Change 'original' to 'md5' if you want to encrypt the filename
			$upload->uploadFile($target_dir, 'original', 50);
			$msg = JText::_('UPLOAD SUCCESS');
			} else {
			$msg = JText::_('ERR CANNOT UPLOAD FILE');
			}	
	    }
		return $msg;
	}

	/*------------------------------------------------------------------
	downloadFile:
	Checks if a file exists and performs download
	Copyright (c) 2011 by KISS Software
	-------------------------------------------------------------------*/
      function downloadFile(){
	  global $option, $mainframe;
	  $db	=& JFactory::getDBO();	  
	  $rowid = JRequest::getVar('rid', 0, 'GET', 'INT');
	  $userid = JRequest::getVar('uid', 0, 'GET', 'INT');
	  $conf =& JTable::getInstance('config', 'Table');
	  $conf->load(1);
	  $query = "SELECT * FROM #__ksads_ads WHERE `id` = $rowid";
	  $db->setQuery($query);
	  if ($downfile = $db->loadObject()) {
	  $path = JPATH_ROOT.DS.'images'.DS.'ksadvertiser'.DS.'U'.$userid.DS.'uploads'.DS.$downfile->down_uri;
	  if (file_exists($path) && is_readable($path)) {
	      $view_types = array();
	      $view_types = explode(',', $conf->upl_filetypes); 
	      $len = filesize($path);
	      clearstatcache();
	      $filename = basename($path);
	      $file_extension = strtolower(substr(strrchr($filename,"."),1));
	      $ctype = file_mimetype($file_extension);
	      ob_end_clean();
		  header("Cache-Control: public, must-revalidate");
		  header('Cache-Control: pre-check=0, post-check=0, max-age=0');
		  header("Pragma: no-cache");
		  header("Expires: 0"); 
		  header("Content-Description: File Transfer");
		  header("Expires: Sat, 26 Jul 1997 05:00:00 GMT");
		  header("Content-Type: " . $ctype);
		  header("Content-Length: ".(string)$len);
		  header('Content-Disposition: attachment; filename="'.$filename.'"');
		  header("Content-Transfer-Encoding: binary\n");
		  // open the file in binary read-only mode
		  // display the error messages if the file cannot be opened
		  $fileinfo = @ fopen($path, 'r');
		  if ($fileinfo) {
		      // stream the file and exit the script when complete
		      fpassthru($fileinfo);
		      exit;
		      } // end if ($fileinfo)
		} // End if (file_exists...)
	  } // End if ($downlink = ...)
      }

	/*------------------------------------------------------------------
	file_mimetype:
	sets the mimetype of a file for downloads
	Copyright (c) 2011 by KISS Software
	-------------------------------------------------------------------*/
function file_mimetype($filetype) {
    
    switch ($filetype) {
        case "ez":  $mime="application/andrew-inset"; break;
        case "hqx": $mime="application/mac-binhex40"; break;
        case "cpt": $mime="application/mac-compactpro"; break;
        case "doc": $mime="application/msword"; break;
        case "bin": $mime="application/octet-stream"; break;
        case "dms": $mime="application/octet-stream"; break;
        case "lha": $mime="application/octet-stream"; break;
        case "lzh": $mime="application/octet-stream"; break;
        case "exe": $mime="application/octet-stream"; break;
        case "class": $mime="application/octet-stream"; break;
        case "dll": $mime="application/octet-stream"; break;
        case "oda": $mime="application/oda"; break;
        case "pdf": $mime="application/pdf"; break;
        case "ai":  $mime="application/postscript"; break;
        case "eps": $mime="application/postscript"; break;
        case "ps":  $mime="application/postscript"; break;
        case "xls": $mime="application/vnd.ms-excel"; break;
        case "ppt": $mime="application/vnd.ms-powerpoint"; break;
        case "wbxml": $mime="application/vnd.wap.wbxml"; break;
        case "wmlc": $mime="application/vnd.wap.wmlc"; break;
        case "wmlsc": $mime="application/vnd.wap.wmlscriptc"; break;
        case "vcd": $mime="application/x-cdlink"; break;
        case "pgn": $mime="application/x-chess-pgn"; break;
        case "csh": $mime="application/x-csh"; break;
        case "dvi": $mime="application/x-dvi"; break;
        case "spl": $mime="application/x-futuresplash"; break;
        case "gtar": $mime="application/x-gtar"; break;
        case "hdf": $mime="application/x-hdf"; break;
        case "js":  $mime="application/x-javascript"; break;
        case "nc":  $mime="application/x-netcdf"; break;
        case "cdf": $mime="application/x-netcdf"; break;
        case "swf": $mime="application/x-shockwave-flash"; break;
        case "tar": $mime="application/x-tar"; break;
        case "tcl": $mime="application/x-tcl"; break;
        case "tex": $mime="application/x-tex"; break;
        case "texinfo": $mime="application/x-texinfo"; break;
        case "texi": $mime="application/x-texinfo"; break;
        case "t":   $mime="application/x-troff"; break;
        case "tr":  $mime="application/x-troff"; break;
        case "roff": $mime="application/x-troff"; break;
        case "man": $mime="application/x-troff-man"; break;
        case "me":  $mime="application/x-troff-me"; break;
        case "ms":  $mime="application/x-troff-ms"; break;
        case "ustar": $mime="application/x-ustar"; break;
        case "src": $mime="application/x-wais-source"; break;
        case "zip": $mime="application/zip"; break;
        case "au":  $mime="audio/basic"; break;
        case "snd": $mime="audio/basic"; break;
        case "mid": $mime="audio/midi"; break;
        case "midi": $mime="audio/midi"; break;
        case "kar": $mime="audio/midi"; break;
        case "mpga": $mime="audio/mpeg"; break;
        case "mp2": $mime="audio/mpeg"; break;
        case "mp3": $mime="audio/mpeg"; break;
        case "aif": $mime="audio/x-aiff"; break;
        case "aiff": $mime="audio/x-aiff"; break;
        case "aifc": $mime="audio/x-aiff"; break;
        case "m3u": $mime="audio/x-mpegurl"; break;
        case "ram": $mime="audio/x-pn-realaudio"; break;
        case "rm":  $mime="audio/x-pn-realaudio"; break;
        case "rpm": $mime="audio/x-pn-realaudio-plugin"; break;
        case "ra":  $mime="audio/x-realaudio"; break;
        case "wav": $mime="audio/x-wav"; break;
        case "pdb": $mime="chemical/x-pdb"; break;
        case "xyz": $mime="chemical/x-xyz"; break;
        case "bmp": $mime="image/bmp"; break;
        case "gif": $mime="image/gif"; break;
        case "ief": $mime="image/ief"; break;
        case "jpeg": $mime="image/jpeg"; break;
        case "jpg": $mime="image/jpeg"; break;
        case "jpe": $mime="image/jpeg"; break;
        case "png": $mime="image/png"; break;
        case "tiff": $mime="image/tiff"; break;
        case "tif": $mime="image/tiff"; break;
        case "wbmp": $mime="image/vnd.wap.wbmp"; break;
        case "ras": $mime="image/x-cmu-raster"; break;
        case "pnm": $mime="image/x-portable-anymap"; break;
        case "pbm": $mime="image/x-portable-bitmap"; break;
        case "pgm": $mime="image/x-portable-graymap"; break;
        case "ppm": $mime="image/x-portable-pixmap"; break;
        case "rgb": $mime="image/x-rgb"; break;
        case "xbm": $mime="image/x-xbitmap"; break;
        case "xpm": $mime="image/x-xpixmap"; break;
        case "xwd": $mime="image/x-xwindowdump"; break;
        case "msh": $mime="model/mesh"; break;
        case "mesh": $mime="model/mesh"; break;
        case "silo": $mime="model/mesh"; break;
        case "wrl": $mime="model/vrml"; break;
        case "vrml": $mime="model/vrml"; break;
        case "css": $mime="text/css"; break;
        case "asc": $mime="text/plain"; break;
        case "txt": $mime="text/plain"; break;
        case "gpg": $mime="text/plain"; break;
        case "rtx": $mime="text/richtext"; break;
        case "rtf": $mime="text/rtf"; break;
        case "wml": $mime="text/vnd.wap.wml"; break;
        case "wmls": $mime="text/vnd.wap.wmlscript"; break;
        case "etx": $mime="text/x-setext"; break;
        case "xsl": $mime="text/xml"; break;
        case "flv": $mime="video/x-flv"; break;
        case "mpeg": $mime="video/mpeg"; break;
        case "mpg": $mime="video/mpeg"; break;
        case "mpe": $mime="video/mpeg"; break;
        case "qt":  $mime="video/quicktime"; break;
        case "mov": $mime="video/quicktime"; break;
        case "mxu": $mime="video/vnd.mpegurl"; break;
        case "avi": $mime="video/x-msvideo"; break;
        case "movie": $mime="video/x-sgi-movie"; break;
        case "asf": $mime="video/x-ms-asf"; break;
        case "asx": $mime="video/x-ms-asf"; break;
        case "wm":  $mime="video/x-ms-wm"; break;
        case "wmv": $mime="video/x-ms-wmv"; break;
        case "wvx": $mime="video/x-ms-wvx"; break;
        case "ice": $mime="x-conference/x-cooltalk"; break;
        case "rar": $mime="application/x-rar"; break;
        default:    $mime="application/octet-stream"; break; 
    }
    return $mime;
}

	/*------------------------------------------------------------------
	renderMedia:
	Renders the output of a media player for specified media
	Copyright (c) 2010 joomlaworks.gr, modified by KISS Software
	-------------------------------------------------------------------*/
	function renderMedia($tagOrder) {
		global $option;
		include_once(JPATH_ROOT .DS.'components'.DS.$option.DS.'players'.DS.'sources.php');
		include_once(JPATH_ROOT .DS.'components'.DS.$option.DS.'players'.DS.'helper.php');
		$live_site = &JURI::root();
		$conf =& JTable::getInstance('config', 'Table');
		$conf->load(1);
		$user =& JFactory::getUser();
		$user_id = $user->get( 'id' );
		foreach ($tagReplace as $plg_tag => $value) {
			// expression to search for
			$regex = "#{".$plg_tag."}(.*?){/".$plg_tag."}#s";
			// process tags
			if (preg_match_all($regex, $tagOrder, $matches, PREG_PATTERN_ORDER) > 0) {
				// start the replace loop
				foreach ($matches[0] as $key => $match) {
					$tagcontent 		= preg_replace("/{.+?}/", "", $match);
					$tagparams 		= explode('|',$tagcontent);
					$tagsource 		= trim(strip_tags($tagparams[0]));
					$final_vwidth 		= (@$tagparams[1]) ? $tagparams[1] : $conf->med_width;
					$final_vheight 		= (@$tagparams[2]) ? $tagparams[2] : $conf->med_height;
					$final_autoplay 	= (@$tagparams[3]) ? $tagparams[3] : $conf->med_autoplay;
					$final_transparency 	= (@$tagparams[4]) ? $tagparams[4] : $conf->med_transparency;
					$final_background	= (@$tagparams[5]) ? $tagparams[5] : $conf->med_background;
					$final_backgroundqt	= (@$tagparams[6]) ? $tagparams[6] : $conf->med_backgroundQT;	
					$final_controlbar	= (@$tagparams[7]) ? $tagparams[7] : $conf->med_controlbar;
					// source elements
					$findAVparams = array(
						"{SOURCE}",
						"{SOURCEID}",
						"{FOLDER}",
						"{WIDTH}",
						"{HEIGHT}",		
						"{AUTOPLAY}",
						"{TRANSPARENCY}",
						"{BACKGROUND}",
						"{BACKGROUNDQT}",
						"{CONTROLBAR}",
						"{SITEURL}",
					);
			
					// special treatment
					if($plg_tag=="yahoo"){
						$tagsourceyahoo = explode('/',$tagsource);
						$tagsource = 'id='.$tagsourceyahoo[1].'&amp;vid='.$tagsourceyahoo[0];
					}
					if($plg_tag=="youku") $tagsource = substr($tagsource,3);		
					
					// Prepare the HTML
					$output = new JObject;

					// replacement elements
					if(in_array($plg_tag, array("mp3","mp3remote","wma","wmaremote"))){

						$afolder = getImageDirforUser($user_id, 0)."videos";					
						$transparency = $conf->med_transparency;
						$background = $conf->med_background;
						$backgroundQT = $conf->med_backgroundQT;
						$controlBarLocation = $conf->med_controlbar;
					
						$replaceAVparams = array(
							$tagsource,
							substr(md5($tagsource),1,8),
							$afolder,
							$awidth,
							$aheight,
							$final_autoplay,
							$transparency,
							$background,
							$backgroundQT,
							$controlBarLocation,
							$live_site,
						);
						
						$output->playerWidth = $awidth;
						$output->playerHeight = $aheight;
						
					} else {

						$vfolder = getImageDirforUser($user_id, 0)."videos";
						$transparency = $conf->med_transparency;
						$background = $conf->med_background;
						$backgroundQT = $conf->med_backgroundQT;
						$controlBarLocation = $conf->med_controlbar;
					
						$replaceAVparams = array(
							$tagsource,
							substr(md5($tagsource),1,8),
							$vfolder,
							$final_vwidth,
							$final_vheight,
							$final_autoplay,
							$transparency,
							$background,
							$backgroundQT,
							$controlBarLocation,
							$live_site,
						);
						
						$output->playerWidth = $final_vwidth;
						$output->playerHeight = $final_vheight;
						
					}
					
					$output->playerID = 'AVPlayerID_'.substr(md5($tagsource),1,8);
					$output->player = JFilterOutput::ampReplace(str_replace($findAVparams, $replaceAVparams, $tagReplace[$plg_tag]));
					$output->playerEmbedHTML = preg_replace("#(\r|\t|\n|)#s","",htmlentities($output->player, ENT_QUOTES));

					// Download button
					if(isset($downloadLink) && $downloadLink){
						if (in_array($plg_tag, array("flv","swf","wmv","mov","mp4","3gp","divx"))) {
							$output->downloadLink = $live_site.'components'.DS.$option.DS.'players'.DS.'download.php?file='.$vfolder.DS.$tagsource; //.'.'.$plg_tag;
						} elseif(in_array($plg_tag, array("mp3","wma"))) {
							$output->downloadLink = $live_site.'components'.DS.$option.DS.'players'.DS.'download.php?file='.$afolder.DS.$tagsource; //.'.'.$plg_tag;
						} else {
							$output->downloadLink = '';
						}
					} else {
						$output->downloadLink = '';
					}
					
					// Lightbox popup
					if(isset($lightboxLink) && $lightboxLink && !in_array($plg_tag, array("mp3","mp3remote","wma","wmaremote"))) { // video formats only
						$output->lightboxLink = '#'.$output->playerID;
					} else {
						$output->lightboxLink = '';
					}
					
					// Embed form
					if(isset ($embedForm ) && $embedForm && !in_array($plg_tag, array("wmv","wmvremote","wma","wmaremote"))){ // no Windows Media formats
						$output->embedLink = 'embed_'.$output->playerID;
					}	else {
						$output->embedLink = '';
					}

					// Fetch the template
					ob_start();
					if (!isset($plg_name)) {
						$plg_name = null;
					    }
					$getTemplatePath = AllVideosHelper::getTemplatePath($plg_name,'default.php');
					$getTemplatePath = $getTemplatePath->file;
					include($getTemplatePath);
					$getTemplate = "<!-- Video Player Start -->".ob_get_contents()."<!-- Video Player End -->";
					ob_end_clean();

					// Do the replace
					$retval = preg_replace("#{".$plg_tag."}".preg_quote($tagcontent)."{/".$plg_tag."}#s", $getTemplate , $tagOrder);
					return $retval;

				} // end foreach
	
			} // end if
		
		} // END ALLVIDEOS LOOP	
	}

    /*------------------------------------------------------------------
	showStatistics:
	Shows a statistic bar at the bottom of the page
	Copyright (c) 2010 KISS Software
    -------------------------------------------------------------------*/
    function showStatistics($catno = 0) 
    {
      $today = date("Y-m-d");
      $db =& JFactory::getDBO();
      $query = "SELECT * FROM #__ksads_ads";
      if ($catno > 0) {$query .= " WHERE catid = $catno";}
      $db->setQuery($query);
      $ads_total = count($db->loadObjectList());
      $query = "SELECT * FROM #__ksads_ads WHERE date_expiry <= '$today' AND expiry_deactivate = 0";
      if ($catno > 0) {$query .= " AND catid = $catno";}
      $db->setQuery($query);
      $ads_expired = count($db->loadObjectList());
      $query = "SELECT * FROM #__ksads_ads WHERE published = 0";
      if ($catno > 0) {$query .= " AND catid = $catno";}
      $db->setQuery($query);
      $ads_waiting = count($db->loadObjectList());
      $query = "SELECT * FROM #__ksads_cats WHERE published = 1";
      if ($catno > 0) {$query .= " AND pid = $catno";}
      $db->setQuery($query);
      $categs = count($db->loadObjectList());
      $query = "SELECT * FROM #__users WHERE block = 0";
      $db->setQuery($query);
      $users_total = count($db->loadObjectList());
      // Build Statistics HTML
      $stats  = "<table class=\"statistics\" width=\"100%\">";
      $stats .= "<tr class=\"statistics\"><td class=\"statistics\">";
      $stats .= "<h3 class=\"statstitle\">".JText::_("Statistics")."</h3>";
      $stats .= "<p><span class=\"statsline\">".JText::_("Ads number").": ".number_format($ads_total, 0, ",", ".")."</span></p>";
      $stats .= "</td><td class=\"statistics\">";
      $stats .= "<p><span class=\"statsline\">".JText::_("Expired").": ".number_format($ads_expired, 0, ",", ".")."</span></p>";
      $stats .= "<p><span class=\"statsline\">".JText::_("Waiting").": ".number_format($ads_waiting, 0, ",", ".")."</span></p>";
      $stats .= "</td><td class=\"statistics\">";
      $stats .= "<p><span class=\"statsline\">".JText::_("Categories").": ".number_format($categs, 0, ",", ".")."</span></p>";
      $stats .= "<p><span class=\"statsline\">".JText::_("Users").": ".number_format($users_total, 0, ",", ".")."</span></p>";
      $stats .= "</td></tr>";
      $stats .= "</table>";
      return $stats;
    }

  /*------------------------------------------------------------------
	get_geo:
	returns a geocode of a given address from Google Maps
	Copyright (c) 2010 by KISS Software
  -------------------------------------------------------------------*/
	function get_geo($googlewebsite, $address, $iso, $key)
	{
		$coords = '';
		$getpage='';
		$replace = array("\n", "\r", "&lt;br/&gt;", "&lt;br /&gt;", "&lt;br&gt;", "<br>", "<br />", "<br/>");
		$address = str_replace($replace, '', $address);
		$suburb=''; $country=''; $city=''; $county=''; $street=''; $state = null; $plz = '';
		$logmessage = "Address: ".$address."<br />";
		$uri = "http://".$googlewebsite."/maps/geo?q=".urlencode($address)."&output=xml&oe=".$iso."&key=".$key;
		//	initialize variables
		$plz = null; $street = null; $city = null; $county = null; $suburb = null; $country = null; $state = null;

		if ( !class_exists('SimpleXMLElement') )
		{
			// PHP4
			$ok = false;
			$logmessage .="SimpleXMLElement doesn't exists so probably PHP 4.x <br />";
			if (ini_get('allow_url_fopen'))
				if (($getpage = file_get_contents($uri)))
					$ok = true;

			if (!$ok) {
				$logmessage = "URI couldn't be opened probably ALLOW_URL_FOPEN off";
				if (function_exists('curl_init')) {
					$logmessage .="curl_init does exists <br />";
					$ch = curl_init();
					$timeout = 5; // set to zero for no timeout
					curl_setopt ($ch, CURLOPT_URL, $uri);
					curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
					curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
					$getpage = curl_exec($ch);
					curl_close($ch);
				} else
					$logmessage .="curl_init doesn't exists <br />";
			}
	
			$logmessage .= "Returned page: ".$getpage;
	
			if (function_exists('mb_detect_encoding')) {
				$enc = mb_detect_encoding($getpage);
				if (!empty($enc))
					$getpage = mb_convert_encoding($getpage, $iso, $enc);
			}
				
			if (function_exists('domxml_open_mem')&&($getpage<>'')) {
				$responsedoc = domxml_open_mem($getpage);
				if ($responsedoc !=null) {				
					$response = $responsedoc->get_elements_by_tagname("Response");
					if ($response!=null) {
						$placemark = $response[0]->get_elements_by_tagname("Placemark");
						if ($placemark!=null) {
							$point = $placemark[0]->get_elements_by_tagname("Point");
							if ($point!=null) {
								$coords = $point[0]->get_content();
								$logmessage .="Coordinates: ".join(", ", explode(",", $coords))."<br />";
								$geodata = array(
								'coords' => $coords
								  );
								return $geodata;
							}
						}
					}
				}
			}
			$logmessage .="Coordinates: null <br />";
			return null;

			} else {

			// PHP5
			$logmessage .="SimpleXMLElement does exists so probably PHP 5.x <br />";
			$ok = false;
			if (ini_get('allow_url_fopen')) { 
				if (file_exists($uri)) {
					$getpage = file_get_contents($uri);
					$ok = true;
				}
			} 
			
			if (!$ok) { 
				$logmessage .="URI couldn't be opened probably ALLOW_URL_FOPEN off <br />";
				if (function_exists('curl_init')) {
					$logmessage .="curl_init does exists <br />";
					$ch = curl_init();
					$timeout = 5; // set to zero for no timeout
					curl_setopt ($ch, CURLOPT_URL, $uri);
					curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
					curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
					$getpage = curl_exec($ch);
					curl_close($ch);
				} else
					$logmessage .="curl_init doesn't exists <br />";
			}

			$logmessage .="Returned page: ".$getpage."<br />";
			if (function_exists('mb_detect_encoding')) {
				$enc = mb_detect_encoding($getpage);
				if (!empty($enc))
					$getpage = mb_convert_encoding($getpage, $iso, $enc);
			}

			if ($getpage <>'') {
				$expr = '/xmlns/';
				$getpage = preg_replace($expr, 'id', $getpage);
				$xml = new SimpleXMLElement($getpage);
				foreach($xml->xpath('//coordinates') as $value) {
					//$coords = $coordinates;
					$coords = $value;
					break;
				}
				foreach($xml->xpath('//AdministrativeAreaName') as $value) {
					$state = $value;
					break;
				}
				foreach($xml->xpath('//SubAdministrativeAreaName') as $value) {
					$county = $value;
					break;
				}
				foreach($xml->xpath('//CountryName') as $value) {
					$country = $value;
					break;
				}
				foreach($xml->xpath('//ThoroughfareName') as $value) {
					$street = $value;
					break;
				}
				foreach($xml->xpath('//PostalCodeNumber') as $value) {
					$plz = $value;
					break;
				}
				foreach($xml->xpath('//LocalityName') as $value) {
					$city = $value;
					break;
				}
				foreach($xml->xpath('//DependentLocalityName') as $value) {
					$suburb = $value;
					break;
				}

				$geodata = array(
				'coords' => $coords,
				'street' => $street,
				'city' => $city,
				'zip' => $plz,
				'county' => $county,
				'state' => $state,
				'country' => $country,
				'suburb' => $suburb
				  );

				if ($coords=='') {
					$logmessage .="Coordinates: null <br />";
				}

				$logmessage .="Coordinates: ".join(", ", explode(",", $coords))."<br />";
				return $geodata;
			}
		}
		$logmessage .="get_geo totally wrong end! <br />";
	}

  /*------------------------------------------------------------------
	cronNotify:
	checks all ads for expiry and notifies users three days before expiry
	Copyright (c) 2010 by KISS Software
  -------------------------------------------------------------------*/
	function cronNotify()
	{
	$user =& JFactory::getUser();
	$user_id = $user->get( 'id' );
	$today = date("Y-m-d H:i:s", mktime(date('H'),date('i'),date('s'),date('m'),date('d'),date('y')));		
	$expday = date("Y-m-d H:i:s", mktime(date('H'),date('i'),date('s'),date('m'),date('d') + 3,date('y')));	
	$db =& JFactory::getDBO();
	$query = "SELECT * FROM #__ksads_customers";
	$db->setQuery($query);
	$crows = $db->loadObjectList();
	foreach ($crows as $customer) {
		$model = getModelforUser($customer->uid);
		$pdays = $model->days_payment;	
		$live_site = & JURI::root();	
		$rowItemid = JRequest::getInt('Itemid', 0);	
		if ($rowItemid) {
			$linkItemid = "&Itemid=$rowItemid";
			} else {
			$linkItemid = "";
			}
		$link0 = $live_site."index.php?option=com_ksadvertiser$linkItemid";
		$payday = date("Y-m-d H:i:s", mktime(date('H'),date('i'),date('s'),date('m'),date('d') - $pdays,date('y')));		
		$query ="SELECT * FROM #__ksads_ads WHERE (date_expiry >= '$today' AND date_expiry <= '$expday')
					AND mid = $model->id 
					AND expiry_deactivate = 0 
					AND published = '1' 
					AND notified_expiry = '0'";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		foreach ($rows as $row) {
				 $link = $link0."&task=view&id=".$row->id;
				 $sent = _sendExpiryMail($row->id, $link);
				}
		$query = "UPDATE #__ksads_ads SET notified_expiry = '1' WHERE date_expiry <= '$expday' AND expiry_deactivate = 0 AND published = '1' AND notified_expiry = '0'";
		$db->setQuery($query);
		$db->query();
		$query = "UPDATE #__ksads_config SET cron_notification = '$today' WHERE id = '1'";
		$db->setQuery($query);
		$db->query();
		// deactivate all non-paid ads
		$query ="UPDATE #__ksads_ads SET published = '0' WHERE date_created < '$payday' 
					AND ad_paid = 0 
					AND published = '1'"; 
		$db->setQuery($query);
		$db->query();
		}
	}

  /*------------------------------------------------------------------
	fetchChildren:
	gets all child categories from a parent category
	Copyright (c) 2010 by KISS Software
  -------------------------------------------------------------------*/
function fetchChildren($catid) {
	$db =& JFactory::getDBO();	
	$user =& JFactory::getUser();
	$user_gid = $user->get( 'gid' );
	// If not in KISS Joomla mode, the user table does not contain a field named 'aid'
	if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
	    $user_aid = 0;				
	    } else {
		$user_aid = $user->get( 'aid' );	
	    }	
	$query = "SELECT * FROM #__ksads_cats WHERE pid = ". $catid . " AND published = '1'";
	$query .= " AND (gid=0 OR gid <= ".$user_gid.") AND (aid=0 OR aid=".$user_aid.")"; 
	$query .=" ORDER BY pid, ordering, cat_name";
	$db->setQuery($query);
	$result=$db->loadObjectList();
	return $result;
}

  /*------------------------------------------------------------------
	countVote:
	Counts a user vote for an ad
	Copyright (c) 2010 by KISS Software
  -------------------------------------------------------------------*/
function countVote() {
	global $mainframe, $option;
	$db =& JFactory::getDBO();	
	$user =& JFactory::getUser();
	$user_id = $user->get( 'id' );
	$url = JRequest::getVar( 'url', '', 'post', 'string');
	$aid = JRequest::getInt( 'aid', 0 );
	$rat = JRequest::getInt( 'user_rating', 0 );
	$votes = 0;
	$total = 0;
	if(isset($_SERVER["REMOTE_ADDR"])) {
	    $cip = $_SERVER["REMOTE_ADDR"];
	  } elseif (isset($HTTP_SERVER_VARS["REMOTE_ADDR"])) {
	    $cip = $HTTP_SERVER_VARS["REMOTE_ADDR"];
	  } elseif (getenv("REMOTE_ADDR")) {
	    $cip = getenv("REMOTE_ADDR");
	  }

	$query = "SELECT * FROM #__ksads_ads WHERE id = ".$aid;
	$db->setQuery($query);
	if ($row = $db->loadObject()) {
	    $rating = explode(",", $row->rating);
	    $votes = $rating[0] + 1;
	    $total = $rating[1] + $rat;
	    $newvote = $votes .",".$total;
	    $query = "UPDATE #__ksads_ads SET `rating` = '$newvote' WHERE id = ".$aid;
	    $db->setQuery($query);
	    $db->query();
	    // TODO: Set Cookie for user to avoid multiple voting when ip has changed
	    $query = "INSERT INTO #__ksads_votes (adid, uid, uip) VALUES ($aid, $user_id, ".$db->quote($cip).")";
	    $db->setQuery($query);
	    $db->query();
	    }
	$mainframe->redirect( $url, JText::_('Thanksvote'));
}

 /*------------------------------------------------------------------
	activateModelForUser:
	Activates a selected Ad plan for a certain user, only for free plans
	Copyright (c) 2011 by KISS Software
  -------------------------------------------------------------------*/
function activateModelForUser() {
	global $mainframe, $option;
	$db =& JFactory::getDBO();	
	$model = JRequest::getInt( 'mod', 0 );
	$user_id = JRequest::getInt( 'usr', 0 );	
	$query = "SELECT * FROM #__ksads_customers WHERE uid = $user_id";
		$db->setQuery($query);
		if ($cust = $db->loadObject()) {
			$is_customer = true;
			} else {
			$is_customer = false;
			}
  	$today = date("Y-m-d H:i:s", mktime(date('H'),date('i'),date('s'),date('m'),date('d'),date('y')));			
	if ($is_customer) {
		// User is Customer, change model
		$query = "UPDATE #__ksads_customers SET mid = $model WHERE uid = $user_id";
		} else {
		$query = "INSERT INTO #__ksads_customers (`uid`, `mid`, `adsleft`, `balance`, `published`, `date_created`) 
				  VALUES ($user_id, $model, 99999, 0, 1, '$today')";
		}
		
		$db->setQuery($query);
		$db->query();
	$url = 'index.php?option='.$option.'&task=myads';		
	$mainframe->redirect( $url, JText::_('Your model was changed'));
}

  /*------------------------------------------------------------------
	fetchNumAds
	gets all ads from a category and all its subcategories (if set)
	Copyright (c) 2010 by KISS Software
  -------------------------------------------------------------------*/
function fetchNumAds($catid, $recursive=0) {
	$db =& JFactory::getDBO();	
	$user =& JFactory::getUser();
	$session =& JFactory::getSession();						
	$today = date("Y-m-d H:i:s");
	$conf =& JTable::getInstance('config', 'Table');
	$conf->load(1);
	$lic = array();
	$lic = explode(",",base64_decode(str_rot13($conf->license)));
	$result = array();
	$regionfilter = $session->get('regionfilter', array(), 'ksaregfilter');
	if (!empty($regionfilter)) {
		$filter_fedstate = $regionfilter['filter_fedstate'];
		$filter_country = $regionfilter['filter_country'];
		$filter_county = $regionfilter['filter_county'];
		} else {
		$filter_fedstate = JRequest::getVar('filter_fedstate', 0, 'POST', 'INT');
		$filter_county = JRequest::getVar('filter_county', 0, 'POST', 'INT');
		$filter_country = JRequest::getVar('filter_country', 0, 'POST', 'INT');		
		}
	    $tmp = "";
		// Country Filter	
		if ( $filter_country ) {
			$tmp .= ' AND region_country = '.$filter_country;
			}
		// Federal State Filter	
		if ( $filter_fedstate ) {
			$tmp .= ' AND region_fedstate = '.$filter_fedstate;
			}
		// County Filter
		if ( $filter_county ) {
			$tmp .= ' AND region_county = '.$filter_county;
			}
	$query = "SELECT * FROM #__ksads_ads WHERE catid = ".$catid. " AND published = '1'";
	$query .= " AND (date_expiry >= '$today' OR expiry_deactivate = 1)"; 
	if ($lic[3] && $conf->show_regionalinfo) {
	    $query .= $tmp;
	    }

	$db->setQuery( $query );
	$result = array_merge($db->loadObjectList());
    while ($recursive) {
			$subquery = "SELECT * FROM #__ksads_cats WHERE pid = ".$catid. " AND published = '1'";
			$db->setQuery( $subquery );	
			if ($categs = $db->loadObjectList()) {
				foreach($categs as $categ) {
					$catid = $categ->id;
					$query = "SELECT * FROM #__ksads_ads WHERE catid = ".$catid. " AND published = '1'";
					$query .= " AND (date_expiry >= '$today' OR expiry_deactivate = 1)";
					if ($lic[3] && $conf->show_regionalinfo) {
					    $query .= $tmp;
					    }
					$db->setQuery( $query );
					$result = array_merge($result, $db->loadObjectList());
					}
				} else {
				$recursive = 0;
				}
		  }
	return $result;
}

  /*------------------------------------------------------------------
	remove_HTML:
	strips all HTML tags from a string
	Copyright (c) 2010 by KISS Software
  -------------------------------------------------------------------*/
    function remove_HTML($s , $keep = '' , $expand = 'script|style|noframes|select|option'){
        /**///prep the string
        $s = ' ' . $s;
       
        /**///initialize keep tag logic
        if(strlen($keep) > 0){
            $k = explode('|',$keep);
            for($i=0;$i<count($k);$i++){
                $s = str_replace('<' . $k[$i],'[{(' . $k[$i],$s);
                $s = str_replace('</' . $k[$i],'[{(/' . $k[$i],$s);
            }
        }
       
        //begin removal
        /**///remove comment blocks
        while(stripos($s,'<!--') > 0){
            $pos[1] = stripos($s,'<!--');
            $pos[2] = stripos($s,'-->', $pos[1]);
            $len[1] = $pos[2] - $pos[1] + 3;
            $x = substr($s,$pos[1],$len[1]);
            $s = str_replace($x,'',$s);
        }
       
        /**///remove tags with content between them
        if(strlen($expand) > 0){
            $e = explode('|',$expand);
            for($i=0;$i<count($e);$i++){
                while(stripos($s,'<' . $e[$i]) > 0){
                    $len[1] = strlen('<' . $e[$i]);
                    $pos[1] = stripos($s,'<' . $e[$i]);
                    $pos[2] = stripos($s,$e[$i] . '>', $pos[1] + $len[1]);
                    $len[2] = $pos[2] - $pos[1] + $len[1];
                    $x = substr($s,$pos[1],$len[2]);
                    $s = str_replace($x,'',$s);
                }
            }
        }
       
        /**///remove remaining tags
        while(stripos($s,'<') > 0){
            $pos[1] = stripos($s,'<');
            $pos[2] = stripos($s,'>', $pos[1]);
            $len[1] = $pos[2] - $pos[1] + 1;
            $x = substr($s,$pos[1],$len[1]);
            $s = str_replace($x,'',$s);
        }
       
        /**///finalize keep tag
        for($i=0;$i<count($k);$i++){
            $s = str_replace('[{(' . $k[$i],'<' . $k[$i],$s);
            $s = str_replace('[{(/' . $k[$i],'</' . $k[$i],$s);
        }
       
        return trim($s);
    }
	
  /*------------------------------------------------------------------
	getSubcatNumbers
	Iterates through a parent category to retrieve all child categories
	Copyright (c) 2010 by KISS Software
  -------------------------------------------------------------------*/
	function getSubcatNumbers ($parentid = 0) {
		// Initialize variables
		$db	=& JFactory::getDBO();
		$subs = "";
		$query = "SELECT * FROM #__ksads_cats WHERE `pid`= '$parentid'";	
		$db->setQuery($query);
		if ($categs = $db->loadObjectList()) {
			foreach($categs as $categ) {
				$subs .= $categ->id.",";
				$subs .= getSubcatNumbers($categ->id);
				}
			}
		return $subs;	
	}

  /*------------------------------------------------------------------
	_sendFriendMail
	Notifies the user and administrator of ads which are about to expire
	Copyright (c) 2010 by KISS Software
  -------------------------------------------------------------------*/
	function _sendFriendMail($row)
        {
		global $option, $mainframe;
        require_once(JPATH_SITE.DS.'components'.DS.'com_mailto'.DS.'helpers'.DS.'mailto.php');
		$uri	=& JURI::getInstance();
		$base	= $uri->toString( array('scheme', 'host', 'port'));
        $link	= $base.JRoute::_( "index.php?option=$option&task=viewad&id=$row->id", false );
        $url    = 'index.php?option=com_mailto&tmpl=component&link='.MailToHelper::addLink($link);
		$status = 'width=400,height=350,menubar=yes,resizable=yes';
		$text = JHTML::_('image.site', 'emailButton.png', '/images/M_images/', NULL, NULL, JText::_('Tellafriend'));
		$attribs = array();
		$attribs['title']	= JText::_( 'Tellafriend' );
		$attribs['onclick'] = "window.open(this.href,'win2','".$status."'); return false;";

		$output = JHTML::_('link', JRoute::_($url), $text, $attribs);
		return $output;
	}
	
  /*------------------------------------------------------------------
	_sendExpiryMail
	Notifies the user and administrator of ads which are about to expire
	Copyright (c) 2010 by KISS Software
  -------------------------------------------------------------------*/
	function _sendExpiryMail($adno, $link, $func=0)
	{
		global $mainframe;

		$db	=& JFactory::getDBO();
		$user 	=& JFactory::getUser();
		$query	= "SELECT * FROM #__ksads_ads WHERE id = $adno";
		$db->setQuery($query);
		$data = $db->loadObject();

		// Get Advertiser User ID
		// if not KISS Joomla Version, the user table does not contain a field named "firstname"
		$ad_userid = $data->userid;
		if ($ad_userid > 0) {
			if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
				$query = "SELECT name, email, sendEmail";				
				} else {
				$query = "SELECT CONCAT_WS(' ', firstname, name) as name, email, sendEmail";
				}
			$query .=" FROM #__users WHERE id = '" . $ad_userid . "'";

			$db->setQuery( $query );
			$advertiser = $db->loadObject();

			$ad_name	= $advertiser->name;
			$ad_email	= $advertiser->email;
			} else {
			$ad_name	= $data->contact_name;
			$ad_email	= $data->contact_email;			
			}
		$usermail	= $user->get('email');
		$username 	= $user->get('username');

		$usersConfig 	= &JComponentHelper::getParams( 'com_users' );
		$sitename 	= $mainframe->getCfg( 'sitename' );
		$mailfrom 	= $mainframe->getCfg( 'mailfrom' );
		$fromname 	= $mainframe->getCfg( 'fromname' );
		$siteURL	= JURI::base();

		$subject 	= sprintf (JText::_('Expiry Subject'), $data->ad_ident, $sitename);
		$subject 	= remove_HTML($subject);

		$message = sprintf ( JText::_( 'Expiry Message User 1' ), $advertiser->name, $sitename, $data->ad_ident, $data->ad_name, $data->ad_desc, $link );
		$message = remove_HTML($message);

		//get all super administrators
		// if not KISS Joomla Version, the user table does not contain a field named "firstname"
		if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
			$query = "SELECT name FROM #__users WHERE id = '" . $row->user_id . "'";				
			} else {
			$query = "SELECT CONCAT_WS(' ', firstname, name) as name, email, sendEmail";
			}
		$query .=' FROM #__users' .
			 ' WHERE LOWER( usertype ) = "super administrator"';
		$db->setQuery( $query );
		$rows = $db->loadObjectList();

		// Send email to user
		if ( ! $mailfrom  || ! $fromname ) {
			$fromname = $rows[0]->name;
			$mailfrom = $rows[0]->email;
		}
		// If mail should be sent only to admin, set func = 1
		if ($func == 0) {
		    JUtility::sendMail($mailfrom, $siteURL, $ad_email, $subject, $message);
		   }

		// get superadministrators id
		foreach ( $rows as $row )
		{
			if ($row->sendEmail)
			{
				$message2 = sprintf ( JText::_( 'Expiry Message Admin 1' ), $row->name, $data->ad_ident, $advertiser->name, $sitename, $advertiser->name, $ad_email, $username, $data->ad_ident, $data->ad_name, $data->ad_intro);
				$message2 = remove_HTML($message2);
				JUtility::sendMail($mailfrom, $fromname, $row->email, $subject, $message2);
			}
		}
	}

  /*------------------------------------------------------------------
	showAffiliateAds
	Determines whether or not to show affiliate ads
	Copyright (c) 2010 by KISS Software
  -------------------------------------------------------------------*/
	function showAffiliateAds($func = 1)
	{
		$conf =& JTable::getInstance('config', 'Table');
		$conf->load(1);
		$aff = ($func == 1) ? $conf->show_affiliate : $conf->show_affiliate_2;
		$user 	=& JFactory::getUser();
		$uid = $user->get('id');

		// is affiliate activated for none?
		switch ($aff) {
			case 0: // No affiliate ads at all
			return false;
			break;
			case 1: // Public only
			if ($uid == 0) {
				return true;
				} else {
				return false;
				}
			break;
			case 2: // Public and Registered 
				return true;
			break;
		}
	}

  /*------------------------------------------------------------------
	paypalButton
	Shows a PayPal 'Buy Now' Button
	Copyright (c) 2011 by KISS Software
  -------------------------------------------------------------------*/
	function paypalButton ($row, $cust) {
	  global $option;
	  $lang =& JFactory::getLanguage();
	  $language = str_replace('-' , '_' , $lang->getTag());
	  $curr=getCurrency($row->catid);
	  $live_site = &JURI::root();
	  $cancellink = $live_site."index.php?option=$option&task=show_cancel";
	  $successlink = $live_site."index.php?option=$option&task=show_success_thirdparty";
	  $buttonfile = $live_site."components".DS."com_ksadvertiser".DS."images".DS."button_paypal.png";	  
	  $ks_help = new KissHelper();
	  $sitename = & JSite::getCfg('sitename' );	  
		$html = '
		<form action="https://www.paypal.com/cgi-bin/webscr" method="post" name="form_paypal" id="form_paypal">
			<input name="cmd" value="_xclick" type="hidden">
			<input name="business" value="'.$ks_help->decrypted($cust->cust_cart_paypal).'" type="hidden">
			<input name="item_name" value="'.$row->ad_name.'" type="hidden">
			<input name="item_number" value="'.$row->ad_ident.'" type="hidden">
			<input name="amount" value="'.number_format($row->ad_price, 2, ".", "").'" type="hidden">
			<input name="no_shipping" value="1" type="hidden">
			<input name="no_note" value="1" type="hidden">
			<input name="currency_code" value="'.$curr.'" type="hidden">
			<input name="cancel_return" value="'.$cancellink.'" type="hidden">
			<input name="return" value="'.$successlink.'" type="hidden">
			<input name="bn" value="IC_Beispiel" type="hidden">
			<input name="rm" value="GET" type="hidden">
			<input name="cbt" value="'.sprintf(JText::_('Return to'), $sitename).'" type="hidden">
			<input src="'.$buttonfile.'" name="submit" alt="'.JText::_('Paypal Claim').'" type="image">
			<img alt="" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1">
		</form>
		';
		return $html;
	}
	
  /*------------------------------------------------------------------
	buildQueryString
	Builds a query string for ads
	Copyright (c) 2011 by KISS Software
  -------------------------------------------------------------------*/
	function buildQueryString($catid = 0) {
		$conf =& JTable::getInstance('config', 'Table');
		$conf->load(1);
		$lic = array();
		$lic = explode(",",base64_decode(str_rot13($conf->license)));

		$today = date("Y-m-d H:i:s", mktime(date('H'),date('i'),date('s'),date('m'),date('d'),date('y')));
			switch ($conf->startpanel) {

			case 1:
			case 2:
			default:
				$filter_order = 'ad_price_pu DESC, ad_name';
				$filter_order_dir = 'ASC';
			break;
			case 3:
			case 7:
				$filter_order = 'ad_price_pu DESC, ad_post ASC, ad_name';
				$filter_order_dir = 'ASC';
			break;
			case 4:
			case 6:
				$filter_order = 'ad_price_pu DESC, date_created DESC, id';
				$filter_order_dir = 'DESC';
			break;
			}

		$query = "SELECT * FROM #__ksads_ads WHERE catid = '" . $catid ."'"
				." AND (date_expiry > '" . $today ."' OR expiry_deactivate = 1)"
				." AND published = '1'";

		if ($lic[3] && $conf->show_regionalinfo) {
			$session =& JFactory::getSession();	
			$regionfilter = $session->get('regionfilter', array(), 'ksaregfilter');
			if (!empty($regionfilter)) {
				$filter_fedstate = $regionfilter['filter_fedstate'];
				$filter_country = $regionfilter['filter_country'];
				$filter_county = $regionfilter['filter_county'];
				} else {
				$filter_fedstate = 0;
				$filter_country = 0;
				$filter_county = 0;
				}
			$tmp = "";
			// Country Filter	
			if ( $filter_country ) {
			  $tmp .= ' AND region_country = '.$filter_country;
			}
			// Federal State Filter	
			if ( $filter_fedstate ) {
			  $tmp .= ' AND region_fedstate = '.$filter_fedstate;
			}
			// County Filter
			if ( $filter_county ) {
			  $tmp .= ' AND region_county = '.$filter_county;
			}
			$query .= $tmp;
			}

		$query .= " ORDER BY ".$filter_order . " " . $filter_order_dir;
		return $query;
	}
?>