DROP TABLE IF EXISTS `#__ksads_addresses`;
DROP TABLE IF EXISTS `#__ksads_ads`;
DROP TABLE IF EXISTS `#__ksads_cats`;
DROP TABLE IF EXISTS `#__ksads_complaints`;
DROP TABLE IF EXISTS `#__ksads_config`;
DROP TABLE IF EXISTS `#__ksads_currencies`;
DROP TABLE IF EXISTS `#__ksads_customeraccounts`;
DROP TABLE IF EXISTS `#__ksads_customers`;
DROP TABLE IF EXISTS `#__ksads_extensions`;
DROP TABLE IF EXISTS `#__ksads_fields`;
DROP TABLE IF EXISTS `#__ksads_files`;
DROP TABLE IF EXISTS `#__ksads_models`;
DROP TABLE IF EXISTS `#__ksads_reg_counties`;
DROP TABLE IF EXISTS `#__ksads_reg_countries`;
DROP TABLE IF EXISTS `#__ksads_reg_fedstates`;
DROP TABLE IF EXISTS `#__ksads_selectitems`;
DROP TABLE IF EXISTS `#__ksads_usernotify`;
DROP TABLE IF EXISTS `#__ksads_votes`;

CREATE TABLE IF NOT EXISTS `#__ksads_ads` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `mid` int(11) NOT NULL default 1,  
  `catid` int(11) NOT NULL DEFAULT 1,
  `user_id` int(11) NOT NULL,
  `ad_ident` varchar(20) NOT NULL,
  `ad_name` varchar(255) NOT NULL,
  `ad_address` varchar(255) NOT NULL,  
  `ad_intro` varchar(255) NOT NULL,
  `ad_desc` text(2000) NOT NULL,
  `ad_state` tinyint(1) NOT NULL DEFAULT 0,
  `ad_price` float(11) NOT NULL,
  `ad_location` varchar(100) NOT NULL,
  `ad_post` varchar(20) NOT NULL,
  `ad_delivery` tinyint(1) NOT NULL DEFAULT 0,
  `ad_image` varchar(255) NOT NULL,
  `ad_img_comment` varchar(255) NOT NULL,
  `ad_boxnumber` tinyint(1) NOT NULL,
  `ad_commercial` tinyint(1) NOT NULL DEFAULT 0,
  `ad_price_pu` float(11) NOT NULL DEFAULT 0,  
  `ad_vid_prov` smallint(3) NOT NULL DEFAULT 0,  
  `ad_vid_id` varchar(255) NOT NULL,  
  `ad_paid` tinyint(1) NOT NULL DEFAULT 1,
  `contact_name` varchar(255) NOT NULL,
  `contact_tel` varchar(30) NOT NULL,
  `contact_email` varchar(255) NOT NULL,
  `contact_website` varchar(255) NOT NULL,  
  `date_created` date NOT NULL DEFAULT '0000-00-00 00:00:00',
  `date_expiry` date NOT NULL DEFAULT '0000-00-00 00:00:00',
  `expiry_deactivate` tinyint(1) NOT NULL DEFAULT 0,
  `published` tinyint(1) NOT NULL,
  `notified_expiry` tinyint(1) NOT NULL DEFAULT 0,  
  `prolonged` smallint(2) NOT NULL DEFAULT 0,
  `show_address` tinyint(1) NOT NULL,
  `views` int(11) NOT NULL DEFAULT 0,
  `meta` varchar(255) NOT NULL,  
  `phonetic` varchar(255) NOT NULL,
  `showinmodule` tinyint(1) NOT NULL DEFAULT 1,
  `longitude` float(11) NOT NULL,
  `latitude` float(11) NOT NULL,
  `article_id` int(11) NOT NULL DEFAULT 0,
  `condition` smallint(2) NOT NULL DEFAULT 0, 
  `rating` varchar(20) NOT NULL DEFAULT '0,0',
  `link_uri` varchar(255) NOT NULL DEFAULT '',  
  `link_txt` varchar(255) NOT NULL DEFAULT '',
  `down_uri` varchar(255) NOT NULL DEFAULT '',  
  `down_txt` varchar(255) NOT NULL DEFAULT '',
  `region_country` int(11) NOT NULL DEFAULT 0,  
  `region_fedstate` int(11) NOT NULL DEFAULT 0,
  `region_county` int(11) NOT NULL DEFAULT 0,
  `opt_bold` tinyint(1) NOT NULL DEFAULT 0,
  `opt_new` tinyint(1) NOT NULL DEFAULT 0,
  `opt_color` tinyint(1) NOT NULL DEFAULT 0,
  `opt_bold_paid` tinyint(1) NOT NULL DEFAULT 0,
  `opt_new_paid` tinyint(1) NOT NULL DEFAULT 0,
  `opt_color_paid` tinyint(1) NOT NULL DEFAULT 0,
  `watermark` tinyint(1) NOT NULL DEFAULT 0,
  `sold` tinyint(1) NOT NULL DEFAULT 0,   
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8 COMMENT='stores the classifieds information';

CREATE TABLE IF NOT EXISTS `#__ksads_cats` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `gid` int(11) NOT NULL DEFAULT 0,
  `aid` int(11) NOT NULL DEFAULT 0,
  `pid` int(11) NOT NULL DEFAULT 0,
  `cat_name` varchar(255) NOT NULL,
  `cat_img` varchar(255) NOT NULL,
  `cat_desc` varchar(255) NOT NULL,
  `fee` tinyint(1) NOT NULL DEFAULT 0,
  `payment` int(11) NOT NULL DEFAULT 0,
  `expiry` tinyint(1) NOT NULL DEFAULT 0,
  `ordering` int(11) NOT NULL,
  `ovr_addr_num` int(11) NOT NULL default 0,  
  `ovr_addr_ovr` tinyint(1) NOT NULL default 0,  
  `allow_img` tinyint(1) NOT NULL DEFAULT 1,
  `autopublish` tinyint(1) NOT NULL DEFAULT 0,
  `published` tinyint(1) NOT NULL DEFAULT 1,
  `restrict_to` tinyint(1) NOT NULL DEFAULT 0,
  `complaints` tinyint(1) NOT NULL DEFAULT 1,  
  `showads` tinyint(1) NOT NULL DEFAULT 1,
  `showinmodule` tinyint(1) NOT NULL DEFAULT 1,  
  `currency` smallint(3) NOT NULL DEFAULT 0,  
  `extension` smallint(3) NOT NULL DEFAULT 0,
  `rating` tinyint(1) NOT NULL DEFAULT 0,  
  PRIMARY KEY (`id`) 
) DEFAULT CHARSET=utf8 COMMENT='stores the category informations';

--
-- Daten für Tabelle `ksads_cats`
--
INSERT INTO `#__ksads_cats` (`id`, `gid`, `aid`, `pid`, `cat_name`, `cat_img`, `cat_desc`, `ordering`, `fee`, `payment`, `expiry`, `published`, `autopublish`, `restrict_to`, `complaints`, `showads`, `currency`) VALUES
(1, 0, 0, 0, 'Allgemein', 'Compressed.png', 'Allgemeine Kleinanzeigen', 0, 0, 0, 0, 1, 1, 0, 1, 1, 0);

CREATE TABLE IF NOT EXISTS `#__ksads_config` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `access_delete` smallint(2) NOT NULL DEFAULT '18',  
  `access_remotefiles` smallint(1) NOT NULL DEFAULT '1',
  `access_reply` int(2) NOT NULL DEFAULT '0',  
  `access_rss` smallint(1) NOT NULL DEFAULT '0',
  `access_vid` smallint(2) NOT NULL DEFAULT '1',
  `access` int(2) NOT NULL DEFAULT '0',
  `addetailstyle` smallint(1) NOT NULL DEFAULT '1',
  `adliststyle` smallint(1) NOT NULL DEFAULT '1',    
  `adsense_ldb` text(2000) NOT NULL,  
  `adsense_squ` text(2000) NOT NULL,    
  `adsense_wss` text(2000) NOT NULL,  
  `ad_detail_font` varchar(7) NOT NULL DEFAULT '#339966',
  `ad_img_dir` varchar(255) NOT NULL DEFAULT 'ksadvertiser',
  `ad_state_font` varchar(7) NOT NULL DEFAULT '#339999',
  `bank_account` varchar(64) NOT NULL DEFAULT '',
  `bank_bic` varchar(64) NOT NULL DEFAULT '',
  `bank_code` varchar(20) NOT NULL DEFAULT '',  
  `bank_iban` varchar(64) NOT NULL DEFAULT '',
  `bank_name` varchar(128) NOT NULL DEFAULT '',
  `behavior_img_click` tinyint(1) NOT NULL DEFAULT '1',      
  `catliststyle` smallint(1) NOT NULL DEFAULT '1',  
  `check_address_geocode` smallint(1) NOT NULL DEFAULT '1',
  `create_thumbnails` tinyint(1) NOT NULL DEFAULT '1',
  `cron_notification` date NOT NULL DEFAULT '0000-00-00 00:00:00', 
  `currency` smallint(3) NOT NULL DEFAULT '49',
  `date_format` varchar(20) NOT NULL DEFAULT 'd.m.Y',  
  `days_shown` smallint(3) NOT NULL DEFAULT '80',
  `decimals` smallint(2) NOT NULL DEFAULT '2',  
  `distance` smallint(1) NOT NULL DEFAULT '1',
  `editor` varchar(40) NOT NULL DEFAULT 'tinymce',
  `filter` smallint(1) NOT NULL DEFAULT '0',
  `font_color` varchar(7) NOT NULL DEFAULT '#993300',
  `frontpage_intro` text(2000) NOT NULL,
  `img_maxheight` int(11) NOT NULL DEFAULT '600', 
  `img_maxwidth` int(11) NOT NULL DEFAULT '800',
  `img_maxheight_detail` int(11) NOT NULL DEFAULT '250', 
  `img_maxwidth_detail` int(11) NOT NULL DEFAULT '400',
  `img_preview_size` int(11) NOT NULL DEFAULT '80',
  `introlimit` int(3) NOT NULL DEFAULT '255',  
  `license` varchar(100) NOT NULL DEFAULT '',
  `loginlink` varchar(255) NOT NULL DEFAULT 'index.php?option=com_user&view=login',  
  `logo_file` varchar(255) NOT NULL DEFAULT '',  
  `mapwidth` int(3) NOT NULL DEFAULT '0',  
  `map` smallint(1) NOT NULL DEFAULT '1',
  `markasnew` smallint(2) NOT NULL DEFAULT '14',
  `med_autoplay` smallint(1) NOT NULL DEFAULT '0',
  `med_backgroundqt` varchar(8) NOT NULL DEFAULT '#AFAFAF',
  `med_background` varchar(8) NOT NULL DEFAULT '#AFAFAF',
  `med_controlbar` tinyint(1) NOT NULL DEFAULT '1',
  `med_height` smallint(4) NOT NULL DEFAULT '300',
  `med_transparency` smallint(2) NOT NULL DEFAULT '50',
  `med_width` smallint(4) NOT NULL DEFAULT '450',
  `menustyle` smallint(1) NOT NULL DEFAULT '2', 
  `notify_email` varchar(255) NOT NULL DEFAULT '',  
  `notify_expiry` smallint(1) NOT NULL DEFAULT '1',
  `notify_user` smallint(1) NOT NULL DEFAULT '1',
  `notify` smallint(1) NOT NULL DEFAULT '1',
  `owner_address` varchar(128) NOT NULL DEFAULT '',	  
  `owner_city` varchar(128) NOT NULL DEFAULT '',
  `owner_comm` varchar(128) NOT NULL DEFAULT '',	    
  `owner_name` varchar(128) NOT NULL DEFAULT '',	
  `paid_col_1` varchar(7) NOT NULL DEFAULT '#AFAFAF',
  `paid_col_2` varchar(7) NOT NULL DEFAULT '#ECECEC',
  `paid_col_3` varchar(7) NOT NULL DEFAULT '#DFDFDF',
  `paid_col_4` varchar(7) NOT NULL DEFAULT '#C1A1D1',
  `paid_col_5` varchar(7) NOT NULL DEFAULT '#F4B4A4',
  `payment_model` smallint(3) NOT NULL DEFAULT '1',
  `paypal_info` varchar(100) NOT NULL DEFAULT '',  
  `prolong` smallint(1) NOT NULL DEFAULT '1',
  `prune` int(11) NOT NULL DEFAULT '60',
  `regionalsearch` smallint(1) NOT NULL DEFAULT '1',
  `route` smallint(1) NOT NULL DEFAULT '1',
  `sep_decimal` varchar(1) NOT NULL DEFAULT ',',
  `sep_thousand` varchar(1) NOT NULL DEFAULT '.',    
  `share_img_anonymous` smallint(1) NOT NULL DEFAULT '1',      
  `show_address` smallint(4) NOT NULL DEFAULT '0',  
  `show_affiliate_2` smallint(1) NOT NULL DEFAULT '0',    
  `show_affiliate` smallint(1) NOT NULL DEFAULT '0', 
  `show_banners_2` smallint(4) NOT NULL DEFAULT '0',    
  `show_banners` smallint(4) NOT NULL DEFAULT '0',  
  `show_captcha` smallint(1) NOT NULL DEFAULT '0',
  `show_commercial` smallint(1) NOT NULL DEFAULT '0',
  `show_details_details` smallint(1) NOT NULL DEFAULT '1',
  `show_details_list` smallint(1) NOT NULL DEFAULT '1',
  `show_ext_catlist` tinyint(1) NOT NULL DEFAULT '1',
  `show_pushlink` smallint(1) NOT NULL DEFAULT '0',  
  `show_rating_2` smallint(1) NOT NULL DEFAULT '0',
  `show_rating` smallint(1) NOT NULL DEFAULT '0',
  `show_regionalinfo` smallint(1) NOT NULL DEFAULT '1',  
  `show_sliders` smallint(1) NOT NULL DEFAULT '0',
  `show_statistics` smallint(1) NOT NULL DEFAULT '0',
  `show_terms` smallint(1) NOT NULL DEFAULT '1',
  `show_thumbnails` smallint(2) NOT NULL DEFAULT '0',
  `show_weblink` smallint(1) NOT NULL DEFAULT '0',
  `startpanel` smallint(1) NOT NULL DEFAULT '1',
  `tax_vat` int(11) NOT NULL DEFAULT '19',  
  `udelete` smallint(2) NOT NULL DEFAULT '18',
  `upl_filesize` float(11) NOT NULL DEFAULT '0.5',
  `upl_filetypes` varchar(255) NOT NULL DEFAULT 'jpg,jpeg,gif,png,flv,mov,wmv,mp3,avi',
  `upl_immediate` smallint(1) NOT NULL DEFAULT '1',  
  `upl_maxwidth` int(11) NOT NULL DEFAULT '500',
  `upl_rights` smallint(3) NOT NULL DEFAULT '755',
  `upl_simple` tinyint(1) NOT NULL DEFAULT '0',
  `version` varchar(15) NOT NULL DEFAULT '1.5.00',
  `watermark` varchar(255) NOT NULL DEFAULT '',  
  `watermark_opacity` smallint(2) NOT NULL DEFAULT '20',    
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 COMMENT='stores the configuration';

INSERT INTO #__ksads_config ( `id`,`version` ) VALUES ( '1','1.5.71' );

CREATE TABLE IF NOT EXISTS `#__ksads_complaints` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `adid` int(11) NOT NULL,  
  `complaint` varchar(255) NOT NULL DEFAULT '',
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `published` tinyint(1) NOT NULL DEFAULT 1,
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8 COMMENT='stores complaints';

CREATE TABLE IF NOT EXISTS `#__ksads_files` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `adid` int(11) NOT NULL,
  `file` varchar(255) NOT NULL,
  `comment` varchar(255) NOT NULL,  
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8 COMMENT='stores additional files for ads';

CREATE TABLE IF NOT EXISTS `#__ksads_backup` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `date_created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `date_restored` timestamp NOT NULL,
  `title` varchar(50) NOT NULL,  
  `description` varchar(255) NOT NULL,  
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8 COMMENT='stores information about backups';

CREATE TABLE IF NOT EXISTS `#__ksads_votes` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `adid` int(11) NOT NULL,
  `uid` varchar(11) NOT NULL,
  `date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `uip` varchar(20) NOT NULL,
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8 COMMENT='stores user votes for ads';

--
-- Tabellenstruktur für Tabelle `ksads_models`
--
CREATE TABLE IF NOT EXISTS `#__ksads_models` (
  `id` int(11) NOT NULL auto_increment,
  `gid` int(11) NOT NULL DEFAULT 0,
  `aid` int(11) NOT NULL DEFAULT 0,
  `model_name` varchar(128) default NULL,
  `model_description` varchar(255) default NULL,
  `ads_per_period` int(11) NOT NULL default 0,
  `expiry` int(11) NOT NULL default 0,
  `currency` smallint(3) NOT NULL DEFAULT 0,  
  `days_payment` smallint(3) NOT NULL DEFAULT 3,  
  `prolong` smallint(1) NOT NULL DEFAULT 1,  
  `images` int(11) NOT NULL default 1,
  `videos` tinyint(1) NOT NULL default 1,
  `price` float(11) NOT NULL default 0,
  `price_prolong` int(11) NOT NULL default 0,   
  `payment` smallint(1) NOT NULL default 0,
  `payment_advance` smallint(1) NOT NULL default 1,
  `views` int(11) NOT NULL default 0, 
  `duration` int(11) NOT NULL default 180,
  `commercial` smallint(1) NOT NULL default 0,
  `webshops` tinyint(1) NOT NULL default 0,
  `weblinks` tinyint(1) NOT NULL default 1, 
  `opt_charge` tinyint(1) NOT NULL default 0,
  `opt_new` tinyint(1) NOT NULL default 1,
  `opt_color` tinyint(1) NOT NULL default 1,
  `opt_bold` tinyint(1) NOT NULL default 1,
  `opt_new_price` float(11) NOT NULL default 0,
  `opt_color_price` float(11) NOT NULL default 0,
  `opt_bold_price` float(11) NOT NULL default 0,
  `ovr_addr_num` int(11) NOT NULL default 0,  
  `ovr_addr_ovr` tinyint(1) NOT NULL default 0,
  `socialnet` tinyint(1) NOT NULL default 0,
  `tellafriend` tinyint(1) NOT NULL default 1,
  `forcecategory` tinyint(1) NOT NULL default 0,  
  `downloads` tinyint(1) NOT NULL default 0,
  `downgrade` smallint(3) NOT NULL DEFAULT 0,
  `provision` float(11) NOT NULL default 0,  
  `ordering` int(11) NOT NULL,  
  `published` smallint(1) NOT NULL default 1,   
  `watermark` tinyint(1) NOT NULL default 0,    
  `comments` smallint(3) NOT NULL default 5,      
  PRIMARY KEY  (`id`),
  KEY `idx_model_name` (`model_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='stores information about classifieds plans';

--
-- Tabellenstruktur für Tabelle `ksads_customers`
--

CREATE TABLE IF NOT EXISTS `#__ksads_customers` (
  `id` int(11) NOT NULL auto_increment,
  `uid` int(11) NOT NULL default 0,
  `mid` int(11) NOT NULL default 1,
  `color` smallint(1) NOT NULL default 1,  
  `balance` float(11) NOT NULL default 0,
  `cust_company` varchar(255) NOT NULL,
  `cust_address` varchar(255) NOT NULL,
  `cust_postcode` varchar(20) NOT NULL,
  `cust_city` varchar(100) NOT NULL,      
  `cust_telephone` varchar(30) NOT NULL,      
  `cust_fax` varchar(30) NOT NULL,      
  `cust_email` varchar(255) NOT NULL,
  `cust_website` varchar(255) NOT NULL,
  `cust_company_invoice` varchar(255) NOT NULL,
  `cust_address_invoice` varchar(255) NOT NULL,
  `cust_postcode_invoice` varchar(20) NOT NULL,
  `cust_city_invoice` varchar(100) NOT NULL,
  `cust_country` int(11) NOT NULL DEFAULT 0,  
  `cust_fedstate` int(11) NOT NULL DEFAULT 0,
  `cust_county` int(11) NOT NULL DEFAULT 0,
  `cust_cart_paypal` varchar(255) NOT NULL,
  `cust_cart_google` varchar(255) NOT NULL,    
  `date_created` date NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT 1,
  `adsleft` int(11) NOT NULL default 0,  
  PRIMARY KEY  (`id`),
  KEY `idx_uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='stores information about customers' AUTO_INCREMENT=2 ;
--
-- Daten für Tabelle `ksads_customers`
--
INSERT INTO `#__ksads_customers` (`id`, `uid`, `mid`) VALUES
(1, 0, 1);

--
-- Tabellenstruktur für Tabelle `ksads_customeraccounts`
--
CREATE TABLE IF NOT EXISTS `#__ksads_customeraccounts` (
  `ca_id` int(11) NOT NULL auto_increment,
  `ca_cid` int(11) NOT NULL default 0,
  `ca_aid` int(11) NOT NULL default 0,  
  `ca_pid` smallint(1) NOT NULL default 0,  
  `ca_payment` float(11) NOT NULL default 0,
  `ca_text` varchar(100) NOT NULL,
  `ca_paydate` date NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ca_credit` float(11) NOT NULL default 0,
  `published` tinyint(1) NOT NULL DEFAULT 1,
  PRIMARY KEY  (`ca_id`),
  KEY `idx_cid` (`ca_cid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='stores information about customer payments';

--
-- Tabellenstruktur für Tabelle `ksads_fields`
--
CREATE TABLE IF NOT EXISTS `#__ksads_fields` (
  `id` int(11) NOT NULL,
  `catid` int(11) NOT NULL default '0',
  `gid` int(11) NOT NULL default '0',
  `uid` int(11) NOT NULL default '0',
  `aid` int(11) NOT NULL default '0',  
  `eid` int(11) NOT NULL default '0',
  `fieldname` varchar(100) default NULL,
  `fieldtitle` varchar(100) default NULL,
  `default` text NOT NULL default '',
  `mandatory` tinyint(1) NOT NULL default '0',
  `visible` tinyint(1) NOT NULL default '1',
  `activated` tinyint(1) NOT NULL default '1',  
  `backcolor` varchar(8) NOT NULL default 'FFFFFF',
  `forecolor` varchar(8) NOT NULL default '000000',  
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8 COMMENT='stores the ads fields display information';
--
-- Daten für Tabelle `ksads_fields`
--
INSERT INTO `#__ksads_fields` (`id`, `fieldname`, `fieldtitle`, `mandatory`) VALUES
(1, 'ad_ident', 'Identno', 0),
(2, 'ad_name', 'Ad Title', 1),
(3, 'ad_address', 'Address of Item', 1),
(4, 'ad_intro', 'Intro', 0),
(5, 'ad_desc', 'Description', 0),
(6, 'ad_state', 'State', 0),
(7, 'ad_price', 'Price', 0),
(8, 'ad_location', 'Location of Item', 1),
(9, 'ad_post', 'Item Postcode', 1),
(10, 'ad_delivery', 'Delivery Options', 0),
(11, 'ad_image', 'Label Image', 0),
(12, 'date_created', 'Date Created', 0),
(13, 'ad_boxnumber', 'Ad Boxnumber', 0),
(14, 'contact_name', 'Contact Name', 1),
(15, 'contact_email', 'Contact Email Address', 1),
(16, 'contact_tel', 'Contact Telephone', 0),
(17, 'contact_website', 'Contact Website', 0),
(18, 'meta', 'Metasearch', 0),
(19, 'ad_vid_id', 'Video ID', 0),
(20, 'link_uri', 'Deeplink Uri', 0),
(21, 'region_country', 'Regional Information', 0);
--
-- Tabellenstruktur für Tabelle `ksads_usernotify`
--
CREATE TABLE IF NOT EXISTS `#__ksads_usernotify` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `catid` int(11) NOT NULL,
  `mid` int(11) NOT NULL,  
  `date` date NOT NULL DEFAULT '0000-00-00 00:00:00', 
  `rss` smallint(1) NOT NULL DEFAULT '0',   
  `rsuid` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8 COMMENT='stores user notification info';

--
-- Tabellenstruktur für Tabelle `ksads_extensions`
--
  CREATE TABLE IF NOT EXISTS `#__ksads_extensions` (
    `id` int(11) NOT NULL DEFAULT 0,
    `ext_name` varchar(128) NOT NULL,  
    `ressource` varchar(64) NOT NULL,
    `active` tinyint(1) NOT NULL DEFAULT 1,
    PRIMARY KEY (`id`)
  ) DEFAULT CHARSET=utf8 COMMENT='stores the extensions information';

--
-- Tabellenstruktur für Tabelle `ksads_addresses`
--
CREATE TABLE IF NOT EXISTS `#__ksads_addresses` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `street` varchar(128) NOT NULL,
  `postcode` varchar(20) NOT NULL,  
  `city` varchar(128) NOT NULL,
  `region_country` int(11) NOT NULL,  
  `region_county` int(11) NOT NULL,  
  `region_fedstate` int(11) NOT NULL,    
  `phone` varchar(48) NOT NULL,  
  `email` varchar(128) NOT NULL,  
  `website` varchar(128) NOT NULL,  
  `companyname` varchar(128) NOT NULL,
  `personname` varchar(128) NOT NULL,  
  `published` tinyint(1) NOT NULL DEFAULT 1,  
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8 COMMENT='stores override addresses info';

--
-- Tabellenstruktur für Tabelle `ksads_reg_countries`
--
CREATE TABLE IF NOT EXISTS `#__ksads_reg_countries` (
  `cnt_id` int(11) NOT NULL AUTO_INCREMENT,
  `ressource` varchar(128) NOT NULL,    
  `flag_img` varchar(128) NOT NULL DEFAULT '',
  `published` tinyint(1) NOT NULL DEFAULT 1,
  PRIMARY KEY (`cnt_id`)
) DEFAULT CHARSET=utf8 COMMENT='stores country information';
--
-- Daten für Tabelle `ksads_countries`
--
INSERT INTO `#__ksads_reg_countries` (`ressource`, `flag_img`, `published`) VALUES
('GERMANY', 'flag_germany.png', 1),
('AUSTRIA', 'flag_austria.png', 1),
('SWITZERLAND', 'flag_switzerland.png', 1),
('USA', 'flag_usa.png', 1),
('ENGLAND', 'flag_england.png', 1),
('BRAZIL', 'flag_brazil.png', 1),
('NETHERLANDS', 'flag_netherlands.png', 1),
('CANADA', 'flag_canada.png', 1),
('AUSTRALIA', 'flag_australia.png', 1),
('IRELAND', 'flag_ireland.png', 1),
('SPAIN', 'flag_spain.png', 1);

--
-- Tabellenstruktur für Tabelle `ksads_reg_fedstates`
--
CREATE TABLE IF NOT EXISTS `#__ksads_reg_fedstates` (
  `fed_id` int(11) NOT NULL AUTO_INCREMENT,
  `cnt_id` int(11) NOT NULL DEFAULT 0,  
  `ressource` varchar(128) NOT NULL,    
  `flag_img` varchar(128) NOT NULL DEFAULT '',
  `published` tinyint(1) NOT NULL DEFAULT 1,
  PRIMARY KEY (`fed_id`)
) DEFAULT CHARSET=utf8 COMMENT='stores federal states information';
--
-- Daten für Tabelle `ksads_reg_fedstates`
--
INSERT INTO `#__ksads_reg_fedstates` ( `cnt_id`, `ressource`, `flag_img`, `published`) VALUES
(1, 'BERLIN', 'flag_berlin.png', 1),
(1, 'HAMBURG', 'flag_hamburg.png', 1),
(1, 'BREMEN', 'flag_bremen.png', 1),
(1, 'BAVARIA', 'flag_bavaria.png', 1),
(1, 'BADEN WUERTTEMBERG', 'flag_bw.png', 1),
(1, 'NRW', 'flag_nrw.png', 1),
(1, 'MECKPOMM', 'flag_meckpomm.png', 1),
(1, 'HASSIA', 'flag_hassia.png', 1),
(1, 'SAXONY', 'flag_saxony.png', 1),
(1, 'ANHALT', 'flag_sh.png', 1),
(1, 'SAARLAND', 'flag_saarland.png', 1),
(1, 'BRANDENBURG', 'flag_brandenburg.png', 1),
(1, 'LOWERSAXONY', 'flag_lowersaxony.png', 1),
(1, 'THURINGIA', 'flag_thuringia.png', 1),
(1, 'RHINELAND', 'flag_rp.png', 1),
(1, 'SCHLESWIG', 'flag_schleswig.png', 1),
(2, 'BURGENLAND', 'flag_burgenland.png', 1),
(2, 'CARINTHIA', 'flag_carinthia.png', 1),
(2, 'LOWERAUSTRIA', 'flag_loweraustria.png', 1),
(2, 'UPPERAUSTRIA', 'flag_upperaustria.png', 1),
(2, 'SALZBURG', 'flag_salzburg.png', 1),
(2, 'STEIERMARK', 'flag_steiermark.png', 1),
(2, 'TYROLIA', 'flag_tyrolia.png', 1),
(2, 'VORARLBERG', 'flag_vorarlberg.png', 1),
(2, 'VIENNA', 'flag_vienna.png', 1),
(3, 'AARGAU', 'flag_aargau.png', 1),
(3, 'APPENZELL AUS', 'flag_appenzell_ausserrhoden.png', 1),
(3, 'APPENZELL INN', 'flag_appenzell_innerrhoden.png', 1),
(3, 'BASEL LAND', 'flag_basel_landschaft.png', 1),
(3, 'BASEL STADT', 'flag_basel_stadt.png', 1),
(3, 'BERN', 'flag_bern.png', 1),
(3, 'FREIBURG', 'flag_freiburg.png', 1),
(3, 'GENF', 'flag_genf.png', 1),
(3, 'GLARUS', 'flag_glarus.png', 1),
(3, 'GRAUBUENDEN', 'flag_graubuenden.png', 1),
(3, 'JURA', 'flag_jura.png', 1),
(3, 'LUZERN', 'flag_luzern.png', 1),
(3, 'NEUENBURG', 'flag_neuenburg.png', 1),
(3, 'NIDWALDEN', 'flag_nidwalden.png', 1),
(3, 'OBWALDEN', 'flag_obwalden.png', 1),
(3, 'STGALLEN', 'flag_stgallen.png', 1),
(3, 'SCHAFFHAUSEN', 'flag_schaffhausen.png', 1),
(3, 'SCHWYZ', 'flag_schwyz.png', 1),
(3, 'SOLOTHURN', 'flag_solothurn.png', 1),
(3, 'THURGAU', 'flag_thurgau.png', 1),
(3, 'TESSIN', 'flag_tessin.png', 1),
(3, 'URI', 'flag_uri.png', 1),
(3, 'WAADT', 'flag_waadt.png', 1),
(3, 'WALLIS', 'flag_wallis.png', 1),
(3, 'ZUG', 'flag_zug.png', 1),
(3, 'ZUERICH', 'flag_zuerich.png', 1),
(3, 'NEUCHATEL', 'flag_neuchatel.png', 1),
(4, 'ALABAMA', 'flag_alabama.png', 1),
(4, 'ALASKA', 'flag_alaska.png', 1),
(4, 'ARIZONA', 'flag_arizona.png', 1),
(4, 'ARKANSAS', 'flag_arkansas.png', 1),
(4, 'COLORADO', 'flag_colorado.png', 1),
(4, 'CONNECTICUT', 'flag_connecticut.png', 1),
(4, 'DELAWARE', 'flag_delaware.png', 1),
(4, 'DISTRICTCOLUMBIA', 'flag_districtcolumbia.png', 1),
(4, 'FLORIDA', 'flag_florida.png', 1),
(4, 'GEORGIA', 'flag_georgia.png', 1),
(4, 'HAWAII', 'flag_hawaii.png', 1),
(4, 'IDAHO', 'flag_idaho.png', 1),
(4, 'ILLINOIS', 'flag_illinois.png', 1),
(4, 'INDIANA', 'flag_indiana.png', 1),
(4, 'IOWA', 'flag_iowa.png', 1),
(4, 'CALIFORNIA', 'flag_california.png', 1),
(4, 'KENTUCKY', 'flag_kentucky.png', 1),
(4, 'KANSAS', 'flag_kansas.png', 1),
(4, 'LOUISIANA', 'flag_louisiana.png', 1),
(4, 'MAINE', 'flag_maine.png', 1),
(4, 'MARYLAND', 'flag_maryland.png', 1),
(4, 'MASSACHUSETTS', 'flag_massachusetts.png', 1),
(4, 'MICHIGAN', 'flag_michigan.png', 1),
(4, 'MINNESOTA', 'flag_minnesota.png', 1),
(4, 'MISSISSIPPI', 'flag_mississippi.png', 1),
(4, 'MISSOURI', 'flag_missouri.png', 1),
(4, 'NEBRASKA', 'flag_montana.png', 1),
(4, 'NEVADA', 'flag_nevada.png', 1),
(4, 'NEW HAMPSHIRE', 'flag_newhampshire.png', 1),
(4, 'NEW YORK', 'flag_newyork.png', 1),
(4, 'NEW MEXICO', 'flag_newmexico.png', 1),
(4, 'NEW JERSEY', 'flag_newjersey.png', 1),
(4, 'NORTH CAROLINA', 'flag_northcarolina.png', 1),
(4, 'NORTH DAKOTA', 'flag_northdakota.png', 1),
(4, 'OREGON', 'flag_oregon.png', 1),
(4, 'OHIO', 'flag_ohio.png', 1),
(4, 'OKLAHOMA', 'flag_oklahoma.png', 1),
(4, 'PENNSYLVANIA', 'flag_pennsylvania.png', 1),
(4, 'RHODE ISLAND', 'flag_rhodeisland.png', 1),
(4, 'SOUTH CAROLINA', 'flag_southcarolina.png', 1),
(4, 'SOUTH DAKOTA', 'flag_southdakota.png', 1),
(4, 'TENNESSEE', 'flag_tennessee.png', 1),
(4, 'TEXAS', 'flag_texas.png', 1),
(4, 'UTAH', 'flag_utah.png', 1),
(4, 'VERMONT', 'flag_vermont.png', 1),
(4, 'VIRGINIA', 'flag_virginia.png', 1),
(4, 'WASHINGTON', 'flag_washington.png', 1),
(4, 'WEST VIRGINIA', 'flag_westvirginia.png', 1),
(4, 'WISCONSIN', 'flag_wisconsin.png', 1),
(4, 'WYOMING', 'flag_wyoming.png', 1),
(4, 'MONTANA', 'flag_montana.png', 1),
(4, 'PUERTO RICO', 'flag_puertorico.png', 1),
(4, 'MICRONESIA', 'flag_micronesia.png', 1),
(4, 'MARSHALL ISLANDS', 'flag_marshallislands.png', 1),
(4, 'NORTHERN MARIANA ISLANDS', 'flag_nmislands.png', 1),
(4, 'AMERICAN SAMOA', 'flag_americansamoa.png', 1),
(4, 'PALAU', 'flag_palau.png', 1),
(4, 'GUAM', 'flag_guam.png', 1),
(4, 'VIRGIN ISLANDS', 'flag_virgin.png', 1),
(5, 'Avon', '', 1),
(5, 'Bedfordshire', '', 1),
(5, 'Berkshire', '', 1),
(5, 'Buckinghamshire', '',  1),
(5, 'Cambridgeshire', '', 1),
(5, 'Cheshire', '', 1),
(5, 'Cleveland', '', 1),
(5, 'Cornwall', '', 1),
(5, 'Cumbria', '', 1),
(5, 'Derbyshire', '', 1),
(5, 'Devon', '', 1),
(5, 'Dorset', '', 1),
(5, 'Durham', '', 1),
(5, 'Essex', '', 1),
(5, 'Gloucestershire', '', 1),
(5, 'Greater London', '', 1),
(5, 'Greater Manchester', '', 1),
(5, 'Hampshire', '', 1),
(5, 'Hereford & Worcestershire', '', 1),
(5, 'Hertfordshire', '', 1),
(5, 'Humberside', '', 1),
(5, 'Isle of Man', '', 1),
(5, 'Isle of Wight', '', 1),
(5, 'Kent', '', 1),
(5, 'Lancashire', '', 1),
(5, 'Leicestershire', '', 1),
(5, 'Lincolnshire', '', 1),
(5, 'Merseyside', '', 1),
(5, 'Norfolk', '', 1),
(5, 'Northamptonshire', '', 1),
(5, 'Northumberland', '', 1),
(5, 'Nottinghamshire', '', 1),
(5, 'Oxfordshire', '', 1),
(5, 'Shropshire', '', 1),
(5, 'Somerset', '', 1),
(5, 'Staffordshire', '', 1),
(5, 'Suffolk', '', 1),
(5, 'Surrey', '', 1),
(5, 'Sussex', '', 1),
(5, 'Warwickshire', '', 1),
(5, 'West Midlands', '', 1),
(5, 'Wiltshire', '', 1),
(5, 'Yorkshire', '', 1),
(6, 'Acre', '', 1),
(6, 'Alagoas', '', 1),
(6, 'Amazonas', '', 1),
(6, 'Amapa', '', 1),
(6, 'Baia', '', 1),
(6, 'Ceara', '', 1),
(6, 'Distrito Federal', '', 1),
(6, 'Espirito Santo', '', 1),
(6, 'Fernando de Noronha', '', 1),
(6, 'Goias', '', 1),
(6, 'Maranhao', '', 1),
(6, 'Minas Gerais', '', 1),
(6, 'Grosso do Sul', '', 1),
(6, 'Grosso', '', 1),
(6, 'Para', '', 1),
(6, 'Paraiba', '', 1),
(6, 'Pernambuco', '', 1),
(6, 'Piaui', '', 1),
(6, 'Parana', '', 1),
(6, 'Rio de Janeiro', '', 1),
(6, 'Rio Grande do Norte', '', 1),
(6, 'Rondonia', '', 1),
(6, 'Roraima', '', 1),
(6, 'Rio Grande do Sul', '', 1),
(6, 'Santa Catarina', '', 1),
(6, 'Sergipe', '', 1),
(6, 'Sao Paulo', '', 1),
(6, 'Tocatins', '', 1),
(7, 'Drente', '', 1),
(7, 'Flevoland', '', 1),
(7, 'Friesland', '', 1),
(7, 'Gelderland', '', 1),
(7, 'Groningen', '', 1),
(7, 'Limburg', '', 1),
(7, 'Noord Brabant', '', 1),
(7, 'Noord Holland', '', 1),
(7, 'Overijssel', '', 1),
(7, 'Utrecht', '', 1),
(7, 'Zuid Holland', '', 1),
(7, 'Zeeland', '', 1),
(8, 'Alberta', '', 1),
(8, 'Manitoba', '', 1),
(8, 'British Columbia', '', 1),
(8, 'New Brunswick', '', 1),
(8, 'New Foundland and Labrador', '', 1),
(8, 'Nova Scotia', '', 1),
(8, 'Northwest Territories', '', 1),
(8, 'Nunavut', '', 1),
(8, 'Ontario', '', 1),
(8, 'Prince Edward Island', '', 1),
(8, 'Quebec', '', 1),
(8, 'Saskatchewan', '', 1),
(8, 'Yukon Territory', '', 1),
(9, 'Australian Antarctic Territory', '', 1),
(9, 'Australian Capital Territory', '', 1),
(9, 'Northern Territory', '', 1),
(9, 'New South Wales', '', 1),
(9, 'Queensland', '', 1),
(9, 'South Australia', '', 1),
(9, 'Tasmania', '', 1),
(9, 'Victoria', '', 1),
(9, 'Western Australia', '', 1),
(10, 'County Antrim', '', 1),
(10, 'County Armagh', '', 1),
(10, 'County Down', '', 1),
(10, 'County Fermanagh', '', 1),
(10, 'County Londonderry', '', 1),
(10, 'County Tyrone', '', 1),
(10, 'County Cavan', '', 1),
(10, 'County Donegal', '', 1),
(10, 'County Monaghan', '', 1),
(10, 'County Dublin', '', 1),
(10, 'County Carlow', '', 1),
(10, 'County Kildare', '', 1),
(10, 'County Kilkenny', '', 1),
(10, 'County Laois', '', 1),
(10, 'County Longford', '', 1),
(10, 'County Louth', '', 1),
(10, 'County Meath', '', 1),
(10, 'County Offaly', '', 1),
(10, 'County Westmeath', '', 1),
(10, 'County Wexford', '', 1),
(10, 'County Wicklow', '', 1),
(10, 'County Galway', '', 1),
(10, 'County Mayo', '', 1),
(10, 'County Leitrim', '', 1),
(10, 'County Roscommon', '', 1),
(10, 'County Sligo', '', 1),
(10, 'County Clare', '', 1),
(10, 'County Cork', '', 1),
(10, 'County Kerry', '', 1),
(10, 'County Limerick', '', 1),
(10, 'County Tipperary', '', 1),
(10, 'County Waterford', '', 1),
(11, 'Andalucía', '', 1),
(11, 'Aragón', '', 1),
(11, 'Asturias', '', 1),
(11, 'Islas Baleares', '', 1),
(11, 'País Vasco', '', 1),
(11, 'Extremadura', '', 1),
(11, 'Galicia', '', 1),
(11, 'Islas Canarias', '', 1),
(11, 'Cantabria', '', 1),
(11, 'Castilla-La Mancha', '', 1),
(11, 'Castilla y León', '', 1),
(11, 'Cataluña', '', 1),
(11, 'La Rioja', '', 1),
(11, 'Madrid', '', 1),
(11, 'Región de Murcia', '', 1),
(11, 'Navarra', '', 1),
(11, 'Valencia', '', 1),
(11, 'Ceuta', '', 1),
(11, 'Melilla', '', 1);

--
-- Tabellenstruktur für Tabelle `ksads_reg_counties`
--
CREATE TABLE IF NOT EXISTS `#__ksads_reg_counties` (
  `cny_id` int(11) NOT NULL AUTO_INCREMENT,
  `fed_id` int(11) NOT NULL DEFAULT 0,
  `cnt_id` int(11) NOT NULL DEFAULT 0,  
  `ressource` varchar(128) NOT NULL,    
  `flag_img` varchar(128) NOT NULL DEFAULT '',
  `published` tinyint(1) NOT NULL DEFAULT 1,
  PRIMARY KEY (`cny_id`)
) DEFAULT CHARSET=utf8 COMMENT='stores county information';

--
-- Daten für Tabelle `ksads_counties`
--
INSERT INTO `#__ksads_reg_counties` ( `cnt_id`, `ressource`, `fed_id`, `published`) VALUES
(1, 'Aachen',6, 1),
(1, 'Ahrweiler',15, 1),
(1, 'Aichach-Friedberg',4, 1),
(1, 'Alb-Donau-Kreis', 5, 1),
(1, 'Altenburger Land', 14, 1),
(1, 'Altenkirchen Westerwald', 15, 1),
(1, 'Altmarkkreis Salzwedel', 10, 1),
(1, 'Altötting',4, 1),
(1, 'Alzey-Worms',15, 1),
(1, 'Amberg-Sulzbach',4, 1),
(1, 'Ammerland',13, 1),
(1, 'Anhalt-Bitterfeld',10, 1),
(1, 'Ansbach',4, 1),
(1, 'Aschaffenburg',4, 1),
(1, 'Augsburg',4, 1),
(1, 'Aurich',13, 1),
(1, 'Bad Doberan',7, 1),
(1, 'Bad Dürkheim',15, 1),
(1, 'Bad Kissingen',4, 1),
(1, 'Bad Kreuznach',15, 1),
(1, 'Bad Tölz-Wolfratshausen',4, 1),
(1, 'Bamberg',4, 1),
(1, 'Barnim',12, 1),
(1, 'Bautzen',9, 1),
(1, 'Bayreuth',4, 1),
(1, 'Berchtesgadener Land',4, 1),
(1, 'Bergstraße',8, 1),
(1, 'Bernkastel-Wittlich',15, 1),
(1, 'Biberach',5, 1),
(1, 'Birkenfeld',15, 1),
(1, 'Böblingen',5, 1),
(1, 'Bodenseekreis',5, 1),
(1, 'Börde',10, 1),
(1, 'Borken',6, 1),
(1, 'Breisgau-Hochschwarzwald',5, 1),
(1, 'Burgenlandkreis',10, 1),
(1, 'Calw',5, 1),
(1, 'Celle',13, 1),
(1, 'Cham',4, 1),
(1, 'Cloppenburg',13, 1),
(1, 'Coburg',4, 1),
(1, 'Cochem-Zell',15, 1),
(1, 'Coesfeld',6, 1),
(1, 'Cuxhaven',13, 1),
(1, 'Dachau',4, 1),
(1, 'Dahme-Spreewald',12, 1),
(1, 'Darmstadt-Dieburg',8, 1),
(1, 'Deggendorf',4, 1),
(1, 'Demmin',7, 1),
(1, 'Diepholz',13, 1),
(1, 'Dillingen a.d.Donau',4, 1),
(1, 'Dingolfing-Landau',4, 1),
(1, 'Dithmarschen',16, 1),
(1, 'Donau-Ries',4, 1),
(1, 'Donnersbergkreis',15, 1),
(1, 'Düren',6, 1),
(1, 'Ebersberg',4, 1),
(1, 'Eichsfeld',14, 1),
(1, 'Eichstätt',4, 1),
(1, 'Eifelkreis Bitburg-Prüm',15, 1),
(1, 'Elbe-Elster',12, 1),
(1, 'Emmendingen',5, 1),
(1, 'Emsland',13, 1),
(1, 'Ennepe-Ruhr-Kreis',6, 1),
(1, 'Enzkreis',5, 1),
(1, 'Erding',4, 1),
(1, 'Erlangen-Höchstadt',4, 1),
(1, 'Erzgebirgskreis',9, 1),
(1, 'Esslingen',5, 1),
(1, 'Euskirchen',6, 1),
(1, 'Forchheim',4, 1),
(1, 'Freising',4, 1),
(1, 'Freudenstadt',5, 1),
(1, 'Freyung-Grafenau',4, 1),
(1, 'Friesland',13, 1),
(1, 'Fulda',8, 1),
(1, 'Fürstenfeldbruck',4, 1),
(1, 'Fürth',4, 1),
(1, 'Garmisch-Partenkirchen',4, 1),
(1, 'Germersheim',15, 1),
(1, 'Gießen',8, 1),
(1, 'Gifhorn',13, 1),
(1, 'Göppingen',5, 1),
(1, 'Görlitz',9, 1),
(1, 'Goslar',13, 1),
(1, 'Gotha',14, 1),
(1, 'Göttingen',13, 1),
(1, 'Grafschaft Bentheim',13, 1),
(1, 'Greiz',14, 1),
(1, 'Groß-Gerau',8, 1),
(1, 'Günzburg',4, 1),
(1, 'Güstrow',7, 1),
(1, 'Gütersloh',6, 1),
(1, 'Hameln-Pyrmont',13, 1),
(1, 'Hannover Region',13, 1),
(1, 'Harburg',13, 1),
(1, 'Harz',10, 1),
(1, 'Haßberge',4, 1),
(1, 'Havelland',12, 1),
(1, 'Heidenheim',5, 1),
(1, 'Heilbronn',5, 1),
(1, 'Heinsberg',6, 1),
(1, 'Helmstedt',13, 1),
(1, 'Herford',6, 1),
(1, 'Hersfeld-Rotenburg',8, 1),
(1, 'Herzogtum Lauenburg',16, 1),
(1, 'Hildburghausen',14, 1),
(1, 'Hildesheim',13, 1),
(1, 'Hochsauerlandkreis',6, 1),
(1, 'Hochtaunuskreis',8, 1),
(1, 'Hof',4, 1),
(1, 'Hohenlohekreis',5, 1),
(1, 'Holzminden',13, 1),
(1, 'Höxter',6, 1),
(1, 'Ilm-Kreis',14, 1),
(1, 'Jerichower Land',10, 1),
(1, 'Kaiserslautern',15, 1),
(1, 'Karlsruhe',5, 1),
(1, 'Kassel',8, 1),
(1, 'Kelheim',4, 1),
(1, 'Kitzingen',4, 1),
(1, 'Kleve',6, 1),
(1, 'Konstanz',5, 1),
(1, 'Kronach',4, 1),
(1, 'Kulmbach',4, 1),
(1, 'Kusel',15, 1),
(1, 'Kyffhäuserkreis',14, 1),
(1, 'Lahn-Dill-Kreis',8, 1),
(1, 'Landsberg am Lech',4, 1),
(1, 'Landshut',4, 1),
(1, 'Leer',13, 1),
(1, 'Leipzig',9, 1),
(1, 'Lichtenfels',4, 1),
(1, 'Limburg-Weilburg',8, 1),
(1, 'Lindau Bodensee',4, 1),
(1, 'Lippe',6, 1),
(1, 'Lörrach',5, 1),
(1, 'Lüchow-Dannenberg',13, 1),
(1, 'Ludwigsburg',5, 1),
(1, 'Ludwigslust',7, 1),
(1, 'Lüneburg',13, 1),
(1, 'Main-Kinzig-Kreis',8, 1),
(1, 'Main-Spessart',4, 1),
(1, 'Main-Tauber-Kreis',5, 1),
(1, 'Main-Taunus-Kreis',8, 1),
(1, 'Mainz-Bingen',15, 1),
(1, 'Mansfeld-Südharz',10, 1),
(1, 'Marburg-Biedenkopf',8, 1),
(1, 'Märkischer Kreis',6, 1),
(1, 'Märkisch-Oderland',12, 1),
(1, 'Mayen-Koblenz',15, 1),
(1, 'Mecklenburg-Strelitz',7, 1),
(1, 'Meißen',9, 1),
(1, 'Merzig-Wadern',11, 1),
(1, 'Mettmann',6, 1),
(1, 'Miesbach',4, 1),
(1, 'Miltenberg',4, 1),
(1, 'Minden-Lübbecke',6, 1),
(1, 'Mittelsachsen',9, 1),
(1, 'Mühldorf a.Inn',4, 1),
(1, 'München',4, 1),
(1, 'Müritz',7, 1),
(1, 'Neckar-Odenwald-Kreis',5, 1),
(1, 'Neuburg-Schrobenhausen',4, 1),
(1, 'Neumarkt i.d.OPf.',4, 1),
(1, 'Neunkirchen',11, 1),
(1, 'Neustadt a.d.Aisch-Bad Windsheim',4, 1),
(1, 'Neustadt a.d.Waldnaab',4, 1),
(1, 'Neu-Ulm',4, 1),
(1, 'Neuwied',15, 1),
(1, 'Nienburg/Weser',13, 1),
(1, 'Nordfriesland',16, 1),
(1, 'Nordhausen',14, 1),
(1, 'Nordsachsen',9, 1),
(1, 'Nordvorpommern',7, 1),
(1, 'Nordwestmecklenburg',7, 1),
(1, 'Northeim',13, 1),
(1, 'Nürnberger Land',4, 1),
(1, 'Oberallgäu',4, 1),
(1, 'Oberbergischer Kreis',6, 1),
(1, 'Oberhavel',12, 1),
(1, 'Oberspreewald-Lausitz',12, 1),
(1, 'Odenwaldkreis',8, 1),
(1, 'Oder-Spree',12, 1),
(1, 'Offenbach',8, 1),
(1, 'Oldenburg',13, 1),
(1, 'Olpe',6, 1),
(1, 'Ortenaukreis',5, 1),
(1, 'Osnabrück',13, 1),
(1, 'Ostalbkreis',5, 1),
(1, 'Ostallgäu',4, 1),
(1, 'Osterholz',13, 1),
(1, 'Osterode am Harz',13, 1),
(1, 'Ostholstein',16, 1),
(1, 'Ostprignitz-Ruppin',12, 1),
(1, 'Ostvorpommern',7, 1),
(1, 'Paderborn',6, 1),
(1, 'Parchim',7, 1),
(1, 'Passau',4, 1),
(1, 'Peine',13, 1),
(1, 'Pfaffenhofen a.d.Ilm',4, 1),
(1, 'Pinneberg',16, 1),
(1, 'Plön',16, 1),
(1, 'Potsdam-Mittelmark',12, 1),
(1, 'Prignitz',12, 1),
(1, 'Rastatt',5, 1),
(1, 'Ravensburg',5, 1),
(1, 'Recklinghausen',6, 1),
(1, 'Regen',4, 1),
(1, 'Regensburg',4, 1),
(1, 'Rems-Murr-Kreis',5, 1),
(1, 'Rendsburg-Eckernförde',16, 1),
(1, 'Reutlingen',5, 1),
(1, 'Rhein-Erft-Kreis',6, 1),
(1, 'Rheingau-Taunus-Kreis',8, 1),
(1, 'Rhein-Hunsrück-Kreis',15, 1),
(1, 'Rheinisch-Bergischer Kreis',6, 1),
(1, 'Rhein-Kreis Neuss',6, 1),
(1, 'Rhein-Lahn-Kreis',15, 1),
(1, 'Rhein-Neckar-Kreis',5, 1),
(1, 'Rhein-Pfalz-Kreis',15, 1),
(1, 'Rhein-Sieg-Kreis',6, 1),
(1, 'Rhön-Grabfeld',4, 1),
(1, 'Rosenheim',4, 1),
(1, 'Rotenburg',13, 1),
(1, 'Roth',4, 1),
(1, 'Rottal-Inn',4, 1),
(1, 'Rottweil',5, 1),
(1, 'Rügen',7, 1),
(1, 'Saale-Holzland-Kreis',14, 1),
(1, 'Saalekreis',10, 1),
(1, 'Saale-Orla-Kreis',14, 1),
(1, 'Saalfeld-Rudolstadt',14, 1),
(1, 'Saarbrücken Regionalverband',11, 1),
(1, 'Saarlouis',11, 1),
(1, 'Saarpfalz-Kreis',11, 1),
(1, 'Sächsische Schweiz-Osterzgebirge',9, 1),
(1, 'Salzlandkreis',10, 1),
(1, 'St. Wendel',11, 1),
(1, 'Schaumburg',13, 1),
(1, 'Schleswig-Flensburg',16, 1),
(1, 'Schmalkalden-Meiningen',14, 1),
(1, 'Schwäbisch Hall',5, 1),
(1, 'Schwalm-Eder-Kreis',8, 1),
(1, 'Schwandorf',4, 1),
(1, 'Schwarzwald-Baar-Kreis',5, 1),
(1, 'Schweinfurt',4, 1),
(1, 'Segeberg',16, 1),
(1, 'Siegen-Wittgenstein',6, 1),
(1, 'Sigmaringen',5, 1),
(1, 'Soest',6, 1),
(1, 'Soltau-Fallingbostel',13, 1),
(1, 'Sömmerda',14, 1),
(1, 'Sonneberg',14, 1),
(1, 'Spree-Neiße',12, 1),
(1, 'Stade',13, 1),
(1, 'Starnberg',4, 1),
(1, 'Steinburg',16, 1),
(1, 'Steinfurt',6, 1),
(1, 'Stendal',10, 1),
(1, 'Stormarn',16, 1),
(1, 'Straubing-Bogen',4, 1),
(1, 'Südliche Weinstraße',15, 1),
(1, 'Südwestpfalz',15, 1),
(1, 'Teltow-Fläming',12, 1),
(1, 'Tirschenreuth',4, 1),
(1, 'Traunstein',4, 1),
(1, 'Trier-Saarburg',15, 1),
(1, 'Tübingen',5, 1),
(1, 'Tuttlingen',5, 1),
(1, 'Uckermark',12, 1),
(1, 'Uecker-Randow',7, 1),
(1, 'Uelzen',13, 1),
(1, 'Unna',6, 1),
(1, 'Unstrut-Hainich-Kreis',14, 1),
(1, 'Unterallgäu',4, 1),
(1, 'Vechta',13, 1),
(1, 'Verden',13, 1),
(1, 'Viersen',6, 1),
(1, 'Vogelsbergkreis',8, 1),
(1, 'Vogtlandkreis',9, 1),
(1, 'Vulkaneifel',15, 1),
(1, 'Waldeck-Frankenberg',8, 1),
(1, 'Waldshut',5, 1),
(1, 'Warendorf',6, 1),
(1, 'Wartburgkreis',14, 1),
(1, 'Weilheim-Schongau',4, 1),
(1, 'Weimarer Land',14, 1),
(1, 'Weißenburg-Gunzenhausen',4, 1),
(1, 'Werra-Meißner-Kreis',8, 1),
(1, 'Wesel',6, 1),
(1, 'Wesermarsch',13, 1),
(1, 'Westerwaldkreis',15, 1),
(1, 'Wetteraukreis',8, 1),
(1, 'Wittenberg',10, 1),
(1, 'Wittmund',13, 1),
(1, 'Wolfenbüttel',13, 1),
(1, 'Wunsiedel im Fichtelgebirge',4, 1),
(1, 'Würzburg',4, 1),
(1, 'Zollernalbkreis',5, 1),
(1, 'Zwickau',9, 1),
(1, 'Stadt Aachen',6, 1),
(1, 'Stadt Amberg',4, 1),
(1, 'Stadt Ansbach',4, 1),
(1, 'Stadt Aschaffenburg',4, 1),
(1, 'Stadt Augsburg',4, 1),
(1, 'Stadt Baden-Baden',5, 1),
(1, 'Stadt Bamberg',4, 1),
(1, 'Stadt Bayreuth',4, 1),
(1, 'Stadt Berlin',1, 1),
(1, 'Stadt Bielefeld',6, 1),
(1, 'Stadt Bochum',6, 1),
(1, 'Stadt Bonn',6, 1),
(1, 'Stadt Bottrop',6, 1),
(1, 'Stadt Brandenburg an der Havel',12, 1),
(1, 'Stadt Braunschweig',13, 1),
(1, 'Stadt Bremen',3, 1),
(1, 'Stadt Bremerhaven',3, 1),
(1, 'Stadt Chemnitz',9, 1),
(1, 'Stadt Coburg',4, 1),
(1, 'Stadt Cottbus',12, 1),
(1, 'Stadt Darmstadt',8, 1),
(1, 'Stadt Delmenhorst',13, 1),
(1, 'Stadt Dessau',10, 1),
(1, 'Stadt Dortmund',6, 1),
(1, 'Stadt Dresden',9, 1),
(1, 'Stadt Duisburg',6, 1),
(1, 'Stadt Düsseldorf',6, 1),
(1, 'Stadt Eisenach',14, 1),
(1, 'Stadt Emden',13, 1),
(1, 'Stadt Erfurt',14, 1),
(1, 'Stadt Erlangen',4, 1),
(1, 'Stadt Essen',6, 1),
(1, 'Stadt Flensburg',16, 1),
(1, 'Stadt Frankenthal Pfalz',15, 1),
(1, 'Stadt Frankfurt Oder',12, 1),
(1, 'Stadt Frankfurt am Main',8, 1),
(1, 'Stadt Freiburg im Breisgau',5, 1),
(1, 'Stadt Fürth',4, 1),
(1, 'Stadt Gelsenkirchen',6, 1),
(1, 'Stadt Gera',14, 1),
(1, 'Stadt Greifswald',7, 1),
(1, 'Stadt Göttingen',13, 1),
(1, 'Stadt Hagen',6, 1),
(1, 'Stadt Halle Saale',10, 1),
(1, 'Stadt Hamburg',2, 1),
(1, 'Stadt Hamm',6, 1),
(1, 'Stadt Hannover',13, 1),
(1, 'Stadt Heidelberg',5, 1),
(1, 'Stadt Heilbronn',5, 1),
(1, 'Stadt Herne',6, 1),
(1, 'Stadt Hof',4, 1),
(1, 'Stadt Ingolstadt',4, 1),
(1, 'Stadt Jena',14, 1),
(1, 'Stadt Kaiserslautern',15, 1),
(1, 'Stadt Karlsruhe',5, 1),
(1, 'Stadt Kassel',8, 1),
(1, 'Stadt Kaufbeuren',4, 1),
(1, 'Stadt Kempten Allgäu',4, 1),
(1, 'Stadt Kiel',16, 1),
(1, 'Stadt Koblenz',15, 1),
(1, 'Stadt Krefeld',6, 1),
(1, 'Stadt Köln',6, 1),
(1, 'Stadt Landau in der Pfalz',15, 1),
(1, 'Stadt Landshut',4, 1),
(1, 'Stadt Leipzig',9, 1),
(1, 'Stadt Leverkusen',6, 1),
(1, 'Stadt Ludwigshafen am Rhein',15, 1),
(1, 'Stadt Lübeck',16, 1),
(1, 'Stadt Magdeburg',10, 1),
(1, 'Stadt Mainz',15, 1),
(1, 'Stadt Mannheim',5, 1),
(1, 'Stadt Memmingen',4, 1),
(1, 'Stadt Mönchengladbach',6, 1),
(1, 'Stadt Mülheim an der Ruhr',6, 1),
(1, 'Stadt München',4, 1),
(1, 'Stadt Münster Westfalen',6, 1),
(1, 'Stadt Neubrandenburg',7, 1),
(1, 'Stadt Neumünster',16, 1),
(1, 'Stadt Neustadt an der Weinstraße',15, 1),
(1, 'Stadt Nürnberg',4, 1),
(1, 'Stadt Oberhausen',6, 1),
(1, 'Stadt Offenbach am Main',8, 1),
(1, 'Stadt Oldenburg',13, 1),
(1, 'Stadt Osnabrück',13, 1),
(1, 'Stadt Passau',4, 1),
(1, 'Stadt Pforzheim',5, 1),
(1, 'Stadt Pirmasens',15, 1),
(1, 'Stadt Potsdam',12, 1),
(1, 'Stadt Regensburg',4, 1),
(1, 'Stadt Remscheid',6, 1),
(1, 'Stadt Rosenheim',4, 1),
(1, 'Stadt Rostock',7, 1),
(1, 'Stadt Salzgitter',13, 1),
(1, 'Stadt Schwabach',4, 1),
(1, 'Stadt Schweinfurt',4, 1),
(1, 'Stadt Schwerin',7, 1),
(1, 'Stadt Solingen',6, 1),
(1, 'Stadt Speyer',15, 1),
(1, 'Stadt Stralsund',7, 1),
(1, 'Stadt Straubing',4, 1),
(1, 'Stadt Stuttgart',5, 1),
(1, 'Stadt Suhl',14, 1),
(1, 'Stadt Trier',15, 1),
(1, 'Stadt Ulm',5, 1),
(1, 'Stadt Weiden in der Oberpfalz',4, 1),
(1, 'Stadt Weimar',14, 1),
(1, 'Stadt Wiesbaden',8, 1),
(1, 'Stadt Wilhelmshaven',13, 1),
(1, 'Stadt Wismar',7, 1),
(1, 'Stadt Wolfsburg',13, 1),
(1, 'Stadt Worms',15, 1),
(1, 'Stadt Wuppertal',6, 1),
(1, 'Stadt Würzburg',4, 1),
(1, 'Stadt Zweibrücken',15, 1);

--
-- Tabellenstruktur für Tabelle `ksads_selectitems`
--
CREATE TABLE IF NOT EXISTS `#__ksads_selectitems` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sid` smallint(3) NOT NULL default '0',  
  `name` varchar(128) NOT NULL DEFAULT '',
  `ressource` varchar(128) NOT NULL DEFAULT '',
  `published` tinyint(1) NOT NULL DEFAULT 1,
  PRIMARY KEY (`id`)
) DEFAULT CHARSET=utf8 COMMENT='stores information about select box items';
--
-- Daten für Tabelle `ksads_selectitems`
--
INSERT INTO `#__ksads_selectitems` (`sid`, `name`, `ressource`, `published`) VALUES
(0, 'delivery', 'None', 1),
(1, 'delivery', 'Pickup Only', 1),
(2, 'delivery', 'Delivery Only', 1),
(3, 'delivery', 'Pickup or Delivery', 1),
(0, 'country', 'Select Country', 1),
(1, 'country', 'GERMANY',  1),
(2, 'country', 'AUSTRIA', 0),
(3, 'country', 'SWITZERLAND',  0),
(4, 'country', 'USA', 0),
(5, 'country', 'ENGLAND',  0),
(6, 'country', 'BRAZIL', 0),
(7, 'country', 'NETHERLANDS', 0),
(8, 'country', 'CANADA', 0),
(9, 'country', 'AUSTRALIA',  0),
(10, 'country', 'IRELAND', 0),
(11, 'country', 'SPAIN', 0),
(0, 'adstate', 'None', 1),
(1, 'adstate', 'For Sale', 1),
(2, 'adstate', 'Wanted', 1),
(3, 'adstate', 'For Hire', 1),
(4, 'adstate', 'Hire Request', 1),
(5, 'adstate', 'Offer', 1),
(6, 'adstate', 'Contact', 1),
(7, 'adstate', 'Give Away', 1),
(8, 'adstate', 'To Share', 1),
(9, 'adstate', 'Share Request', 1),
(10, 'adstate', 'Donate', 1),
(11, 'adstate', 'Sponsoring', 1),
(12, 'adstate', 'For Charter', 1),
(13, 'adstate', 'Charter Request', 1),
(14, 'adstate', 'Obituary Notice', 1),
(15, 'adstate', 'Personal Notice', 1),
(0, 'videoprovider', 'None', 1),
(1, 'videoprovider', 'YouTube', 1),
(2, 'videoprovider', 'Google', 1),
(3, 'videoprovider', '123Video', 0),
(4, 'videoprovider', 'Aniboom', 0),
(5, 'videoprovider', 'Badjojo', 0),
(6, 'videoprovider', 'Brightcove', 0),
(7, 'videoprovider', 'CollegeHumor', 0),
(8, 'videoprovider', 'Current', 0),
(9, 'videoprovider', 'Dailymotion', 0),
(10, 'videoprovider', 'Espn', 0),
(11, 'videoprovider', 'Flurl', 0),
(12, 'videoprovider', 'Funnyordie', 0),
(13, 'videoprovider', 'Gametrailers', 0),
(14, 'videoprovider', 'Dailymotion', 0),
(15, 'videoprovider', 'Godtube', 0),
(16, 'videoprovider', 'Gofish', 0),
(17, 'videoprovider', 'Guba', 0),
(18, 'videoprovider', 'Hook', 0),
(19, 'videoprovider', 'Jumpcut', 0),
(20, 'videoprovider', 'Kewego', 0),
(21, 'videoprovider', 'Krazyshow', 0),
(22, 'videoprovider', 'Ku6', 0),
(23, 'videoprovider', 'Liveleak', 0),
(24, 'videoprovider', 'Livevideo', 0),
(25, 'videoprovider', 'Metacafe', 0),
(26, 'videoprovider', 'Mofile', 0),
(27, 'videoprovider', 'Myspace', 0),
(28, 'videoprovider', 'Myvideo', 0),
(29, 'videoprovider', 'Redtube', 0),
(30, 'videoprovider', 'Revver', 0),
(31, 'videoprovider', 'Sapo', 0),
(32, 'videoprovider', 'Sevenload', 1),
(33, 'videoprovider', 'Sohu', 0),
(34, 'videoprovider', 'Southpark', 0),
(35, 'videoprovider', 'Spike', 0),
(36, 'videoprovider', 'Stickam', 0),
(37, 'videoprovider', 'Stupidvideos', 0),
(38, 'videoprovider', 'Ustream', 0),
(39, 'videoprovider', 'Veoh', 0),
(40, 'videoprovider', 'Videotube', 0),
(41, 'videoprovider', 'Vidiac', 0),
(42, 'videoprovider', 'Vimeo', 0),
(43, 'videoprovider', 'Yahoo', 0),
(44, 'videoprovider', 'Youare', 0),
(45, 'videoprovider', 'Youku', 0),
(46, 'videoprovider', 'Youmaker', 0),
(47, 'videoprovider', 'Own Video', 1);

--
-- Tabellenstruktur für Tabelle `ksads_currencies`
--

CREATE TABLE IF NOT EXISTS `#__ksads_currencies` (
  `id` int(11) NOT NULL auto_increment,
  `currency_name` varchar(64) default NULL,
  `currency_code` char(3) default NULL,
  PRIMARY KEY  (`id`),
  KEY `idx_currency_name` (`currency_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='stores information about currencies' AUTO_INCREMENT=160 ;

--
-- Daten für Tabelle `ksads_currencies`
--

INSERT INTO `#__ksads_currencies` (`id`, `currency_name`, `currency_code`) VALUES
(1, 'Andorran Peseta', 'ADP'),
(2, 'United Arab Emirates Dirham', 'AED'),
(3, 'Afghanistan Afghani', 'AFA'),
(4, 'Albanian Lek', 'ALL'),
(5, 'Netherlands Antillian Guilder', 'ANG'),
(6, 'Angolan Kwanza', 'AOK'),
(7, 'Argentine Peso', 'ARS'),
(9, 'Australian Dollar', 'AUD'),
(10, 'Aruban Florin', 'AWG'),
(11, 'Barbados Dollar', 'BBD'),
(12, 'Bangladeshi Taka', 'BDT'),
(14, 'Bulgarian Lev', 'BGL'),
(15, 'Bahraini Dinar', 'BHD'),
(16, 'Burundi Franc', 'BIF'),
(17, 'Bermudian Dollar', 'BMD'),
(18, 'Brunei Dollar', 'BND'),
(19, 'Bolivian Boliviano', 'BOB'),
(20, 'Brazilian Real', 'BRL'),
(21, 'Bahamian Dollar', 'BSD'),
(22, 'Bhutan Ngultrum', 'BTN'),
(23, 'Burma Kyat', 'BUK'),
(24, 'Botswanian Pula', 'BWP'),
(25, 'Belize Dollar', 'BZD'),
(26, 'Canadian Dollar', 'CAD'),
(27, 'Swiss Franc', 'CHF'),
(28, 'Chilean Unidades de Fomento', 'CLF'),
(29, 'Chilean Peso', 'CLP'),
(30, 'Yuan (Chinese) Renminbi', 'CNY'),
(31, 'Colombian Peso', 'COP'),
(32, 'Costa Rican Colon', 'CRC'),
(33, 'Czech Koruna', 'CZK'),
(34, 'Cuban Peso', 'CUP'),
(35, 'Cape Verde Escudo', 'CVE'),
(36, 'Cyprus Pound', 'CYP'),
(40, 'Danish Krone', 'DKK'),
(41, 'Dominican Peso', 'DOP'),
(42, 'Algerian Dinar', 'DZD'),
(43, 'Ecuador Sucre', 'ECS'),
(44, 'Egyptian Pound', 'EGP'),
(46, 'Ethiopian Birr', 'ETB'),
(47, 'Euro', 'EUR'),
(49, 'Fiji Dollar', 'FJD'),
(50, 'Falkland Islands Pound', 'FKP'),
(52, 'British Pound', 'GBP'),
(53, 'Ghanaian Cedi', 'GHC'),
(54, 'Gibraltar Pound', 'GIP'),
(55, 'Gambian Dalasi', 'GMD'),
(56, 'Guinea Franc', 'GNF'),
(58, 'Guatemalan Quetzal', 'GTQ'),
(59, 'Guinea-Bissau Peso', 'GWP'),
(60, 'Guyanan Dollar', 'GYD'),
(61, 'Hong Kong Dollar', 'HKD'),
(62, 'Honduran Lempira', 'HNL'),
(63, 'Haitian Gourde', 'HTG'),
(64, 'Hungarian Forint', 'HUF'),
(65, 'Indonesian Rupiah', 'IDR'),
(66, 'Irish Pound', 'IEP'),
(67, 'Israeli Shekel', 'ILS'),
(68, 'Indian Rupee', 'INR'),
(69, 'Iraqi Dinar', 'IQD'),
(70, 'Iranian Rial', 'IRR'),
(73, 'Jamaican Dollar', 'JMD'),
(74, 'Jordanian Dinar', 'JOD'),
(75, 'Japanese Yen', 'JPY'),
(76, 'Kenyan Schilling', 'KES'),
(77, 'Kampuchean (Cambodian) Riel', 'KHR'),
(78, 'Comoros Franc', 'KMF'),
(79, 'North Korean Won', 'KPW'),
(80, '(South) Korean Won', 'KRW'),
(81, 'Kuwaiti Dinar', 'KWD'),
(82, 'Cayman Islands Dollar', 'KYD'),
(83, 'Lao Kip', 'LAK'),
(84, 'Lebanese Pound', 'LBP'),
(85, 'Sri Lanka Rupee', 'LKR'),
(86, 'Liberian Dollar', 'LRD'),
(87, 'Lesotho Loti', 'LSL'),
(89, 'Libyan Dinar', 'LYD'),
(90, 'Moroccan Dirham', 'MAD'),
(91, 'Malagasy Franc', 'MGF'),
(92, 'Mongolian Tugrik', 'MNT'),
(93, 'Macau Pataca', 'MOP'),
(94, 'Mauritanian Ouguiya', 'MRO'),
(95, 'Maltese Lira', 'MTL'),
(96, 'Mauritius Rupee', 'MUR'),
(97, 'Maldive Rufiyaa', 'MVR'),
(98, 'Malawi Kwacha', 'MWK'),
(99, 'Mexican Peso', 'MXP'),
(100, 'Malaysian Ringgit', 'MYR'),
(101, 'Mozambique Metical', 'MZM'),
(102, 'Nigerian Naira', 'NGN'),
(103, 'Nicaraguan Cordoba', 'NIC'),
(105, 'Norwegian Kroner', 'NOK'),
(106, 'Nepalese Rupee', 'NPR'),
(107, 'New Zealand Dollar', 'NZD'),
(108, 'Omani Rial', 'OMR'),
(109, 'Panamanian Balboa', 'PAB'),
(110, 'Peruvian Nuevo Sol', 'PEN'),
(111, 'Papua New Guinea Kina', 'PGK'),
(112, 'Philippine Peso', 'PHP'),
(113, 'Pakistan Rupee', 'PKR'),
(114, 'Polish Złoty', 'PLN'),
(116, 'Paraguay Guarani', 'PYG'),
(117, 'Qatari Rial', 'QAR'),
(118, 'Romanian Leu', 'RON'),
(119, 'Rwanda Franc', 'RWF'),
(120, 'Saudi Arabian Riyal', 'SAR'),
(121, 'Solomon Islands Dollar', 'SBD'),
(122, 'Seychelles Rupee', 'SCR'),
(123, 'Sudanese Pound', 'SDP'),
(124, 'Swedish Krona', 'SEK'),
(125, 'Singapore Dollar', 'SGD'),
(126, 'St. Helena Pound', 'SHP'),
(127, 'Sierra Leone Leone', 'SLL'),
(128, 'Somali Schilling', 'SOS'),
(129, 'Suriname Guilder', 'SRG'),
(130, 'Sao Tome and Principe Dobra', 'STD'),
(131, 'Russian Ruble', 'RUB'),
(132, 'El Salvador Colon', 'SVC'),
(133, 'Syrian Potmd', 'SYP'),
(134, 'Swaziland Lilangeni', 'SZL'),
(135, 'Thai Bath', 'THB'),
(136, 'Tunisian Dinar', 'TND'),
(137, 'Tongan Pa`anga', 'TOP'),
(138, 'East Timor Escudo', 'TPE'),
(139, 'Turkish Lira', 'TRY'),
(140, 'Trinidad and Tobago Dollar', 'TTD'),
(141, 'Taiwan Dollar', 'TWD'),
(142, 'Tanzanian Schilling', 'TZS'),
(143, 'Uganda Shilling', 'UGS'),
(144, 'US Dollar', 'USD'),
(145, 'Uruguayan Peso', 'UYP'),
(146, 'Venezualan Bolivar', 'VEB'),
(147, 'Vietnamese Dong', 'VND'),
(148, 'Vanuatu Vatu', 'VUV'),
(149, 'Samoan Tala', 'WST'),
(150, 'Democratic Yemeni Dinar', 'YDD'),
(151, 'Yemeni Rial', 'YER'),
(152, 'New Yugoslavia Dinar', 'YUD'),
(153, 'South African Rand', 'ZAR'),
(154, 'Zambian Kwacha', 'ZMK'),
(155, 'Zaire Zaire', 'ZRZ'),
(156, 'Zimbabwe Dollar', 'ZWD'),
(157, 'Slovak Koruna', 'SKK'),
(158, 'Armenian Dram', 'AMD'),
(159, 'Working Hours', 'h'),
(160, 'Ukrainian Hrywnja', 'UAH'),
(161, 'Belarus Rubel', 'BYR'),
(162, 'Serbian Dinar', 'RSD'),
(163, 'Croatian Kuna', 'HKR')
;