<?php
/**
* KISS Advertiser Tab Class for handling the CB tab api
* @version $Id: cb.advertisertab.php 103 2010-03-15 14:41:46Z DocChicago $
* @package Community Builder
* @subpackage cb.advertisertab.php
* @author DocChicago
* @copyright (C) DocChicago, www.kiss-software.de
* @license http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL version 2
*/

// ensure this file is being included by a parent file
if ( ! ( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) { die( 'Direct Access to this location is not allowed.' ); }

JHTML::_('behavior.modal');
class getAdvertiserTab extends cbTabHandler {
	
	function getAdvertiserTab() {
		$this->cbTabHandler();
	}
	
	function getDisplayTab($tab,$user,$ui) {
		global $_CB_framework, $_CB_database, $mainframe, $option;
		$rowItemid = JRequest::getInt('Itemid', 0);	
		if ($rowItemid) {
			$linkItemid = "&Itemid=$rowItemid";
			} else {
			$linkItemid = "";
			}
		$document = & JFactory::getDocument();			
		$document->addScriptDeclaration("function askcb_confirm(func) {
			  if (func=='delete') {
			     return confirm('".JText::_("UE_CONFIRMDELETE")."');
			     } 
			}");

		$lang = JFactory::getLanguage();
		$lang->load('plg_cbksadvertisertab');

		$db	=& JFactory::getDBO();
		$jVer		=	checkJversion();
		$width		= 	100;    
		$showHits	=	$_CB_framework->getCfg( 'hits' );
		$return		=	'';
		
		$today = date("Y-m-d H:i:s");
		$query = "SELECT * FROM #__ksads_config WHERE id = 1";
		$db->setQuery( $query );
		$conf = $db->loadObject($query);

		$query = "SELECT * FROM #__ksads_ads WHERE date_expiry > '" . $today ."'"
				." AND published = '1'"
				." AND user_id = " . $user->id
				." ORDER BY catid ASC, ad_name";

		$db->setQuery( $query );
		$items = $db->loadObjectList();
		if(!count($items)>0) {
			$return .= "<br /><br /><div class=\"cbNoArticles\" style=\"text-align:left;width:95%;\">";
			$return .= JText::_('UE_NOADS');
			$return .= "</div>";
			return $return;
		}

		$return .= $this->_writeTabDescription( $tab, $user );
		
		$return .= "<table cellpadding=\"5\" cellspacing=\"0\" border=\"0\" width=\"95%\">";
		$return .= "<tr class=\"sectiontableheader\">";
		$return .= "<th>".JText::_('UE_AD_IMAGE')."</th>";
		$return .= "<th>".JText::_('UE_AD_TITLE')."</th>";
		$return .= "<th>".JText::_('UE_AD_DATE')."</th>";
		if( $showHits ) $return .= "<th>".JText::_('UE_AD_HITS')."</th>";

		$return .= "</tr>";
		$i=1;
		$hits="";

		foreach($items AS $item) {
		  $return .= "<tr><td align=\"left\">";
			$img_base = basename($item->ad_image);
		  $imagename = JPATH_ROOT.DS."images".DS.$conf->ad_img_dir.DS."U".$item->user_id.DS.$img_base;
				  if (file_exists($imagename)) {
				    $imagedata = getimagesize($imagename);
				    $width1 = $imagedata[0];
				    $height1 = $imagedata[1];
				    $filename = str_replace(JPATH_ROOT.DS, '', $imagename);
				    $return .= "<a class=\"modal\" href='$filename' rel=\"{handler: 'iframe', size: {x: $width1, y: $height1}}\">";
				    $return .= "<img name=\"compimg\" title=\"".JText::_( 'Label Showimage Origsize' )."\" id=\"compimg\" width=\"$width\" src=\"$filename\" border=\"0\" valign=\"top\">";
				    $return .= "</a>";
				    }
					/* Show some links for own ads of user */
					if ($item->user_id > 0) {
						$linkdel = JFilterOutput::ampReplace('index.php?option=com_ksadvertiser' . $linkItemid . '&task=remove&cid[]=' . $item->id . '&retr=1&catid='.$item->catid);
						$linkedt = JFilterOutput::ampReplace('index.php?option=com_ksadvertiser' . $linkItemid . '&catid='.$item->catid.'&task=edit&cid[]=' . $item->id);
						$return .= '<br /><a href="' . $linkedt . '"><img src="components'.DS.'com_ksadvertiser'.DS.'images'.DS.'icon-16-organizer.png" border="0" title="'.JText::_('Edit Ad').'"/></a>&nbsp;';
						//Show delete link if user belongs to a group allowed to delete
						if ($user_gid >= $conf->access_delete) {
							$return .= '&nbsp;<a onclick="return askcb_confirm(\'delete\')" href="' . $linkdel . '"><img src="components'.DS.'com_ksadvertiser'.DS.'images'.DS.'icon-16-trash.png" border="0" title="'.JText::_('Delete').'" /></a>&nbsp;';
							}
						}					 					
		  $url	=cbSef( 'index.php?option=com_ksadvertiser&amp;task=viewad&amp;id=' . $item->id );
		  $return .="</td>"
			  ."<td align=\"left\"><a href=\"$url\">".$item->ad_name."</a></td>"
			  ."<td align=\"right\">".cbFormatDate( $item->date_created )."</td>";
			  if( $showHits ) $return .= "<td align=\"right\">".$item->views."</td>";
		  $return .="</tr>";	  
		  } // end foreach $items as $item
		$return .= "</table>";

		return $return;
	}
}	// end class getAdvertiserTab.
?>