<?php
/**
* @author Guillermo Vargas, http://joomla.vargas.co.cr
* @email guille@vargas.co.cr
* @version $Id: com_remository.php 126 2008-08-04 16:11:59Z root $
* @package Xmap
* @license GNU/GPL
* @description Xmap plugin for Remository component
*/

defined( '_JEXEC' ) or die( 'Restricted access.' );

class xmap_com_ksadvertiser {

	function getTree( &$xmap, &$parent, &$params) {
		if ( strpos($parent->link, 'func=fileinfo') ) {
			return $list;	
		}

		$link_query = parse_url( $parent->link );
                parse_str( html_entity_decode($link_query['query']), $link_vars );
                $catid = JArrayHelper::getValue($link_vars,'id',0);

		$include_files = JArrayHelper::getValue( $params, 'include_files',1,'' );
		$include_files = ( $include_files == 1
                                  || ( $include_files == 2 && $xmap->view == 'xml') 
                                  || ( $include_files == 3 && $xmap->view == 'html'));
		$params['include_files'] = $include_files;

		$priority = JArrayHelper::getValue($params,'cat_priority',$parent->priority,'');
		$changefreq = JArrayHelper::getValue($params,'cat_changefreq',$parent->changefreq,'');
		if ($priority  == '-1')
			$priority = $parent->priority;
		if ($changefreq  == '-1')
			$changefreq = $parent->changefreq;

		$params['cat_priority'] = $priority;
		$params['cat_changefreq'] = $changefreq;

		$priority = JArrayHelper::getValue($params,'file_priority',$parent->priority,'');
		$changefreq = JArrayHelper::getValue($params,'file_changefreq',$parent->changefreq,'');
		if ($priority  == '-1')
			$priority = $parent->priority;

		if ($changefreq  == '-1')
			$changefreq = $parent->changefreq;

		$params['file_priority'] = $priority;
		$params['file_changefreq'] = $changefreq;

		if ( $include_files ) {
			$params['limit'] = '';
			$params['days'] = '';
			$limit = JArrayHelper::getValue($params,'max_files','','');

			if ( intval($limit) )
				$params['limit'] = ' LIMIT '.$limit;

			$days = JArrayHelper::getValue($params,'max_age','','');
			if ( intval($days) )
				$params['days'] = ' AND filedate >= \''.date('Y-m-d H:m:s', ($xmap->now - ($days*86400)) ) ."' ";
		}

		xmap_com_ksadvertiser::getKSAdvertiserTree( $xmap, $parent, $params, $catid );
	}

	function getKSAdvertiserTree ( &$xmap, &$parent, &$params, &$catid ) {
		$db = JFactory::getDBO();
		$user		=& JFactory::getUser();
		$usertype	= $user->get ( 'usertype' );
		$userID		= $user->get ( 'id' );
		$userGroup	= $user->get ( 'gid' );
		$userAID	= $user->get( 'aid' );

		$db->setQuery("select id, pid, cat_name from #__ksads_cats where pid=$catid and published = '1' and showinmodule = '1' AND (aid = $userAID or aid = 0) AND (gid <= $userGroup or gid = 0) order by cat_name");
		$cats = $db->loadObjectList();
		$xmap->changeLevel(1);
		foreach($cats as $cat) {
			$node = new stdclass;
			$node->id   = $parent->id;
			$node->uid  = $parent->uid .'d'.$file->id;			
			$node->pid  = $cat->pid;
			$node->name = $cat->cat_name ? $cat->cat_name : $cat->cat_desc;
			$node->priority   = $params['cat_priority'];
			$node->changefreq = $params['cat_changefreq'];
			$node->link = 'index.php?option=com_ksadvertiser&amp;func=view&amp;catid='.$cat->id;
			$node->tree = array();

			if ($xmap->printNode($node) !== FALSE) {
				xmap_com_ksadvertiser::getKSAdvertiserTree($xmap, $parent, $params, $cat->id);
			}
		}

		if ($params['include_files']) {
			$db->setQuery ("select id, ad_name, ad_intro from #__ksads_ads where catid=$catid and published = '1' and showinmodule = '1' ".$params['days']." order by ad_name" . $params['limit']);

			$files = $db->loadObjectList();
			foreach($files as $file) {
				$node = new stdclass;
				$node->id   = $parent->id;
				$node->uid  = $parent->uid .'d'.$file->id;
				$node->name = ($file->ad_name ? $file->ad_name : $file->ad_intro);
				$node->link = 'index.php?option=com_ksadvertiser&amp;func=viewad&amp;id='.$file->id;
				$node->priority   = $params['file_priority'];
				$node->changefreq = $params['file_changefreq'];
				$node->tree = array();
				$xmap->printNode($node);
			}
		}
		$xmap->changeLevel(-1);
	}

}