<?php
/*----------------------------------------------------------------------------------------------
| Kiss Advertiser (com_ksadvertiser)						Version	1.5.62
|-----------------------------------------------------------------------------------------------
| Author: Heiner Klostermann (DocChicago) - KISS Software Germany				
| Copyright (c) 2010 by KISS Software, 59227 Ahlen (NRW), Germany				
|-----------------------------------------------------------------------------------------------
| License GNU/GPL 					http://www.gnu.org/copyleft/gpl.html
|-----------------------------------------------------------------------------------------------
|												
| This component is free software, distributed under the GNU / GPL License. You may use,	
| copy and redistribute it free of charge as long as it complies with the license terms.	
|												
| 
| For help and suggestions please visit our support forum at www.kiss-software.de
|
|-----------------------------------------------------------------------------------------------
| created 2010-01-01								updated	2011-09-02
|-----------------------------------------------------------------------------------------------*/

/**
 * KISS Helper Class for Components
 * 
 * @package    Joomla.KISS
 * @subpackage Components
 * @link http://www.kiss-software.de
 * @license		GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * KISS Helper
 *
 * @package    Joomla.KISS.KSContacts
 * @subpackage Components
 */
class KissHelper
{
	/**
	 * Error Message
	 * @var string
	 * @access private
	 */
	var $error = '';
	var $_sefFuncHtmlEnt;
	
	function userGroups()
	{
		//Build usergroups array
		$access = array (
		'0' => array('value' => '0', 'text' => JText::_('Public')), 
		'1' => array('value' => '18', 'text' => JText::_('Registered')),
		'2' => array('value' => '19', 'text' => JText::_('Authors')), 
		'3' => array('value' => '20', 'text' => JText::_('Editors')), 
		'4' => array('value' => '21', 'text' => JText::_('Publishers')), 
		'5' => array('value' => '23', 'text' => JText::_('Managers')), 
		'6' => array('value' => '24', 'text' => JText::_('Admins')),  
		);
		return $access;
	}

	function accessGroups()
	{
	      // User Access Groups, Initialize variables
	      $agroups = array();
	      $db	= & JFactory::getDBO();
	      $query = "SELECT id, name FROM #__groups";
	      $db->setQuery($query);
	      $agroups = array_merge($agroups, $db->loadObjectList());
	      return $agroups;
	}

	function currencies()
	{
		$db	= & JFactory::getDBO();
		$query = "SELECT id, currency_name FROM #__ksads_currencies ORDER by currency_name";				
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$currency[0] = array('value' => '0', 'text' => JText::_('None')); 
		foreach ($rows as $row) {
			 $currency[$row->id] = array('value' => $row->id, 'text' => $row->currency_name); 
			}
		return $currency;
	}

	function countries()
	{
		$db	= & JFactory::getDBO();
		$query = "SELECT cnt_id, ressource FROM #__ksads_reg_countries WHERE published = '1' ORDER by ressource";				
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$arr[0] = array('value' => '0', 'text' => JText::_('Select Country')); 
		foreach ($rows as $row) {
			 $arr[$row->cnt_id] = array('value' => $row->cnt_id, 'text' => JText::_($row->ressource)); 
			}
		return $arr;
	}

	function fedstates($country = 0)
	{
		$countryselect = ($country > 0) ? "AND f.cnt_id = '$country'": "";			
		$db	= & JFactory::getDBO();
		$query = "SELECT fed_id, f.cnt_id AS ctr, f.ressource AS statename FROM #__ksads_reg_fedstates as f 
					INNER JOIN #__ksads_selectitems AS c ON (f.cnt_id = c.sid) 
					WHERE f.published = '1' AND c.name='country' AND c.published = '1' 
					$countryselect ORDER by f.ressource";	
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$arr[0] = array('value' => '0', 'text' => JText::_('Select Fedstate')); 
		$arr[0]['country'] = '0';		
		foreach ($rows as $row) {
			 $arr[$row->fed_id] = array('value' => $row->fed_id, 'text' => JText::_($row->statename)); 
			 $arr[$row->fed_id]['country'] = $row->ctr; 			 
			}
		return $arr;
	}

	function counties($country=0, $fedstate=0, $stateinfo=0)
	{
		$db	= & JFactory::getDBO();
		$countryselect = ($country > 0) ? "AND f.cnt_id = '$country'": "";		
		$stateselect = ($fedstate > 0) ? "AND fed_id = '$fedstate'": "";
		$state = ($stateinfo > 0) ? ", fed_id" : ""; 
		$query = "SELECT cny_id, f.cnt_id AS ctr $state, f.ressource AS countyname FROM #__ksads_reg_counties as f 
					INNER JOIN #__ksads_selectitems AS c ON (f.cnt_id = c.sid) 
					WHERE f.published = '1' AND c.name='country' AND c.published = '1' 
					$countryselect $stateselect ORDER by f.ressource";		
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$arr[0] = array('value' => '0', 'text' => JText::_('Select County'));
		if ($stateinfo) {
		    $arr[0]['state'] = '0';
		    }
		foreach ($rows as $row) {
			 $arr[$row->cny_id] = array('value' => $row->cny_id, 'text' => JText::_($row->countyname)); 
			 if ($stateinfo) {
			      $arr[$row->cny_id]['state'] = $row->fed_id;
			      }
			}
		return $arr;
	}

	function models()
	{
		$db	= & JFactory::getDBO();
		$query = "SELECT id, model_name FROM #__ksads_models ORDER by model_name";				
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$models[0] = array('value' => '0', 'text' => JText::_('None')); 
		foreach ($rows as $row) {
			 $models[$row->id] = array('value' => $row->id, 'text' => $row->model_name); 
			}
		return $models;
	}

	function addresses()
	{
		$db	= & JFactory::getDBO();
		$query = "SELECT * FROM #__ksads_addresses ORDER by companyname";				
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$arr[0] = array('value' => '0', 'text' => JText::_('None')); 
		foreach ($rows as $row) {
			 $text = $this->decrypted($row->companyname) . " [" . $this->decrypted($row->personname) . "], ". $this->decrypted($row->postcode)." ".$this->decrypted($row->city); 
			 $arr[$row->id] = array('value' => $row->id, 'text' => trim(substr($text,0,80))); 
			}
		return $arr;
	}

	function extensions()
	{
		$db	= & JFactory::getDBO();
		$query = "SELECT id, ext_name FROM #__ksads_extensions ORDER by ext_name";				
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$extensions[0] = array('value' => '0', 'text' => JText::_('None')); 
		foreach ($rows as $row) {
			 $extensions[$row->id] = array('value' => $row->id, 'text' => JText::_('Extension'.$row->id)); 
			}
		return $extensions;
	}

	/*------------------------------------------------------------------
	selectitems:
	Returns an array with selectitems in order to create a select box
	Copyright (c) 2010 KISS-Software.de
	-------------------------------------------------------------------*/
	function selectitems($name = 'delivery', $pub = 0)
	{
		$arr = array();
		$db	= & JFactory::getDBO();
		$published = ($pub == 1) ? "AND published = '1'" : "";
		$query = "SELECT sid, ressource FROM #__ksads_selectitems WHERE name = '$name' ".$published." ORDER by sid";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$i = 0;
		foreach ($rows as $row) {
			 $arr[$i] = array('value' => $row->sid, 'text' => JText::_($row->ressource)); 
			 $i++;
			}
		return $arr;
	}

	/*------------------------------------------------------------------
	selectarray:
	Returns an array with all possible selectitems
	Copyright (c) 2010 KISS-Software.de
	-------------------------------------------------------------------*/
	function selectarray($name = NULL, $pub = 0)
	{
		$arr=array();
		$db	= & JFactory::getDBO();
		$filter_name = (isset($name)) ? " WHERE name = '$name'" :"";
		$published = ($pub == 1) ? " AND published = '1'" : "";
		$filter = $filter_name.$published;
		$query = "SELECT * FROM #__ksads_selectitems$filter ORDER by name, sid";
		$db->setQuery($query);
		$arr = array_merge($arr, $db->loadObjectList());
		return $arr;
	}

	function distances()
	{
	    $arr = array (
		'0' => array('value' => 0, 'text' => JText::_('Any')), 
		'1' => array('value' => 5, 'text' => JText::_('up to 5')), 
		'2' => array('value' => 10, 'text' => JText::_('up to 10')), 
		'3' => array('value' => 25, 'text' => JText::_('up to 25')),
		'4' => array('value' => 50, 'text' => JText::_('up to 50')),
		'5' => array('value' => 100, 'text' => JText::_('up to 100')),
		'6' => array('value' => 150, 'text' => JText::_('up to 150')),
		'7' => array('value' => 250, 'text' => JText::_('up to 250'))
		);
	    return $arr;
	}

	function distanceunits()
	{
	    $arr = array (
		'0' => array('value' => 0, 'text' => JText::_('None')), 
		'1' => array('value' => 1, 'text' => JText::_('Kilometers')), 
		'2' => array('value' => 2, 'text' => JText::_('Miles')) 
		);
		return $arr;
	}

	function affiliates()
	{
	    $arr = array (
		'0' => array('value' => 0, 'text' => JText::_('None')), 
		'1' => array('value' => 1, 'text' => JText::_('Public only')), 
		'2' => array('value' => 2, 'text' => JText::_('Public and Registered')) 
		);
		return $arr;
	}

	function payments()
	{
	    $ad_payment = array (
		'0' => array('value' => 0, 'text' => JText::_('None')), 
		'1' => array('value' => 1, 'text' => JText::_('Per Period')), 
		'2' => array('value' => 2, 'text' => JText::_('Per Views')) 
		);
		return $ad_payment;
	}

	function searchphrase()
	{
	      $options = array();
	      $options[] = JHTML::_('select.option', '1', JText::_('Phrase And'));
	      $options[] = JHTML::_('select.option', '2', JText::_('Phrase Or'));
	      $options[] = JHTML::_('select.option', '3', JText::_('Phrase Exact'));
	      return $options;
	}

	function searchordering()
	{
	      $options = array();
	      $options[] = JHTML::_('select.option', '1', JText::_('Newest first'));
	      $options[] = JHTML::_('select.option', '2', JText::_('Oldest first'));
	      $options[] = JHTML::_('select.option', '3', JText::_('Popular first'));
	      $options[] = JHTML::_('select.option', '4', JText::_('Alphabetical'));
	      $options[] = JHTML::_('select.option', '5', JText::_('By Category'));
	      $options[] = JHTML::_('select.option', '6', JText::_('By Price'));
	      $options[] = JHTML::_('select.option', '7', JText::_('By Postcode'));
		return $options;
	}

	function startpanels()
	{
	    $arr = array (
		'1' => array('value' => 1, 'text' => JText::_('Categories by name')), 
		'6' => array('value' => 6, 'text' => JText::_('Categories by date')),
		'7' => array('value' => 7, 'text' => JText::_('Categories by postcode')),
		'2' => array('value' => 2, 'text' => JText::_('All Ads Alpha')),
		'3' => array('value' => 3, 'text' => JText::_('All Ads Postcode')),
		'4' => array('value' => 4, 'text' => JText::_('All Ads Date')),
		'5' => array('value' => 5, 'text' => JText::_('Search')),
		);
		return $arr;
	}


	function boolean()
	{
	      $yesno = array (
		'0' => array('value' => '0', 'text' => JText::_('No')), 
		'1' => array('value' => '1', 'text' => JText::_('Yes')) 
	      );
	      return $yesno;
	}

	function payment() 
	{
	      $payment = array (
	      '0' => array('value' => '0', 'text' => JText::_('None')), 
	      '1' => array('value' => '1', 'text' => JText::_('Per Views')), 
	      '2' => array('value' => '2', 'text' => JText::_('Per Period'))
	      );
	      return $payment;
	}

	function menustyles() 
	{
	      $menustyles = array (
	      '0' => array('value' => '0', 'text' => JText::_('Above')), 
	      '1' => array('value' => '1', 'text' => JText::_('Below')), 
	      '2' => array('value' => '2', 'text' => JText::_('Both'))		  
	      );
	      return $menustyles;
	}

	function statstyles() 
	{
	      $menustyles = array (
	      '0' => array('value' => '0', 'text' => JText::_('None')), 
	      '1' => array('value' => '1', 'text' => JText::_('Above')), 
	      '2' => array('value' => '2', 'text' => JText::_('Below')), 
	      '3' => array('value' => '3', 'text' => JText::_('Both'))		  
	      );
	      return $menustyles;
	}

	function rsslist() 
	{
	      $menustyles = array (
	      '0' => array('value' => '0', 'text' => JText::_('None')), 
	      '1' => array('value' => '1', 'text' => JText::_('Category')), 
	      '2' => array('value' => '2', 'text' => JText::_('User')),
	      '3' => array('value' => '3', 'text' => JText::_('Both'))
	      );
	      return $menustyles;
	}

	function catlists() 
	{
	      $catlists = array (
	      '0' => array('value' => '1', 'text' => JText::_('Category per Row 1')), 
	      '1' => array('value' => '2', 'text' => JText::_('Category per Row 2')), 
	      '2' => array('value' => '3', 'text' => JText::_('Category per Row 3')),
	      '3' => array('value' => '4', 'text' => JText::_('Category per Row 4')),
	      '4' => array('value' => '5', 'text' => JText::_('Category without Subcategories')),
	      '5' => array('value' => '6', 'text' => JText::_('Category with ads in tabs'))		  		  		  
	      );
	      return $catlists;
	}

	function catlists_extension_text() 
	{
	      $arr = array (
	      '0' => array('value' => '1', 'text' => JText::_('Three column leftbound')), 
	      '1' => array('value' => '2', 'text' => JText::_('Three column leftright')), 
	      '2' => array('value' => '3', 'text' => JText::_('One column multiple lines')),
	      '3' => array('value' => '4', 'text' => JText::_('One column single line'))  
	      );
	      return $arr;
	}

	function adlists() 
	{
	      $arr = array (
	      '0' => array('value' => '1', 'text' => JText::_('Adlist Default')), 
	      '1' => array('value' => '2', 'text' => JText::_('Adlist Businesscard')),
	      '2' => array('value' => '3', 'text' => JText::_('Adlist Simple')),  
	      '3' => array('value' => '4', 'text' => JText::_('Adlist Number')),
	      '4' => array('value' => '5', 'text' => JText::_('Adlist Custom')),
	      );
	      return $arr;
	}

	function adstyles() 
	{
	      $arr = array (
	      '0' => array('value' => '1', 'text' => JText::_('Adstyle Default')), 
	      '1' => array('value' => '2', 'text' => JText::_('Adstyle Simple')), 
	      '2' => array('value' => '3', 'text' => JText::_('Adstyle Notabs')),
	      '3' => array('value' => '4', 'text' => JText::_('Adstyle Custom'))		    
	      );
	      return $arr;
	}

	function searchops_text()
	{
	      $ad_searchops = array (
		'0' => array('value' => 0, 'text' => JText::_('Any')), 
		'1' => array('value' => 1, 'text' => JText::_('Begins')), 
		'2' => array('value' => 2, 'text' => JText::_('Ends')), 
		'3' => array('value' => 3, 'text' => JText::_('Like')),
		'4' => array('value' => 4, 'text' => JText::_('Equal'))
		);
	      return $ad_searchops;
	}

	function searchops_numeric()
	{
	    $ad_searchops = array (
		'0' => array('value' => 0, 'text' => JText::_('Any')), 
		'1' => array('value' => 1, 'text' => JText::_('Begins')), 
		'2' => array('value' => 2, 'text' => JText::_('Ends')), 
		'3' => array('value' => 3, 'text' => JText::_('Like')),
		'4' => array('value' => 4, 'text' => JText::_('Equal')),
		'5' => array('value' => 5, 'text' => JText::_('Greater')),
		'6' => array('value' => 6, 'text' => JText::_('Smaller')),
		'7' => array('value' => 7, 'text' => JText::_('Between'))
		);
	    return $ad_searchops;
	}
	
	function behavior_image_click() 
	{
	      $arr = array (
	      '0' => array('value' => '0', 'text' => JText::_('None')), 
	      '1' => array('value' => '1', 'text' => JText::_('Label Showimage Origsize')), 
	      '2' => array('value' => '2', 'text' => JText::_('Ad Details'))
	      );
	      return $arr;
	}



	/*------------------------------------------------------------------
	editors:
	Returns an array with available editors
	Copyright (c) 2010 KISS-Software.de
	-------------------------------------------------------------------*/
	function editors()
	{
		$db	= & JFactory::getDBO();
		// compile list of available editors
		$query = 'SELECT element AS value, name AS text'
				.' FROM #__plugins'
				.' WHERE folder = "editors"'
				.' AND published = 1'
				.' ORDER BY ordering, name'
				;
		$db->setQuery($query);
		$edits = $db->loadObjectList();
		return $edits;
	}

	/*------------------------------------------------------------------
	articles:
	Returns an array with available articles from Joomla content
	Copyright (c) 2010 KISS-Software.de
	-------------------------------------------------------------------*/
	function articles()
	{

		$db		= & JFactory::getDBO();
		$nullDate	= $db->getNullDate();
		$date 		=& JFactory::getDate();
		$now 		= $date->toMySQL();

		$query = 'SELECT * FROM #__content WHERE (publish_up = '.$db->Quote($nullDate).' OR publish_up <= '.$db->Quote($now).' )'
			. ' AND ( publish_down = '.$db->Quote($nullDate).' OR publish_down >= '.$db->Quote($now).' )  ORDER by title';
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		$article[0] = array('value' => '0', 'text' => JText::_('None')); 
		foreach ($rows as $row) {
			 $article[$row->id] = array('value' => $row->id, 'text' => $row->title); 
			}
		return $article;
	}

	/*------------------------------------------------------------------
	userList:
	Makes an array of users
	Copyright (c) 2010 KISS-Software.de
	-------------------------------------------------------------------*/
	function userList($active = NULL)
	{
		// Initialize variables
		$users = array(
		  '0' => array('value' => '0', 'text' => JText::_('None'))
		);

		$db	= & JFactory::getDBO();
		// if not KISS Joomla Version, the user table does not contain a field named "firstname"
		if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
			$query = "SELECT id AS value, name AS text FROM #__users WHERE block = 0 ORDER by name";
			} else {
			$query = "SELECT id AS value, CONCAT_WS(', ', name, firstname) AS text FROM #__users WHERE block = 0 ORDER by name, firstname";
			}
		$db->setQuery($query);
		$users = array_merge($users, $db->loadObjectList());
		return $users;
	}

	/*------------------------------------------------------------------
	showUserSelect:
	Shows a select box of users
	Copyright (c) 2010 KISS-Software.de
	-------------------------------------------------------------------*/
	function showUserSelect($active = NULL, $fieldname = NULL, $onchange = NULL)
	{
		// Initialize variables
		$users = array();
		$users[] = JHTML::_('select.option', '0', '- '.JText::_('Select User').' -','id','name');
		$db	= & JFactory::getDBO();
		// if not KISS Joomla Version, the user table does not contain a field named "firstname"
		if (!file_exists(JPATH_ROOT.DS.'includes/kiss.php')) {
			$query = "SELECT id, name FROM #__users WHERE block = 0 ORDER by name";				
			} else {
			$query = "SELECT id, CONCAT_WS(', ', name, firstname) as name FROM #__users WHERE block = 0 ORDER by name, firstname";
			}

		$db->setQuery($query);
		$users = array_merge($users, $db->loadObjectList());
		$text = 'class="inputbox" size="1"';
		if (strlen($onchange) > 0) {
		    $text .= ' onchange="'.$onchange.'"';
		    }
		$groupselect = JHTML::_('select.genericlist',  $users, $fieldname, $text, 'id', 'name', $active);
		return $groupselect;
	}
	
	/*------------------------------------------------------------------
	BannercatList:
	Makes an array of banner categories
	Copyright (c) 2010 KISS-Software.de
	-------------------------------------------------------------------*/
	function BannercatList($active = NULL)
	{
		// Initialize variables
		$bannercats = array();
		$db	= & JFactory::getDBO();
		$query = "SELECT id as value, title as text FROM #__categories WHERE section = 'com_banner'";
		$agroups[] = JHTML::_('select.option', '0', '- '.JText::_('None').' -');
		$db->setQuery($query);
		$bannercats = array_merge($agroups, $db->loadObjectList());
		return $bannercats;
	}
	
	/*------------------------------------------------------------------
	topTenPrice:
	Makes an array of Top Ten Ads order by price
	Copyright (c) 2010 KISS-Software.de
	-------------------------------------------------------------------*/
	function topTenPrice($refprice = 0, $cur='EUR')
	{
		// Initialize variables
		$db	= & JFactory::getDBO();
		$query = "SELECT * FROM #__ksads_ads WHERE ad_price_pu > $refprice ORDER BY ad_price_pu DESC, id DESC LIMIT 10";
		$db->setQuery($query);
		$arr = array ();		
		if ($rows = $db->loadObjectList()) {
		  foreach($rows as $row) {
		  $i++;
		  $arr[] = JHTML::_('select.option', $row->ad_price_pu - $refprice + 1, $i.": ".$row->ad_name."  ".number_format($row->ad_price_pu - $refprice + 1, 2, ',', '.')." $cur<br />");		  
		  }	
		} else {
		  $arr[] = JHTML::_('select.option', 1, JText::_('Top Position')." # 1:  ".number_format(1, 2, ',', '.')." $cur<br />");		  
		}	
		return $arr;
	}

	/*------------------------------------------------------------------
	AGroupList:
	Makes an array of access groups
	Copyright (c) 2010 KISS-Software.de
	-------------------------------------------------------------------*/
	function AGroupList($active = NULL)
	{
		// Initialize variables
		$agroups = array();
		$db	= & JFactory::getDBO();
		$query = "SELECT id as value, name as text FROM #__groups";
		$db->setQuery($query);
		$agroups = array_merge($agroups, $db->loadObjectList());
		return $agroups;
	}

	/*------------------------------------------------------------------
	showAGroupSelect:
	Shows a select box of user access groups
	Copyright (c) 2010 KISS-Software.de
	-------------------------------------------------------------------*/
	function showAGroupSelect($active = NULL)
	{
		// Initialize variables
		$agroups = array();
		$db	= & JFactory::getDBO();
		$query = "SELECT id, name FROM #__groups";
		$agroups[] = JHTML::_('select.option', '0', '- '.JText::_('Select Access Group').' -');
		$db->setQuery($query);
		$agroups = array_merge($agroups, $db->loadObjectList());

		$groupselect = JHTML::_('select.genericlist',  $agroups, 'aid', 'class="inputbox" size="1"', 'id', 'name', $active);
		return $groupselect;
	}

	/*------------------------------------------------------------------
	encrypted:
	Encrypts an expression
	Copyright (c) 2010 KISS-Software.de
	-------------------------------------------------------------------*/
	function encrypted($value)
	{
	return strtr(base64_encode($value), '-_~', '+/=');
	}

	/*------------------------------------------------------------------
	decrypted:
	Decrypts an expression which was encrypted by the 'encrypted' function
	Copyright (c) 2010 KISS-Software.de
	-------------------------------------------------------------------*/
	function decrypted($value)
	{
	return base64_decode(strtr($value,  '+/=', '-_~'));
	}


	/*------------------------------------------------------------------
	canUpload:
	Checks whether a file can be uploaded or not
	Copyright (c) 2010 KISS-Software.de
	-------------------------------------------------------------------*/
	/**
	 * @param array File information
	 * @param string An error message to be returned
	 * @return boolean
	 */
	function canUpload($files)
	{
	$db	= & JFactory::getDBO();
	$query = "SELECT * FROM #__ksads_config WHERE id ='1'";
	$db->setQuery($query);
	$conf = $db->loadObject();
	$allowable = explode(',', strtolower($conf->upl_filetypes));
	$maxSize = (int) $conf->upl_filesize * 1024 * 1024;
      //Following functions not yet implemented
//	      $restrict = (int) $conf['restrict_uploads'];
//	      $upload_mime = $conf['upload_mime'];
//	      $illegal_mime = $conf['upload_mime_illegal'];
//	      $check_mime = $conf['check_mime'];
//	      $ignored = explode(',', $conf['ignore_extensions']);
	$check_mime = 0;
	$restrict = 0;
	$i=0;
	    foreach ($_FILES as $varname => $array) {
		if(empty($array['name'][$i])) {
			$this->error = JText::_('UPL Filename Empty');
			return false;
		}

		jimport('joomla.filesystem.file');
		if ($array['name'][$i] !== JFile::makesafe($array['name'][$i])) {
			$this->error = 'UPL Filename Invalid';
			return false;
		}
		$filename = $array['name'][$i];
		$format = strtolower(JFile::getExt($filename));

		if (!in_array($format, $allowable) )
			{
			$this->error = JText::_('UPL Filename not allowed');
			return false;
			}

		if ($maxSize > 0 && (int) $array['size'][$i] > $maxSize)
		{
			$this->error = JText::_('UPL File too large');
			return false;
		}

		$user = JFactory::getUser();
		$imginfo = null;
		if($restrict == 1) {
			$images = explode( ',', $params->get( 'image_extensions' ));
			if(in_array($format, $images)) { // if its an image run it through getimagesize
				if(($imginfo = getimagesize($array['tmp_name'][$i])) === FALSE) {
					$this->error = JText::_('UPL Image Type Invalid');
					return false;
				}
			} else if(!in_array($format, $ignored)) {
				// if its not an image...and we're not ignoring it
				if(function_exists('finfo_open') && $check_mime == 1) {
					// We have fileinfo
					$finfo = finfo_open(FILEINFO_MIME);
					$type = finfo_file($finfo, $array['tmp_name'][$i]);
					if(strlen($type) && !in_array($type, $allowed_mime) && in_array($type, $illegal_mime)) {
						$this->error = JText::_('UPL Mime Type Invalid');
						return false;
					}
					finfo_close($finfo);
				} else if(function_exists('mime_content_type') && $params->get('check_mime',1)) {
					// we have mime magic
					$type = mime_content_type($array['tmp_name'][$i]);
					if(strlen($type) && !in_array($type, $allowed_mime) && in_array($type, $illegal_mime)) {
						$this->error = JText::_('UPL Mime Content Type Invalid');
						return false;
					}
				} else if(!$user->authorize( 'login', 'administrator' )) {
					$this->error = JText::_('UPL Admins Only');
					return false;
				}
			}
		}

		$xss_check =  JFile::read($array['tmp_name'][$i],false,256);
		$html_tags = array('abbr','acronym','address','applet','area','audioscope','base','basefont','bdo','bgsound','big','blackface','blink','blockquote','body','bq','br','button','caption','center','cite','code','col','colgroup','comment','custom','dd','del','dfn','dir','div','dl','dt','em','embed','fieldset','fn','font','form','frame','frameset','h1','h2','h3','h4','h5','h6','head','hr','html','iframe','ilayer','img','input','ins','isindex','keygen','kbd','label','layer','legend','li','limittext','link','listing','map','marquee','menu','meta','multicol','nobr','noembed','noframes','noscript','nosmartquotes','object','ol','optgroup','option','param','plaintext','pre','rt','ruby','s','samp','script','select','server','shadow','sidebar','small','spacer','span','strike','strong','style','sub','sup','table','tbody','td','textarea','tfoot','th','thead','title','tr','tt','ul','var','wbr','xml','xmp','!DOCTYPE', '!--');
		foreach($html_tags as $tag) {
			// A tag is '<tagname ', so we need to add < and a space or '<tagname>'
			if(stristr($xss_check, '<'.$tag.' ') || stristr($xss_check, '<'.$tag.'>')) {
				$this->error = JText::_('UPL XSS Tags Invalid');
				return false;
			}
		}
		$i++;
	    }
		return true;
	}

	/*------------------------------------------------------------------
	Phonetic
	Changes a string to a phonetic expression (German language only)
	Copyright (c) 2010 KISS-Software.de
	-------------------------------------------------------------------*/
	function phonetic($word){
   
  	/**
  	* @param  string  $word string to be analyzed
  	* @return string  $value represents the German phonetics value
  	* @access public
  	*/
	//avoid complications if $word is empty
	if (strlen($word) < 1) {
	    return;
	    }
	//prepare for processing
	$word=strtolower($word);
	$substitution=array(
            "aa"=>"a",
            "ah"=>"a",
            "ai"=>"ei",
            "ar"=>"a",
            "äu"=>"eu",
            "ay"=>"ei",
            "c"=>"k",			
            "ck"=>"k",
            "cs"=>"tsch",
            "cx"=>"x",
            "cz"=>"tsch",
            "dt"=>"t",
            "dz"=>"z",
            "ee"=>"e",
            "eh"=>"e",
            "el"=>"l",
            "er"=>"a",
            "ey"=>"ei",
            "gk"=>"k",
            "ich"=>"ig",
            "ie"=>"i",
            "ih"=>"i",
            "kk"=>"k",
            "ks"=>"x",
            "kx"=>"x",
            "mm"=>"m",
            "nk"=>"ng",
            "nn"=>"n",
            "nt"=>"nd",
            "oh"=>"o",
            "oi"=>"eu",
            "oo"=>"o",
            "or"=>"a",
            "ou"=>"u",
            "pf"=>"f",
            "ph"=>"f",
            "qx"=>"x",
            "rt"=>"rd",
            "ß"=>"ss",
            "sz"=>"sch",
            "th"=>"t",
            "ti"=>"zi",
            "ts"=>"z",
            "tt"=>"t",
            "tz"=>"z",
            "uh"=>"u",
            "ur"=>"a",
            "uu"=>"u",
            "v"=>"f",
            "y"=>"i",
            "zz"=>"z",
	    "ä"=>"e",
	    "ö"=>"oe",
	    "ü"=>"ue",
            " "=>"_",
            "-"=>"_",
            "'"=>"_",
            "/"=>"_",
            "&"=>"_"
            );

	foreach ($substitution as $letter=>$substitute) {
	    $word=str_replace($letter,$substitute,$word);
	    }
   
	return $word;

	}


	function sdx($word){
   
  	/**
  	* @param  string  $word string to be analyzed
  	* @return string  $value represents the Kölner Phonetik value
  	* @access public
  	*/
	//avoid complications if $word is empty
	if (strlen($word) < 1) {
	    return;
	    }
	//prepare for processing
	$word=strtolower($word);
	$substitution=array(
            "ä"=>"a",
            "ü"=>"u",
            "ö"=>"o",
            "ß"=>"ss",
            "ph"=>"f"
            );

	foreach ($substitution as $letter=>$substitution) {
	$word=str_replace($letter,$substitution,$word);
	}
   
	$len=strlen($word);
   
	//Rule for exeptions
	$exceptionsLeading=array(
	4=>array("ca","ch","ck","cl","co","cq","cu","cx"),
	8=>array("dc","ds","dz","tc","ts","tz"),
	9=>array("cz","cs","tsch","sz")
	);
   
	$exceptionsFollowing=array("sc","zc","cx","kx","qx");
   
	//Table for coding
	$codingTable=array(
	0=>array("a","e","i","j","o","u","y"),
	1=>array("b","p"),
	2=>array("d","t"),
	3=>array("f","v","w"),
	4=>array("c","g","k","q"),
	48=>array("x"),
	5=>array("l"),
	6=>array("m","n"),
	7=>array("r"),
	8=>array("c","s","z"),
	9=>array("s"),
	);

	for ($i=0;$i<$len;$i++){
	$value[$i]="";

        //Exceptions
        if ($i==0 AND $word[$i].$word[$i+1]=="cr") $value[$i]=4;

        foreach ($exceptionsLeading as $code=>$letters) {
            if (in_array($word[$i].$word[$i+1],$letters)){

                    $value[$i]=$code;
		}
	}

        if ($i!=0 AND (in_array($word[$i-1].$word[$i], $exceptionsFollowing))) {

            $value[$i]=8;

	}

        //Normal encoding
        if ($value[$i]==""){
                foreach ($codingTable as $code=>$letters) {
                    if (in_array($word[$i],$letters))$value[$i]=$code;
                }
            }
        }

	//delete double values
	$len=count($value);

	for ($i=1;$i<$len;$i++){
		if ($value[$i]==$value[$i-1]) $value[$i]="";
	}

	//delete vocals
	for ($i=1;$i>$len;$i++){//omitting first characer code and h
		if ($value[$i]==0) $value[$i]="";
	}


	$value=array_filter($value);
	$value=implode("",$value);

	return $value;

	}

	/*------------------------------------------------------------------
	TreeSelectList:
	Shows a select box with items in tree form (indented)
	Copyright (c) 2009 KISS-Software.de
	-------------------------------------------------------------------*/
      function treeSelectList( $src_list, $src_id, $tgt_list, $tag_name, $tag_attribs, $key, $text, $selected, $base=0, $base_text='', $disable=1 )
       {
           // establish the hierarchy of the menu
           $children = array();
           // first pass - collect children
           foreach ($src_list as $v ) {
               $pt = $v->parent;
               $list = @$children[$pt] ? $children[$pt] : array();
               array_push( $list, $v );
               $children[$pt] = $list;
           }
           // second pass - get an indent list of the items
           $ilist = JHTML::_('menu.treerecurse', 0, '', array(), $children );

		   // make base option '- select item -' if set
		if ($base == 1){
		    $tgt_list[] = JHTML::_('select.option', 0, $base_text, $key );
		    }

	  // assemble menu items to the array
           $this_treename = '';
           foreach ($ilist as $item) {
		  $disabled = $item->active == 1 ? false : true;
		  if ($disabled == true && $disable == 0) {
		      $disabled = false;
		      }
               if ($this_treename) {
                   if ($item->id != $src_id && strpos( $item->treename, $this_treename ) === false) {
			  $tgt_list[] = JHTML::_('select.option', $item->id, $item->treename, 'value', 'text', $disabled );
                   }
               } else {
                   if ($item->id != $src_id) {
			  $tgt_list[] = JHTML::_('select.option', $item->id, $item->treename, 'value', 'text', $disabled );
                  } else {
                      $this_treename = "$item->treename/";
                  }
              }
          }
          // build the html select list
           return JHTML::_('select.genericlist', $tgt_list, $tag_name, $tag_attribs, $key, $text, $selected );
      }

	/*------------------------------------------------------------------
	ShowMediaFileList:
	Displays a select box with media files
	Copyright (c) 2011 KISS-Software.de
	-------------------------------------------------------------------*/
	function showMediaFileList($path = NULL, $target= NULL, $image = NULL, $id = NULL, $media = 0) 
	{
		global $mainframe;
		$live_site = &JURI::root();
		jimport('joomla.filesystem.folder');
		if (JFolder::exists(JPATH_ROOT.DS.$path)) {
			$files = JFolder::files(JPATH_ROOT.DS.$path);
			} else {
			return;
			}
		$options = array();
		$filearray = array();
		// Build the array of select options for the image file list
		$options[] = JHTML::_('select.option', '0','- '.JText::_('Select File').' -');
		foreach ($files as $file) {
			$folder 	= str_replace(JPATH_BASE, "", $file);
			switch ($media) {
			      case 0: // Images			
			      $value	= $live_site . $path . DS . $file;
			      break;
			      case 1: // Videos
			      $value	= $file;
			      break;
			      }
			$filearray[]	= $value;
			$text	 	= str_replace(DS, "/", $file);
			$options[] 	= JHTML::_('select.option', $value, $text);
		}

		// Sort the folder list array
		if (is_array($options)) {
			sort($options);
		}

		// Create the drop-down file select list
		switch ($media) {
		case 0: // Show images
		$list = JHTML::_('select.genericlist',  $options, $id, "class=\"inputbox\" size=\"1\" onchange=\"javascript:zeigeBild(this, '".$target."');\" ", 'value', 'text', $image);
		break;
	
		case 1: // Show video files
		$list = JHTML::_('select.genericlist',  $options, $id, "class=\"inputbox\" size=\"1\" ", 'value', 'text', $image);
		break;
		}
		return $list;
	}

	/*------------------------------------------------------------------
	smartCopy:
	copys files and directories recursively from source to destination
	Copyright (c) 2010 KISS-Software.de
	# source=file & dest=dir => copy file from source-dir to dest-dir
	# source=file & dest=file / not there yet => copy file from source-dir to dest and overwrite a file there, if present
	# source=dir & dest=dir => copy all content from source to dir
	# source=dir & dest not there yet => copy all content from source to a, yet to be created, dest-dir
	-------------------------------------------------------------------*/
    function smartCopy($source, $dest, $options=array('folderPermission'=>0755,'filePermission'=>0755))
    {
        $result=false;
		     
        if (is_file($source)) {
		if ($dest[strlen($dest)-1]=='/') {
                if (!file_exists($dest)) {
                    cmfcDirectory::makeAll($dest,$options['folderPermission'],true);
                }
                $__dest=$dest."/".basename($source);
            } else {
                $__dest=$dest;				
            }
            $result=copy($source, $__dest);
            chmod($__dest,$options['filePermission']);
           
        } elseif(is_dir($source)) {
		
            if ($dest[strlen($dest)-1]=='/') {
                if ($source[strlen($source)-1]=='/') {
                    //Copy only contents
                } else {
                    //Change parent itself and its contents
                    $dest=$dest.basename($source);
                    mkdir($dest);
                    chmod($dest,$options['filePermission']);
                }
            } else {
                if ($source[strlen($source)-1]=='/') {
                    //Copy parent directory with new name and all its content
                    mkdir($dest,$options['folderPermission']);
                    chmod($dest,$options['filePermission']);
                } else {
                    //Copy parent directory with new name and all its content
                    mkdir($dest,$options['folderPermission']);
                    chmod($dest,$options['filePermission']);
                }
            }

            $dirHandle=opendir($source);
            while($file=readdir($dirHandle))
            {
                if($file!="." && $file!="..")
                {
                     if(!is_dir($source.DS.$file)) {
                        $__dest=$dest.DS.$file;
                    } else {
                        $__dest=$dest.DS.$file;
                    }
                    $result=$this->smartCopy($source.DS.$file, $__dest, $options);
                }
            }
            closedir($dirHandle);
           
        } else {
            $result=false;
        }
        return $result;
    }
}