<?php
/*----------------------------------------------------------------------------------------------
| Kiss Advertiser (com_ksadvertiser)						Version	1.5.62
|-----------------------------------------------------------------------------------------------
| Author: Heiner Klostermann (DocChicago) - KISS Software Germany				
| Copyright (c) 2010 by KISS Software, 59227 Ahlen (NRW), Germany				
|-----------------------------------------------------------------------------------------------
| License GNU/GPL 					http://www.gnu.org/copyleft/gpl.html
|-----------------------------------------------------------------------------------------------
|												
| This component is free software, distributed under the GNU / GPL License. You may use,	
| copy and redistribute it free of charge as long as it complies with the license terms.	
|												
| 
| For help and suggestions please visit our support forum at www.kiss-software.de
|
|-----------------------------------------------------------------------------------------------
| created 2010-01-01							updated	2011-01-02
|-----------------------------------------------------------------------------------------------*/

	class kissTabs {
		      /** @var int Use cookies */
		      var $useCookies = 0;
		      /**
		      * Constructor
		      * Includes files needed for displaying tabs and sets cookie options
		      * @param int useCookies, if set to 1 cookie will hold last used tab between page refreshes
		      */
		      function kissTabs( $useCookies, $xhtml=NULL ) {
			      global $mainframe;
			      $live_site = &JURI::root();
			      $document = & JFactory::getDocument();
			      $cur_dir = str_replace(JPATH_ROOT, '', JPATH_COMPONENT);
			      $document->addStyleSheet(JRoute::_("components".DS."com_ksadvertiser".DS."tabs".DS."tabpane.css"), 'text/css', 'all', array('id'=>'luna-tab-style-sheet'));
			      $document->addScript(JRoute::_("components".DS."com_ksadvertiser".DS."tabs".DS."tabpane_mini.js"));


			      $this->useCookies = $useCookies;
		      }

		      /**
		      * creates a tab pane and creates JS obj
		      * @param string The Tab Pane Name
		      */
		      function startPane($id){
			      echo "<div class=\"tab-page\" id=\"".$id."\">";
			      echo "<script type=\"text/javascript\">\n";
			      echo "	var tabPane1 = new WebFXTabPane( document.getElementById( \"".$id."\" ), ".$this->useCookies." )\n";
			      echo "</script>\n";
		      }

		      /**
		      * Ends Tab Pane
		      */
		      function endPane() {
			      echo "</div>";
		      }

		      /*
		      * Creates a tab with title text and starts that tabs page
		      * @param tabText - This is what is displayed on the tab
		      * @param paneid - This is the parent pane to build this tab on
		      */
		      function startPanel( $tabText, $paneid ) {
			      echo "<div class=\"tab-page\" id=\"".$paneid."\">";
			      echo "<h2 class=\"tab\">".$tabText."</h2>";
			      echo "<script type=\"text/javascript\">\n";
			      echo "  tabPane1.addTabPage( document.getElementById( \"".$paneid."\" ) );";
			      echo "</script>";
		      }

		      /*
		      * Ends a tab page
		      */
		      function endPanel() {
			      echo "</div>";
		      }
	}

?>