<?php
/*----------------------------------------------------------------------------------------------
| Kiss PDF Creator														Version	1.5.61
| Creates a PDF Document on the fly using the Joomla TCPDF Class
|-----------------------------------------------------------------------------------------------
| Author: Heiner Klostermann (DocChicago) - KISS Software Germany				
| Copyright (c) 2010 by KISS Software, 59227 Ahlen (NRW), Germany				
|-----------------------------------------------------------------------------------------------
| License GNU/GPL 									http://www.gnu.org/copyleft/gpl.html
|-----------------------------------------------------------------------------------------------
|												
| This component is free software, distributed under the GNU / GPL License. You may use,	
| copy and redistribute it free of charge as long as it complies with the license terms.	
|												
| 
| For help and suggestions please visit our support forum at www.kiss-software.de
|
|-----------------------------------------------------------------------------------------------
| created 2010-01-01												updated	2010-12-22
|-----------------------------------------------------------------------------------------------*/

defined('_JEXEC') or die('Restricted Access');

// Set some required variables
	$lang =& JFactory::getLanguage();
	$language = substr($lang->getTag(),0,2);
	
	// Output File - Should be set by the caller routine. If not, use Standard
	if (!isset($outputfile)) {
	    $datestamp = date("Ymdhis");
	    $outputfile = "kiss_$datestamp.pdf";
	    }
	// Output Target: I=Browser (Standard) D=Downloadfile F=Local File S=String E=Email
	if (!isset($outputdest)) {
	    $outputdest = 'I';	
	    }

	if (!isset($pdf_author)) {
	    $pdf_author = 'KISS Software';	
	    }
	if (!isset($pdf_title)) {
	    $pdf_title = 'Document Title';	
	    }
	if (!isset($pdf_subject)) {
	    $pdf_subject = 'Document Subject';	
	    }
	if (!isset($pdf_keywords)) {
	    $pdf_keywords = 'KISS Software, PDF, Document';	
	    }

require_once('tcpdf.php');

	if (!isset($pdf_header_logo)) {
	    $pdf_header_logo = PDF_HEADER_LOGO;	
	    }
	if (!isset($pdf_header_logo_width)) {
	    $pdf_header_logo_width = PDF_HEADER_LOGO_WIDTH;	
	    }
	if (!isset($pdf_header_title)) {
	    $pdf_header_title = PDF_HEADER_TITLE;	
	    }
	if (!isset($pdf_header_string)) {
	    $pdf_header_string = PDF_HEADER_STRING;	
	    }

// create new PDF document
$pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);

// set document information
$pdf->SetCreator(PDF_CREATOR);
$pdf->SetAuthor($pdf_author);
$pdf->SetTitle($pdf_title);
$pdf->SetSubject($pdf_subject);
$pdf->SetKeywords($pdf_keywords);

// set default header data
$pdf->SetHeaderData($pdf_header_logo, $pdf_header_logo_width, $pdf_header_title, $pdf_header_string);

// set header and footer fonts
$pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
$pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

// set default monospaced font
$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);

//set margins
$pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
$pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);

//set auto page breaks
$pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);

//set image scale factor
$pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);

//set some language-dependent strings
$pdf->setLanguageArray($language);

// ---------------------------------------------------------

// set font
$pdf->SetFont('helvetica', '', 10);
// ----------------Start generating the pages --------------
foreach($html as $page) {
	// add a page
	$pdf->AddPage();
	// output the HTML content
	$pdf->writeHTML($page, true, false, true, false, '');
	// - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	// reset pointer to the last page
	$pdf->lastPage();
	}
// ---------------------------------------------------------

//Close and output PDF document
$pdf->Output($outputfile, $outputdest);
//Leave the routine (same as javascript: return false)
exit;
