<?php
/**
 * $Id: $
 * KISS Advertiser Search Bot (based on work from Heiner Klostermann)
 * @version 1.5 
 * 
 * @copyright (C) Copyright 2010by Heiner Klostermann
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL

18/Nov/2009	Heiner Klostermann	1.3	Added ad_address search
29/Dec/2009	Zorro Jankel		1.5	MySQL 5 compatible, added keyword density
 */

/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' ) ;

// Get VM vars


jimport( 'joomla.plugin' ) ;

/** Register search function inside Joomla's API */
$mainframe->registerEvent( 'onSearch', 'ksAdvertiserSearch' ) ;

/**
 * Search method
 *
 * The sql must return the following fields that are used in a common display
 * routine: href, title, section, created, text, browsernav
 */
function ksAdvertiserSearch( $text, $phrase = '', $ordering = '' ) {
	$database = JFactory::getDBO() ;
	$user		=& JFactory::getUser();
	$usertype	= $user->get ( 'usertype' );
	$userID		= $user->get ( 'id' );
	$userGroup	= $user->get ( 'gid' );
	$userAID	= $user->get( 'aid' );

	$text = trim( $text ) ;
	if( $text == '' ) {
		return array( ) ;
	}
	$text_phonetic = phonetic($text);
  
	// Get plugin parameters
	// check if param query has previously been processed
	if( ! isset( $GLOBALS['_search_mambot_params']['ksadvertiser'] ) ) {
		// load mambot params info
		$query = "SELECT params FROM #__plugins WHERE element = 'ksadvertiser.plugin' AND folder = 'search'" ;
		$database->setQuery( $query ) ;
		$mambot = $database->loadObject() ;
		// save query to class variable
		$GLOBALS['_search_mambot_params']['ksadvertiser'] = $mambot ;
	}
	// pull query data from class variable
	$mambot = $GLOBALS['_search_mambot_params']['ksadvertiser'] ;
 	$botParams = new JParameter( $mambot->params );
	
	$fields = array( ) ;
	if( $botParams->def( 'adident_flag', 1 ) == 1 )
		$fields[] = 'p.ad_ident' ;
	if( $botParams->def( 'adname_flag', 1 ) == 1 )
		$fields[] = 'p.ad_name' ;
	if( $botParams->def( 'addesc_flag', 1 ) == 1 )
		$fields[] = 'p.ad_desc' ;
	if( $botParams->def( 'adintro_flag', 1 ) == 1 )
		$fields[] = 'p.ad_intro' ;
	if( $botParams->def( 'adstate_flag', 1 ) == 1 )
		$fields[] = 'p.ad_state' ;
	if( $botParams->def( 'adaddress_flag', 1 ) == 1 )
		$fields[] = 'p.ad_address' ;
	if( $botParams->def( 'adlocation_flag', 1 ) == 1 )
		$fields[] = 'p.ad_location' ;
	if( $botParams->def( 'addelivery_flag', 1 ) == 1 )
		$fields[] = 'p.ad_delivery' ;
	if( $botParams->def( 'contactname_flag', 1 ) == 1 )
		$fields[] = 'p.contact_name' ;
	if( $botParams->def( 'contactmail_flag', 1 ) == 1 )
		$fields[] = 'p.contact_email' ;
	if( $botParams->def( 'meta_flag', 1 ) == 1 )
		$fields[] = 'p.meta' ;

	// Build search logic
	$wheres = array( ) ;
	switch( $phrase) {
		case 'exact' :
			$wheres2 = array( ) ;
			foreach ($fields as $field) {	
				if ($fields == 'p.ad_address') {
					$wheres1 = "($field LIKE '%".$database->getEscaped($text)."%' AND show_address = 1)" ;
					} elseif ($field == 'p.contact_name') {
					$wheres1 = "($field LIKE '%".$database->getEscaped($text)."%' AND ad_boxnumber = 0)" ;					
					} else {
					$wheres1 = "$field LIKE '%".$database->getEscaped($text)."%'" ;					
					}
				$wheres2[] = $wheres1;	
			}
			$where = '(' . implode( ') OR (', $wheres2 ) . ')' ;
		break ;
		case 'all' :
		case 'any' :
		default :
			$words = explode( ' ', $text ) ;
			$wheres = array( ) ;
			foreach( $words as $word ) {
				$wheres2 = array( ) ;
				foreach( $fields as $field ) {
					if ($word == 'p.ad_address') {
					$wheres1 = "($field LIKE '%".$database->getEscaped($word)."%' AND show_address = 1)" ;
					} elseif ($field == 'p.contact_name') {
					$wheres1 = "($field LIKE '%".$database->getEscaped($word)."%' AND ad_boxnumber = 0)" ;					
					} else {
					$wheres1 = "$field LIKE '%".$database->getEscaped($word)."%'" ;					
					}
				$wheres2[] = $wheres1;						
				}
				$wheres[] = implode( ' OR ', $wheres2 ) ;
			}
			$where = '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')' ;

			//phonetic search terms
			$wheres3 = array();
			$wheres4 = array();
			// Do not use phonetic search on boxnumber ads to avoid finding a name		
			foreach( $words as $word ) {
				$pword = phonetic($word);
				$wheres1 = "p.phonetic LIKE '%".$database->getEscaped($pword)."%' AND ad_boxnumber = 0" ;
				$wheres3[] = $wheres1;
				}
			$wheres4[] = implode( ' OR ', $wheres3 ) ;
			$ph_where = 'OR (' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres4 ) . ')' ;
		break ;
	}
	
	switch( $ordering) {
		case 'newest' :
		default :
			$order = 'p.date_created DESC' ;
		break ;
		case 'oldest' :
			$order = 'p.cate_created ASC' ;
		break ;
		case 'popular' :
			$order = 'p.ad_name ASC' ;
		break ;
		case 'alpha' :
			$order = 'p.ad_name ASC' ;
		break ;
		case 'category' :
			$order = 'p.catid ASC' ;
		break ;
	}
	
	if( $botParams->def( 'density_flag', 1 ) == 1 ) {
		$whole_text = ", CONCAT_WS(' ',LOWER(" . implode( '), LOWER(', $fields ) . ')) AS whole_text ' ;
	} else {
		$whole_text = '' ;
	}
	
	//Get KSAdvertiser module ID
	$database->setQuery( " SELECT id, name FROM  `#__menu` WHERE link LIKE '%com_ksadvertiser%' AND published=1 AND access=0" ) ;
	$Item = $database->loadObject() ;
	$ItemName = ! empty( $Item->name ) ? $Item->name : "Kleinanzeigen" ;
	$Itemid = ! empty( $Item->id ) ? $Item->id : "1" ;
	
	$query = "SELECT DISTINCT p.id, p.ad_name as title,
			FROM_UNIXTIME( p.date_created, '%Y-%m-%d'  ) AS created,
			p.ad_desc AS text,
			c.id, c.cat_name, c.gid, c.aid, 
			CONCAT('index.php?option=com_ksadvertiser&task=viewad&id=', p.id) as href,
			CONCAT('$ItemName/', c.cat_name) as section,									
			'2' as browsernav 
			$whole_text 
			FROM #__ksads_ads as p
			INNER JOIN #__ksads_cats AS c ON c.id = p.catid\n
				WHERE ($where)" . "\n
				$ph_where" . "\n
				AND p.published='1'\n
				AND (c.gid =0 OR c.gid <= $userGroup)\n
				AND (c.aid =0 OR c.aid <= $userAID)\n						
				ORDER BY $order" ;

	$database->setQuery( $query ) ;
	
	$row = $database->loadObjectList() ;
	
	if( ! empty( $row ) && $botParams->def( 'density_flag', 1 ) == 1 ) {
		$txt = strtolower( $text ) ;
		if( $phrase != 'exact' )
			$txt_array = explode( ' ', $txt ) ; else
			$txt_array[0] = $txt ;
		$i = 0 ;
		foreach( $row as $result ) {
			$count = 0 ;
			foreach( $txt_array as $txt ) {
				$count = substr_count( $result->whole_text, $txt ) + $count ;
			}
			$row[$i]->count = $count ;
			$i ++ ;
		}
		pg_keydensitySort( $row, 'count', 'DESC' ) ;
	}
	return $row ;

}

function pg_keydensitySort( &$data, $key, $order ) {
	for( $i = count( $data ) - 1 ; $i >= 0 ; $i -- ) {
		$swapped = false ;
		for( $j = 0 ; $j < $i ; $j ++ ) {
			if( $order == 'ASC' ) {
				if( $data[$j]->$key > $data[$j + 1]->$key ) {
					$tmp = $data[$j] ;
					$data[$j] = $data[$j + 1] ;
					$data[$j + 1] = $tmp ;
					$swapped = true ;
				}
			} else {
				if( $data[$j]->$key < $data[$j + 1]->$key ) {
					$tmp = $data[$j] ;
					$data[$j] = $data[$j + 1] ;
					$data[$j + 1] = $tmp ;
					$swapped = true ;
				}
			}
		
		}
		if( ! $swapped )
			return ;
	}
}

function phonetic($word){
   
  	/**
  	* @param  string  $word string to be analyzed
  	* @return string  $value represents the German phonetics value
  	* @access public
  	*/
	//avoid complications if $word is empty
	if (strlen($word) < 1) {
	    return;
	    }
	//prepare for processing
	$word=strtolower($word);
	$substitution=array(
            "aa"=>"a",
            "ah"=>"a",
            "ai"=>"ei",
            "ar"=>"a",
            "äu"=>"eu",
            "ay"=>"ei",
            "c"=>"k",			
            "ck"=>"k",
            "cs"=>"tsch",
            "cx"=>"x",
            "cz"=>"tsch",
            "dt"=>"t",
            "dz"=>"z",
            "ee"=>"e",
            "eh"=>"e",
            "el"=>"l",
            "er"=>"a",
            "ey"=>"ei",
            "gk"=>"k",
            "ich"=>"ig",
            "ie"=>"i",
            "ih"=>"i",
            "kk"=>"k",
            "ks"=>"x",
            "kx"=>"x",
            "mm"=>"m",
            "nk"=>"ng",
            "nn"=>"n",
            "nt"=>"nd",
            "oh"=>"o",
            "oi"=>"eu",
            "oo"=>"o",
            "or"=>"a",
            "ou"=>"u",
            "pf"=>"f",
            "ph"=>"f",
            "qx"=>"x",
            "rt"=>"rd",
            "ß"=>"ss",
            "sz"=>"sch",
            "th"=>"t",
            "ti"=>"zi",
            "ts"=>"z",
            "tt"=>"t",
            "tz"=>"z",
            "uh"=>"u",
            "ur"=>"a",
            "uu"=>"u",
            "v"=>"f",
            "y"=>"i",
            "zz"=>"z",
	    "ä"=>"e",
	    "ö"=>"oe",
	    "ü"=>"ue",
            " "=>"_",
            "-"=>"_",
            "'"=>"_",
            "/"=>"_",
            "&"=>"_"
            );

	foreach ($substitution as $letter=>$substitute) {
	    $word=str_replace($letter,$substitute,$word);
	    }
   
	return $word;

}

?>
