<?php
/*----------------------------------------------------------------------------------------------
| Kiss Advertiser Module (mod_ksadvertiser)					Version	1.5.55
|-----------------------------------------------------------------------------------------------
| Author: Heiner Klostermann (DocChicago) - KISS Software Germany				
| Copyright (c) 2010 by KISS Software, 59227 Ahlen (NRW), Germany				
|-----------------------------------------------------------------------------------------------
| License GNU/GPL 					http://www.gnu.org/copyleft/gpl.html
|-----------------------------------------------------------------------------------------------
|												
| This component is free software, distributed under the GNU / GPL License. You may use,	
| copy and redistribute it free of charge as long as it complies with the license terms.	
|												
| 
| For help and suggestions please visit our support forum at www.kiss-software.de
|
|-----------------------------------------------------------------------------------------------
| created 2010-01-01							updated	2011-01-15
|-----------------------------------------------------------------------------------------------*/
if(!defined( '_JEXEC' ) ) die( 'Direct Access to this location is not allowed.' );


/*********************************************************
************* CATEGORY TREE ******************************
*/
    $js_src = $live_site.'modules'.DS.'mod_ksadvertiser';
    $document = & JFactory::getDocument();
    $document->addStyleSheet("$js_src".DS."dtree".DS."dtree.css");
    $document->addScript ("$js_src".DS."dtree".DS."dtree.js");	
    /* dTree API, default values
	* change to fit your needs **/
    $useSelection =  'true';
    $useLines =  'true';
    $useIcons =  'true';
    $useStatusText =  'false';
    $useCookies =  'false';
    $closeSameLevel =  'false';
    
    // if all folders should be open, we will ignore the closeSameLevel
    $openAll =  'false';
    if ( $openAll == "true" ) { $closeSameLevel = "false"; }
    
    
    $menu_htmlcode = "";
    
	// what should be used as the base of the tree?
	// ( could be *first* menu item, *site* name, *module*, *menu* name or *text* )
	$base = "first";
	
	
	// in case *text* should be the base node, what text should be displayed?
	$basetext =  "";
	
	// what category_id is selected?
	$category_id = JRequest::getInt( 'category_id' );
	

	// how many menu items in this menu?
	$catrowscount = count($catrows);
	
	// create a unique tree identifier, in case multiple dtrees are used 
	// (max one per module)
	$tree = "d".uniqid( "tree_" );
	
	
	// start creating the content
	// create left aligned table, load the CSS stylesheet and dTree code
	$menu_htmlcode .= "<table border=\"0\" cellspacing=\"1\" cellpadding=\"0\" width=\"100%\"><tr><td align=\"left\">\n";
	$menu_htmlcode .= "<script type=\"text/javascript\">\n";
	
	// create the tree, using the unique name
	// pass the live_site parameter on so dTree can find the icons
	$menu_htmlcode .= "$tree = new dTree('$tree',\"$js_src\");\n";
	
	// pass on the dTree API parameters
	$menu_htmlcode .= "$tree.config.useSelection=".$useSelection.";\n";
	$menu_htmlcode .= "$tree.config.useLines=".$useLines.";\n";
	$menu_htmlcode .= "$tree.config.useIcons=".$useIcons.";\n";
	$menu_htmlcode .= "$tree.config.useCookies=".$useCookies.";\n";
	$menu_htmlcode .= "$tree.config.useStatusText=".$useStatusText.";\n";
	$menu_htmlcode .= "$tree.config.closeSameLevel=".$closeSameLevel.";\n";
	
	$basename = JText::_("Category Overview");
	
	// what is the ID of this node?
	$baseid = 0;
	// create the link (if not a menu item, no link [could be: to entry page of site])
	$baselink = ( $base == "first") ? JRoute::_("index.php?option=com_ksadvertiser") : "";

	// remember which item is open, normally $Itemid
	// except when we want the first item (e.g. Home) to be the base;
	// in that case we have to pretend all remaining items belong to "Home"
	$openid = $category_id;
   
	// it could be that we are displaying e.g. mainmenu in this dtree, 
	// but item in usermenu is selected, 
	// so: for the rest of this module track if this menu contains the selected item
	// Default value: first node (=baseid), but not selected
	$opento = $baseid;
	$opento_selected = "false";
	// what do you know... the first node was selected
	if ($baseid == $openid) { $opento_selected = "true"; }
	$target = "";
	
	// create the first node, parent is always -1
	$menu_htmlcode .= "$tree.add(\"$baseid\",\"-1\",\"$basename\",\"$baselink\",\"\",\"$target\");\n";

	// process each of the nodes
	foreach( $catrows as $catrow ) {
			$children = 0;
			foreach ($catrows as $catrow2) {
				if ($catrow2->parent == $catrow->id) {
					$children = 1;
					}
			}
		// get name and link (just to save space in the code later on)
		$name = $catrow->name;
		// TODO: Get items in category
		if ($children) {
			$url = JRoute::_("index.php?option=com_ksadvertiser&pid=".$catrow->id."&task=showcats");
			} else {
			$url = JRoute::_("index.php?option=com_ksadvertiser&catid=".$catrow->id."&task=view");
			}
		$menu_htmlcode .= "$tree.add(\"".$catrow->id."\",\"".$catrow->parent."\",\"$name\",\"$url\",\"\",\"$target\");\n";
	  
		// if this node is the selected node
		if ($catrow->id == $openid) { 
			$opento = $openid; $opento_selected = "true"; 
		}  
	}
	
	$menu_htmlcode .= "document.write($tree);\n";
	$menu_htmlcode .= $openAll == "true" ? "$tree.openAll();\n" : "$tree.closeAll();\n";
	$menu_htmlcode .= "$tree.openTo(\"$opento\",\"$opento_selected\");\n";
	$menu_htmlcode .= "</script>\n";
	$menu_htmlcode .= "<noscript>\n";
	$menu_htmlcode .= "Sorry, no Javascript - no tree menu!";
	$menu_htmlcode .= "</noscript>\n";
	$menu_htmlcode .= "</td></tr></table>\n";
	
	echo $menu_htmlcode;
        

/************* END OF CATEGORY TREE ******************************
*********************************************************
*/
?>